package com.tin.FVU;


/* ------------------------------------------------------------------------------------------------------------------------------------------
 *  Modifications
 *  ------------- 
 *  M01      [M01_B  - Indicates beginning of the code change for M01  & M01_E - End of code change for M01]
 *  ----
 *  Description   : Allowing dot(.) in the name of the TDS/TCS statement input file 
 *  Modified By   : Dhanya P
 *  Modified Date : 09/12/2010
 *  ------------------------------------------------------------------------------------------------------------------------------------------
 */




import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Desktop;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.Frame;
import java.awt.GridBagConstraints;
import java.awt.TextArea;
import java.awt.Dialog.ModalityType;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.KeyEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintStream;
import java.io.PrintWriter;
import java.net.NoRouteToHostException;
import java.net.URI;
import java.net.URISyntaxException;
import java.security.KeyManagementException;
import java.security.NoSuchAlgorithmException;
import java.util.Calendar;
import java.util.GregorianCalendar;
import java.util.StringTokenizer;
import java.util.regex.Pattern;

import javax.swing.AbstractAction;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.KeyStroke;

import com.tin.tds.FileValidatorInterface;
import com.tin.tds.FormValidator;
import com.tin.tds.ProxyValidator;
import com.tin.tds.VersionValidator;
import com.tin.tds.bean.FileStatistics;
import com.tin.tds.uff.ReportGenerator;
import com.tin.tds.util.FileGenerator;
import com.tin.tds.util.Hash;
import com.tin.tds.util.PDFGenerator;
import com.tin.tds.util.Parameters;
/**
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class FVU extends JFrame implements FileValidatorInterface
{
	//static Logger logObj = Logger.getLogger("TDSLogging");
	
	final int utilityLevel = 0; // Specifies the Level of Utility. '0' Signifies Standalone FVU.
	final static int fhFieldCountTds = 10; //AMI
	public static boolean logging =  false; //Added by sourabh
	// Number of Fields in File Header Record of Sal, Non-Sal and PAN Correction File
	boolean isConsValid=false;
	private static javax.swing.JPanel jContentPane = null;
	private javax.swing.JLabel jLabel = null;
	private javax.swing.JLabel jLabel1 = null;
	private javax.swing.JLabel jLabelCIN = null;
	private javax.swing.JLabel jLabelCons=null;
	private javax.swing.JTextField txtInputFileName = null;
	private javax.swing.JTextField txtCINFileName = null;
	private javax.swing.JTextField txtErrorFilePath = null;
	private javax.swing.JTextField consFileName=null;
	private javax.swing.JButton btnValidate = null;
	public static String errFilepath = ""; // newly added for FVU4.8 by Akansha
	// added for FVU 4.8
	private boolean flag ;
	// ended for FVU 4.8
	private javax.swing.JButton btnExit = null;
	private javax.swing.JButton btnHelp = null;
	private javax.swing.JButton btnbrowseInputFileName = null;
	private javax.swing.JButton btnbrowseTempFileName = null;
	private javax.swing.JButton btnbrowseErrorFilePath = null;
	private javax.swing.JButton consTempFileName  = null;
	private javax.swing.JTextPane jHelpTextPane = null;
	private javax.swing.JScrollPane jHelpScrollTextPane = new JScrollPane();
	public String file;
	public String cinfile;
	private String previousSorurceFileFolder = ""; // store the path of Previous Input Folder opened by File Chooser
	private String previousOutputFileFolder = "";
	// store the path of Previous Output (To Save Error File ) Folder opened by File Chooser
	private int i = 0;
	 private int toContinue=0;
	final String errorMsg_01 = "Input File Name with Path or \n Error/Upload and Statistics Report File Path not chosen";
	final String errorMsg_02 = "Invalid Input File Name. Length of Input File Name cannot be more than 12 characters (including extension).";
	final String errorMsg_03 = "Invalid Input File Name";
	final String errorMsg_04 = "Invalid File Name.\n  :  /  ?  >  <  *  \"  |  \\  _ ^ or Space, not allowed in File Name.";
	final String errorMsg_06 = "Invalid TDS/TCS input file name. Extension of the e-TDS/TCS file name should be txt/fvu.";
	final String errorMsgCIN_01 = "CIN File Name with Path or \n Error/Upload and Statistics Report File Path not chosen";
	final String errorMsgCIN_02 = "Invalid CIN File Name. Length of CIN File Name cannot be more than 25 characters (including extension).";
	final String errorMsgCIN_03 = "Invalid CIN File Name";
	final String errorMsgCIN_04 = "Invalid CIN File Name.\n  :  /  ?  >  <  *  \"  |  \\  _ ^ or Space, not allowed in File Name.";
	final String errorMsgCIN_05 = "Extension of challan file should be csi.";
	final String errorMsg_05 = "Error/Upload and Statistics Report File Path does not exist or \n File Name specified alongwith path instead of only path.";
	final String errorMsgCons="The consolidated file provided is not valid...";
	final String errorMsgCons1="Consolidated file is mandatory for validation of Correction File";
	// added by priyanka for fvu 4.9
	final static String errorMsgCons2="This FVU version is old. Please download latest version of FVU from TIN website.\n Statement validated using this FVU will get rejected at TIN Central System."; // added for FVU 4.8
	private javax.swing.JButton jButton = null;
	
	private boolean processingInProgress= false;
	private boolean consProvidedwitRegular=false;
	DialogForLink dfunc = new DialogForLink();
	//newly added by priya
	// Button to  View PDF of procedure about filing of e-TDS/TCSstatement(s)
	//private JButton btnNewButton;
	private JButton viewPDFButton;
	
	JDialog jframe; //Rahul Feedback FVU 7.5
	public String buttonpress=""; //Rahul Feedback FVU 7.5
	
	public static void main(String[] args)
	{
		
		
		
		//Checking if Certificate is expired
//		try
//		{
//			CertificateFactory certF = CertificateFactory.getInstance("X.509");
//			X509Certificate cert = (X509Certificate) certF.generateCertificate(new FileInputStream(Parameters.certificateFile));
//			cert.checkValidity();
//		}
//		catch(CertificateException e)
//		{
//			JOptionPane.showMessageDialog(null, "Invalid Certificate");
//			System.exit(0);
//		}
//		catch(FileNotFoundException e1)
//		{
//			JOptionPane.showMessageDialog(null, "Certificate Not found");
//			System.exit(0);
//		}
		
		
		PrintStream fvuLogs  = null;
		
		try {
			fvuLogs = new PrintStream(new FileOutputStream("./fvu.log"));
			//System.out.println();
		} catch (FileNotFoundException e2) {
			System.out.println("Cannot create log file");
			e2.printStackTrace();
			System.exit(0);
		}
		System.setOut(fvuLogs);
		System.setErr(fvuLogs);
		
		if (args.length == 6 || args.length == 7 || args.length == 8)
		{	
			//Added for FVU4.8 by Akansha
			versionCheck();
			//******************************************
			String inFileNameSAM = args[0]; //Getting the input file name with path
			String errorFileNameSAM = args[1]; //Generating the name of the error file
			System.out.println("FVU path: "+ args[1]);
			errFilepath = args[2]; // newly added for FVU4.8 by Akansha
			String outFileNameSAM = args[2]; // Name of Generated HASH File
			String utilityLevelSamScm = args[3]; //Gives whether the function is being called by FVU,SAM,SCM,STM
			String samScmFvuVersion = args[4]; //FVU version passed as a input parameter
			String samScmPaperReturn = args[5]; //Paper Return File indicator Flag 1 - Electronic Return , 2 - Paper Return
			//Added by sourabh 
			String cinFilePath="";
			String consFilePath="";

			System.out.println("--TO CHECK FVU VERSION-- 4.5");
			if (args.length==6&&!utilityLevelSamScm.equals("0"))
			{
				logging = true;
				
			}
			//Added by sourabh for Giving path of CIN File From RPU Called FVU
			if (args.length==7&&utilityLevelSamScm.equals("0"))
			{
				cinFilePath = args[6];
				FileStatistics.setCinUploadFlag(0);
				FileStatistics.setCinFileName("");	
			}
			
			if (args.length==8 && utilityLevelSamScm.equals("0"))
			{
				cinFilePath = args[6].trim();

				FileStatistics.setCinUploadFlag(0);
				FileStatistics.setCinFileName("");


				consFilePath=args[7];
			}
			File f1 = new File(inFileNameSAM);
			File f2 = new File(outFileNameSAM);
			String tab = "^";

			int utilityLevelInt = Integer.parseInt(utilityLevelSamScm.trim());
			int paperReturnIndiFlag = Integer.parseInt(samScmPaperReturn.trim());

			FileGenerator obj_FileGenerator = new FileGenerator();
			StringBuffer FH_obj_StringBuffer = new StringBuffer();

			//utility level check added (27-12-2005) for jar check in case of SAM,SCM
			//in case of FVU,SVU this jar check is not performed
			if (utilityLevelInt == 0 || utilityLevelInt == 1 || utilityLevelInt == 2)
			{
				if (!samScmFvuVersion.equals(TDSFVUVersion))
				{
					FH_obj_StringBuffer.append("1" + tab + "NA" + tab + "NA" + tab + tab + tab + tab + "Incorrect FVU Version of JAR");
					try
					{
						obj_FileGenerator.writeToFile(errorFileNameSAM, FH_obj_StringBuffer.toString(), 0);
					}
					catch (IOException e)
					{
							e.printStackTrace();
						
					}
					System.exit(0); //if jar does not match exit
				}
			}
			//          utility level check added (27-12-2005) for jar check in case of SAM,SCM

			if (utilityLevelInt == 0)
			{
				String x = "just to overload constructor";
				FVU f = new FVU(x);
//				System.out.println("Inside utility level 0 just before call to RPU func errorFileNameSAM = " + errorFileNameSAM);
				int i;
				for (i = errorFileNameSAM.length(); i > 0; i--)
				{
					//if (errorFileNameSAM.charAt(i - 1) == '\\')
					//added below if to for linux /window compatibility start 
					if (errorFileNameSAM.charAt(i - 1) == File.separatorChar)
						break;
				}
//				System.out.println("input file name :: " + inFileNameSAM);
				//Added by sourabh for CIN file upload from RPU calling FVU
				if(cinFilePath.length()!=0)
					FileStatistics.setCinFileName(cinFilePath);
					
				f.RPUcalled_FVUaction(inFileNameSAM, errorFileNameSAM.substring(0, i), outFileNameSAM, samScmFvuVersion, paperReturnIndiFlag,consFilePath);
//				System.out.println("just before exit");
				System.out.println("the errorFileNameSAM is " + errorFileNameSAM );
                  
                //---bug fix for in memory javaw.exe after RPU call-- Manvendra Singh :: 20-Feb-2008
				//System.out.println("---FVUBUG---1"); 
				//System.exit(0);
			}
			else
			{

				//       Hash validation called in hash.java. It returns appropriate error code and 0 on successful hash validation
				//       Description of error codes given at the start of Hash.java
				Hash hashObj = new Hash();
				int hashCode = 0;
				try {
					hashCode = hashObj.startProcessing(inFileNameSAM, outFileNameSAM, utilityLevelInt, fhFieldCountTds, paperReturnIndiFlag);
				} catch (Exception e2) {
					e2.printStackTrace();
				}
				//System.out.println("Error Code Returned: " + hashCode);

				if (hashCode != 0)
				{
					//              write appropriate error message in the files as per the error code returned
					int lineNumber = hashObj.getRecordNumber();
					if (hashCode == 3)
					{
						FH_obj_StringBuffer.append("1" + tab + "NA" + tab + "NA" + tab + tab + tab + T_FV_1021_C + tab + T_FV_1021_M);
					}
					else if (hashCode == 4)
					{
						FH_obj_StringBuffer.append("1" + tab + "NA" + tab + "NA" + tab + tab + tab + T_FV_1024_C + tab + T_FV_1024_M);
					}
					else if (hashCode == 5)
					{
						FH_obj_StringBuffer.append("1" + tab + "NA" + tab + "NA" + tab + tab + tab + T_FV_1025_C + tab + T_FV_1025_M);
					}
					else if (hashCode == 9)
					{
						FH_obj_StringBuffer.append("1" + tab + "NA" + tab + "NA" + tab + tab + tab + T_FV_1026_C + tab + T_FV_1026_M);
					}
					else if (hashCode == 10)
					{
						FH_obj_StringBuffer.append("1" + tab + "NA" + tab + "NA" + tab + tab + tab + T_FV_1027_C + tab + T_FV_1027_M);
					}
					else if (hashCode == 11)
					{
						FH_obj_StringBuffer.append("1" + tab + "NA" + tab + "NA" + tab + tab + tab + T_FV_1028_C + tab + T_FV_1028_M);
					}
					//Added for FVU 7.1 // Obs no 1 - FVU 7.1 - Vinita
					else if (hashCode == 18)
					{
						FH_obj_StringBuffer.append("1" + tab + "NA" + tab + "NA" + tab + tab + tab + T_FV_6202_C + tab + T_FV_6202_M);
					}
					else
					{
						FH_obj_StringBuffer.append(lineNumber + tab + "NA" + tab + "NA" + tab + "NA" + tab + "NA" + tab + T_FV_1022_C + tab + T_FV_1022_M);
					}
					try
					{
						obj_FileGenerator.writeToFile(errorFileNameSAM, FH_obj_StringBuffer.toString(), 0);
					}
					catch (IOException e)
					{
						e.printStackTrace();
					}
					//          write appropriate error message in the files as per the error code returned
				}
				else if (hashCode == 0)
				{
					//if hash validation is successful then call format validation        
					//Creating the object of the Form_Validatior class////////////////
					FormValidator obj_FormValidator = new FormValidator();
					try
					{
						obj_FormValidator.readFile(inFileNameSAM, errorFileNameSAM, utilityLevelInt);
					}
					catch (Exception e1)
					{
						e1.printStackTrace();
					}
					if (obj_FormValidator.obj_StringBuffer.errorBufferString.length() == 0)
					{
						try
						{
							String dataRecord = null;
							/* Deleting PAN Statistics Report if Generated
							 * SAM SCM DOES NOT REQUIRE PAN STATISTICS REPORT
							 */
							String panStatFileName = errorFileNameSAM.substring(0, (errorFileNameSAM.length() - 4)) + STATISTICS_FILE_EXT;
							File panStatFile = new File(panStatFileName);
							if (panStatFile.exists())
							{
								panStatFile.delete();
							}
							// PAN Statistics Report Deleted
							// Deleting Paper Return warning File if Generated
							String paperRetWarFileName = errorFileNameSAM.substring(0, (errorFileNameSAM.length() - 4)) + PAPER_RET_WAR_FILE_EXT;
							File paperReturnWarFile = new File(paperRetWarFileName);
							if (paperReturnWarFile.exists())
							{
								paperReturnWarFile.delete();
							}
							// Deleting Paper Return warning File DELETED

							// Write Data that will be used by SAM / SCM in File
							
							String electronicRetWarFileName = errorFileNameSAM.substring(0, (errorFileNameSAM.length() - 4)) + ELECTRONIC_RET_WAR_FILE_EXT;
							File electronicReturnWarFile = new File(electronicRetWarFileName);
							if (electronicReturnWarFile.exists())
							{
								electronicReturnWarFile.delete();
							}
							
//							System.out.println("Receipt String ::::::::::: "+obj_FormValidator.getReceiptString().toString()+"\n");
//							System.out.println("Statistic FileBuffer"+obj_FormValidator.getStatisticFileStrBuff().toString());
							
							String samScmString =
								obj_FormValidator.getSamScmNoOfBatch()
									+ "^"
									+ obj_FormValidator.getSamScmLineCountOfFile()
									+ "^"
									+ obj_FormValidator.getFVUVer()
									+ "^"
									+ obj_FormValidator.getFileHash()
									+ "^"
									+ obj_FormValidator.getSAMVer()
									+ "^"
									+ obj_FormValidator.getSAMHash()
									+ "^"
									+ "\n"
									+ obj_FormValidator.getReceiptString().toString()
									+ "\n"
									+ obj_FormValidator.getStatisticFileStrBuff().toString()
									+ "\n"
									+ obj_FormValidator.getSamScmData().toString();
							String samScmDataFlNm = outFileNameSAM + ".raw";
							obj_FileGenerator.writeToFile(samScmDataFlNm, samScmString, 0, false);
							// Write Data that will be used by SAM / SCM in File

							BufferedReader brRead = new BufferedReader(new FileReader(inFileNameSAM));
							PrintWriter outWrite = new PrintWriter(new BufferedWriter(new FileWriter(outFileNameSAM, true)));
							while ((dataRecord = brRead.readLine()) != null)
							{
								outWrite.println(dataRecord);
							}
							outWrite.flush();
							outWrite.close();
							brRead.close();
						}
						catch (Exception e)
						{
							e.printStackTrace();
						}
						f1.renameTo(f2);
					}
					else
					{
						System.out.println("Errors Found during Validation.\r\nOpen " + errorFileNameSAM + " for details");
						// added by faizan for FVU  4.8
						File htmlFile1 = new File(errorFileNameSAM);
						try {
							Desktop.getDesktop().browse(htmlFile1.toURI());
						} catch (IOException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
						// ended for FVU 4.8
					}
					}
			}
		}
		else if (args.length == 0)
		{
			versionCheck();
			FVU f = new FVU();
			f.setVisible(true);
		}
		else
			System.err.println("Exception : Invalid Number of arguments passed in Main() : ");
	}
	/**
	 * This is the default constructor
	 */
	public FVU()
	{
		super();
		initialize();
	}
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	public FVU(String x)
	{

	}
	private void initialize()
	{
		
		this.setSize(700, 220);
		this.setLocation(250, 250);
		this.setContentPane(getJContentPane());
		this.setTitle("TDS/TCS File Validation Utility - Version " + TDSFVUVersion);
		this.setResizable(false);
		btnValidate.setEnabled(false);
		this.setDefaultCloseOperation(javax.swing.JFrame.EXIT_ON_CLOSE);
		this.setIconImage(java.awt.Toolkit.getDefaultToolkit().getImage(getClass().getResource("/nsdl-logo.png")));
		this.addWindowListener(new WindowAdapter()
		{
			public void windowClosing(WindowEvent e)
			{
				System.exit(0);
			}
		});
	}
	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJContentPane()
	{
		if (jContentPane == null)
		{
			jContentPane = new javax.swing.JPanel();
			java.awt.GridBagConstraints consGridBagConstraints14 = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints15 = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints16 = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints12 = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints17 = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints38 = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints18 = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints39 = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints40 = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints41 = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints42 = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints43 = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints45 = new java.awt.GridBagConstraints();
			consGridBagConstraints45.fill = GridBagConstraints.HORIZONTAL;
			java.awt.GridBagConstraints consGridBagConstraints44 = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints46 = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints47 = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints48 = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints49 = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints50 = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints51 = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints1 = new java.awt.GridBagConstraints();
			consGridBagConstraints1.anchor = GridBagConstraints.SOUTH;
			//newly added by priya
			java.awt.GridBagConstraints gbc_viewPDFButton = new java.awt.GridBagConstraints();
			consGridBagConstraints1.gridy = 4;
			consGridBagConstraints1.gridx = 12;//***
			consGridBagConstraints1.gridwidth = 1;
			consGridBagConstraints1.insets = new java.awt.Insets(0, 0, 0, 5);
			//newly modified by priya
			consGridBagConstraints45.insets = new java.awt.Insets(0, 0, 0, 5);
			consGridBagConstraints45.gridy = 4;
			consGridBagConstraints45.gridx = 11;
			//*********************************
			consGridBagConstraints17.gridy = 8;
			consGridBagConstraints17.gridx = 0;
			consGridBagConstraints17.gridheight = 2;
			consGridBagConstraints14.gridy = 2;
			consGridBagConstraints14.gridx = 0;
			consGridBagConstraints18.gridy = 8;
			consGridBagConstraints18.gridx = 1;
			consGridBagConstraints15.fill = java.awt.GridBagConstraints.BOTH;
			consGridBagConstraints15.weightx = 1.0;
			consGridBagConstraints15.gridy = 1;
			consGridBagConstraints15.gridx = 1;
			consGridBagConstraints16.fill = java.awt.GridBagConstraints.BOTH;
			consGridBagConstraints16.weightx = 1.0;
			consGridBagConstraints16.gridy = 2;
			consGridBagConstraints16.gridx = 1;
			consGridBagConstraints43.insets = new java.awt.Insets(8, 7, 5, 10);//**FVU 5.0
			consGridBagConstraints43.gridy = 1;
			consGridBagConstraints43.gridx = 12;//***
			consGridBagConstraints43.anchor = java.awt.GridBagConstraints.EAST;
			consGridBagConstraints12.gridy = 1;
			consGridBagConstraints12.gridx = 0;
			consGridBagConstraints12.anchor = java.awt.GridBagConstraints.NORTH;
			consGridBagConstraints12.fill = java.awt.GridBagConstraints.BOTH;
			consGridBagConstraints14.fill = java.awt.GridBagConstraints.BOTH;
			consGridBagConstraints42.insets = new java.awt.Insets(11, 7, 7, 5);//***FVU 5.0
			consGridBagConstraints42.fill = java.awt.GridBagConstraints.HORIZONTAL;
			consGridBagConstraints42.weightx = 1.0;
			consGridBagConstraints42.gridwidth = 11;//***
			consGridBagConstraints42.gridy = 1;
			consGridBagConstraints42.gridx = 1;
			consGridBagConstraints39.insets = new java.awt.Insets(11, 7, 7, 5);//***FVU 5.0
			consGridBagConstraints39.fill = java.awt.GridBagConstraints.HORIZONTAL;
			consGridBagConstraints39.weightx = 1.0;
			consGridBagConstraints39.gridwidth = 11;//***
			consGridBagConstraints39.gridy = 0;
			consGridBagConstraints39.gridx = 1;
			consGridBagConstraints40.insets = new java.awt.Insets(8, 7, 4, 10);
			consGridBagConstraints40.gridy = 0;
			consGridBagConstraints40.gridx = 12;//****
			consGridBagConstraints40.anchor = java.awt.GridBagConstraints.EAST;
			consGridBagConstraints38.insets = new java.awt.Insets(13, 10, 9, 5);//***FVU 5.0
			consGridBagConstraints38.gridy = 0;
			consGridBagConstraints38.gridx = 0;
			consGridBagConstraints38.anchor = java.awt.GridBagConstraints.WEST;
			consGridBagConstraints38.fill = java.awt.GridBagConstraints.NONE;
			//newly modified by priya
			consGridBagConstraints44.insets = new java.awt.Insets(0,0,0,5);
			consGridBagConstraints44.gridy = 4;
			consGridBagConstraints44.gridx = 10;
			//****************************
			consGridBagConstraints41.insets = new java.awt.Insets(13, 10, 9, 5);//***FVU 5.0
			consGridBagConstraints41.gridy = 1;
			consGridBagConstraints41.gridx = 0;
			consGridBagConstraints41.anchor = java.awt.GridBagConstraints.WEST;
			consGridBagConstraints41.fill = java.awt.GridBagConstraints.NONE;
			
			consGridBagConstraints46.insets = new java.awt.Insets(13, 10, 9, 5);//***FVU 5.0
			consGridBagConstraints46.gridy = 2;
			consGridBagConstraints46.gridx = 0;
			consGridBagConstraints46.anchor = java.awt.GridBagConstraints.WEST;
			consGridBagConstraints46.fill = java.awt.GridBagConstraints.NONE;
			
			
			
			consGridBagConstraints47.insets = new java.awt.Insets(11, 7, 7, 5);//***FVU 5.0
			consGridBagConstraints47.gridwidth = 11;//***
			consGridBagConstraints47.gridy = 2;
			consGridBagConstraints47.gridx = 1;
			consGridBagConstraints47.fill = java.awt.GridBagConstraints.HORIZONTAL;
			consGridBagConstraints47.weightx = 1.0;
			


			consGridBagConstraints48.insets = new java.awt.Insets(8, 7,5, 10);
			consGridBagConstraints48.gridy = 2;
			consGridBagConstraints48.gridx = 12;
			consGridBagConstraints48.anchor = java.awt.GridBagConstraints.EAST;
			
			
			consGridBagConstraints49.insets = new java.awt.Insets(16, 12, 11, 5);//**FVU 5.0
			consGridBagConstraints49.gridy = 3;
			consGridBagConstraints49.gridx = 0;
			consGridBagConstraints49.anchor = java.awt.GridBagConstraints.WEST;
			consGridBagConstraints49.fill = java.awt.GridBagConstraints.NONE;
			
			consGridBagConstraints50.insets = new java.awt.Insets(11, 7, 7, 5);//**FVU 5.0
			consGridBagConstraints50.gridwidth = 11;//***
			consGridBagConstraints50.gridy = 3;
			consGridBagConstraints50.gridx = 1;
			consGridBagConstraints50.fill = java.awt.GridBagConstraints.HORIZONTAL;
			consGridBagConstraints50.weightx = 1.0;
			
			
			consGridBagConstraints51.insets = new java.awt.Insets(8, 7, 5, 10); //**FVU 5.0
			consGridBagConstraints51.gridy = 3;
			consGridBagConstraints51.gridx = 12;//****
			consGridBagConstraints51.anchor = java.awt.GridBagConstraints.EAST;
			
			
			jContentPane.setLayout(new java.awt.GridBagLayout());
			jContentPane.add(getJLabel(), consGridBagConstraints38);
			jContentPane.add(getTxtInputFileName(), consGridBagConstraints39);
			jContentPane.add(getBtnbrowseInputFileName(), consGridBagConstraints40);
			jContentPane.add(getJLabelCIN(), consGridBagConstraints41);
			jContentPane.add(getTxtCINFilePath(), consGridBagConstraints42); //added by sourabh for CIN File Upload
			jContentPane.add(getBtnbrowseCINFileName(), consGridBagConstraints43); //added by sourabh for CIN File Upload
			jContentPane.add(getJLabel1(), consGridBagConstraints46);
			jContentPane.add(getTxtErrorFilePath(), consGridBagConstraints47);
			jContentPane.add(getBtnbrowseErrorFilePath(), consGridBagConstraints48);
			jContentPane.add(getJLabelCons(), consGridBagConstraints49);    //added by manas
			jContentPane.add(getConsFileName(), consGridBagConstraints50);  //added by manas
			jContentPane.add( getBtnbrowseConsFileName(), consGridBagConstraints51);   //added by manas
			jContentPane.add(getBtnValidate(), consGridBagConstraints44);
			jContentPane.add(getBtnExit(), consGridBagConstraints45);
			jContentPane.add(getBtnHelp(), consGridBagConstraints1);
			txtInputFileName.setToolTipText("text file with filename extension .txt/fvu");
			txtCINFileName.setToolTipText("filename extension .csi");
			//newly added by priya for FVU 5.0
		
			gbc_viewPDFButton.gridwidth = 10;
			gbc_viewPDFButton.insets = new java.awt.Insets(0, 10, 0, 5);
			gbc_viewPDFButton.gridx = 0;
			gbc_viewPDFButton.gridy = 4;
			jContentPane.add(getViewPDFButton(), gbc_viewPDFButton);
			//End :: newly added by priya for FVU 5.0
			//******************
		}
		return jContentPane;
	}
	/**
	 * This method initializes jLabel
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel()
	{
		if (jLabel == null)
		{
			jLabel = new javax.swing.JLabel();
			jLabel.setText("TDS / TCS Input File Name with Path ");
		}
		return jLabel;
	}
	/**
	 * This method initializes jLabel1
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel1()
	{
		if (jLabel1 == null)
		{
			jLabel1 = new javax.swing.JLabel();
			jLabel1.setText("Error/Upload & Statistics Report File Path");
		}
		return jLabel1;
	}
	//added by sourabh for CIN File Upload
	
	private javax.swing.JLabel getJLabelCIN()
		{
			if (jLabelCIN == null)
			{
				jLabelCIN = new javax.swing.JLabel();
				jLabelCIN.setText("Challan Input File Name with Path");
			}
			return jLabelCIN;
		}
	
	//added for cons_file also in FVU
	private javax.swing.JLabel getJLabelCons()
	{
		if (jLabelCons == null)
		{
			jLabelCons = new javax.swing.JLabel();
			jLabelCons.setText("Consolidate File Name with Path");
		}
		return jLabelCons;
	}
	
	/**
	 * This method initializes txtInputFileName
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getTxtInputFileName()
	{
		if (txtInputFileName == null)
		{
			txtInputFileName = new javax.swing.JTextField();
			txtInputFileName.setPreferredSize(new java.awt.Dimension(150, 19));
			txtInputFileName.addFocusListener(new FocusListener()
			{
				public void focusGained(FocusEvent arg0)
				{
				}
				public void focusLost(FocusEvent arg0)
				{
					String inputFilePath = txtInputFileName.getText().trim();
					String errorFilePath = txtErrorFilePath.getText().trim();
				   if (inputFilePath.length() != 0 && errorFilePath.length() != 0 && !processingInProgress)
					{
						btnValidate.setEnabled(true);
					}
				}
			});
		}
		return txtInputFileName;
	}
	/**
	 * This method initializes txtErrorFilePath
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getTxtErrorFilePath()
	{
//		String errorFilePath = "";
		if (txtErrorFilePath == null)
		{
			txtErrorFilePath = new javax.swing.JTextField();
			txtErrorFilePath.setPreferredSize(new java.awt.Dimension(150, 19));
			txtErrorFilePath.addFocusListener(new FocusListener()
			{
				public void focusGained(FocusEvent arg0)
				{
				}
				public void focusLost(FocusEvent arg0)
				{
					String inputFilePath = txtInputFileName.getText().trim();
					String errorFilePath = txtErrorFilePath.getText().trim();
					if (errorFilePath.length() != 0 && inputFilePath.length() != 0 && !processingInProgress)
					{
						btnValidate.setEnabled(true);
					}
				}
			});
		}
		
		return txtErrorFilePath;
	}
	//added by sourabh for CIN File Upload
	
	private javax.swing.JTextField getTxtCINFilePath()
		{
			if (txtCINFileName == null)
			{
				txtCINFileName = new javax.swing.JTextField();
				txtCINFileName.setPreferredSize(new java.awt.Dimension(150, 19));
				txtCINFileName.addFocusListener(new FocusListener()
				{
					public void focusGained(FocusEvent arg0)
					{
					}
					public void focusLost(FocusEvent arg0)
					{
						String inputFilePath = txtInputFileName.getText().trim();
						String errorFilePath = txtErrorFilePath.getText().trim();
						if (errorFilePath.length() != 0 && inputFilePath.length() != 0 && !processingInProgress)
						{
							btnValidate.setEnabled(true);
						}
					}
				});
			}
			return txtCINFileName;
		}
	
	//added for consfile
	private javax.swing.JTextField getConsFileName()
	{
		if (consFileName == null)
		{
			consFileName = new javax.swing.JTextField();
			consFileName.setPreferredSize(new java.awt.Dimension(150, 19));
			consFileName.addFocusListener(new FocusListener()
			{
				public void focusGained(FocusEvent arg0)
				{
				}
				public void focusLost(FocusEvent arg0)
				{
					String inputFilePath = consFileName.getText().trim();
					String errorFilePath = consFileName.getText().trim();
					if (inputFilePath.length() != 0 && errorFilePath.length() != 0)
					{
						btnValidate.setEnabled(true);
					}
				}
			});
		}
		return consFileName;
	}
	
	
	/**
	 * This method initializes btnValidate
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getBtnValidate()
	{
		
		
		
		if (btnValidate == null)
		{
			btnValidate = new javax.swing.JButton();
			btnValidate.setText("Validate");
			btnValidate.setToolTipText("VALIDATE FILE");
			btnValidate.setPreferredSize(new java.awt.Dimension(84, 25));
			btnValidate.addActionListener(new java.awt.event.ActionListener()
			{
				public void actionPerformed(final java.awt.event.ActionEvent e)
				{
					Thread t = new Thread() {
						
						public void run() {
							
							processingInProgress = true;
							btnValidate.setEnabled(false);
							btnbrowseErrorFilePath.setEnabled(false);
							btnbrowseInputFileName.setEnabled(false);
							btnbrowseTempFileName.setEnabled(false);
							
					
					try
					{
						Object obj = ((JButton) e.getSource()).getParent().getParent().getParent().getParent();
						final MyDialog dlg = new MyDialog((JFrame) obj);
						dlg.setModal(true);
						dlg.addWindowListener(new WindowAdapter()
						{
							public void windowClosing(WindowEvent e)
							{
								dlg.setVisible(false);
							}
						});
						String tab = "^";
						//Creating the object of the Form_Validatior class////////////////
						
						//Added for FVU ver 4.8 by Akansha
						///versionCheck();
						//*******************************************						
						
						FormValidator obj_FormValidator = new FormValidator();
						PDFGenerator pdfGen = new PDFGenerator();
						FileStatistics.setCinUploadFlag(0);
						FileStatistics.setCinFileName("");	
						String inFileName = txtInputFileName.getText().trim();
						//Getting the input file name with path
						String errorFileName = txtErrorFilePath.getText().trim();
						
						String cinFileName = txtCINFileName.getText().trim(); 
						int errorCodeCIN = 0;
						//Generating the name of the error file
						String hashFileName = null;
						String statisticFileName = null;
						String pdfFileName = null;
						String temppdfFileName = null;
						String htmlErrorFileName = null;
						String userFriendlyFileBHDD = null; // to store the absolute path and name of HTML report to be generated
						String userFriendlyFileCD = null; // to store the absolute path and name of HTML report containing Challan Details if any
						String uffNamingBHDD = null; //to store the name to be assigned to HTML file of BH
						String uffNamingCD = null; //to store the name to be assigned to HTML file of CD
						File addrFile = new File(inFileName);
						String fileName = addrFile.getName();
						int errorCode = checkFileFolderName(fileName,"I");
						if(!(fileName.endsWith(".txt")||fileName.endsWith(".fvu")))
						errorCode = 6;
						if (errorCode == 0)
						{
							if(cinFileName.length() != 0)
							{	
								FileStatistics.setCinUploadFlag(1);
								File cinFile = new File(cinFileName);
								String fileNameCIN = cinFile.getName();
								FileStatistics.setCinFileName(cinFileName);
								errorCodeCIN = checkFileFolderName(fileNameCIN,"C");
								if(!fileNameCIN.endsWith(".csi"))
								{
									errorCodeCIN = 12; //sourabh
								}
								FileStatistics.setCinErrorCode(errorCodeCIN);

								  if(FileStatistics.getCinErrorCode() != 0)
								  {
		
	 
									if (errorCodeCIN == 1 || errorCodeCIN == 8)
										JOptionPane.showMessageDialog(jContentPane, errorMsgCIN_01);
									else if (errorCodeCIN == 2)
										JOptionPane.showMessageDialog(jContentPane, errorMsgCIN_02);
									else if (errorCodeCIN == 3)
										JOptionPane.showMessageDialog(jContentPane, errorMsgCIN_03);
									else if (errorCodeCIN == 5)
										JOptionPane.showMessageDialog(jContentPane, errorMsgCIN_04);
									else if (errorCodeCIN == 12)
										JOptionPane.showMessageDialog(jContentPane, errorMsgCIN_05);
			
									txtInputFileName.setText("");
									txtErrorFilePath.setText("");
									txtCINFileName.setText("");
									btnValidate.setEnabled(false);
								  }	
		 
							}
							else
							{
								FileStatistics.setCinUploadFlag(0);
								FileStatistics.setCinFileName("");
							}
						}
						File errorDir = new File(errorFileName);
						if (errorFileName.length() == 0)
							errorCode = 8;
						if (errorCode == 0&&errorCodeCIN ==0)
						{
							int i;
							int j;
							char ch;
							for (i = inFileName.length() - 1; i > -1; i--)
							{
								if ((ch = inFileName.charAt(i)) == '.')
								{
									break;
								}
							}
							if (i > 0)
							{
								for (j = i; j > -1; j--)
								{
									//if (inFileName.charAt(j) == '\\')
									//added below if for linux /window compatibility  
									if (inFileName.charAt(j) == File.separatorChar)
									{
										break;
									}
								}
							
								
								hashFileName = errorFileName + File.separator+ inFileName.substring(j + 1, i) + ".fvu";
								htmlErrorFileName = errorFileName + File.separator + inFileName.substring(j + 1, i) + "err.html";
								statisticFileName = errorFileName + File.separator + inFileName.substring(j + 1, i) + ".html";
								temppdfFileName = errorFileName + File.separator + inFileName.substring(j + 1, inFileName.length()) + "pdf.html";
								pdfFileName = errorFileName + File.separator + inFileName.substring(j + 1, inFileName.length()) + ".pdf";
								userFriendlyFileBHDD = errorFileName + File.separator + inFileName.substring(j + 1, i) + "_BH" + ".html";
								userFriendlyFileCD = errorFileName + File.separator + inFileName.substring(j + 1, i) + "_CD" + ".html";
								uffNamingBHDD = inFileName.substring(j + 1, i) + "_BH" + ".html";
								uffNamingCD = inFileName.substring(j + 1, i) + "_CD" + ".html";
								errorFileName = errorFileName + File.separator + inFileName.substring(j + 1, i) + ".err";
								System.out.println("the errorFileName is " + errorFileName + "the hashFileName is "+ hashFileName + "the htmlErrorFileName" + htmlErrorFileName);
							}
							else
							{
								for (j = (inFileName.length() - 1); j > -1; j--)
								{
									//if (inFileName.charAt(j) == '\\')
									//added below if for linux /window compatibility 
									if (inFileName.charAt(j) == File.separatorChar)
									{
										break;
									}
								}
								//commented  below  for linux /window compatibility  
//								hashFileName = errorFileName + "\\" + inFileName.substring(j + 1, inFileName.length()) + ".fvu";
//								htmlErrorFileName = errorFileName + "\\" + inFileName.substring(j + 1, inFileName.length()) + "err.html";
//								statisticFileName = errorFileName + "\\" + inFileName.substring(j + 1, inFileName.length()) + ".html";
//								temppdfFileName = errorFileName + "\\" + inFileName.substring(j + 1, inFileName.length()) + "pdf.html";
//								pdfFileName = errorFileName + "\\" + inFileName.substring(j + 1, inFileName.length()) + ".pdf";
//								userFriendlyFileBHDD = errorFileName + "\\" + inFileName.substring(j + 1, inFileName.length()) + "_BH" + ".html";
//								userFriendlyFileCD = errorFileName + "\\" + inFileName.substring(j + 1, inFileName.length()) + "_CD" + ".html";
//								uffNamingBHDD = inFileName.substring(j + 1, inFileName.length()) + "_BH" + ".html";
//								uffNamingCD = inFileName.substring(j + 1, inFileName.length()) + "_CD" + ".html";
//								errorFileName = errorFileName + "\\" + inFileName.substring(j + 1, inFileName.length()) + ".err";

								
								hashFileName = errorFileName + File.separator + inFileName.substring(j + 1, inFileName.length()) + ".fvu";
								htmlErrorFileName = errorFileName + File.separator + inFileName.substring(j + 1, inFileName.length()) + "err.html";
								statisticFileName = errorFileName + File.separator + inFileName.substring(j + 1, inFileName.length()) + ".html";
								temppdfFileName = errorFileName + File.separator + inFileName.substring(j + 1, inFileName.length()) + "pdf.html";
								pdfFileName = errorFileName + File.separator + inFileName.substring(j + 1, inFileName.length()) + ".pdf";
								userFriendlyFileBHDD = errorFileName + File.separator + inFileName.substring(j + 1, inFileName.length()) + "_BH" + ".html";
								userFriendlyFileCD = errorFileName + File.separator + inFileName.substring(j + 1, inFileName.length()) + "_CD" + ".html";
								uffNamingBHDD = inFileName.substring(j + 1, inFileName.length()) + "_BH" + ".html";
								uffNamingCD = inFileName.substring(j + 1, inFileName.length()) + "_CD" + ".html";
								errorFileName = errorFileName + File.separator + inFileName.substring(j + 1, inFileName.length()) + ".err";
							}
							errorFileName = errorFileName.replace('\\', '/');
							hashFileName = hashFileName.replace('\\', '/');
							htmlErrorFileName = htmlErrorFileName.replace('\\', '/');
							if (!(errorDir.isDirectory()))
							{
								JOptionPane.showMessageDialog(jContentPane, errorMsg_05);
								txtErrorFilePath.setText("");
							}
							else
							{
								
								if( (consFileName==null || consFileName.getText().trim().length()==0)&& Parameters.consMandatory && UPLOADTYPE_CORRECTION.equals(obj_FormValidator.getTypeOfFile(txtInputFileName.getText())))
								{
									JOptionPane.showMessageDialog(jContentPane, errorMsgCons1);
									FileGenerator fgen = new FileGenerator();
									String errText = "NA" + tab + "NA" + tab + "NA" + tab + tab + tab + T_FV_1040_C + tab + T_FV_1040_M;
									fgen.writeToFile(errorFileName, errText, 1);
									String htmlText = fgen.generateHtmlErrorFile(errText).toString();
									fgen.writeToFile(htmlErrorFileName, htmlText, 1);
									toContinue=1;
									
									
								}
								else if(consFileName!=null && consFileName.getText().trim().length()!=0 )
								{
									System.out.println("Thje cons File name is "+consFileName.getText().trim().length()); 
									isConsValid=obj_FormValidator.ValidateConsHash(consFileName.getText().trim());
									 boolean consMatched[]=obj_FormValidator.matchConsFile(inFileName);
									 if(consMatched[2]==false)
									 {
										 FileGenerator fgen = new FileGenerator();
										 String errText = "1" + tab + "NA" + tab + "NA" + tab + tab + tab + T_FV_1000_C + tab + T_FV_1000_M;
										 fgen.writeToFile(errorFileName, errText, 1);
										 String htmlText = fgen.generateHtmlErrorFile(errText).toString();
										 fgen.writeToFile(htmlErrorFileName, htmlText, 1);
										toContinue=1; 
										
									 }
									 else if(consMatched[0])
									{
										JOptionPane.showMessageDialog(jContentPane, "Consolidate file should not be provided with a regular file");
										consProvidedwitRegular=true;
										toContinue=1;
									}
									else if(!isConsValid)
									{
										//JOptionPane.showMessageDialog(jContentPane, errorMsgCons); //hashed by Abhishek on 28/12/22	
//										JOptionPane.showConfirmDialog(jContentPane,"The COnsfile Provided is not Valid..Do you wish to continue?");
										System.out.println("Inside isConsValid");
										FileGenerator fgen = new FileGenerator();
										String errText = "NA" + tab + "NA" + tab + "NA" + tab + tab + tab + T_FV_1038_C + tab + T_FV_1038_M;
										fgen.writeToFile(errorFileName, errText, 1);
										String htmlText = fgen.generateHtmlErrorFile(errText).toString();
										fgen.writeToFile(htmlErrorFileName, htmlText, 1);
										toContinue=1;
									}
									else
									{
										System.out.println("In else part of is cons valid");
										
										if(!consMatched[1])
										{
//											For Making mandatory Tocontinue will be 1 and the Dialog Box will be converted to Message dialog
//											toContinue=JOptionPane.showConfirmDialog(jContentPane,"The Consfile Provided is not matching with the File To be validated..Do you wish to continue?");
											if(Parameters.consMandatory==false)
											{
												toContinue=JOptionPane.showConfirmDialog(jContentPane,"The Consfile Provided is not matching with the File To be validated..Do you wish to continue?", "ConsolidatedFileNotMatching", JOptionPane.YES_NO_OPTION);
											}
											else
											{
												FileGenerator fgen = new FileGenerator();
												String errText = "1" + tab + "NA" + tab + "NA" + tab + tab + tab + T_FV_1039_C + tab + T_FV_1039_M;
												fgen.writeToFile(errorFileName, errText, 1);
												String htmlText = fgen.generateHtmlErrorFile(errText).toString();
												fgen.writeToFile(htmlErrorFileName, htmlText, 1);
												toContinue=1;
											}
										}
									}
									System.out.println("To Continue "+toContinue);
								}
								if(((consFileName==null ||consFileName.getText().trim().length()==0 ) || ((consFileName!=null  && consFileName.getText().trim().length()!=0) && isConsValid==true)) && toContinue==0)
								{
								if (addrFile.exists() && addrFile.length() > 0)
								{
									PrintStream  fileLogs = new PrintStream(new FileOutputStream(hashFileName+".log"));
									System.setOut(fileLogs);
									System.setErr(fileLogs);
									System.out.println(logSystemInfo());
									Calendar check = new GregorianCalendar();
									/*System.out.println("*******************************************");
									System.out.println("Earlier FVU Version 5.2.4");
									System.out.println("*******************************************");
									System.out.println("Current FVU Version 5.2.5");
									System.out.println("*******************************************");*/
									
									//Added by shruti fvu 5.4 start 
									System.out.println("*******************************************");
									System.out.println("Earlier FVU Version 5.7.0");
									System.out.println("*******************************************");
									System.out.println("Current FVU Version 5.8.0");
									System.out.println("*******************************************");
									System.out.println("Current FVU Version 5.9.0");
									System.out.println("*******************************************");
									//Added by shruti fvu 5.4 end
									System.out.println("Current FVU Version 6.0.0");
									System.out.println("*******************************************");
									
									System.out.println("Current FVU Version 6.1.0"); // added by jacky for fvu 6.1
									System.out.println("*******************************************");
									
									System.out.println("Current FVU Version 6.2.0"); // added by jacky for fvu 6.1
									System.out.println("*******************************************");
									
									
									System.out.println("Current FVU Version 6.3.0"); // Added by Puja for FVU 6.3
									System.out.println("*******************************************");
									
									System.out.println("Current FVU Version 6.4.0"); // Added by Puja for FVU 6.4
									System.out.println("*******************************************");
									
									System.out.println("Current FVU Version 6.5.0");//Changes added for 6.5_2.161_2.1293 by Puja
									System.out.println("*******************************************");
									
									System.out.println("Current FVU Version 6.6.0");//Changes added for 6.6_2.162_2.1294 by Puja
									System.out.println("*******************************************");
									
									System.out.println("Current FVU Version 6.7.0");//Changes added for 6.7_2.163_2.1295 by puja								
									System.out.println("*******************************************");
									
									System.out.println("Current FVU Version 6.8.0");//Changes added for 6.8_2.164_2.1296 by puja								
									System.out.println("*******************************************");
									
									System.out.println("Current FVU Version 6.9.0");//Changes added for 6.9_2.165_2.1297 by puja								
									System.out.println("*******************************************");
									
									System.out.println("Current FVU Version 7.0.0");//Changes added for 7.0_2.166_2.1298 by Vinita								
									System.out.println("*******************************************");
									
									System.out.println("Current FVU Version 7.1.0");//Changes added for 7.1_2.167_2.1299 by Vinita								
									System.out.println("*******************************************");
									
									System.out.println("Current FVU Version 7.2.0");//Changes added for 7.2_2.168_2.1300 by Vinita								
									System.out.println("*******************************************");
									System.out.println("Current FVU Version 7.3.0");//FVU 7.2 VersionChange Production problem							
									System.out.println("*******************************************");
									
									System.out.println("Current FVU Version 7.5.0");//Changes added for 7.5_2.171_2.1303 by Kiran								
									System.out.println("*******************************************");
									
									System.out.println("STARTING FORMAT VALIDATION");
									obj_FormValidator.readFile(inFileName, errorFileName, utilityLevel);
									check = new GregorianCalendar();
									System.out.println("END OF FORMAT VALIDATION");
									if (obj_FormValidator.obj_StringBuffer.errorBufferString.length() == 0)
									{
										System.out.println("Field validation is successfull now starting hash validation");
										Hash hash = new Hash();
										boolean paperReturnFileGenerated = false;
										boolean paperRetWarFile = false;
										boolean electronicRetWarFile = false;
										int paperReturnIndiFlag = 0;
										check = new GregorianCalendar();
										System.out.println("BEFORE HASHING CALLED::::::"+check.getTime());
										int hashError = hash.startProcessing(inFileName, hashFileName, utilityLevel, fhFieldCountTds, paperReturnIndiFlag);
										check = new GregorianCalendar();
										System.out.println("AFTER HASHING CALLED::::"+check.getTime());
										System.out.println("Return Hash Code = " + hashError);
										
										/* Barcode start*/
										String barcode = searchbarcode(hashFileName);
										//Changes added for 6.5_2.161_2.1293 by Puja
										Pattern digitPattern = Pattern.compile("\\d{20}");
										if(barcode.length() !=20 || barcode == ""|| !digitPattern.matcher(barcode).matches()) {
											if(hashError ==0) {
												hashError=17;
											}
											System.out.println("Barcode is missing");
											
											File ferr2 = new File(hashFileName);
											if(ferr2.exists()) {
												ferr2.delete();							
												System.out.println("fvu file is deleted as barcode is missing.");
											}
										}else {
											System.out.println("Barcode is present");
										}
										/* Barcode end */
										
										if (hashError == 0)
										{
											System.out.println("Hash Validation is sucessfull now started generating file");
											FileGenerator obj_FileGenerator = new FileGenerator();
											
											//String hashFileLocation = hashFileName.substring(0, hashFileName.lastIndexOf("/"));
											
											//added below line to for linux /window compatibility start  
											File hashFileLocationPath = new File(hashFileName);	
											String hashFileLocation = hashFileLocationPath.getAbsolutePath().substring(0,  hashFileLocationPath.getAbsolutePath().lastIndexOf(File.separator));
											//added below line to for linux /window compatibility end
											
											obj_FileGenerator.generateStatisticFile(obj_FormValidator, statisticFileName, fileName, TDSFVUVersion);
											System.out.println("Statistics file is created");
											/**
											 * Code to call the method which will generate the User Friendly file 
											 * Containing data populated as in case of paper return
											 */
											//Added by Shalin for FVU 4.1 (for generation of Form 27A)
											boolean pdfbool=false;
											if(consFileName.getText().trim()!=null)
											{
												pdfbool=pdfGen.generatePDFFile(inFileName,pdfFileName,temppdfFileName,consFileName.getText().trim());
											}
											else
											{
												pdfbool=pdfGen.generatePDFFile(inFileName,pdfFileName,temppdfFileName,"");
											}
											System.out.println("pdf generated"+pdfbool);
											boolean reportGenerated = false;
											ReportGenerator rep = new ReportGenerator();
											long l1 = System.currentTimeMillis();
											//Commented for fvu 5.0 (actually it was commented already when it called through fvu)
											//			reportGenerated = rep.generateHtmlReport(inFileName, userFriendlyFileBHDD, userFriendlyFileCD,uffNamingBHDD,uffNamingCD);
											long l2 = System.currentTimeMillis();
//											System.out.println("TIME Taken to Generate Report in milisec = " + (l2 - l1));

											if (obj_FormValidator.obj_StringBuffer.panStatFileOpened)
											{
												/* If the PAN Statistics HTML File is already Opened then, 
													1. We DO NOT append the PAN Statistic Header
													2. We append the remaining panStat Data in File
													3. We append the HTML File Footer 
												*/
												String panStatFileName = errorFileName.substring(0, (errorFileName.length() - 4)) + STATISTICS_FILE_EXT;
												StringBuffer panStatTableString = new StringBuffer();
												panStatTableString.append(obj_FormValidator.obj_StringBuffer.panStatBufferString.toString());
												panStatTableString.append(obj_FileGenerator.createPANStatTableStructureEnd(fileName));
												panStatTableString.append(obj_FileGenerator.createPANStatFileFooter());
												obj_FileGenerator.writeToFile(panStatFileName, panStatTableString.toString(), 0, true);
											}
											else if (!obj_FormValidator.obj_StringBuffer.panStatFileOpened && (obj_FormValidator.obj_StringBuffer.getPanCounter() > 0))
											{
												/* If the PAN Statistics HTML File is already Opened then, 
													1. We WILL append the HTML File PAN Header
													2. We append the remaining panStat Data in File
													3. We append the HTML File PAN Footer 
												*/
												String panStatFileName = errorFileName.substring(0, (errorFileName.length() - 4)) + STATISTICS_FILE_EXT;
												StringBuffer panStatTableString = new StringBuffer();
												panStatTableString.append(obj_FormValidator.obj_StringBuffer.panStatBufferString.toString());
												panStatTableString.append(obj_FileGenerator.createPANStatTableStructureEnd(fileName));
												panStatTableString.append(obj_FileGenerator.createPANStatFileFooter());
												obj_FileGenerator.writeToFile(panStatFileName, panStatTableString.toString(), 0, false);
											}
											/*
											 * If the count of Paper Return warnings ie 'warningCount' greater than 0
											 * then we will generate Warning File for Paper Return
											 */
											if ((obj_FormValidator.obj_StringBuffer.getWarningCount() > 0))
											{
												paperReturnFileGenerated = true;
												if (obj_FormValidator.obj_StringBuffer.paperRetWarFileOpened)
												{
													String paperRetunWarningFileName = errorFileName.substring(0, (errorFileName.length() - 4)) + PAPER_RET_WAR_FILE_EXT;
													boolean appedHtmlErrorFileHeader = false;
													boolean appedHtmlErrorFileFooter = true;
													paperRetWarFile = true;
													electronicRetWarFile = false;
													StringBuffer htmlWarningFileStringBuffer =
														obj_FileGenerator.generateHtmlErrorFile(
															obj_FormValidator.obj_StringBuffer.warningBufferStringPaperReturn.toString(),
															appedHtmlErrorFileHeader,
															appedHtmlErrorFileFooter,
															paperRetWarFile,
															fileName,
															electronicRetWarFile);
													obj_FileGenerator.writeToFile(
														paperRetunWarningFileName,
														htmlWarningFileStringBuffer.toString(),
														0,
														obj_FormValidator.obj_StringBuffer.paperRetWarFileOpened);
												}
												else
												{
													String paperRetunWarningFileName = errorFileName.substring(0, (errorFileName.length() - 4)) + PAPER_RET_WAR_FILE_EXT;
													boolean appedHtmlErrorFileHeader = true;
													boolean appedHtmlErrorFileFooter = true;
													paperRetWarFile = true;
													electronicRetWarFile = false;
													StringBuffer htmlWarningFileStringBuffer =
														obj_FileGenerator.generateHtmlErrorFile(
															obj_FormValidator.obj_StringBuffer.warningBufferStringPaperReturn.toString(),
															appedHtmlErrorFileHeader,
															appedHtmlErrorFileFooter,
															paperRetWarFile,
															fileName,
															electronicRetWarFile);
													obj_FileGenerator.writeToFile(
														paperRetunWarningFileName,
														htmlWarningFileStringBuffer.toString(),
														0,
														obj_FormValidator.obj_StringBuffer.paperRetWarFileOpened);
												}
											}

											//Added by Nahush for validating Deductor PAN against PAN of deductee.
											/*
											 * If the count of Electronic Return warnings ie 'warningCount' greater than 0
											 * then we will generate Warning File for Electronic Return
											 */
											
											
											if ((obj_FormValidator.obj_StringBuffer.getElecWarningCount() > 0))
											{
												paperReturnFileGenerated = true;
												if (obj_FormValidator.obj_StringBuffer.electronicRetWarFileOpened)
												{
													String electronicReturnWarningFileName = errorFileName.substring(0, (errorFileName.length() - 4)) + ELECTRONIC_RET_WAR_FILE_EXT;
													boolean appedHtmlErrorFileHeader = false;
													boolean appedHtmlErrorFileFooter = true;
													paperRetWarFile = false;
													electronicRetWarFile = true;
													StringBuffer htmlWarningFileStringBuffer =
														obj_FileGenerator.generateHtmlErrorFile(
															obj_FormValidator.obj_StringBuffer.warningBufferStringElectronicReturn.toString(),
															appedHtmlErrorFileHeader,
															appedHtmlErrorFileFooter,
															paperRetWarFile,
															fileName,
															electronicRetWarFile);
													obj_FileGenerator.writeToFile(
															electronicReturnWarningFileName,
														htmlWarningFileStringBuffer.toString(),
														0,
														obj_FormValidator.obj_StringBuffer.electronicRetWarFileOpened);
												}
												else
												{
													String electronicReturnWarningFileName = errorFileName.substring(0, (errorFileName.length() - 4)) + ELECTRONIC_RET_WAR_FILE_EXT;
													boolean appedHtmlErrorFileHeader = true;
													boolean appedHtmlErrorFileFooter = true;
													paperRetWarFile = false;
													electronicRetWarFile = true;
													StringBuffer htmlWarningFileStringBuffer =
														obj_FileGenerator.generateHtmlErrorFile(
															obj_FormValidator.obj_StringBuffer.warningBufferStringElectronicReturn.toString(),
															appedHtmlErrorFileHeader,
															appedHtmlErrorFileFooter,
															paperRetWarFile,
															fileName,
															electronicRetWarFile);
													obj_FileGenerator.writeToFile(
															electronicReturnWarningFileName,
														htmlWarningFileStringBuffer.toString(),
														0,
														obj_FormValidator.obj_StringBuffer.electronicRetWarFileOpened);												
												}
												
											}
											
											
											
											
											
											Calendar cal22 = new GregorianCalendar();
											System.out.println("END TIME : " + cal22.getTime());
											System.out.println("Eobj_FormValidator.obj_StringBuffer.getPanCounter()" + obj_FormValidator.obj_StringBuffer.getPanCounter());
											
											System.out.println("reportGenerated" + reportGenerated);
											System.out.println("paperRetWarFile : " +paperRetWarFile);
											
											if (obj_FormValidator.obj_StringBuffer.getPanCounter() > 0)
											{
												if (paperReturnFileGenerated)
												{
													if (reportGenerated)
													{
														if (paperRetWarFile)
														{
															JOptionPane.showMessageDialog(
																	jContentPane,
																	"File validated successfully at the path " + hashFileLocation +".\r\n Please submit .FVU file in PENDRIVE/CD and duly signed physical Form 27A generated through FVU at TIN Facilitation Centers.");
														System.out.println("the path for the file location is " + hashFileLocation);
														//added by nik for fvu 4.7	
															dfunc.Dialog();
														//ended by nik for fvu 4.7	
															// added for FVU 4.8
														if (obj_FormValidator.getRpuType().contains("Protean"))  //FVU 7.6 BUG FIX
														createCustomDialogPopup(); //Rahul Feedback FVU 7.5
															dirToOpenFunc();
															//end for FVU 4.8
														}
														else if (electronicRetWarFile)
															{
															JOptionPane.showMessageDialog(
																	jContentPane,
																	"File validated successfully at the path " + hashFileLocation +".\r\n Please submit .FVU file in PENDRIVE/CD and duly signed physical Form 27A generated through FVU at TIN Facilitation Centers.");
																System.out.println("the path for the file location is " + hashFileLocation);
														     //added by nik for fvu 4.7	
																dfunc.Dialog();
															//ended by nik for fvu 4.7
																// added for FVU 4.8
																if (obj_FormValidator.getRpuType().contains("Protean"))  //FVU 7.6 BUG FIX
																createCustomDialogPopup(); //Rahul Feedback FVU 7.5
																dirToOpenFunc();
																//end for FVU 4.8
															}	
													}
													else
													{

														if (paperRetWarFile)
															{
															JOptionPane.showMessageDialog(
																	jContentPane,
																	"File validated successfully at the path " + hashFileLocation +".\r\n Please submit .FVU file in PENDRIVE/CD and duly signed physical Form 27A generated through FVU at TIN Facilitation Centers.");
																System.out.println("the path for the file location is " + hashFileLocation);
													       //added by nik for fvu 4.7	
																dfunc.Dialog();
															//ended by nik for fvu 4.7
																// added for FVU 4.8
																if (obj_FormValidator.getRpuType().contains("Protean"))  //FVU 7.6 BUG FIX
																createCustomDialogPopup(); //Rahul Feedback FVU 7.5
																dirToOpenFunc();
																
																//end for FVU 4.8
															}
															else if (electronicRetWarFile)
																{
																JOptionPane.showMessageDialog(
																		jContentPane,
																		"File validated successfully at the path " + hashFileLocation +".\r\n Please submit .FVU file in PENDRIVE/CD and duly signed physical Form 27A generated through FVU at TIN Facilitation Centers.");
																	System.out.println("the path for the file location is " + hashFileLocation); 
															      //added by nik for fvu 4.7	
																	dfunc.Dialog();
																//ended by nik for fvu 4.7	
																	// added for FVU 4.8
																	if (obj_FormValidator.getRpuType().contains("Protean"))  //FVU 7.6 BUG FIX
																	createCustomDialogPopup(); //Rahul Feedback FVU 7.5
																	dirToOpenFunc();
																	//end for FVU 4.8
														          }	
													}
												}
												else
												{
													if (reportGenerated)
													{
														JOptionPane.showMessageDialog(
																jContentPane,
																"File validated successfully at the path " + hashFileLocation +".\r\n Please submit .FVU file in PENDRIVE/CD and duly signed physical Form 27A generated through FVU at TIN Facilitation Centers.");
														System.out.println("the path for the file location is " + hashFileLocation);
										        		//added by nik for fvu 4.7
														dfunc.Dialog();
													//ended by nik for fvu 4.7	
														// added for FVU 4.8
														if (obj_FormValidator.getRpuType().contains("Protean"))  //FVU 7.6 BUG FIX
														createCustomDialogPopup(); //Rahul Feedback FVU 7.5
														dirToOpenFunc();
														//end for FVU 4.8
													}
													else
													{
														JOptionPane.showMessageDialog(
																jContentPane,
																"File validated successfully at the path " + hashFileLocation +".\r\n Please submit .FVU file in PENDRIVE/CD and duly signed physical Form 27A generated through FVU at TIN Facilitation Centers.");
														System.out.println("the path for the file location is " + hashFileLocation);
														//added by nik for fvu 4.7
														dfunc.Dialog();
													//ended by nik for fvu 4.7	
														// added for FVU 4.8
														if (obj_FormValidator.getRpuType().contains("Protean"))  //FVU 7.6 BUG FIX
														createCustomDialogPopup(); //Rahul Feedback FVU 7.5
														dirToOpenFunc();
														//end for FVU 4.8
													}
												}
											}
											else
											{
												if (paperReturnFileGenerated)
												{
													if (reportGenerated)
													{
								
														if (paperRetWarFile)
															{
															JOptionPane.showMessageDialog(
																	jContentPane,
																	"File validated successfully at the path " + hashFileLocation +".\r\n Please submit .FVU file in PENDRIVE/CD and duly signed physical Form 27A generated through FVU at TIN Facilitation Centers.");
																dfunc.Dialog();
															//ended by nik for fvu 4.7	
																// added for FVU 4.8
																if (obj_FormValidator.getRpuType().contains("Protean"))  //FVU 7.6 BUG FIX
																createCustomDialogPopup(); //Rahul Feedback FVU 7.5
																dirToOpenFunc();
																//end for FVU 4.8
															}
															else if (electronicRetWarFile)
																{
																JOptionPane.showMessageDialog(
																		jContentPane,
																		"File validated successfully at the path " + hashFileLocation +".\r\n Please submit .FVU file in PENDRIVE/CD and duly signed physical Form 27A generated through FVU at TIN Facilitation Centers.");
																		dfunc.Dialog();
																	//ended by nik for fvu 4.7
																		// added for FVU 4.8
																		if (obj_FormValidator.getRpuType().contains("Protean"))  //FVU 7.6 BUG FIX
																		createCustomDialogPopup(); //Rahul Feedback FVU 7.5
																		dirToOpenFunc();
																		//end for FVU 4.8
																}	
														
													}
													else
													{
														if (paperRetWarFile)
															{
															JOptionPane.showMessageDialog(
																	jContentPane,
																	"File validated successfully at the path " + hashFileLocation +".\r\n Please submit .FVU file in PENDRIVE/CD and duly signed physical Form 27A generated through FVU at TIN Facilitation Centers.");
																dfunc.Dialog();
															//ended by nik for fvu 4.7	
																// added for FVU 4.8
																if (obj_FormValidator.getRpuType().contains("Protean"))  //FVU 7.6 BUG FIX
																createCustomDialogPopup(); //Rahul Feedback FVU 7.5
																dirToOpenFunc();
																//end for FVU 4.8
															}
															else if (electronicRetWarFile)
																{
																JOptionPane.showMessageDialog(
																		jContentPane,
																		"File validated successfully at the path " + hashFileLocation +".\r\n Please submit .FVU file in PENDRIVE/CD and duly signed physical Form 27A generated through FVU at TIN Facilitation Centers.");
																		dfunc.Dialog();
																    //ended by nik for fvu 4.7	
																		// added for FVU 4.8
																		if (obj_FormValidator.getRpuType().contains("Protean"))  //FVU 7.6 BUG FIX
																		createCustomDialogPopup(); //Rahul Feedback FVU 7.5
																		dirToOpenFunc();
																		//end for FVU 4.8
																}	
													}
												}
												else
												{
													if (reportGenerated)
													{
														JOptionPane.showMessageDialog(
																jContentPane,
																"File validated successfully at the path " + hashFileLocation +".\r\n Please submit .FVU file in PENDRIVE/CD and duly signed physical Form 27A generated through FVU at TIN Facilitation Centers.");
														dfunc.Dialog();
													//ended by nik for fvu 4.7
														if (obj_FormValidator.getRpuType().contains("Protean"))  //FVU 7.6 BUG FIX
														createCustomDialogPopup(); //Rahul Feedback FVU 7.5
														dirToOpenFunc();
													}
													else
													{
														JOptionPane.showMessageDialog(
																jContentPane,
																"File validated successfully at the path " + hashFileLocation +".\r\n Please submit .FVU file in PENDRIVE/CD and duly signed physical Form 27A generated through FVU at TIN Facilitation Centers.");
														dfunc.Dialog();
													//ended by nik for fvu 4.7
														// added for FVU 4.8
														System.out
																.println("calling method");
														if (obj_FormValidator.getRpuType().contains("Protean"))  //FVU 7.6 BUG FIX
														createCustomDialogPopup(); //Rahul Feedback FVU 7.5
														dirToOpenFunc();
														//end for FVU 4.8
													}
												}
											}
										}
										else if (hashError != 0)
										{
											FileGenerator obj_FileGenerator = new FileGenerator();
											StringBuffer FH_obj_StringBuffer = new StringBuffer();
											int lineNumber = hash.getRecordNumber();
											/*
											ErrorVal	Remarks
											------------------------
											0		Success (no errors)
											1		Input File not found
											2		Invalid Input File (
																i. Empty record found 
																ii. At FVU file is having sam/scm info 
																iii. At svu uploadedby is not TFC and file is having sam/scm info
															   )
											3		FVU Version is either Incorrect or NULL
											4		SAM Version is either Incorrect or NULL
											5		SCM Version is either Incorrect or NULL
											6		File Header Record Hash Code mismatch
											7		Record Level Hash Code mismatch
											8		Input File format Error (also if mismatch of number of in the input file.
																For a new file the last char in a record should be '^', 
																and for a file that is already hashed the last character should not be '^')
											9		Mismatch of FVU File Level HashCode
											10		Mismatch of SAM File Level HashCode
											11		Mismatch of SCM File Level HashCode
											12		Unknown Error. Exception occured
											13      CIN File is hashing is not proper
											14      CIN File Not Found
											15      Empty Record in CIN File
											16      Number of challan is not matched in cin file with cin header
											17      barcode is missing
											*/
											if (hashError == 3)
											{
												FH_obj_StringBuffer.append("1" + tab + "NA" + tab + "NA" + tab + tab + tab + T_FV_1021_C + tab + T_FV_1021_M);
											}
											else if (hashError == 4)
											{
												FH_obj_StringBuffer.append("1" + tab + "NA" + tab + "NA" + tab + tab + tab + T_FV_1024_C + tab + T_FV_1024_M);
											}
											else if (hashError == 5)
											{
												FH_obj_StringBuffer.append("1" + tab + "NA" + tab + "NA" + tab + tab + tab + T_FV_1025_C + tab + T_FV_1025_M);
											}
											else if (hashError == 9)
											{
												FH_obj_StringBuffer.append("1" + tab + "NA" + tab + "NA" + tab + tab + tab + T_FV_1026_C + tab + T_FV_1026_M);
											}
											else if (hashError == 10)
											{
												FH_obj_StringBuffer.append("1" + tab + "NA" + tab + "NA" + tab + tab + tab + T_FV_1027_C + tab + T_FV_1027_M);
											}
											else if (hashError == 11)
											{
												FH_obj_StringBuffer.append("1" + tab + "NA" + tab + "NA" + tab + tab + tab + T_FV_1028_C + tab + T_FV_1028_M);
											}
											//Added by sourabh
											else if (hashError == 13)
											{
												FH_obj_StringBuffer.append("NA" + tab + "NA" + tab + "NA" + tab + tab + tab + T_FV_1029_C + tab + T_FV_1029_M);
											}
											else if (hashError == 14)
											{
												FH_obj_StringBuffer.append("NA" + tab + "NA" + tab + "NA" + tab + tab + tab + T_FV_1030_C + tab + T_FV_1030_M);
											}
											else if (hashError == 15)
											{
												FH_obj_StringBuffer.append("NA" + tab + "NA" + tab + "NA" + tab + tab + tab + T_FV_1031_C + tab + T_FV_1031_M);
											}
											else if (hashError == 16)
											{
												FH_obj_StringBuffer.append("NA" + tab + "NA" + tab + "NA" + tab + tab + tab + T_FV_1032_C + tab + T_FV_1032_M);
											}
											else if (hashError == 17)
											{
											    FH_obj_StringBuffer.append("NA" + tab + "NA" + tab + "NA" + tab + tab + tab + T_FV_1044_C + tab + T_FV_1044_M);
											}
											//Added for FVU 7.1 // Obs no 1 - FVU 7.1 - Vinita
											else if (hashError == 18)
											{
												FH_obj_StringBuffer.append("1" + tab + "NA" + tab + "NA" + tab + tab + tab + T_FV_6202_C + tab + T_FV_6202_M);
											}
											else
											{
												FH_obj_StringBuffer.append(lineNumber + tab + "NA" + tab + "NA" + tab + "NA" + tab + "NA" + tab + T_FV_1022_C + tab + T_FV_1022_M);
											}
											obj_FileGenerator.writeToFile(errorFileName, FH_obj_StringBuffer.toString(), 0, obj_FormValidator.obj_StringBuffer.fileOpened);
											boolean appedHtmlErrorFileHeader = true;
											boolean appedHtmlErrorFileFooter = true;
											paperRetWarFile = false;
											electronicRetWarFile = false;
											StringBuffer htmlErrorFileStringBuffer =
												obj_FileGenerator.generateHtmlErrorFile(FH_obj_StringBuffer.toString(), appedHtmlErrorFileHeader, appedHtmlErrorFileFooter, paperRetWarFile, fileName,electronicRetWarFile);
											obj_FileGenerator.writeToFile(htmlErrorFileName, htmlErrorFileStringBuffer.toString(), 0, obj_FormValidator.obj_StringBuffer.fileOpened);
											// Deleting PAN Statistics Report if Generated
											String panStatFileName = errorFileName.substring(0, (errorFileName.length() - 4)) + STATISTICS_FILE_EXT;
											File panStatFile = new File(panStatFileName);
											if (panStatFile.exists())
											{
												panStatFile.delete();
											}
											// PAN Statistics Report Deleted
											// Deleting Paper Return warning File if Generated
											String paperRetWarFileName = errorFileName.substring(0, (errorFileName.length() - 4)) + PAPER_RET_WAR_FILE_EXT;
											File paperReturnWarFile = new File(paperRetWarFileName);
											if (paperReturnWarFile.exists())
											{
												paperReturnWarFile.delete();
											}
											// Deleting Paper Return warning File DELETED
											String electronicRetWarFileName = errorFileName.substring(0, (errorFileName.length() - 4)) + ELECTRONIC_RET_WAR_FILE_EXT;
											File electronicReturnWarFile = new File(electronicRetWarFileName);
											if (electronicReturnWarFile.exists())
											{
												electronicReturnWarFile.delete();
											}

											
											Calendar cal22 = new GregorianCalendar();
											System.out.println("END TIME : " + cal22.getTime());
											JOptionPane.showMessageDialog(
												jContentPane,
												"Errors Found during Validation.\r\nError File and HTML Error File Generated\r\nOpen " + htmlErrorFileName + " for details");
											// added by faizan for FVU 4.8
											File htmlFile = new File(htmlErrorFileName);
											try {
												Desktop.getDesktop().browse(htmlFile.toURI());
											} catch (IOException e) {
												// TODO Auto-generated catch block
												e.printStackTrace();
											}
											// ended for FVU 4.8
										}
									}
									else
									{
										FileGenerator obj_FileGenerator = new FileGenerator();
										StringBuffer htmlErrorFileStringBuffer = null;
										if (obj_FormValidator.obj_StringBuffer.fileOpened)
										{
											boolean appedHtmlErrorFileHeader = false;
											boolean appedHtmlErrorFileFooter = true;
											boolean paperRetWarFile = false;
											boolean electronicRetWarFile = false;
											//Nahush
											//obj_FileGenerator.parseCurrentUploadType(obj_FormValidator);
											
											htmlErrorFileStringBuffer =
												obj_FileGenerator.generateHtmlErrorFile(
													obj_FormValidator.obj_StringBuffer.errorBufferString.toString(),
													appedHtmlErrorFileHeader,
													appedHtmlErrorFileFooter,
													paperRetWarFile,
													fileName,
													electronicRetWarFile);
											obj_FileGenerator.writeToFile(htmlErrorFileName, htmlErrorFileStringBuffer.toString(), 0, obj_FormValidator.obj_StringBuffer.fileOpened);
										}
										else
										{
											boolean appedHtmlErrorFileHeader = true;
											boolean appedHtmlErrorFileFooter = true;
											boolean paperRetWarFile = false;
											boolean electronicRetWarFile = false;
//											Nahush

											//obj_FileGenerator.parseCurrentUploadType(obj_FormValidator);											
											
											htmlErrorFileStringBuffer =
												obj_FileGenerator.generateHtmlErrorFile(
													obj_FormValidator.obj_StringBuffer.errorBufferString.toString(),
													appedHtmlErrorFileHeader,
													appedHtmlErrorFileFooter,
													paperRetWarFile,
													fileName,
													electronicRetWarFile);
											obj_FileGenerator.writeToFile(htmlErrorFileName, htmlErrorFileStringBuffer.toString(), 0, obj_FormValidator.obj_StringBuffer.fileOpened);
										}
										// Deleting PAN Statistics Report if Generated
										String panStatFileName = errorFileName.substring(0, (errorFileName.length() - 4)) + STATISTICS_FILE_EXT;
										File panStatFile = new File(panStatFileName);
										if (panStatFile.exists())
										{
											panStatFile.delete();
										}
										// PAN Statistics Report Deleted
										// Deleting Paper Return warning File if Generated
										String paperRetWarFileName = errorFileName.substring(0, (errorFileName.length() - 4)) + PAPER_RET_WAR_FILE_EXT;
										File paperReturnWarFile = new File(paperRetWarFileName);
										if (paperReturnWarFile.exists())
										{
											paperReturnWarFile.delete();
										}
										// Deleting Paper Return warning File DELETED
										
										String electronicRetWarFileName = errorFileName.substring(0, (errorFileName.length() - 4)) + ELECTRONIC_RET_WAR_FILE_EXT;
										File electronicReturnWarFile = new File(electronicRetWarFileName);
										if (electronicReturnWarFile.exists())
										{
											electronicReturnWarFile.delete();
										}

										
										Calendar cal22 = new GregorianCalendar();
										System.out.println("END TIME : " + cal22.getTime());
										JOptionPane.showMessageDialog(
											jContentPane,
											"Errors Found during Validation.\r\nError File and HTML Error File Generated\r\nOpen " + htmlErrorFileName + " for details");
										// added by faizan for FVU 4.8
										File htmlFile = new File(htmlErrorFileName);
										try {
											Desktop.getDesktop().browse(htmlFile.toURI());
										} catch (IOException e) {
											// TODO Auto-generated catch block
											e.printStackTrace();
										}
										// ended for FVU 4.8
									}
									txtInputFileName.setText("");
									txtErrorFilePath.setText("");
									if(cinFileName.length() != 0)
									{
										txtCINFileName.setText("");
									}
									btnValidate.setEnabled(false);
								} //END  if (addrFile.exists() && addrFile.length()>0)
								else
								{
									FileGenerator obj_FileGenerator = new FileGenerator();
									StringBuffer FH_obj_StringBuffer = new StringBuffer();
									FH_obj_StringBuffer.append("-" + tab + "NA" + tab + "NA" + tab + "NA" + tab + "NA" + tab + T_FV_1020_C + tab + T_FV_1020_M);
									obj_FileGenerator.writeToFile(errorFileName, FH_obj_StringBuffer.toString(), 0, obj_FormValidator.obj_StringBuffer.fileOpened);
									boolean appedHtmlErrorFileHeader = true;
									boolean appedHtmlErrorFileFooter = true;
									boolean paperRetWarFile = false;
									boolean electronicRetWarFile = false;
									StringBuffer htmlErrorFileStringBuffer =
										obj_FileGenerator.generateHtmlErrorFile(FH_obj_StringBuffer.toString(), appedHtmlErrorFileHeader, appedHtmlErrorFileFooter, paperRetWarFile, fileName,electronicRetWarFile);
									obj_FileGenerator.writeToFile(htmlErrorFileName, htmlErrorFileStringBuffer.toString(), 0, obj_FormValidator.obj_StringBuffer.fileOpened);
									// Deleting PAN Statistics Report if Generated
									String panStatFileName = errorFileName.substring(0, (errorFileName.length() - 4)) + STATISTICS_FILE_EXT;
									File panStatFile = new File(panStatFileName);
									if (panStatFile.exists())
									{
										panStatFile.delete();
									}
									// PAN Statistics Report Deleted
									JOptionPane.showMessageDialog(
										jContentPane,
										"Errors Found during Validation.\r\nError File and HTML Error File Generated\r\nOpen " + htmlErrorFileName + " for details");
									// added by faizan for FVU 4.8
									File htmlFile = new File(htmlErrorFileName);
									try {
										Desktop.getDesktop().browse(htmlFile.toURI());
									} catch (IOException e) {
										// TODO Auto-generated catch block
										e.printStackTrace();
									}
									// ended for FVU 4.8
									txtInputFileName.setText("");
									txtErrorFilePath.setText("");
									if(cinFileName.length() != 0)
									{
										txtCINFileName.setText("");
									}
									btnValidate.setEnabled(false);
								}
								
							}
								else if(toContinue==1)
								{
								  if(consProvidedwitRegular)
								  {
									 System.out.println("The cons providedwitregular is"+consProvidedwitRegular); 
								  }
								  else
								  {
								  JOptionPane.showMessageDialog(null, "Errors Found during Validation.\r\nError File and HTML Error File Generated\r\nOpen " + htmlErrorFileName + " for details");
								// added by faizan for FVU 4.8
									File htmlFile = new File(htmlErrorFileName);
									try {
										Desktop.getDesktop().browse(htmlFile.toURI());
									} catch (IOException e) {
										// TODO Auto-generated catch block
										e.printStackTrace();
									}
									// ended for FVU 4.8
								  
								  }
								}
								}
						}
						else
						{
							if (errorCode == 1 || errorCode == 8)
								JOptionPane.showMessageDialog(jContentPane, errorMsg_01);
							else if (errorCode == 2)
								JOptionPane.showMessageDialog(jContentPane, errorMsg_02);
							else if (errorCode == 3)
								JOptionPane.showMessageDialog(jContentPane, errorMsg_03);
							else if (errorCode == 5)
								JOptionPane.showMessageDialog(jContentPane, errorMsg_04);
							else if (errorCode == 6)
							JOptionPane.showMessageDialog(jContentPane, errorMsg_06);	
							txtInputFileName.setText("");
							txtErrorFilePath.setText("");
							if(cinFileName.length() != 0)
							{
								txtCINFileName.setText("");
							}
							btnValidate.setEnabled(false);
						}
					}
					catch (Exception e2) {
						
						JOptionPane.showMessageDialog(jContentPane, "Unexpected error occured please check the log file.");	
						System.out.println("Exception in  actionPerformed method  : "); e2.printStackTrace();
					}
					finally
					{
						txtInputFileName.setText("");
						txtErrorFilePath.setText("");
						consFileName.setText("");
						btnValidate.setEnabled(false);
						toContinue=0;
						consProvidedwitRegular=false;
						
					}
					btnbrowseErrorFilePath.setEnabled(true);
					btnbrowseInputFileName.setEnabled(true);
					btnbrowseErrorFilePath.setEnabled(true);
					btnbrowseTempFileName.setEnabled(true);
					processingInProgress = false;
					
					
						}
					};
					
					t.start();
				}
			});
		}
		return btnValidate;
	}
	
	//Added newly for FVU version 4.8 by Akansha
	public static void versionCheck() {
		// added for FVU 4.8
	ProxyValidator validateProxy = new ProxyValidator();
	boolean val1 = false;
	try {
		val1 = validateProxy.VersionVal1();
	} catch (KeyManagementException e1) {
		// TODO Auto-generated catch block
		e1.printStackTrace();
	} catch (NoRouteToHostException e1) {
		// TODO Auto-generated catch block
		e1.printStackTrace();
	} catch (NoSuchAlgorithmException e1) {
		// TODO Auto-generated catch block
		e1.printStackTrace();
	} catch (IOException e1) {
		// TODO Auto-generated catch block
		e1.printStackTrace();
	}
		System.out.println("the proxy validator is "+val1);
		boolean flag = false;
		if (val1){
		VersionValidator obj_VersionValidator = new VersionValidator();
		String latestVersions = "";
		try {
			latestVersions = obj_VersionValidator.VersionVal();

			if (latestVersions != null) {
				StringTokenizer st = new StringTokenizer(
						latestVersions, "^");
				String FVU_Electronic_after201011 = "";
				String FVU_Electronic_before201011 = "";
				String FVU_Paper = null;

				int k = 0;
				while (st.hasMoreElements()) {

					if (k == 0) {
						FVU_Electronic_after201011 = st
								.nextToken();
					} else if (k == 1) {
						FVU_Electronic_before201011 = st
								.nextToken();
					} else if (k == 2) {
						FVU_Paper = st.nextToken();
					}

					k++;

				}

				System.out
						.println("FVU_Electronic_after201011"
								+ FVU_Electronic_after201011);
				System.out
						.println("FVU_Electronic_before201011"
								+ FVU_Electronic_before201011);
				System.out.println("FVU_Paper" + FVU_Paper);
				if(!"".equals(FVU_Electronic_after201011) && FVU_Electronic_after201011!=null)
				if (Double
						.parseDouble(FVU_Electronic_after201011) == Double
						.parseDouble(TDSFVUVersion)) {

					flag = false;
				} else {
					flag = true;
				}

				if (flag) {
					JOptionPane.showMessageDialog(
							jContentPane, errorMsgCons2);

				}
			}
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} 
		}
		
		

		
		//System.out.println(obj_VersionValidator.VersionVal());
		// ended for FVU 4.8
	}
	
	//***********************************************
	
	//	Create dialog containing the chooser
	//	 final JDialog dialog = chooser.createDialog(frame);
	/**
	 * This method initializes btnExit
	 * 
	 * @return javax.swing.JButton
	 */

	/* this function will be called when the fvu will be combined with RPU :::Created by Manvendra */
	//---------------------------------------------------------------------------------
	
	// added by faizan for FVU 4.8
	public void dirToOpenFunc(){
		//newly added for FVU4.8 by Akansha
		String errorFileNamepath = "";
		if(txtErrorFilePath!=null || "".equals(txtErrorFilePath))
		errorFileNamepath = txtErrorFilePath.getText().trim();
		else{
			int temp2 = errFilepath.lastIndexOf("\\");
			
			String temp3 = errFilepath.substring(0,temp2);
			errorFileNamepath = temp3;
		}
		//*************************************************************
		
		//System.out.println("Path of temp in fvu: "+ errorFileNamepath);
		Desktop desktop = Desktop.getDesktop();
		System.out.println("--DESKTOP OBJECT: "+desktop);
		System.out.println("--error file path: "+errorFileNamepath);
		File dirToOpen = new File (errorFileNamepath);
		System.out.println("--dir to open object: "+dirToOpen);
		System.out.println("the text error file path is " + errorFileNamepath);
		
		try {
			if(dirToOpen!=null)
				desktop.open(dirToOpen);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			System.out.println("Directory path is: "+dirToOpen);
			e.printStackTrace();
		}
		
		
	}
	// ended for FVU 4.8
	
	//Rahul Feedback FVU 7.5
	
		public void createCustomDialogPopup() {    //Rahul Feedback FVU 7.5
			jframe = new JDialog(new JFrame(),"Message",ModalityType.APPLICATION_MODAL);
			jframe.setFont(new Font("Arial", Font.PLAIN, 15));
			String str="";
			JLabel jlabel = new JLabel();
			jlabel.setText(
	                "<html>"
	                + "<body>"
	                + "<table border='0px' cxellpadding='10px' height='100%'>"
	                + "<tr>"
	                + "<td valign='center'>"
					+"<b>Please take a minute to help us to improve our services. To share your feedback click</b>"			
	                + "</td>"
	                + "</tr>"
	                + "</table>"
	                + "</body>"
	                + "</html>"
	                );
			
			JButton okbtn = new JButton("OK");
			JButton cnlbtn = new JButton("Cancel");
			JPanel jpanel = new JPanel();
			jpanel.setLayout(new FlowLayout());
			jpanel.add(jlabel);
			jpanel.add(okbtn);
			jpanel.add(cnlbtn);
			jframe.getContentPane().add(jpanel);
			jframe.getRootPane().setDefaultButton(okbtn);
			jframe.getRootPane().getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW).put(
			            KeyStroke.getKeyStroke(KeyEvent.VK_ESCAPE, 0), "Cancel"); 
			jframe.getRootPane().getActionMap().put("Cancel", new AbstractAction(){ 
			            public void actionPerformed(ActionEvent e)
			            {
			            	jframe.dispose();
			            }
			        });

			//**************
				
			okbtn.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent arg0) {
					buttonpress="";
					buttonpress+="OK";
					URI uri_btn = null;
					try {
						
						
			uri_btn = new URI("https://onlineservices.nsdl.com/customerFeedbackFormWeb/customer/feedbackFormTDS/data");//Prod Link	
						
						
					} catch (URISyntaxException e) {
						// TODO Auto-generated catch block  
						e.printStackTrace();
					}
					if (Desktop.isDesktopSupported()) {
						try {
							Desktop.getDesktop().browse(uri_btn);
						} catch (IOException e) {
							e.printStackTrace();
						}
					} else {
					}
					
					jframe.dispose();	
				}
			});
			cnlbtn.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent arg0) {
					buttonpress="";
					buttonpress+="CL";
					jframe.dispose();	
				}
			});
			jframe.addWindowListener(new WindowAdapter() {
				public void windowClosing(WindowEvent arg0) {
					jframe.setDefaultCloseOperation(DISPOSE_ON_CLOSE);
				}
				public void windowClosed(WindowEvent arg0) {		
					jframe.setDefaultCloseOperation(DISPOSE_ON_CLOSE);	
				}
			});
			
			jframe.setSize(550, 120);   //550,140 //450,200
			jframe.setResizable(false);
			jframe.setLocationRelativeTo(jContentPane); 
			jframe.setVisible(true);
		}
	


	public void RPUcalled_FVUaction(String inFileName, String errorFileName, String hashFileName, String samScmFvuVersion, int paperReturnIndiFlag, String consFilePath)
	{

		StringBuffer returntoRPU = null;
		try
		{

			System.out.println("Inside RPU func");
			String tab = "^";
			//Creating the object of the Form_Validatior class////////////////
			FormValidator obj_FormValidator = new FormValidator();
			System.out.println("Inside RPU func 1");
			PDFGenerator pdfGen = new PDFGenerator();
			//String hashFileName = null;
			String statisticFileName = null;
			String pdfFileName = null;
			String temppdfFileName = null;
			String htmlErrorFileName = null;
			String userFriendlyFileBHDD = null; // to store the absolute path and name of HTML report to be generated
			String userFriendlyFileCD = null; // to store the absolute path and name of HTML report containing Challan Details if any
			String uffNamingBHDD = null; //to store the name to be assigned to HTML file of BH
			String uffNamingCD = null; //to store the name to be assigned to HTML file of CD
			File addrFile = new File(inFileName);
			String fileName = addrFile.getName();
			int errorCode = checkFileFolderName(fileName,"I");
			if(!(fileName.endsWith(".txt") || fileName.endsWith(".fvu")))
			errorCode = 6;
			File errorDir = new File(errorFileName);
			//Added by sourabh for rpu calling FVU
			int errorCodeCIN =0;
			if(FileStatistics.getCinFileName().length()!=0 && errorCode==0)
			{
				FileStatistics.setCinUploadFlag(1);	
				File cinFile = new File(FileStatistics.getCinFileName());
				String cinFileName = cinFile.getName();
				errorCodeCIN = checkFileFolderName(cinFileName,"C");
				if(!cinFileName.endsWith(".csi"))
				{
					errorCodeCIN = 12; //sourabh
				}
				if (errorCodeCIN != 0)
				{
					if (errorCodeCIN == 1 || errorCodeCIN == 8)
						JOptionPane.showMessageDialog(jContentPane, errorMsgCIN_01);
					else if (errorCodeCIN == 2)
						JOptionPane.showMessageDialog(jContentPane, errorMsgCIN_02);
					else if (errorCodeCIN == 3)
						JOptionPane.showMessageDialog(jContentPane, errorMsgCIN_03);
					else if (errorCodeCIN == 5)
						JOptionPane.showMessageDialog(jContentPane, errorMsgCIN_04);
					else if (errorCodeCIN == 12)
						JOptionPane.showMessageDialog(jContentPane, errorMsgCIN_05);
							txtInputFileName.setText("");
							txtCINFileName.setText("");
							btnValidate.setEnabled(false);  
				}
			}//End of upload flag
			if (errorFileName.length() == 0)
				errorCode = 8;
			if (errorCode == 0&&errorCodeCIN ==0)
			{
				int i;
				int j;
				char ch;
				for (i = inFileName.length() - 1; i > -1; i--)
				{
					if ((ch = inFileName.charAt(i)) == '.')
					{
						break;
					}
				}
				if (i > 0)
				{
					for (j = i; j > -1; j--)
					{
					    //if (inFileName.charAt(j) == '\\')
						//added below line to for linux /window compatibility start 
						if (inFileName.charAt(j) == File.separatorChar)
						{
							break;
						}
					}
					
					//commented below line to for linux /window compatibility  
//					
//					// hashFileName = errorFileName + "\\" + inFileName.substring(j + 1, i) + ".fvu";
//					htmlErrorFileName = errorFileName + "\\" + inFileName.substring(j + 1, i) + "err.html";
//					statisticFileName = errorFileName + "\\" + inFileName.substring(j + 1, i) + ".html";
//					temppdfFileName = errorFileName + "\\" + inFileName.substring(j + 1, inFileName.length()) + "pdf.html";
//					pdfFileName = errorFileName + "\\" + inFileName.substring(j + 1, inFileName.length()) + ".pdf";
//					userFriendlyFileBHDD = errorFileName + "\\" + inFileName.substring(j + 1, i) + "_BH" + ".html";
//					userFriendlyFileCD = errorFileName + "\\" + inFileName.substring(j + 1, i) + "_CD" + ".html";
//					uffNamingBHDD = inFileName.substring(j + 1, i) + "_BH" + ".html";
//					uffNamingCD = inFileName.substring(j + 1, i) + "_CD" + ".html";
//					errorFileName = errorFileName + "\\" + inFileName.substring(j + 1, i) + ".err";

														
					
					// hashFileName = errorFileName + "\\" + inFileName.substring(j + 1, i) + ".fvu";
					htmlErrorFileName = errorFileName + File.separator + inFileName.substring(j + 1, i) + "err.html";
					statisticFileName = errorFileName + File.separator + inFileName.substring(j + 1, i) + ".html";
					temppdfFileName = errorFileName + File.separator + inFileName.substring(j + 1, inFileName.length()) + "pdf.html";
					pdfFileName = errorFileName + File.separator + inFileName.substring(j + 1, inFileName.length()) + ".pdf";
					userFriendlyFileBHDD = errorFileName + File.separator + inFileName.substring(j + 1, i) + "_BH" + ".html";
					userFriendlyFileCD = errorFileName + File.separator + inFileName.substring(j + 1, i) + "_CD" + ".html";
					uffNamingBHDD = inFileName.substring(j + 1, i) + "_BH" + ".html";
					uffNamingCD = inFileName.substring(j + 1, i) + "_CD" + ".html";
					errorFileName = errorFileName + File.separator + inFileName.substring(j + 1, i) + ".err";
				}
				else
				{
					for (j = (inFileName.length() - 1); j > -1; j--)
					{
						//if (inFileName.charAt(j) == '\\')
						//added below line to for linux /window compatibility  
						if (inFileName.charAt(j) == File.separatorChar)
						{
							break;
						}
					}
					
					
//					//   hashFileName = errorFileName + "\\" + inFileName.substring(j + 1, inFileName.length()) + ".fvu";
//					htmlErrorFileName = errorFileName + "\\" + inFileName.substring(j + 1, inFileName.length()) + "err.html";
//					statisticFileName = errorFileName + "\\" + inFileName.substring(j + 1, inFileName.length()) + ".html";
//					temppdfFileName = errorFileName + "\\" + inFileName.substring(j + 1, inFileName.length()) + "pdf.html";
//					pdfFileName = errorFileName + "\\" + inFileName.substring(j + 1, inFileName.length()) + "pdf.html";
//					userFriendlyFileBHDD = errorFileName + "\\" + inFileName.substring(j + 1, inFileName.length()) + "_BH" + ".html";
//					userFriendlyFileCD = errorFileName + "\\" + inFileName.substring(j + 1, inFileName.length()) + "_CD" + ".html";
//					uffNamingBHDD = inFileName.substring(j + 1, inFileName.length()) + "_BH" + ".html";
//					uffNamingCD = inFileName.substring(j + 1, inFileName.length()) + "_CD" + ".html";
//					errorFileName = errorFileName + "\\" + inFileName.substring(j + 1, inFileName.length()) + ".err";
										
					
					//   hashFileName = errorFileName + "\\" + inFileName.substring(j + 1, inFileName.length()) + ".fvu";
					htmlErrorFileName = errorFileName + File.separator + inFileName.substring(j + 1, inFileName.length()) + "err.html";
					statisticFileName = errorFileName + File.separator + inFileName.substring(j + 1, inFileName.length()) + ".html";
					temppdfFileName = errorFileName + File.separator + inFileName.substring(j + 1, inFileName.length()) + "pdf.html";
					pdfFileName = errorFileName + File.separator + inFileName.substring(j + 1, inFileName.length()) + "pdf.html";
					userFriendlyFileBHDD = errorFileName + File.separator + inFileName.substring(j + 1, inFileName.length()) + "_BH" + ".html";
					userFriendlyFileCD = errorFileName + File.separator + inFileName.substring(j + 1, inFileName.length()) + "_CD" + ".html";
					uffNamingBHDD = inFileName.substring(j + 1, inFileName.length()) + "_BH" + ".html";
					uffNamingCD = inFileName.substring(j + 1, inFileName.length()) + "_CD" + ".html";
					errorFileName = errorFileName + File.separator + inFileName.substring(j + 1, inFileName.length()) + ".err";
				}
				errorFileName = errorFileName.replace('\\', '/');
				hashFileName = hashFileName.replace('\\', '/');
				htmlErrorFileName = htmlErrorFileName.replace('\\', '/');
				

								if( (consFilePath==null || consFilePath.trim().length()==0)&& Parameters.consMandatory && UPLOADTYPE_CORRECTION.equals(obj_FormValidator.getTypeOfFile(inFileName)))
								{
									JOptionPane.showMessageDialog(jContentPane, errorMsgCons1);
									FileGenerator fgen = new FileGenerator();
									String errText = "NA" + tab + "NA" + tab + "NA" + tab + tab + tab + T_FV_1040_C + tab + T_FV_1040_M;
									fgen.writeToFile(errorFileName, errText, 1);
									String htmlText = fgen.generateHtmlErrorFile(errText).toString();
									fgen.writeToFile(htmlErrorFileName, htmlText, 1);
									toContinue=1;
									
									
								}
								else if(consFilePath!=null && consFilePath.trim().length()!=0 )
								{
									System.out.println("The cons File name is "+consFilePath.trim().length()); 
									isConsValid=obj_FormValidator.ValidateConsHash(consFilePath.trim());
									 boolean consMatched[]=obj_FormValidator.matchConsFile(inFileName);
									 if(consMatched[2]==false)
									 {
										 FileGenerator fgen = new FileGenerator();
										 String errText = "1" + tab + "NA" + tab + "NA" + tab + tab + tab + T_FV_1000_C + tab + T_FV_1000_M;
										 fgen.writeToFile(errorFileName, errText, 1);
										 String htmlText = fgen.generateHtmlErrorFile(errText).toString();
										 fgen.writeToFile(htmlErrorFileName, htmlText, 1);
										toContinue=1; 
										
									 }
									 else if(consMatched[0])
					{
						JOptionPane.showMessageDialog(jContentPane, "Consolidate file should not be provided with a regular file");
						toContinue=1;
					}
					else if(!isConsValid)
					{
						//JOptionPane.showMessageDialog(jContentPane, errorMsgCons);	//Hashed by Abhishek 28/12/2011
//						JOptionPane.showConfirmDialog(jContentPane,"The COnsfile Provided is not Valid..Do you wish to continue?");
						System.out.println("Inside isConsValid");
						FileGenerator fgen = new FileGenerator();
						String errText = "NA" + tab + "NA" + tab + "NA" + tab + tab + tab + T_FV_1038_C + tab + T_FV_1038_M;
						fgen.writeToFile(errorFileName, errText, 1);
						String htmlText = fgen.generateHtmlErrorFile(errText).toString();
						fgen.writeToFile(htmlErrorFileName, htmlText, 1);
						toContinue=1;
					}
					else
					{
						System.out.println("In else part of is cons valid");
						
						if(!consMatched[1])
						{
//							For Making mandatory Tocontinue will be 1 and the Dialog Box will be converted to Message dialog
//							toContinue=JOptionPane.showConfirmDialog(jContentPane,"The Consfile Provided is not matching with the File To be validated..Do you wish to continue?");
							if(Parameters.consMandatory==false)
							{
								toContinue=JOptionPane.showConfirmDialog(jContentPane,"The Consfile Provided is not matching with the File To be validated..Do you wish to continue?", "ConsolidatedFileNotMatching", JOptionPane.YES_NO_OPTION);
							}
							else
							{
								FileGenerator fgen = new FileGenerator();
								String errText = "1" + tab + "NA" + tab + "NA" + tab + tab + tab + T_FV_1039_C + tab + T_FV_1039_M;
								fgen.writeToFile(errorFileName, errText, 1);
								String htmlText = fgen.generateHtmlErrorFile(errText).toString();
								fgen.writeToFile(htmlErrorFileName, htmlText, 1);
								toContinue=1;
							}
						}
					}
					System.out.println("To Continue "+toContinue);
				}
				
				
				
				if(((consFilePath==null ||consFilePath.trim().length()==0 ) || ((consFilePath!=null  && consFilePath.trim().length()!=0) && isConsValid==true)) && toContinue==0)
				{
				if (addrFile.exists() && addrFile.length() > 0)
				{
					PrintStream  fileLogs = new PrintStream(new FileOutputStream(hashFileName+".log"));
					System.setOut(fileLogs);
					System.setErr(fileLogs);
					logSystemInfo();
					obj_FormValidator.readFile(inFileName, errorFileName, utilityLevel);
					if (obj_FormValidator.obj_StringBuffer.errorBufferString.length() == 0)
					{
						System.out.println("Field Validation of file is compleated sucessfully");
						Hash hash = new Hash();
						boolean paperReturnFileGenerated = false;
						boolean paperRetWarFile = false;
						boolean electronicRetWarFile = false;
						// int paperReturnIndiFlag = 0;
						int hashError = hash.startProcessing(inFileName, hashFileName, utilityLevel, fhFieldCountTds, paperReturnIndiFlag);						
						
						System.out.println("Return Hash Code = " + hashError);
						
						/* Barcode start*/
						String barcode = searchbarcode(hashFileName);
						//Changes added for 6.5_2.161_2.1293 by Puja
						Pattern digitPattern = Pattern.compile("\\d{20}");
						if(barcode.length() !=20 || barcode ==""|| !digitPattern.matcher(barcode).matches()) {
							if(hashError ==0) {
								hashError=17;
							}
							System.out.println("Barcode is missing");
							
							File ferr2 = new File(hashFileName);
							if(ferr2.exists()) {
								ferr2.delete();							
								System.out.println("fvu file is deleted as barcode is missing.");
							}
						}else {
							System.out.println("Barcode is present");
						}
						/* Barcode end */
						
						if (hashError == 0)
						{
							System.out.println("Hash Validation of file is done sucessfully");
							FileGenerator obj_FileGenerator = new FileGenerator();
					//		String hashFileLocation = hashFileName.substring(0, hashFileName.lastIndexOf("/"));

							//added below line to for linux /window compatibility start  
							File hashFileLocationPath = new File(hashFileName);	
							String hashFileLocation = hashFileLocationPath.getAbsolutePath().substring(0,  hashFileLocationPath.getAbsolutePath().lastIndexOf(File.separator));
							//added below line to for linux /window compatibility end						
							
							
							obj_FileGenerator.generateStatisticFile(obj_FormValidator, statisticFileName, fileName, TDSFVUVersion);
							/**
							 * Code to call the method which will generate the User Friendly file 
							 * Containing data populated as in case of paper return
							 */
							//Added by Shalin for FVU 4.1 (for generation of Form 27A)
							
							boolean pdfbool=false;
						
							if(consFilePath.trim()!=null)
							{
								pdfbool=pdfGen.generatePDFFile(inFileName,pdfFileName,temppdfFileName,consFilePath.trim());
							}
							else
							{
								pdfbool=pdfGen.generatePDFFile(inFileName,pdfFileName,temppdfFileName,"");
							}
							System.out.println("pdf generated"+pdfbool);
							
							
							
							boolean reportGenerated = false;
							ReportGenerator rep = new ReportGenerator();
							long l1 = System.currentTimeMillis();
							//commented for this special version by sid
							//commented for FVU 5.0 when it called through rpu ..to stop genrating bh.html and cd.html
							//reportGenerated = rep.generateHtmlReport(inFileName, userFriendlyFileBHDD, userFriendlyFileCD, uffNamingBHDD, uffNamingCD);
							long l2 = System.currentTimeMillis();
//							System.out.println("TIME Taken to Generate Report in milisec = " + (l2 - l1));

							if (obj_FormValidator.obj_StringBuffer.panStatFileOpened)
							{
								/* If the PAN Statistics HTML File is already Opened then, 
								    1. We DO NOT append the PAN Statistic Header
								    2. We append the remaining panStat Data in File
								    3. We append the HTML File Footer 
								*/
								String panStatFileName = errorFileName.substring(0, (errorFileName.length() - 4)) + STATISTICS_FILE_EXT;
								StringBuffer panStatTableString = new StringBuffer();
								panStatTableString.append(obj_FormValidator.obj_StringBuffer.panStatBufferString.toString());
								panStatTableString.append(obj_FileGenerator.createPANStatTableStructureEnd(fileName));
								panStatTableString.append(obj_FileGenerator.createPANStatFileFooter());
								obj_FileGenerator.writeToFile(panStatFileName, panStatTableString.toString(), 0, true);
							}
							else if (!obj_FormValidator.obj_StringBuffer.panStatFileOpened && (obj_FormValidator.obj_StringBuffer.getPanCounter() > 0))
							{
								/* If the PAN Statistics HTML File is already Opened then, 
								    1. We WILL append the HTML File PAN Header
								    2. We append the remaining panStat Data in File
								    3. We append the HTML File PAN Footer 
								*/
								String panStatFileName = errorFileName.substring(0, (errorFileName.length() - 4)) + STATISTICS_FILE_EXT;
								StringBuffer panStatTableString = new StringBuffer();
								panStatTableString.append(obj_FormValidator.obj_StringBuffer.panStatBufferString.toString());
								panStatTableString.append(obj_FileGenerator.createPANStatTableStructureEnd(fileName));
								panStatTableString.append(obj_FileGenerator.createPANStatFileFooter());
								obj_FileGenerator.writeToFile(panStatFileName, panStatTableString.toString(), 0, false);
							}
							/*
							 * If the count of Paper Return warnings ie 'warningCount' greater than 0
							 * then we will generate Warning File for Paper Return
							 */
							if ((obj_FormValidator.obj_StringBuffer.getWarningCount() > 0))
							{
								paperReturnFileGenerated = true;
								if (obj_FormValidator.obj_StringBuffer.paperRetWarFileOpened)
								{
									String paperRetunWarningFileName = errorFileName.substring(0, (errorFileName.length() - 4)) + PAPER_RET_WAR_FILE_EXT;
									boolean appedHtmlErrorFileHeader = false;
									boolean appedHtmlErrorFileFooter = true;
									paperRetWarFile = true;
									electronicRetWarFile = false;
									StringBuffer htmlWarningFileStringBuffer =
										obj_FileGenerator.generateHtmlErrorFile(
											obj_FormValidator.obj_StringBuffer.warningBufferStringPaperReturn.toString(),
											appedHtmlErrorFileHeader,
											appedHtmlErrorFileFooter,
											paperRetWarFile,
											fileName,
											electronicRetWarFile);
									obj_FileGenerator.writeToFile(paperRetunWarningFileName, htmlWarningFileStringBuffer.toString(), 0, obj_FormValidator.obj_StringBuffer.paperRetWarFileOpened);
								}
								else
								{
									String paperRetunWarningFileName = errorFileName.substring(0, (errorFileName.length() - 4)) + PAPER_RET_WAR_FILE_EXT;
									boolean appedHtmlErrorFileHeader = true;
									boolean appedHtmlErrorFileFooter = true;
									paperRetWarFile = true;
									electronicRetWarFile = false;
									StringBuffer htmlWarningFileStringBuffer =
										obj_FileGenerator.generateHtmlErrorFile(
											obj_FormValidator.obj_StringBuffer.warningBufferStringPaperReturn.toString(),
											appedHtmlErrorFileHeader,
											appedHtmlErrorFileFooter,
											paperRetWarFile,
											fileName,
											electronicRetWarFile);
									obj_FileGenerator.writeToFile(paperRetunWarningFileName, htmlWarningFileStringBuffer.toString(), 0, obj_FormValidator.obj_StringBuffer.paperRetWarFileOpened);
								}
							}

							//Added by Nahush for validating Deductor PAN against PAN of deductee.
							/*
							 * If the count of Electronic Return warnings ie 'warningCount' greater than 0
							 * then we will generate Warning File for Electronic Return
							 */
							
							if ((obj_FormValidator.obj_StringBuffer.getElecWarningCount() > 0))
							{
								paperReturnFileGenerated = true;
								if (obj_FormValidator.obj_StringBuffer.electronicRetWarFileOpened)
								{
									String electronicReturnWarningFileName = errorFileName.substring(0, (errorFileName.length() - 4)) + ELECTRONIC_RET_WAR_FILE_EXT;
									boolean appedHtmlErrorFileHeader = false;
									boolean appedHtmlErrorFileFooter = true;
									paperRetWarFile = false;
									electronicRetWarFile = true;
									StringBuffer htmlWarningFileStringBuffer =
										obj_FileGenerator.generateHtmlErrorFile(
											obj_FormValidator.obj_StringBuffer.warningBufferStringElectronicReturn.toString(),
											appedHtmlErrorFileHeader,
											appedHtmlErrorFileFooter,
											paperRetWarFile,
											fileName,
											electronicRetWarFile);
									obj_FileGenerator.writeToFile(
										electronicReturnWarningFileName,
										htmlWarningFileStringBuffer.toString(),
										0,
										obj_FormValidator.obj_StringBuffer.electronicRetWarFileOpened);
								}
								else
								{
									String electronicReturnWarningFileName = errorFileName.substring(0, (errorFileName.length() - 4)) + ELECTRONIC_RET_WAR_FILE_EXT;
									boolean appedHtmlErrorFileHeader = true;
									boolean appedHtmlErrorFileFooter = true;
									paperRetWarFile = false;
									electronicRetWarFile = true;
									StringBuffer htmlWarningFileStringBuffer =
										obj_FileGenerator.generateHtmlErrorFile(
											obj_FormValidator.obj_StringBuffer.warningBufferStringElectronicReturn.toString(),
											appedHtmlErrorFileHeader,
											appedHtmlErrorFileFooter,
											paperRetWarFile,
											fileName,
											electronicRetWarFile);
									obj_FileGenerator.writeToFile(
											electronicReturnWarningFileName,
										htmlWarningFileStringBuffer.toString(),
										0,
										obj_FormValidator.obj_StringBuffer.electronicRetWarFileOpened);												}
							}
							
							
							
							
							
							
							Calendar cal22 = new GregorianCalendar();
							System.out.println("END TIME : " + cal22.getTime());
							returntoRPU = new StringBuffer();
							if (obj_FormValidator.obj_StringBuffer.getPanCounter() > 0)
							{
								if (paperReturnFileGenerated)
								{
									if (reportGenerated)
									{
										if (paperRetWarFile)
										{
											JOptionPane.showMessageDialog(
													jContentPane,
													"File validated successfully at the path " + hashFileLocation +".\r\n Please submit .FVU file in PENDRIVE/CD and duly signed physical Form 27A generated through FVU at TIN Facilitation Centers.");
											dfunc.Dialog();
										//ended by nik for fvu 4.7	
											// added for FVU 4.8
											if (obj_FormValidator.getRpuType().contains("Protean"))  //FVU 7.6 BUG FIX
											createCustomDialogPopup();	//Rahul Feedback FVU 7.5
											dirToOpenFunc();
											//end for FVU 4.8
										}
										else if (electronicRetWarFile)
										{ 
											JOptionPane.showMessageDialog(
													jContentPane,
													"File validated successfully at the path " + hashFileLocation +".\r\n Please submit .FVU file in PENDRIVE/CD and duly signed physical Form 27A generated through FVU at TIN Facilitation Centers.");
											
										 //added by nik for fvu 4.7
											dfunc.Dialog();
										//ended by nik for fvu 4.7	
											// added for FVU 4.8
											if (obj_FormValidator.getRpuType().contains("Protean"))  //FVU 7.6 BUG FIX
											createCustomDialogPopup();	//Rahul Feedback FVU 7.5
											dirToOpenFunc();
											//end for FVU 4.8
										}
									
									}
									else
									{

										if (paperRetWarFile)
											{
											JOptionPane.showMessageDialog(
													jContentPane,
													"File validated successfully at the path " + hashFileLocation +".\r\n Please submit .FVU file in PENDRIVE/CD and duly signed physical Form 27A generated through FVU at TIN Facilitation Centers.");
												dfunc.Dialog();
											//ended by nik for fvu 4.7	
												// added for FVU 4.8
												if (obj_FormValidator.getRpuType().contains("Protean"))  //FVU 7.6 BUG FIX
												createCustomDialogPopup();	//Rahul Feedback FVU 7.5
												dirToOpenFunc();
												//end for FVU 4.8
											}
											else if (electronicRetWarFile)
											{
												JOptionPane.showMessageDialog(
														jContentPane,
														"File validated successfully at the path " + hashFileLocation +".\r\n Please submit .FVU file in PENDRIVE/CD and duly signed physical Form 27A generated through FVU at TIN Facilitation Centers.");
							     				//added by nik for fvu 4.7
												dfunc.Dialog();
											//ended by nik for fvu 4.7	
												// added for FVU 4.8
												if (obj_FormValidator.getRpuType().contains("Protean"))  //FVU 7.6 BUG FIX
												createCustomDialogPopup();	//Rahul Feedback FVU 7.5
												dirToOpenFunc();
												//end for FVU 4.8
											}		
									}
								}
								else
								{
									if (reportGenerated)
									{
										JOptionPane.showMessageDialog(
												jContentPane,
												"File validated successfully at the path " + hashFileLocation +".\r\n Please submit .FVU file in PENDRIVE/CD and duly signed physical Form 27A generated through FVU at TIN Facilitation Centers.");
										dfunc.Dialog();
									//ended by nik for fvu 4.7	
										// added for FVU 4.8
										if (obj_FormValidator.getRpuType().contains("Protean"))  //FVU 7.6 BUG FIX
										createCustomDialogPopup();	//Rahul Feedback FVU 7.5
										dirToOpenFunc();
										//end for FVU 4.8
									}
									else
									{
										JOptionPane.showMessageDialog(
												jContentPane,
												"File validated successfully at the path " + hashFileLocation +".\r\n Please submit .FVU file in PENDRIVE/CD and duly signed physical Form 27A generated through FVU at TIN Facilitation Centers.");
										dfunc.Dialog();
								    //ended by nik for fvu 4.7	
										// added for FVU 4.8
										if (obj_FormValidator.getRpuType().contains("Protean"))  //FVU 7.6 BUG FIX
										createCustomDialogPopup();	//Rahul Feedback FVU 7.5
										dirToOpenFunc();
										//end for FVU 4.8
									}
								}
							}
							else
							{
								if (paperReturnFileGenerated)
								{
									if (reportGenerated)
									{
										if (paperRetWarFile)
										{
											JOptionPane.showMessageDialog(
													jContentPane,
													"File validated successfully at the path " + hashFileLocation +".\r\n Please submit .FVU file in PENDRIVE/CD and duly signed physical Form 27A generated through FVU at TIN Facilitation Centers.");
								    		//added by nik for fvu 4.7
											dfunc.Dialog();
										//ended by nik for fvu 4.7	
											// added for FVU 4.8
											if (obj_FormValidator.getRpuType().contains("Protean"))  //FVU 7.6 BUG FIX
											createCustomDialogPopup();	//Rahul Feedback FVU 7.5
											dirToOpenFunc();
											//end for FVU 4.8
										}
										 
										 else if (electronicRetWarFile)
											{
											 JOptionPane.showMessageDialog(
														jContentPane,
														"File validated successfully at the path " + hashFileLocation +".\r\n Please submit .FVU file in PENDRIVE/CD and duly signed physical Form 27A generated through FVU at TIN Facilitation Centers.");
													dfunc.Dialog();
												//ended by nik for fvu 4.7	
													// added for FVU 4.8
													if (obj_FormValidator.getRpuType().contains("Protean"))  //FVU 7.6 BUG FIX
													createCustomDialogPopup();	//Rahul Feedback FVU 7.5
													dirToOpenFunc();
													//end for FVU 4.8
											}
											
									}
									else
									{
										
										if (paperRetWarFile)
										{
											JOptionPane.showMessageDialog(
													jContentPane,
													"File validated successfully at the path " + hashFileLocation +".\r\n Please submit .FVU file in PENDRIVE/CD and duly signed physical Form 27A generated through FVU at TIN Facilitation Centers.");
											dfunc.Dialog();
										//ended by nik for fvu 4.7	
											// added for FVU 4.8
											if (obj_FormValidator.getRpuType().contains("Protean"))  //FVU 7.6 BUG FIX
											createCustomDialogPopup();	//Rahul Feedback FVU 7.5
											dirToOpenFunc();
											//end for FVU 4.8
										}
										
										 else if (electronicRetWarFile)
											{
											 JOptionPane.showMessageDialog(
														jContentPane,
														"File validated successfully at the path " + hashFileLocation +".\r\n Please submit .FVU file in PENDRIVE/CD and duly signed physical Form 27A generated through FVU at TIN Facilitation Centers.");
													dfunc.Dialog();
												//ended by nik for fvu 4.7	
													// added for FVU 4.8
													if (obj_FormValidator.getRpuType().contains("Protean"))  //FVU 7.6 BUG FIX
													createCustomDialogPopup();	//Rahul Feedback FVU 7.5
													dirToOpenFunc();
													//end for FVU 4.8
											}

									}
								}
								else
								{
									if (reportGenerated)
									{
										JOptionPane.showMessageDialog(
												jContentPane,
												"File validated successfully at the path " + hashFileLocation +".\r\n Please submit .FVU file in PENDRIVE/CD and duly signed physical Form 27A generated through FVU at TIN Facilitation Centers.");
										dfunc.Dialog();
									//ended by nik for fvu 4.7	
										// added for FVU 4.8
										
										if (obj_FormValidator.getRpuType().contains("Protean"))  //FVU 7.6 BUG FIX
										createCustomDialogPopup();	//Rahul Feedback FVU 7.5
										dirToOpenFunc();
										//end for FVU 4.8
									}
									else
									{
										JOptionPane.showMessageDialog(
												jContentPane,
												"File validated successfully at the path " + hashFileLocation +".\r\n Please submit .FVU file in PENDRIVE/CD and duly signed physical Form 27A generated through FVU at TIN Facilitation Centers.");
										dfunc.Dialog();
									//ended by nik for fvu 4.7	
										// added for FVU 4.8
										if (obj_FormValidator.getRpuType().contains("Protean"))  //FVU 7.6 BUG FIX
										createCustomDialogPopup();	//Rahul Feedback FVU 7.5
										dirToOpenFunc();
										//end for FVU 4.8
									}
								}
							}
//							System.out.println("reportGenerated == " + reportGenerated);
						}
						else if (hashError != 0)
						{
							FileGenerator obj_FileGenerator = new FileGenerator();
							StringBuffer FH_obj_StringBuffer = new StringBuffer();
							int lineNumber = hash.getRecordNumber();
							/*
							ErrorVal    Remarks
							------------------------
							0       Success (no errors)
							1       Input File not found
							2       Invalid Input File (
							                    i. Empty record found 
							                    ii. At FVU file is having sam/scm info 
							                    iii. At svu uploadedby is not TFC and file is having sam/scm info
							                   )
							3       FVU Version is either Incorrect or NULL
							4       SAM Version is either Incorrect or NULL
							5       SCM Version is either Incorrect or NULL
							6       File Header Record Hash Code mismatch
							7       Record Level Hash Code mismatch
							8       Input File format Error (also if mismatch of number of in the input file.
							                    For a new file the last char in a record should be '^', 
							                    and for a file that is already hashed the last character should not be '^')
							9       Mismatch of FVU File Level HashCode
							10      Mismatch of SAM File Level HashCode
							11      Mismatch of SCM File Level HashCode
							12      Unknown Error. Exception occured
							13      CIN File is hashing is not proper
							14      CIN File Not Found
							15      Empty Record in CIN File
							16      Number of challan is not matched in cin file with cin header
							17      Barcode is not generated
							*/
							if (hashError == 3)
							{
								FH_obj_StringBuffer.append("1" + tab + "NA" + tab + "NA" + tab + tab + tab + T_FV_1021_C + tab + T_FV_1021_M);
							}
							else if (hashError == 4)
							{
								FH_obj_StringBuffer.append("1" + tab + "NA" + tab + "NA" + tab + tab + tab + T_FV_1024_C + tab + T_FV_1024_M);
							}
							else if (hashError == 5)
							{
								FH_obj_StringBuffer.append("1" + tab + "NA" + tab + "NA" + tab + tab + tab + T_FV_1025_C + tab + T_FV_1025_M);
							}
							else if (hashError == 9)
							{
								FH_obj_StringBuffer.append("1" + tab + "NA" + tab + "NA" + tab + tab + tab + T_FV_1026_C + tab + T_FV_1026_M);
							}
							else if (hashError == 10)
							{
								FH_obj_StringBuffer.append("1" + tab + "NA" + tab + "NA" + tab + tab + tab + T_FV_1027_C + tab + T_FV_1027_M);
							}
							else if (hashError == 11)
							{
								FH_obj_StringBuffer.append("1" + tab + "NA" + tab + "NA" + tab + tab + tab + T_FV_1028_C + tab + T_FV_1028_M);
							}
//							Added by sourabh
							  else if (hashError == 13)
							  {
								  FH_obj_StringBuffer.append("NA" + tab + "NA" + tab + "NA" + tab + tab + tab + T_FV_1029_C + tab + T_FV_1029_M);
							  }
							  else if (hashError == 14)
							  {
								  FH_obj_StringBuffer.append("NA" + tab + "NA" + tab + "NA" + tab + tab + tab + T_FV_1030_C + tab + T_FV_1030_M);
							  }
							  else if (hashError == 15)
							  {
								  FH_obj_StringBuffer.append("NA" + tab + "NA" + tab + "NA" + tab + tab + tab + T_FV_1031_C + tab + T_FV_1031_M);
							  }
							  else if (hashError == 16)
							  {
								  FH_obj_StringBuffer.append("NA" + tab + "NA" + tab + "NA" + tab + tab + tab + T_FV_1032_C + tab + T_FV_1032_M);
							  }
							  else if (hashError == 17)
							  {
								  FH_obj_StringBuffer.append("NA" + tab + "NA" + tab + "NA" + tab + tab + tab + T_FV_1044_C + tab + T_FV_1044_M);
							  }
							//Added for FVU 7.1 // Obs no 1 - FVU 7.1 - Vinita
								else if (hashError == 18)
								{
									FH_obj_StringBuffer.append("1" + tab + "NA" + tab + "NA" + tab + tab + tab + T_FV_6202_C + tab + T_FV_6202_M);
								}
							//End by sourabh
							else
							{
								FH_obj_StringBuffer.append(lineNumber + tab + "NA" + tab + "NA" + tab + "NA" + tab + "NA" + tab + T_FV_1022_C + tab + T_FV_1022_M);
							}
							obj_FileGenerator.writeToFile(errorFileName, FH_obj_StringBuffer.toString(), 0, obj_FormValidator.obj_StringBuffer.fileOpened);
							boolean appedHtmlErrorFileHeader = true;
							boolean appedHtmlErrorFileFooter = true;
							paperRetWarFile = false;
							electronicRetWarFile = false;
							StringBuffer htmlErrorFileStringBuffer =
								obj_FileGenerator.generateHtmlErrorFile(FH_obj_StringBuffer.toString(), appedHtmlErrorFileHeader, appedHtmlErrorFileFooter, paperRetWarFile, fileName,electronicRetWarFile);
							obj_FileGenerator.writeToFile(htmlErrorFileName, htmlErrorFileStringBuffer.toString(), 0, obj_FormValidator.obj_StringBuffer.fileOpened);
							// Deleting PAN Statistics Report if Generated
							String panStatFileName = errorFileName.substring(0, (errorFileName.length() - 4)) + STATISTICS_FILE_EXT;
							File panStatFile = new File(panStatFileName);
							if (panStatFile.exists())
							{
								panStatFile.delete();
							}
							// PAN Statistics Report Deleted
							// Deleting Paper Return warning File if Generated
							String paperRetWarFileName = errorFileName.substring(0, (errorFileName.length() - 4)) + PAPER_RET_WAR_FILE_EXT;
							File paperReturnWarFile = new File(paperRetWarFileName);
							if (paperReturnWarFile.exists())
							{
								paperReturnWarFile.delete();
							}
							// Deleting Paper Return warning File DELETED
							String electronicRetWarFileName = errorFileName.substring(0, (errorFileName.length() - 4)) + ELECTRONIC_RET_WAR_FILE_EXT;
							File electronicReturnWarFile = new File(electronicRetWarFileName);
							if (electronicReturnWarFile.exists())
							{
								electronicReturnWarFile.delete();
							}

							Calendar cal22 = new GregorianCalendar();
							System.out.println("END TIME : " + cal22.getTime());
							JOptionPane.showMessageDialog(null, "Errors Found during Validation.\r\nError File and HTML Error File Generated\r\nOpen " + htmlErrorFileName + " for details");
							// added by faizan for FVU 4.8
							File htmlFile = new File(htmlErrorFileName);
							try {
								Desktop.getDesktop().browse(htmlFile.toURI());
							} catch (IOException e) {
								// TODO Auto-generated catch block
								e.printStackTrace();
							}
							// ended for FVU 4.8
						}
					}
					else
					{
						FileGenerator obj_FileGenerator = new FileGenerator();
						StringBuffer htmlErrorFileStringBuffer = null;
						if (obj_FormValidator.obj_StringBuffer.fileOpened)
						{
							boolean appedHtmlErrorFileHeader = false;
							boolean appedHtmlErrorFileFooter = true;
							boolean paperRetWarFile = false;
							boolean electronicRetWarFile = false;
							htmlErrorFileStringBuffer =
								obj_FileGenerator.generateHtmlErrorFile(
									obj_FormValidator.obj_StringBuffer.errorBufferString.toString(),
									appedHtmlErrorFileHeader,
									appedHtmlErrorFileFooter,
									paperRetWarFile,
									fileName,
									electronicRetWarFile);
							obj_FileGenerator.writeToFile(htmlErrorFileName, htmlErrorFileStringBuffer.toString(), 0, obj_FormValidator.obj_StringBuffer.fileOpened);
						}
						else
						{
							boolean appedHtmlErrorFileHeader = true;
							boolean appedHtmlErrorFileFooter = true;
							boolean paperRetWarFile = false;
							boolean electronicRetWarFile = false;
							htmlErrorFileStringBuffer =
								obj_FileGenerator.generateHtmlErrorFile(
									obj_FormValidator.obj_StringBuffer.errorBufferString.toString(),
									appedHtmlErrorFileHeader,
									appedHtmlErrorFileFooter,
									paperRetWarFile,
									fileName,
									electronicRetWarFile);
							obj_FileGenerator.writeToFile(htmlErrorFileName, htmlErrorFileStringBuffer.toString(), 0, obj_FormValidator.obj_StringBuffer.fileOpened);
						}
						// Deleting PAN Statistics Report if Generated
						String panStatFileName = errorFileName.substring(0, (errorFileName.length() - 4)) + STATISTICS_FILE_EXT;
						File panStatFile = new File(panStatFileName);
						if (panStatFile.exists())
						{
							panStatFile.delete();
						}
						// PAN Statistics Report Deleted
						// Deleting Paper Return warning File if Generated
						String paperRetWarFileName = errorFileName.substring(0, (errorFileName.length() - 4)) + PAPER_RET_WAR_FILE_EXT;
						File paperReturnWarFile = new File(paperRetWarFileName);
						if (paperReturnWarFile.exists())
						{
							paperReturnWarFile.delete();
						}
						// Deleting Paper Return warning File DELETED
						String electronicRetWarFileName = errorFileName.substring(0, (errorFileName.length() - 4)) + ELECTRONIC_RET_WAR_FILE_EXT;
						File electronicReturnWarFile = new File(electronicRetWarFileName);
						if (electronicReturnWarFile.exists())
						{
							electronicReturnWarFile.delete();
						}

						
						Calendar cal22 = new GregorianCalendar();
						System.out.println("END TIME : " + cal22.getTime());
						JOptionPane.showMessageDialog(jContentPane, "Errors Found during Validation.\r\nError File and HTML Error File Generated\r\nOpen " + htmlErrorFileName + " for details");
						// added by faizan for FVU 4.8
						File htmlFile = new File(htmlErrorFileName);
						try {
							Desktop.getDesktop().browse(htmlFile.toURI());
						} catch (IOException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
						// ended for FVU 4.8
					}
					//                           txtInputFileName.setText("");
					//                          txtErrorFilePath.setText("");
					//                          btnValidate.setEnabled(false);
				} //END  if (addrFile.exists() && addrFile.length()>0)
				else
				{
					FileGenerator obj_FileGenerator = new FileGenerator();
					StringBuffer FH_obj_StringBuffer = new StringBuffer();
					FH_obj_StringBuffer.append("-" + tab + "NA" + tab + "NA" + tab + "NA" + tab + "NA" + tab + T_FV_1020_C + tab + T_FV_1020_M);
					obj_FileGenerator.writeToFile(errorFileName, FH_obj_StringBuffer.toString(), 0, obj_FormValidator.obj_StringBuffer.fileOpened);
					boolean appedHtmlErrorFileHeader = true;
					boolean appedHtmlErrorFileFooter = true;
					boolean paperRetWarFile = false;
					boolean electronicRetWarFile = false;
					StringBuffer htmlErrorFileStringBuffer =
						obj_FileGenerator.generateHtmlErrorFile(FH_obj_StringBuffer.toString(), appedHtmlErrorFileHeader, appedHtmlErrorFileFooter, paperRetWarFile, fileName,electronicRetWarFile);
					obj_FileGenerator.writeToFile(htmlErrorFileName, htmlErrorFileStringBuffer.toString(), 0, obj_FormValidator.obj_StringBuffer.fileOpened);
					// Deleting PAN Statistics Report if Generated
					String panStatFileName = errorFileName.substring(0, (errorFileName.length() - 4)) + STATISTICS_FILE_EXT;
					File panStatFile = new File(panStatFileName);
					if (panStatFile.exists())
					{
						panStatFile.delete();
					}
					// PAN Statistics Report Deleted
					//                           JOptionPane.showMessageDialog(jContentPane, "Errors Found during Validation.\r\nError File and HTML Error File Generated\r\nOpen " + htmlErrorFileName + " for details");
					//                   txtInputFileName.setText("");
					//                     txtErrorFilePath.setText("");
					//                       btnValidate.setEnabled(false);
				}

			}
			else
			{
				if(consProvidedwitRegular)
				{
					
				}
				else{
				JOptionPane.showMessageDialog(null, "Errors Found during Validation.\r\nError File and HTML Error File Generated\r\nOpen " + htmlErrorFileName + " for details");
				// added by faizan for FVU 4.8
				File htmlFile = new File(htmlErrorFileName);
				try {
					Desktop.getDesktop().browse(htmlFile.toURI());
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				// ended for FVU 4.8
				}
				
			}

			}
			else
			{
				if (errorCode == 1 || errorCode == 8)
					JOptionPane.showMessageDialog(null, errorMsg_01);
				else if (errorCode == 2)
					JOptionPane.showMessageDialog(null, errorMsg_02);
				else if (errorCode == 3)
					JOptionPane.showMessageDialog(null, errorMsg_03);
				else if (errorCode == 5)
					JOptionPane.showMessageDialog(null, errorMsg_04);
				//txtInputFileName.setText("");
				//  txtErrorFilePath.setText("");
				//btnValidate.setEnabled(false);
			}
		}
		catch (Exception o)
		{
			System.err.println("Exception in  actionPerformed method  : "); o.printStackTrace();
		}
		finally
		{
			toContinue=0;

		}
	}

	//end of RPU fuction........

	private javax.swing.JButton getBtnExit()
	{
		if (btnExit == null)
		{
			btnExit = new javax.swing.JButton();
			btnExit.setText("Exit");
			btnExit.setToolTipText("CLOSE THE PROGRAM");
			btnExit.setPreferredSize(new java.awt.Dimension(84, 25));
			btnExit.addActionListener(new java.awt.event.ActionListener()
			{
				public void actionPerformed(java.awt.event.ActionEvent e)
				{
					System.exit(0);
				}
			});
		}
		return btnExit;
	}
	/**
	 * This method initializes btnbrowseInputFileName
	 * 
	 * @return javax.swing.JButton
	 * 
	 */
	private javax.swing.JButton getBtnbrowseInputFileName()
	{
		if (btnbrowseInputFileName == null)
		{
			btnbrowseInputFileName = new javax.swing.JButton();
			btnbrowseInputFileName.setText("Browse");
			btnbrowseInputFileName.setToolTipText("CHOOSE A FILE FOR VALIDATION");
			btnbrowseInputFileName.setPreferredSize(new java.awt.Dimension(84, 25));
			try
			{
				btnbrowseInputFileName.addActionListener(new java.awt.event.ActionListener()
				{
					public void actionPerformed(java.awt.event.ActionEvent e)
					{
						JFileChooser jf = new JFileChooser();
						if (previousSorurceFileFolder.trim().length() == 0)
						{
							jf.setCurrentDirectory(jf.getCurrentDirectory());
						}
						else
						{
							File currentFile = new File(previousSorurceFileFolder.trim());
							jf.setCurrentDirectory(currentFile);
						}
						jf.setDialogTitle("Open Input File Name");
						int result = jf.showOpenDialog(((JButton) e.getSource()).getParent().getParent().getParent().getParent());
						if (result == JFileChooser.CANCEL_OPTION)
						{
							// No Statement
						}
						else if (result == JFileChooser.ERROR_OPTION)
						{
							// No Statement
						}
						else
						{
							txtInputFileName.setText(jf.getSelectedFile().getPath());
							file = jf.getSelectedFile().getPath();
							previousSorurceFileFolder = jf.getSelectedFile().getPath();
							System.out.println("the previousSorurceFileFolder is " + previousSorurceFileFolder);
							if (txtErrorFilePath.getText().length() != 0 && txtInputFileName.getText().length() != 0 && !processingInProgress)
								btnValidate.setEnabled(true);
							//Enable the validate button after selecting the I/P file name and Error file name 
						}
					}
				});
			}
			catch (Exception e)
			{
				System.err.println("Exception in  getBtnbrowseInputFileName method  : "); e.printStackTrace();
			}
		}
		return btnbrowseInputFileName;
	}
	private javax.swing.JButton getBtnbrowseCINFileName()
		{
			if (btnbrowseTempFileName == null)
			{
				btnbrowseTempFileName = new javax.swing.JButton();
				btnbrowseTempFileName.setText("Browse");
				btnbrowseTempFileName.setToolTipText("CHOOSE A CIN FILE FOR VALIDATION");
				btnbrowseTempFileName.setPreferredSize(new java.awt.Dimension(84, 25));
				try
				{
					btnbrowseTempFileName.addActionListener(new java.awt.event.ActionListener()
					{
						public void actionPerformed(java.awt.event.ActionEvent e)
						{
							JFileChooser jf = new JFileChooser();
							if (previousSorurceFileFolder.trim().length() == 0)
							{
								jf.setCurrentDirectory(jf.getCurrentDirectory());
							}
							else
							{
								File currentFile = new File(previousSorurceFileFolder.trim());
								jf.setCurrentDirectory(currentFile);
							}
							jf.setDialogTitle("Open CIN File Name");
							int result = jf.showOpenDialog(((JButton) e.getSource()).getParent().getParent().getParent().getParent());
							if (result == JFileChooser.CANCEL_OPTION)
							{
								// No Statement
							}
							else if (result == JFileChooser.ERROR_OPTION)
							{
								// No Statement
							}
							else
							{
								txtCINFileName.setText(jf.getSelectedFile().getPath());
								cinfile = jf.getSelectedFile().getPath();
								previousSorurceFileFolder = jf.getSelectedFile().getPath();
								if (txtErrorFilePath.getText().length() != 0 && txtInputFileName.getText().length() != 0 && !processingInProgress)
									btnValidate.setEnabled(true);
								//Enable the validate button after selecting the I/P file name and Error file name 
							}
						}
					});
				}
				catch (Exception e)
				{
					System.err.println("Exception in  getBtnbrowseInputFileName method  : "); e.printStackTrace();
				}
			}
			return btnbrowseTempFileName;
		}
	/**
	 * This method initializes btnbrowseErrorFilePath
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getBtnbrowseErrorFilePath()
	{
		if (btnbrowseErrorFilePath == null)
		{
			btnbrowseErrorFilePath = new javax.swing.JButton();
			btnbrowseErrorFilePath.setText("Browse");
			btnbrowseErrorFilePath.setToolTipText("CHOOSE A FOLDER TO SAVE OUTPUT FILE");
			btnbrowseErrorFilePath.setPreferredSize(new java.awt.Dimension(84, 25));
			btnbrowseErrorFilePath.addActionListener(new java.awt.event.ActionListener()
			{
				public void actionPerformed(java.awt.event.ActionEvent e)
				{
					JFileChooser jf = new JFileChooser();

					jf.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
					if (previousOutputFileFolder.trim().length() == 0)
					{
						jf.setCurrentDirectory(jf.getCurrentDirectory());
					}
					else
					{
						File currentFile = new File(previousOutputFileFolder.trim());
						jf.setCurrentDirectory(currentFile);
					}
					jf.setDialogTitle("Select Folder to save Output File");
					jf.setApproveButtonToolTipText("CHOOSE A FOLDER TO SAVE OUTPUT FILE");
					int result = jf.showOpenDialog(((JButton) e.getSource()).getParent().getParent().getParent().getParent());
					if (result == JFileChooser.CANCEL_OPTION)
					{
						// No Statement
					}
					else if (result == JFileChooser.ERROR_OPTION)
					{
						// No Statement
					}
					else
					{
						txtErrorFilePath.setText(jf.getSelectedFile().getPath());
						previousOutputFileFolder = jf.getSelectedFile().getPath();
						if (txtErrorFilePath.getText().length() != 0 && txtInputFileName.getText().length() != 0 && !processingInProgress)
							btnValidate.setEnabled(true);
					}
				}
			});
		}
		System.out.println("the btnbrowseErrorFilePath is " + btnbrowseErrorFilePath);
		return btnbrowseErrorFilePath;
	}
	
	private javax.swing.JButton getBtnbrowseConsFileName()
	{
		if (consTempFileName == null)
		{
			consTempFileName = new javax.swing.JButton();
			consTempFileName.setText("Browse");
			consTempFileName.setToolTipText("CHOOSE A CONS FOR VALIDATION");
			consTempFileName.setPreferredSize(new java.awt.Dimension(84, 25));
			try
			{
				consTempFileName.addActionListener(new java.awt.event.ActionListener()
				{
					public void actionPerformed(java.awt.event.ActionEvent e)
					{
						JFileChooser jf = new JFileChooser();
						if (previousSorurceFileFolder.trim().length() == 0)
						{
							jf.setCurrentDirectory(jf.getCurrentDirectory());
						}
						else
						{
							File currentFile = new File(previousSorurceFileFolder.trim());
							jf.setCurrentDirectory(currentFile);
						}
						jf.setDialogTitle("Open  a CONS File Name");
						int result = jf.showOpenDialog(((JButton) e.getSource()).getParent().getParent().getParent().getParent());
						if (result == JFileChooser.CANCEL_OPTION)
						{
							// No Statement
						}
						else if (result == JFileChooser.ERROR_OPTION)
						{
							// No Statement
						}
						else
						{
							consFileName.setText(jf.getSelectedFile().getPath());
//							consfile = jf.getSelectedFile().getPath();
							previousSorurceFileFolder = jf.getSelectedFile().getPath();
							if (txtErrorFilePath.getText().length() != 0 && txtInputFileName.getText().length() != 0)
								btnValidate.setEnabled(true);
							//Enable the validate button after selecting the I/P file name and Error file name 
						}
					}
				});
			}
			catch (Exception e)
			{
				System.err.println("Exception in  getBtnbrowseConsFileName method  : ");e.printStackTrace();
			}
		}
		return consTempFileName;
	}
	//  Method to validate File Name
	int checkFileFolderName(String testName,String fileFlag)
	{
		if (testName.length() == 0)
			return 1;
		if (fileFlag.equals("C"))
		{	if (testName.length() > 25)
			return 2;
		}
		else
		{	
			if (testName.length() > 12)
			return 2;
		}	
		if (testName.trim().length() >= 5)
		{
			String subName = testName.substring(0, 4);
			//		check if the file name contains  'COM1.' , 'COM2.' , 'LTP1.' , 'LTP2.' , 'NUL.' , 'CON.'     
			if (subName.equalsIgnoreCase("COM1.")
				|| subName.equalsIgnoreCase("COM2.")
				|| subName.equalsIgnoreCase("COM3.")
				|| subName.equalsIgnoreCase("COM4.")
				|| subName.equalsIgnoreCase("COM5.")
				|| subName.equalsIgnoreCase("COM6.")
				|| subName.equalsIgnoreCase("COM7.")
				|| subName.equalsIgnoreCase("COM8.")
				|| subName.equalsIgnoreCase("COM9.")
				|| subName.equalsIgnoreCase("LTP1.")
				|| subName.equalsIgnoreCase("LTP2.")
				|| subName.equalsIgnoreCase("LTP3.")
				|| subName.equalsIgnoreCase("LTP4.")
				|| subName.equalsIgnoreCase("LTP5.")
				|| subName.equalsIgnoreCase("LTP6.")
				|| subName.equalsIgnoreCase("LTP7.")
				|| subName.equalsIgnoreCase("LTP8.")
				|| subName.equalsIgnoreCase("LTP9."))
				return 3;
		}
		if (testName.trim().length() >= 4)
		{
			if (testName.substring(0, 3).equalsIgnoreCase("NUL.") || testName.substring(0, 3).equalsIgnoreCase("CON."))
				return 3;
		}
		//check if the file name contains  '/' , ':' , '?', '>', '<', '*', '"', '|', '\','^', Under score or Space  
		for (int localI = 0; localI < testName.length(); localI++)
		{
			if (testName.charAt(localI) == '/'
				|| testName.charAt(localI) == ':'
				|| testName.charAt(localI) == '*'
				|| testName.charAt(localI) == '?'
				|| testName.charAt(localI) == '"'
				|| testName.charAt(localI) == '<'
				|| testName.charAt(localI) == '>'
				|| testName.charAt(localI) == '|'
				|| testName.charAt(localI) == '\\'
				|| testName.charAt(localI) == ' '
				|| testName.charAt(localI) == '_'
				|| testName.charAt(localI) == '^')
				return 5;
		}
		int alphaDigit = 3;
		for (int localY = 0; localY < testName.length(); localY++)
		{
			if (Character.isLetterOrDigit(testName.charAt(localY)))
			{
				alphaDigit = 0;
				break;
			}
		}
		if (alphaDigit == 3)
		{
			return 3;
		}
		/*		int dotPosition = 3;
			for(int localX = 0; localX < testName.length() ; localX++)
			 {
				if(testName.charAt(localX)== '.' && localX != (testName.length()-1))
				  {
					dotPosition = 0;
				  }
			 }
			
			if(dotPosition == 3)
			 {
				return 3;
			 }
		*/
		return 0;
	}
	/**
	 * This method initializes jButton
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getBtnHelp()
	{
		if (btnHelp == null)
		{
			btnHelp = new javax.swing.JButton();
			btnHelp.setPreferredSize(new java.awt.Dimension(84, 25));
			btnHelp.setActionCommand("Help");
			btnHelp.setText("Read me");
			btnHelp.setToolTipText("OPEN READ ME FILE");
			btnHelp.addActionListener(new java.awt.event.ActionListener()
			{
				public void actionPerformed(java.awt.event.ActionEvent e)
				{
					btnHelp.setEnabled(false);
					jHelpTextPane = new javax.swing.JTextPane();
					jHelpTextPane.setSize(240, 74);
					jHelpTextPane.setEditable(false);
					try
					{
						jHelpTextPane.setPage(getClass().getResource("help.txt"));
						jHelpScrollTextPane.setViewportView(jHelpTextPane);
//						jHelpScrollTextPane.add(jHelpTextPane);
					}
					catch (IOException e1)
					{
						e1.printStackTrace();
					}
					jHelpTextPane.setVisible(true);
					String title = "FVU - Read Me";
					Frame helpFrame = new Frame(title);
					// Create a component to add to the frame
					Component comp = new TextArea();
					// Add the component to the frame; by default, the frame has a border layout
					helpFrame.add(comp, BorderLayout.CENTER);
					// Show the frame
					int width = 600;
					int height = 750;
					helpFrame.setSize(width, height);
					helpFrame.add(jHelpScrollTextPane);
					helpFrame.setLocation(0, 0);
					helpFrame.setVisible(true);
					helpFrame.setIconImage(java.awt.Toolkit.getDefaultToolkit().getImage(getClass().getResource("/nsdl-logo.png")));
					helpFrame.addWindowListener(new WindowAdapter()
					{
						public void windowClosing(WindowEvent evt)
						{
							Frame helpFrame = (Frame) evt.getSource();
							helpFrame.setVisible(false);
							helpFrame.dispose();
							btnHelp.setEnabled(true);
						}
					});
				}
			});
		}
		return btnHelp;
	}
	
	
	public static String logSystemInfo()
	{
		String data = "";
		
		data = System.getProperty("os.arch")+"^"+System.getProperty("os.name")+"^"+System.getProperty("os.version")+"^"+System.getProperty("sun.os.patch.level")+"^"+System.getProperty("java.runtime.version")+"^"+System.getProperty("file.encoding");
		
		return data;
	

	}
	
	// Added for FVU 5.0
	private JButton getViewPDFButton() {
		if (viewPDFButton == null) {
			viewPDFButton = new JButton("Click here to know procedure about filing of e-TDS/TCS statement(s)");
			viewPDFButton.setForeground(Color.red);
		}viewPDFButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				
				if (Desktop.isDesktopSupported()) {
		            try {
		                File myFile = new File( "Filing procedure.pdf");
		                Desktop.getDesktop().open(myFile);
		            } catch (IOException ex) {
		                // no application registered for PDFs
		            }
		        }
		
		}
	});
		return viewPDFButton;
	}
	
	
	public String searchbarcode(String outputFileName){
		
		String FIELD_SEPERATOR="^";
		BufferedReader f = null ;
		 
		String Barcodeval= "";
		System.out.println("searchbarcode called" );
		try {
		f = new BufferedReader (new FileReader(outputFileName));
		String line = f.readLine();
		int isAppendForNextLine = 0;
		boolean NullField;
		boolean FieldFound;
		boolean Caret =false;
		String LineNo=null; 
		
		while (line != null ) { 

			if(line.contains("<CONFEND>"))
			{
					line = f.readLine();
				//	System.out.println("line :: " + line);

					StringTokenizer str = new StringTokenizer(line, FIELD_SEPERATOR, true);

					int localCaretCountBH1 = 0;
					int localCountField_BH1 = 1;

					while (str.hasMoreTokens()) {
						String val = str.nextToken();
						NullField = false;
						FieldFound = false;
						if ((val.equals(FIELD_SEPERATOR) && Caret) || val.length() == 0) {
							NullField = true;
							FieldFound = true;
						}
						if (val.equals(FIELD_SEPERATOR)) {
							Caret = true;
							if (localCountField_BH1 == 1 && localCaretCountBH1 == 0) {
								LineNo = val;
							}
							localCaretCountBH1++;
						} 
						else {
							Caret = false;
							FieldFound = true;
						}

						if (FieldFound) {
							switch (localCountField_BH1) {
							case 7:
								Barcodeval = val;
								break;

							} // Closing switch
							
							localCountField_BH1++;
						} // Closing if
					}

					break;
				}				
				line = f.readLine();

			//	System.out.println("line 2 :: " + line);
			}
   		 f.close();
		
		System.out.println("Barcodeval :" + Barcodeval);
		
		}catch(Exception e) {
			e.printStackTrace();
		}
		
		return Barcodeval;
	}

	
// End ::  Added for FVU 5.0
} //  @jve:visual-info  decl-index=0 visual-constraint="10,10"
