package com.tin.tds.bean;

import java.text.DecimalFormat;
import java.text.DecimalFormatSymbols;
import java.util.Locale;

public class SAMBatchData {

	private static DecimalFormatSymbols sf = new DecimalFormatSymbols(Locale.ENGLISH);
	private static DecimalFormat df  = new DecimalFormat("#.00",sf);
	
	private String batchNo="-";
	private String countOfPanApplied="0";
	private String countOfPanInvalid="0";
	private String countOfPanNotAvbl="0";
	private String lastTan="-";
	private String ddAmtOriginal="-";
	private String ddAmtUpdated="-";
	private String ddAmtAdded="-";
	private String totIcnTaxDedOrg="-";
	private String totIcnTaxDedUpd="-";
	private String totIcnTaxDedAdd="-";
	private String totIcnTaxDedDel="-";
	
	private String totTaxDepOrg="-";
	private String totTaxDepUpd="-";
	private String totTaxDepAdd="-";
	private String totTaxDepDel="-";
	private String totalValueOfPurchase="-";
	private String totalDDRecords="-";
	private String totalSDRecords="-";
	private String dedAtHigherRate="-";
	private String unmatchChallanCount="-";
	private String totTaxableIncome340344="-";
	//FVU 7.6 BUG FIX new requirement .fvu
	private String total94PRecords="-";
	private String totNetTaxPayable="-";
	
	public String getBatchNo() {
		return batchNo;
	}
	public void setBatchNo(String batchNo) {
		this.batchNo = batchNo;
	}
	public String getCountOfPanApplied() {
		return countOfPanApplied;
	}
	public void addCountOfPanApplied() {
		this.countOfPanApplied = String.valueOf(Integer.parseInt(this.countOfPanApplied)+1);
	}
	public String getCountOfPanInvalid() {
		return countOfPanInvalid;
	}
	public void addCountOfPanInvalid() {
		this.countOfPanInvalid = String.valueOf(Integer.parseInt(this.countOfPanInvalid)+1);
	}
	public String getCountOfPanNotAvbl() {
		return countOfPanNotAvbl;
	}
	public void addCountOfPanNotAvbl() {
		this.countOfPanNotAvbl = String.valueOf(Integer.parseInt(this.countOfPanNotAvbl)+1);
	}
	public String getLastTan() {
		return lastTan;
	}
	public void setLastTan(String lastTan) {
		if(lastTan!=null && lastTan.length()==10)
		{
			this.lastTan = lastTan;
		}
	}
	public String getDdAmtOriginal() {
		return ddAmtOriginal;
	}
	public void addDdAmtOriginal(String ddAmtOriginal) {
		if(ddAmtOriginal!=null && !ddAmtOriginal.equals(""))
		{
			if(this.ddAmtOriginal.equals("-"))
			{
				this.ddAmtOriginal = df.format(Double.parseDouble(ddAmtOriginal));
			}
			else
			{
				this.ddAmtOriginal = df.format(Double.parseDouble(this.ddAmtOriginal)+Double.parseDouble(ddAmtOriginal));
			}
		}
	}
	public String getDdAmtUpdated() {
		return ddAmtUpdated;
	}
	public void addDdAmtUpdated(String ddAmtUpdated) {
		if(ddAmtUpdated!=null && !ddAmtUpdated.equals(""))
		{
			if(this.ddAmtUpdated.equals("-"))
			{
				this.ddAmtUpdated = df.format(Double.parseDouble(ddAmtUpdated));
			}
			else
			{
				this.ddAmtUpdated = df.format(Double.parseDouble(this.ddAmtUpdated)+Double.parseDouble(ddAmtUpdated));
			}
		}
	}
	public String getDdAmtAdded() {
		return ddAmtAdded;
	}
	public void addDdAmtAdded(String ddAmtAdded) {
		if(ddAmtAdded!=null && !ddAmtAdded.equals(""))
		{
			if(this.ddAmtAdded.equals("-"))
			{
				this.ddAmtAdded = df.format(Double.parseDouble(ddAmtAdded));
			}
			else
			{
				this.ddAmtAdded = df.format(Double.parseDouble(this.ddAmtAdded)+Double.parseDouble(ddAmtAdded));
			}
		}
	}
	public String getTotIcnTaxDedOrg() {
		return totIcnTaxDedOrg;
	}
	public void addTotIcnTaxDedOrg(String totIcnTaxDedOrg) {
		if(totIcnTaxDedOrg!=null && !totIcnTaxDedOrg.equals(""))
		{
			if(this.totIcnTaxDedOrg.equals("-"))
			{
				this.totIcnTaxDedOrg = df.format(Double.parseDouble(totIcnTaxDedOrg));
			}
			else
			{
				this.totIcnTaxDedOrg = df.format(Double.parseDouble(this.totIcnTaxDedOrg)+Double.parseDouble(totIcnTaxDedOrg));
			}
		}
	}
	public String getTotIcnTaxDedUpd() {
		return totIcnTaxDedUpd;
	}
	public void addTotIcnTaxDedUpd(String totIcnTaxDedUpd) {
		if(totIcnTaxDedUpd!=null && !totIcnTaxDedUpd.equals(""))
		{
			if(this.totIcnTaxDedUpd.equals("-"))
			{
				this.totIcnTaxDedUpd = df.format(Double.parseDouble(totIcnTaxDedUpd));
			}
			else
			{
				this.totIcnTaxDedUpd = df.format(Double.parseDouble(this.totIcnTaxDedUpd)+Double.parseDouble(totIcnTaxDedUpd));
			}
		}
	}
	public String getTotIcnTaxDedAdd() {
		return totIcnTaxDedAdd;
	}
	public void addTotIcnTaxDedAdd(String totIcnTaxDedAdd) {
		if(totIcnTaxDedAdd!=null && !totIcnTaxDedAdd.equals(""))
		{
			if(this.totIcnTaxDedAdd.equals("-"))
			{
				this.totIcnTaxDedAdd = df.format(Double.parseDouble(totIcnTaxDedAdd));
			}
			else
			{
				this.totIcnTaxDedAdd = df.format(Double.parseDouble(this.totIcnTaxDedAdd)+Double.parseDouble(totIcnTaxDedAdd));
			}
		}
	}
	public String getTotIcnTaxDedDel() {
		return totIcnTaxDedDel;
	}
	public void addTotIcnTaxDedDel(String totIcnTaxDedDel) {
		if(totIcnTaxDedDel!=null && !totIcnTaxDedDel.equals(""))
		{
			if(this.totIcnTaxDedDel.equals("-"))
			{
				this.totIcnTaxDedDel = df.format(Double.parseDouble(totIcnTaxDedDel));
			}
			else
			{
				this.totIcnTaxDedDel = df.format(Double.parseDouble(this.totIcnTaxDedDel)+Double.parseDouble(totIcnTaxDedDel));
			}
		}
	}
	public String getTotTaxDepOrg() {
		return totTaxDepOrg;
	}
	public void addTotTaxDepOrg(String totTaxDepOrg) {
		if(totTaxDepOrg!=null && !totTaxDepOrg.equals(""))
		{
			if(this.totTaxDepOrg.equals("-"))
			{
				this.totTaxDepOrg = df.format(Double.parseDouble(totTaxDepOrg));
			}
			else
			{
				this.totTaxDepOrg = df.format(Double.parseDouble(this.totTaxDepOrg)+Double.parseDouble(totTaxDepOrg));
			}
		}
	}
	public String getTotTaxDepUpd() {
		return totTaxDepUpd;
	}
	public void addTotTaxDepUpd(String totTaxDepUpd) {
		if(totTaxDepUpd!=null && !totTaxDepUpd.equals(""))
		{
			if(this.totTaxDepUpd.equals("-"))
			{
				this.totTaxDepUpd = df.format(Double.parseDouble(totTaxDepUpd));
			}
			else
			{
				this.totTaxDepUpd = df.format(Double.parseDouble(this.totTaxDepUpd)+Double.parseDouble(totTaxDepUpd));
			}
		}
	}
	public String getTotTaxDepAdd() {
		return totTaxDepAdd;
	}
	public void addTotTaxDepAdd(String totTaxDepAdd) {
		
		if(totTaxDepAdd!=null && !totTaxDepAdd.equals(""))
		{
			if(this.totTaxDepAdd.equals("-"))
			{
				this.totTaxDepAdd = df.format(Double.parseDouble(totTaxDepAdd));
			}
			else
			{
				this.totTaxDepAdd = df.format(Double.parseDouble(this.totTaxDepAdd)+Double.parseDouble(totTaxDepAdd));
			}
		}
	}
	public String getTotTaxDepDel() {
		return totTaxDepDel;
	}
	public void addTotTaxDepDel(String totTaxDepDel) {
		
		if(totTaxDepDel!=null && !totTaxDepDel.equals(""))
		{
			if(this.totTaxDepDel.equals("-"))
			{
				this.totTaxDepDel = df.format(Double.parseDouble(totTaxDepDel));
			}
			else
			{
				this.totTaxDepDel = df.format(Double.parseDouble(this.totTaxDepDel)+Double.parseDouble(totTaxDepDel));
			}
		}
	}
	public String getTotalValueOfPurchase() {
		return totalValueOfPurchase;
	}
	public void addTotalValueOfPurchase(String totalValueOfPurchase) {
		
		if(totalValueOfPurchase!=null && !totalValueOfPurchase.equals(""))
		{
			if(this.totalValueOfPurchase.equals("-"))
			{
				this.totalValueOfPurchase = df.format(Double.parseDouble(totalValueOfPurchase));
			}
			else
			{
				this.totalValueOfPurchase = df.format(Double.parseDouble(this.totalValueOfPurchase)+Double.parseDouble(totalValueOfPurchase));
			}
		}
	}
	public String getTotalDDRecords() {
		return totalDDRecords;
	}
	public void addTotalDDRecords(String totalDDRecords) {

		if(totalDDRecords!=null && !totalDDRecords.equals(""))
		{
			if(this.totalDDRecords.equals("-"))
			{
				this.totalDDRecords = String.valueOf(Integer.parseInt(totalDDRecords));
			}
			else
			{
				this.totalDDRecords = String.valueOf(Integer.parseInt(this.totalDDRecords)+Integer.parseInt(totalDDRecords));
			}
		}
	}
	public String getTotalSDRecords() {
		return totalSDRecords;
	}
	public void setTotalSDRecords(String totalSDRecords) {
		
		if(totalSDRecords!=null && !totalSDRecords.equals(""))
		{
			this.totalSDRecords = totalSDRecords;
		}
	}
	public String getDedAtHigherRate() {
		return dedAtHigherRate;
	}
	public void addDedAtHigherRate() {

		if(this.dedAtHigherRate.equals("-"))
		{
			this.dedAtHigherRate = String.valueOf(1);
		}
		else
		{
			this.dedAtHigherRate = String.valueOf(Integer.parseInt(this.dedAtHigherRate)+1);
		}

	}
	
	public void setDedAtHigherRate(String dedAtHigherRate) {
		
		if(dedAtHigherRate.equals("-"))
		{
			this.dedAtHigherRate = String.valueOf(0);
		}
		else
		{
			this.dedAtHigherRate = String.valueOf(dedAtHigherRate);
		}
	}
	
	
	
	public String getUnmatchChallanCount() {
		return unmatchChallanCount;
	}
	public void setUnmatchChallanCount(String unmatchChallanCount) {
		
		if(unmatchChallanCount!=null && !unmatchChallanCount.equals(""))
		{
			this.unmatchChallanCount = unmatchChallanCount;
		}
	}
	public String getTotTaxableIncome340344() {
		return totTaxableIncome340344;
	}
	public void addTotTaxableIncome340344(String totTaxableIncome340344) {

		if(totTaxableIncome340344.equals(""))
		{
			totTaxableIncome340344 = "0";
		}
		if(this.totTaxableIncome340344.equals("-"))
		{
			this.totTaxableIncome340344 = df.format(Double.parseDouble(totTaxableIncome340344));
		}
		else
		{
			this.totTaxableIncome340344 = df.format(Double.parseDouble(this.totTaxableIncome340344)+Double.parseDouble(totTaxableIncome340344));
		}
	}
	//FVU 7.6 BUG FIX new requirement .fvu
	public String getTotal94PRecords() {
		return total94PRecords;
	}
	public void setTotal94PRecords(String total94PRecords) {
		
		if(total94PRecords!=null && !total94PRecords.equals(""))
		{
			this.total94PRecords = total94PRecords;
		}
	}
	
	public String getTotNetTaxPayable() {
		return totNetTaxPayable;
	}
	public void addTotNetTaxPayable(String totNetTaxPayable) {

		if(totNetTaxPayable.equals(""))
		{
			totNetTaxPayable = "0";
		}
		if(this.totNetTaxPayable.equals("-"))
		{
			this.totNetTaxPayable = df.format(Double.parseDouble(totNetTaxPayable));
		}
		else
		{
			this.totNetTaxPayable = df.format(Double.parseDouble(this.totNetTaxPayable)+Double.parseDouble(totNetTaxPayable));
		}
	}
}
