/*
 * Author : Madhav
 * SS Version : 5
 */
package com.tin.tds.lower.util;
import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.RandomAccessFile;
import java.math.BigInteger;
import java.security.Security;
import java.security.cert.CertificateFactory;
import java.security.cert.X509Certificate;
import java.sql.Timestamp;
import java.text.SimpleDateFormat;
//import java.time.LocalDateTime;
//import java.time.format.DateTimeFormatter;
import java.util.Calendar;
import java.util.Locale;
import java.util.StringTokenizer;

import javax.crypto.BadPaddingException;
import javax.crypto.Cipher;
import javax.crypto.KeyGenerator;
import javax.crypto.SecretKey;

import com.tin.tds.lower.bean.FileStatistics;

//import sun.misc.BASE64Decoder;
//import sun.misc.BASE64Encoder;


import Decoder.BASE64Decoder;
import Decoder.BASE64Encoder;
/*
ErrorVal	Remarks
------------------------
0		Success (no errors)
1		Input File not found
2		Invalid Input File (
					i. Empty record found 
					ii. At FVU file is having sam/scm info 
					iii. At svu uploadedby is not TFC and file is having sam/scm info
				   )
3		FVU Version is either Incorrect or NULL
4		SAM Version is either Incorrect or NULL
5		SCM Version is either Incorrect or NULL
6		File Header Record Hash Code mismatch
7		Record Level Hash Code mismatch
8		Input File format Error (also if mismatch of number of in the input file.
					For a new file the last char in a record should be '^', 
					and for a file that is already hashed the last character should not be '^')
9		Mismatch of FVU File Level HashCode
10		Mismatch of SAM File Level HashCode
11		Mismatch of SCM File Level HashCode
12		Unknown Error. Exception occured
*/
public class Hash
{
	private String fhString;
	private long fileLevelHC;
	private long fhHC;
	private long fvuFLH;
	private long samFLH;
	private long scmFLH;
	private String fvuVersion = null;
	private String samVersion = null;
	private String scmVersion = null;
	private int utilityLevel;
	private int paperReturnIndiFlag;
	private String inputFileName;
	private String outputFileName;
	private String recStr;
	private int fhFieldCount;
	private BufferedReader br = null;
	private int iErrCode;
	public final static int FVU = 0;
	public final static int SAM = 1;
	public final static int SCM = 2;
	public final static int SVU = 3;
	private int recNo = 0;
	private String consHash = "";
	// added by priyanka for barcode
		 public String inputForBarcode1;
		 public String inputForBarcode2;
		 public String outputForBarcode2;
		 
		  public String currentLine;
		  public String digit9 = null;
		  public String digit99 = null;
		  public String input = "";
		  public int flag = 0;
			
		  private static String value;
			BufferedReader f = null ;
		 
		 // end ::  added by priyanka for barcode
	public int startProcessing(String inputFileName, String outputHashFile, int utilityLevel, int fhFieldCount, int paperReturnIndiFlag) throws Exception
	{
		this.inputFileName = inputFileName;
		this.outputFileName = outputHashFile;
		this.utilityLevel = utilityLevel;
		this.fhFieldCount = fhFieldCount;
		this.paperReturnIndiFlag = paperReturnIndiFlag;
		iErrCode = 0;
		try
		{
			File file = new File(inputFileName);
			if (file.exists() == false)
			{
				iErrCode = 1; //input file not found
				return iErrCode;
			}
			br = new BufferedReader(new FileReader(file));
			recStr = br.readLine();
			if (recStr == null || recStr.length() == 0)
			{
				iErrCode = 2; //empty record found
				return iErrCode;
			}
			tokenizeFileHeader();
			if (iErrCode == 2)
			{
				recNo = 1;
				return iErrCode; //Invalid input file
			}
			switch (utilityLevel)
			{
				case FVU :
					processFVU();
					break;
				case SAM :
					processSAM();
					break;
				case SCM :
					processSCM();
					break;
				case SVU :
					processSVU();
					break;
			}
		}
		catch (Exception e)
		{
			recNo = 1;
			iErrCode = 12; //unknown error. exception occured.
			e.printStackTrace();
			throw e;
		}
		finally
		{
			try
			{
				if (br != null)
					br.close();
			}
			catch (IOException e1)
			{
				e1.printStackTrace();
				throw e1;
			}
		}
		return iErrCode;
	}
	//this method is called at FVU. If the file is not hashed then processFVU_FileNotHashed is called. else processFVU_FileHashed is called. 	
	private boolean processFVU() throws Exception
	{
		//Added by sourabh
		boolean successTDSFile = false;
		boolean successCINFile = false;
		if (samVersion != null || samFLH > 0 || scmVersion != null || scmFLH > 0)
		{
			//In this case SAM version,SAM hash,SCM version,SCM hash 
			//should not be present.  
			recNo = 1;
			iErrCode = 2; //Invalid Input file
			return false;
		}
		//changed by sourabh for validating CIN File
		if (fvuVersion == null && fvuFLH == 0)
		{
			successTDSFile = processFVU_FileNotHashed();
			try{
			if (successTDSFile == true && FileStatistics.getCinUploadFlag() == 1)
			{
				successCINFile = processCINFile();
				if(successCINFile)
				return true;
				else
				{
					try
					{
	
						
						File f = new File(outputFileName);
						f.delete();

					}
					catch(Exception e)
					{
						
					}
					
					return false;
				} 
			}
			else
			return successTDSFile;
			}
			catch(Exception e)
			{
				e.printStackTrace();
				throw e;
				
			}
		}
		else
		{
			successTDSFile = processFVU_FileHashed();
			try{
			if (successTDSFile == true && FileStatistics.getCinUploadFlag() == 1)
			{
				successCINFile = processCINFile();
				
				if(successCINFile)
				return true;
				else
				{
								
					return false;
				} 
				
			}
			else
			return successTDSFile;
			}
			catch(Exception e)
			{
				e.printStackTrace();
				throw e;
			}
		}
	}
	//  this method is called at SAM. If the file is hashed processFVU_FileHashed is called to verify hash.
	private boolean processSAM()
	{

		if (scmVersion != null || scmFLH > 0 || samVersion != null && samFLH > 0 || fvuVersion == null || fvuFLH == 0)
		{
			//in this case FVU version, FVU hash must be present and SAM version,SAM hash,SCM version,SCM hash 
			//should not be present.  
			recNo = 1;
			iErrCode = 2; //Invalid Input file
			return false;
		}

		if (samVersion == null && samFLH == 0)
		{
			return processFVU_FileHashed();
		}
		else
		{
			recNo = 1;
			iErrCode = 2; //Invalid Input file
			return false;
		}

	}

	private boolean processSAM_FileHashed()
	{

		long rlh;
		try
		{
			recNo = 1;
			if (Parameters.ignoreHashing == true)
				return true;

			recStr = recStr.substring(0, recStr.lastIndexOf('^', recStr.lastIndexOf('^', recStr.lastIndexOf('^') - 1) - 1));
			fileLevelHC = hashCode(recStr, true);

			if (Parameters.ignoreRecordLevelHashing == false)
			{
				while ((recStr = br.readLine()) != null)
				{
					recNo++;
					if (recStr.charAt(recStr.length() - 1) == '^')
					{
						iErrCode = 8; //Input File format Error
						return false;
					}
					try
					{
						rlh = Long.parseLong((recStr.substring(recStr.lastIndexOf('^') + 1, recStr.length())).trim());
						recStr = recStr.substring(0, recStr.lastIndexOf('^'));
						if (rlh != hashCode(recStr, true))
						{
							iErrCode = 7; //Record Level Hash Code mismatch at line: recNo
							return false;
						}
						fileLevelHC += (recNo * rlh);
					}
					catch (NumberFormatException e)
					{
						iErrCode = 6; //Input File format Error
						return false;
					}
				}
			}
			else
			{
				while ((recStr = br.readLine()) != null)
				{
					recNo++;
					recStr = recStr.substring(0, recStr.lastIndexOf('^'));
					fileLevelHC += (recNo * hashCode(recStr, true));
				}
			}
			if (fileLevelHC != samFLH)
			{
				iErrCode = 10; //Mismatch of SAM Level HashCode
				return false;
			}
			return true;
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
		return false;

	}

	private boolean processSAM_FileNotHashed()
	{
		BufferedWriter bw = null;
		long pos = 0;
		try
		{
			recNo = 1;
			bw = new BufferedWriter(new FileWriter(outputFileName));
			recStr = recStr.substring(0, recStr.lastIndexOf('^', recStr.lastIndexOf('^', recStr.lastIndexOf('^') - 1) - 1));
			recStr = recStr + Parameters.samVersion[0] + '^';
			pos = recStr.length();
			fileLevelHC = hashCode(recStr, false);
			bw.write(recStr);
			bw.write(get20digitHashCode(fileLevelHC));
			bw.write("^^");
			bw.write('\n');
			while ((recStr = br.readLine()) != null)
			{
				recNo++;
				bw.write(recStr);
				bw.write('\n');
				fileLevelHC += (recNo * Long.parseLong(recStr.substring(recStr.lastIndexOf('^') + 1, recStr.length())));
			}
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
		finally
		{
			try
			{
				bw.close();
			}
			catch (IOException e2)
			{
				e2.printStackTrace();
				return false;
			}
		}
		RandomAccessFile raf = null;
		try
		{
			raf = new RandomAccessFile(outputFileName, "rw");
			raf.seek(pos);
			raf.writeBytes(get20digitHashCode(fileLevelHC));
		}
		catch (IOException e1)
		{
			e1.printStackTrace();
			return false;
		}
		finally
		{
			try
			{
				raf.close();
			}
			catch (IOException e2)
			{
				e2.printStackTrace();
				return false;
			}
		}
		return true;
	}

	//  this method is called at SCM. If the file is hashed processSAM_FileHashed is called to verify hash.
	private boolean processSCM()
	{
		if (paperReturnIndiFlag == 2)
		{
			/* This is a PAPER RETURN FILE. FVU Hash and FVU Version will be checked.
			 * SAM Version and SAM Hash will not be present in file 
			 */
			return processSAM();
		}
		else if (samVersion == null || samFLH == 0 || fvuVersion == null || fvuFLH == 0 || scmVersion != null || scmFLH > 0)
		{
			/* This is a ELECTRONIC RETURN FILE. In this case SAM version,SAM hash, FVU version,
			 * FVU hash must be present and SCM version,SCM hash should not be present.
			 */
			recNo = 1;
			iErrCode = 2; //Invalid Input file
			return false;
		}
		else
		{
			return processSAM_FileHashed();
		}
	}

	private boolean processSCM_FileNotHashed()
	{
		BufferedWriter bw = null;
		long pos = 0;
		try
		{
			recNo = 1;
			bw = new BufferedWriter(new FileWriter(outputFileName));
			recStr = recStr.substring(0, recStr.lastIndexOf('^')) + Parameters.scmVersion[0] + '^';
			pos = recStr.length();
			fileLevelHC = hashCode(recStr, false);
			bw.write(recStr);
			bw.write(get20digitHashCode(fileLevelHC));
			bw.write('\n');
			while ((recStr = br.readLine()) != null)
			{
				recNo++;
				bw.write(recStr);
				bw.write('\n');
				fileLevelHC += (recNo * Long.parseLong(recStr.substring(recStr.lastIndexOf('^') + 1, recStr.length())));
				//				recStr = recStr.substring(0, recStr.lastIndexOf('^'));
				//				fileLevelHC += (recNo * hashCode(recStr));
			}
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
		finally
		{
			try
			{
				bw.close();
			}
			catch (IOException e2)
			{
				e2.printStackTrace();
			}
		}
		RandomAccessFile raf = null;
		try
		{
			raf = new RandomAccessFile(outputFileName, "rw");
			raf.seek(pos);
			raf.writeBytes(get20digitHashCode(fileLevelHC));
		}
		catch (IOException e1)
		{
			e1.printStackTrace();
		}
		finally
		{
			try
			{
				raf.close();
			}
			catch (IOException e2)
			{
				e2.printStackTrace();
			}
		}
		return false;
	}
	//****************************
	//this method is called at svu.
	/*
	 * FH Record hash, FVU and SAM File hash codes are not verified
	 * FVU,SAM and SCM Versions are verified
	 * Record level hash verification is parameterized
	 * hashing and versioning verification are also parameterized
	 */
	private boolean processSVU()
	{
		boolean isTFC;
		long rlh;
		long recLevelHC;
		int k;
		long fvuFileLevelHC = 0;
		//		long samFileLevelHC = 0;
		long scmFileLevelHC = 0;
		if (recStr.indexOf("^T^") != -1)
		{
			isTFC = true; //uploaded by is TFC
		}
		else
		{
			isTFC = false; //uploaded by is Filer
		}
		try
		{
			//if upload by is Filer and sam, scm details are present in the file then reject the file...
			if (isTFC == false)
			{
				if (samVersion != null || samFLH > 0 || scmVersion != null || scmFLH > 0)
				{
					recNo = 1;
					iErrCode = 2; //Invalid File
					return false;
				}
			}
			else /*******SID ADD THIS IN AIR CODE ALSO*******START****/
				{
				if (scmVersion == null || scmFLH == 0)
				{
					recNo = 1;
					iErrCode = 2; //Invalid File
					return false;
				}
			} /*******SID ADD THIS IN AIR CODE ALSO********END***/
			recNo = 1;
			/*****************************************************************************************************************
						if (Parameters.ignoreRecordLevelHashing == false && fhHC != hashCode(fhString, true))
						{
							System.out.println("File Header Hash Code mismatch");
							return false;
						}
			*****************************************************************************************************************/
			if (Parameters.ignoreVersioning == false)
			{
				if (isValidFVUVersion(fvuVersion) == false)
				{
					iErrCode = 3; //Incorrect FVU Version
					return false;
				}
				//if upload by is TFC then sam and scm details cannot be null
				if (isTFC == true)
				{
					if (isValidSAMVersion(samVersion) == false)
					{
						iErrCode = 4; //Incorrect SAM Version
						return false;
					}
					if (isValidSCMVersion(scmVersion) == false)
					{
						iErrCode = 5; //Incorrect SCM Version
						return false;
					}
				}
			}
			if (Parameters.ignoreHashing == true)
				return true;
			k = recStr.lastIndexOf('^');
			recStr = recStr.substring(0, k);
			scmFileLevelHC = hashCode(recStr, true);
			k = recStr.lastIndexOf('^', k - 1);
			k = recStr.lastIndexOf('^', k - 1);
			recStr = recStr.substring(0, k);
			//			samFileLevelHC = hashCode(recStr, true);
			k = recStr.lastIndexOf('^', k - 1);
			k = recStr.lastIndexOf('^', k - 1);
			recStr = recStr.substring(0, k);
			fvuFileLevelHC = hashCode(recStr, true);
			fileLevelHC = 0;
			if (Parameters.ignoreRecordLevelHashing == true)
			{
				while ((recStr = br.readLine()) != null)
				{
					recNo++;
					//recStr = recStr.substring(0, recStr.lastIndexOf('^'));
					k = recStr.lastIndexOf('^');
					try
					{
						recLevelHC = Long.parseLong(recStr.substring(k + 1, recStr.length()));
					}
					catch (NumberFormatException e)
					{
						iErrCode = 6; //Input File format Error
						return false;
					}

					fileLevelHC += (recNo * recLevelHC);
				}
			}
			else
			{
				while ((recStr = br.readLine()) != null)
				{
					recNo++;
					k = recStr.lastIndexOf('^');
					try
					{
						recLevelHC = Long.parseLong(recStr.substring(k + 1, recStr.length()));

					}
					catch (NumberFormatException e)
					{
						iErrCode = 6; //Input File format Error
						return false;
					}

					recStr = recStr.substring(0, k);
					rlh = hashCode(recStr, true);
					if (rlh != recLevelHC)
					{
						iErrCode = 7;
						//mismatch of RecordLevel Hash Code at Record: recNo
						return false;
					}
					fileLevelHC += (recNo * recLevelHC);
				}
			}
			fvuFileLevelHC += fileLevelHC;
			if (isTFC == true)
			{
				/*****************************************************************************************************************
								//  sam is supposed to update the fh record-level hashcode and fvu file-level hashcode 
								//  after making changes to the original file. If it does then uncomment the following block.
								
											if (fvuFileLevelHC != fvuFLH)
											{
												System.out.println("mismatch of FVU File Level HashCode");
												return false;
											}
								
								//	samFileLevelHC += fileLevelHC;
								//	scm is supposed to update the sam file-level hashcode 
								//	after making changes to the file. If it does then uncomment the following block.
												if (samFileLevelHC != samFLH)
												{
													System.out.println("mismatch of SAM File Level HashCode");
													return false;
												}
								//
				*****************************************************************************************************************/
				scmFileLevelHC += fileLevelHC;
				//	checking the details of scm
//				System.out.println("scmFileLevelHC : " + scmFileLevelHC + "\t\t scmFLH : " + scmFLH);
				if (scmFileLevelHC != scmFLH)
				{
					iErrCode = 11; //mismatch of SCM File Level HashCode
					return false;
				}
			}
			else
			{
				if (fvuFileLevelHC != fvuFLH)
				{
					iErrCode = 9; //mismatch of FVU File Level HashCode
					return false;
				}
			}
			return true;
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
		return false;
	}

	private boolean processFVU_FileNotHashed() throws Exception
	{
		long rlh = 0;
		recNo = 1;
		boolean retVal = true;
		BufferedWriter hf = null;
		RandomAccessFile raf = null;
		String unencryptedFileName = outputFileName+".uenc";
		try
		{
			hf = new BufferedWriter(new FileWriter(unencryptedFileName));
			recStr = getFileHeader();
			hf.write(recStr);
			hf.write('^');
			fileLevelHC = hashCode(recStr, true);
			//			if (Parameters.ignoreHashing == false)
			hf.write(get20digitHashCode(fileLevelHC));
			hf.write("^^^^^");
			hf.write(consHash );
			hf.write('\n');
			while ((recStr = br.readLine()) != null)
			{
				recNo++;
				if (recStr.charAt(recStr.length() - 1) != '^')
				{
					iErrCode = 8; //Input File format Error
					retVal = false;
					break;
				}
				hf.write(recStr);
				rlh = hashCode(recStr, false);
				fileLevelHC += (recNo * rlh);
				//				if (Parameters.ignoreRecordLevelHashing == false)
				hf.write(get20digitHashCode(rlh));
				hf.write('\n');
			}
		}
		catch (Exception e)
		{
			e.printStackTrace();
			throw e;
		}
		finally
		{
			try
			{
				if (hf != null)
				{
					hf.close();
					if (retVal == false)
					{
						File f = new File(unencryptedFileName);
						f.delete();
					}
				}
			}
			catch (IOException e)
			{
				e.printStackTrace();
				throw e;
			}
		}
		if (retVal == true)
		{
			try
			{
				raf = new RandomAccessFile(unencryptedFileName, "rw");
				//raf.seek(fhString.length() + 1 /*caret*/ + Parameters.maxHashCodeLength /*FH HC*/ + 1 + Parameters.maxVersionLength /*FVU Ver*/ + 1);
				raf.seek(fhString.length() + 3 + Parameters.maxHashCodeLength + fvuVersion.length());
				raf.writeBytes(get20digitHashCode(fileLevelHC));
			}
			catch (IOException e1)
			{
				e1.printStackTrace();
				throw e1;
			}
			finally
			{
				if (raf != null)
				{
					try
					{
						raf.close();
					}
					catch (IOException e2)
					{
						e2.printStackTrace();
						throw e2;
					}
				}
			}
			
			
			
			
			
			
			//Starting to encrypt the file.
			try
			{
				
				

				//Generating RAW File
				
				//Old Method
//				FormValidator formValidator = new FormValidator();
//				formValidator.readFile(unencryptedFileName, unencryptedFileName+".err", 1);
//				String samScmString = FormValidator.samData.toString();
							
				
				
				//New Method
				
				
				String samScmString = RAWFileGenerator.generateRawFile(unencryptedFileName);
				
				
				
				Security.addProvider(new org.bouncycastle.jce.provider.BouncyCastleProvider()); 
				
				BASE64Encoder enc = new BASE64Encoder();
				BASE64Decoder dec = new BASE64Decoder();
				KeyGenerator keygen = KeyGenerator.getInstance("AES");
				keygen.init(128);
				SecretKey key = keygen.generateKey();

				Cipher aesCipher = Cipher.getInstance("AES","BC");
				aesCipher.init(Cipher.ENCRYPT_MODE, key);
				
				Cipher aesCiphertoDec = Cipher.getInstance("AES","BC");
				aesCiphertoDec.init(Cipher.DECRYPT_MODE, key);
			

				CertificateFactory cf = CertificateFactory.getInstance("X.509");
				X509Certificate cert =(X509Certificate)cf.generateCertificate(new FileInputStream(Parameters.certificateFile));
				
				//Added in FVU 7.1- Check if Certificate is old or not // Obs no 9 09 Mar 2021 - Vinita
				System.out.println("Certificate serial number " +cert.getSerialNumber());
				BigInteger serialNum = new BigInteger("22577027"); // Harcoded latest certificate serial number
				if(!cert.getSerialNumber().equals(serialNum)){ 
					// Error for using old certificate
					iErrCode = 18;  // Obs no 1 - FVU 7.1 - Vinita
					return false;
				}
				
				Cipher rsaCipher = Cipher.getInstance("RSA/ECB/NoPadding","BC");
				rsaCipher.init(Cipher.ENCRYPT_MODE, cert.getPublicKey());
				
				
				
				BufferedReader bfr  = new BufferedReader(new FileReader(unencryptedFileName));
				StringBuffer unencryptedFVUFileData = new StringBuffer();
				String lineData = null;
				
				while((lineData=bfr.readLine())!=null)
				{
					if(lineData.matches("^[0]*1\\^FH\\^.*"))
					{
						int i = 0; 
						while(lineData.charAt(i)!='1')
						{
							i++;
						}
						unencryptedFVUFileData.append(lineData.substring(i)+System.getProperty("line.separator"));
					}
					
					if(lineData.matches("^[0-9]+\\^BH\\^.*"))
					{
						unencryptedFVUFileData.append(lineData+System.getProperty("line.separator"));
					}
				}
				
				File outputFileNameFileObj  = new File(outputFileName);
				FileOutputStream fout = new FileOutputStream(outputFileNameFileObj);
				
				String samStartTag = "<SAMSTART>";
				String samTag ="<SAMEND>";
				
				FileInputStream fileInput = new FileInputStream(unencryptedFileName);
				fout.write(unencryptedFVUFileData.toString().getBytes());
				fout.write(samStartTag.getBytes());
				fout.write(System.getProperty("line.separator").getBytes());
				fout.write("<CONFSTART>".getBytes());
				fout.write(System.getProperty("line.separator").getBytes());
				fout.write(com.tin.FVU.lower.FVU1.logSystemInfo().getBytes());
				fout.write(System.getProperty("line.separator").getBytes());
				fout.write("<CONFEND>".getBytes());
				fout.write(System.getProperty("line.separator").getBytes());
				fout.write(samScmString.getBytes());
				fout.write(samTag.getBytes());
				fout.write(System.getProperty("line.separator").getBytes());
				fout.write(enc.encode(rsaCipher.doFinal(key.getEncoded())).getBytes()); //Storing key
				fout.write("^".getBytes()); // Limiter to determine end of BASE64 Block
				fout.flush();
				
				byte [] data = new byte[1024];
				int readChars = 0;
				while((readChars=fileInput.read(data))!=-1)
				{
					String encodedFinalString  = enc.encode(aesCipher.doFinal(data,0,readChars));
					fout.write(encodedFinalString.getBytes());
					fout.write("^".getBytes());
				}
				
				bfr.close();
				fout.flush();
				fout.close();
				fileInput.close();
				fileInput = null;
				
				
				
				
				
				//Generating file Level Hash
				
				bfr = new BufferedReader(new FileReader(outputFileName));
				String encLine = null;
				long encFileHash = 0;
				int lineNo = 0;
				while((encLine=bfr.readLine())!=null)
				{
					lineNo++;
										
					if(encLine.matches("^[0]*1\\^FH\\^.*"))
					{
						encLine = encLine.substring(0, encLine.lastIndexOf('^'));
						encLine = encLine.substring(0, encLine.lastIndexOf('^'));
						encLine = encLine.substring(0, encLine.lastIndexOf('^'));
						encLine = encLine.substring(0, encLine.lastIndexOf('^'));
						encLine = encLine.substring(0, encLine.lastIndexOf('^'));
						encLine = encLine.substring(0, encLine.lastIndexOf('^'));
					}
					
						encFileHash+=hashCode(encLine, false);
					
				}
				
				bfr.close();
				
				//Adding hash to file on sam record and FH record line 1 and line 5
				
				raf = new RandomAccessFile(outputFileName, "rw");
				
				
				int dataCount = 0;
				
				
				while(dataCount!=12)
				{
					if((char)(raf.read())=='^')
					{
						dataCount++;
					}
				}
				raf.writeBytes(get20digitHashCode(encFileHash));
				raf.close();
				
				
				raf = null;
				bfr = null;
				
				
				File inFileobj = new File(unencryptedFileName);
				inFileobj.delete();
				
				
				
				
				
				//Final check to decrypt the file
				
				ByteArrayOutputStream bout  = new ByteArrayOutputStream();
				FileInputStream fin = new FileInputStream(outputFileName);
				BufferedInputStream fins = new BufferedInputStream(fin);
				
				
				
				int charData = 0;
				while(fins.available()!=0)
				{
					while((charData=fins.read())!=0x0A)
					{
						bout.write(charData);
					}
					if(new String(bout.toByteArray()).trim().equals("<SAMEND>"))
					{
						bout.flush();
						bout.reset();
						break;
					}

					bout.flush();
					bout.reset();
				}
				
				
				while((char)(charData=fins.read())!='^') //skipping key
				{
					bout.write(charData);
				}
				bout.flush();
				bout.reset();
				
				boolean lastBlockCompleted = false;
				while(fins.available()!=0)
				{
					while((char)(charData=fins.read())!='^')
					{
						if(charData==-1)
						{
							lastBlockCompleted = true;
							break;
						}
						bout.write(charData);
					}

					if(lastBlockCompleted==false)
					{
						try
						{
					
							aesCiphertoDec.doFinal(dec.decodeBuffer(new String(bout.toByteArray())));
						}
						catch(BadPaddingException bex)
						{
							bout.flush();
							bout.close();
							fins.close();
							fin.close();
							outputFileNameFileObj.delete();
							throw bex;
						}
						bout.reset();
					}
				}
				
				bout.flush();
				bout.close();
				fins.close();
				fin.close();
				
				
				createBarcode(encFileHash);
				
				
				
				
			}
			catch(Exception e)
			{
				e.printStackTrace();
				throw e;
			}
		}
		return retVal;
	}
	// added by priya for barcode
	private void  createBarcode(long encFileHash)
	{
		boolean retVal = true; // shruti
		char digit1  = 0 ;

		inputForBarcode2 = get20digitHashCode(encFileHash);	
		StringBuilder a = new StringBuilder("");
		//Changes added for 6.5_2.161_2.1293 by Puja
		long time = new java.util.Date().getTime(); 
		Timestamp ts = new Timestamp(time);
		SimpleDateFormat sdf = new SimpleDateFormat("yyMMddHHmmss",Locale.ENGLISH);
		String timeStamp = sdf.format(ts);
        System.out.println(sdf.format(ts));
        outputForBarcode2 = timeStamp.concat((inputForBarcode2.substring(12,20)));
		String tempFileName = "";
		BufferedWriter brTemp = null;
		try
		{
			value=outputForBarcode2;
			//Changes added for 6.5_2.161_2.1293 by Puja
			SimpleDateFormat sfd = new SimpleDateFormat("dd-MM-yyyy HH:mm:ss.SSS",Locale.ENGLISH);
			System.out.println("START # " + sfd.format(Calendar.getInstance().getTime()));
			f = new BufferedReader (new FileReader(outputFileName));
			System.out.println(" Original file object created and file exist");
			tempFileName = outputFileName.replace(".fvu", "_temp.fvu");
			System.out.println("tempFileName String cretaed ::  "+tempFileName);
			brTemp = new BufferedWriter(new FileWriter(tempFileName));
			System.out.println(" brtTemp object created for temp file" );
			String line = f.readLine();
			System.out.println("String line created ");
			int isAppendForNextLine = 0;
			while (line != null ) { 
				if(isAppendForNextLine == 1)
				{
					System.out.println("isAppendForNextLine (Inside if condition ) :: "+isAppendForNextLine);
					brTemp.write(line + outputForBarcode2 + System.getProperty("line.separator"));
					System.out.println(" After appending line "+line + outputForBarcode2);
					isAppendForNextLine =0;
				}
				else
				{
					//System.out.println("Inside else"+line);
					brTemp.write(line + System.getProperty("line.separator"));
				}
				if(line.contains("<CONFEND>"))
				{
					isAppendForNextLine = 1;
				}
				line = f.readLine();
			}

			f.close();
			System.out.println("f.close()");
			f = null;
			System.out.println("f = null");
			brTemp.flush(); 
			System.out.println("brTemp.flush()");
			brTemp.close();
			System.out.println("brTemp.close()");
			brTemp = null;
			System.out.println("brTemp = null;");
			//Changes added for 6.5_2.161_2.1293 by Puja
			System.out.println("END # " + sfd.format(Calendar.getInstance().getTime()));
		}
		catch (Exception e) {
			retVal=false;
			System.out.println("File not read");
			System.out.println("Error in writing fuv file while adding Barcode "+e);
		}
		finally
		{			
			try {
				if (f != null)
				{
					f.close();
					brTemp.flush();
					brTemp.close();
					
					if (retVal == false)
					{
						File ferr = new File(outputFileName);
						ferr.delete();	
						System.out.println("exception fvu file is deleted.");
					}
				}
			}catch (Exception e) {	
				
			}
		}
		try
		{
			File fOriginal = new File(outputFileName);
			fOriginal.delete();
			System.out.println("Original file is deleted");

			File fOriginalTemp = new File(tempFileName);
			fOriginalTemp.renameTo(fOriginal);
			System.out.println("Temp file renamed");
		}
		catch (Exception e) {
			System.out.println("File Delete Failed");
			System.out.println("Error in renaming file while adding Barcode in fvu file "+e);
		}
		finally
		{			
			try {				
					if (retVal == false)
					{
						if (f != null)
						{
						f.close();
						brTemp.flush();
						brTemp.close();
						File ferr2 = new File(tempFileName);
						ferr2.delete();							
						System.out.println("exception temp file is deleted");
						
						File ferr3 = new File(outputFileName);
						ferr3.delete();	
						System.out.println("exception fvu file is deleted.");
						}
					}
				
			}catch (Exception e) {	
				
			}
		}
		
		
//		try {
//
//
//			f = new BufferedReader (new FileReader(outputFileName));
//			while ((currentLine = f.readLine())!=null) 
//			{
//				input+=currentLine + '\n';
//				if (flag == 1) {
//
//					System.out.println("inside flag1");
//					digit9 = currentLine;
//					//System.out.println(digit1);
//					digit99 = digit9.concat(outputForBarcode2);
//					System.out.println("the value of digit99 is " + digit99);
//					//System.out.println(digit11);
//					//System.out.println("the result is" + currentLine.replace(digit1, digit11) );
//					break;
//					//	flag = 0;
//				}
//
//				if (currentLine.contains("<CONFEND>"))
//				{
//					flag =1;
//
//				}
//
//
//			}
//			System.out.println("the input befor replace is " + input);
//			input = input.replace(digit9, digit99);
//			System.out.println("the input is " + input);
//			value=outputForBarcode2;
//
//
//			f.close();
//			//System.out.println(input);
//			FileOutputStream fout1 = new FileOutputStream(outputFileName);
//			System.out.println("bfore file writing");
//			fout1.write(input.getBytes());
//			System.out.println("after file writing");
//			fout1.close();
//		}
//		catch (Exception e) {
//
//			System.out.println("File not read");
//			e.printStackTrace();
//		}
	}



	public static String getBarcode()
	{
		return value;
	}

	// end :: added by priya for barcode
	private boolean processFVU_FileHashed()
	{
		try
		{
			recNo = 1;
			long rlh;

			if (Parameters.ignoreHashing == false && Parameters.ignoreRecordLevelHashing == false && fhHC != hashCode(fhString, true))
			{
				iErrCode = 6; //File Header Hash Code mismatch
				return false;
			}

			//      utility level check added to ignore version check for SAM and SCM

			if (utilityLevel == 0 || utilityLevel == 3)
			{
				if (Parameters.ignoreVersioning == false && isValidFVUVersion(fvuVersion) == false)
				{
					iErrCode = 3; //Incorrect FVU Version
					return false;
				}
			}

			if (Parameters.ignoreHashing == true)
				return true;

			recStr = recStr.substring(0, recStr.lastIndexOf('^', recStr.lastIndexOf('^', recStr.lastIndexOf('^', recStr.lastIndexOf('^', recStr.lastIndexOf('^') - 1) - 1) - 1) - 1));
			fileLevelHC = hashCode(recStr, true);

			if (Parameters.ignoreRecordLevelHashing == false)
			{
				while ((recStr = br.readLine()) != null)
				{
					recNo++;
					//recStr = recStr.substring(0, recStr.lastIndexOf('^'));
					if (recStr.charAt(recStr.length() - 1) == '^')
					{
						iErrCode = 8; //Input File format Error
						return false;
					}
					try
					{
						rlh = Long.parseLong((recStr.substring(recStr.lastIndexOf('^') + 1, recStr.length())).trim());
						recStr = recStr.substring(0, recStr.lastIndexOf('^'));
						if (rlh != hashCode(recStr, true))
						{
							iErrCode = 7;
							//Record Level Hash Code mismatch at line: recNo
							return false;
						}
						fileLevelHC += (recNo * rlh);
					}
					catch (NumberFormatException e)
					{
						iErrCode = 6; //Input File format Error
						return false;
					}
				}
			}
			else
			{
				while ((recStr = br.readLine()) != null)
				{
					recNo++;
					recStr = recStr.substring(0, recStr.lastIndexOf('^'));
					fileLevelHC += (recNo * hashCode(recStr, true));
				}
			}
			if (fileLevelHC != fvuFLH)
			{
				iErrCode = 9; //Mismatch of File Level HashCode
				return false;
			}
			return true;
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
		return false;
	}

	public long hashCode(String recStr, boolean includeCaret)
	{
		long hc = 0;
		int i = 0;
		for (; i < recStr.length(); i++)
		{
			hc += (((int) recStr.charAt(i)) * (i + 1));
		}
		if (includeCaret == true)
			hc += ((i + 1) * ((int) '^'));
		return hc;
	}
	/**************************************************************************************************************
			private String get10digitVersion(String version)
			{
				StringBuffer sb = null;
				if (Parameters.ignoreVersioning == true)
					sb = new StringBuffer();
				else
					sb = new StringBuffer(version);
				for (int i = sb.length(); i < Parameters.maxVersionLength; i++)
					sb.append(' ');
				return sb.toString();
			}
	**************************************************************************************************************/
	public String get20digitHashCode(long hashCode)
	{
		//		StringBuffer sb = null;
		//		if (Parameters.ignoreHashing == true)
		//			sb = new StringBuffer();
		//		else
		//			sb = new StringBuffer(Long.toString(hashCode));
		//
		//		for (int i = sb.length(); i < Parameters.maxHashCodeLength; i++)
		//			sb.append(' ');
		String hashCodeStr = Long.toString(hashCode);
		StringBuffer sb = new StringBuffer();
		for (int i = hashCodeStr.length(); i < Parameters.maxHashCodeLength; i++)
			sb.append('0');
		sb.append(hashCodeStr);
		return sb.toString();
	}
	private String getFileHeader()
	{
		StringBuffer sb = new StringBuffer(fhString);
		sb.append('^');
		sb.append(get20digitHashCode(hashCode(fhString, true)));
		sb.append('^');
		fvuVersion = Parameters.fvuVersion[0];
		sb.append(fvuVersion);
		return sb.toString();
	}
	private boolean isValidFVUVersion(String fvu)
	{
		int i;
		if (fvu == null)
			return false;
		for (i = 0; i < Parameters.fvuVersion.length; i++)
			if (Parameters.fvuVersion[i].trim().equals(fvu.trim()))
				return true;
		return false;
	}
	private boolean isValidSAMVersion(String sam)
	{
		int i;
		if (sam == null)
			return false;
		for (i = 0; i < Parameters.samVersion.length; i++)
			if (Parameters.samVersion[i].trim().equals(sam.trim()))
				return true;
		return false;
	}
	private boolean isValidSCMVersion(String scm)
	{
		int i;
		if (scm == null)
			return false;
		for (i = 0; i < Parameters.scmVersion.length; i++)
			if (Parameters.scmVersion[i].trim().equals(scm.trim()))
				return true;
		return false;
	}
	//Added by sourabh for validating CIN File
	private boolean processCINFile() throws IOException
	{
		System.out.println("In processCINFile method");
		String cinRecStr = "";
		String cinCheckStr = "";
		String cinHashString = "";
		File cinFile = new File(FileStatistics.getCinFileName());//path of hash file
		if (cinFile.exists() == false)
		{
			iErrCode = 14; //CIN input file not found
			
			return false;
		
		}
		BufferedReader cinbr = null;
		BufferedReader cinCheckBr = null;
		String challanCount = "";
		 
		try {
			cinbr = new BufferedReader(new FileReader(cinFile));
			cinCheckBr = new BufferedReader(new FileReader(cinFile));
		} catch (FileNotFoundException e) {
			
			e.printStackTrace();
		}
		int cinrecNo = 0;
		long cinrlh = 0;
		long cinFileLevelHC = 0;
		cinCheckStr = cinCheckBr.readLine();
		if (cinCheckStr == null || cinCheckStr.length() == 0)
		{
			iErrCode = 15; //empty record found
			
			return false;
		}
		StringTokenizer checkToken = new StringTokenizer(cinCheckStr,"^",true);
		// testing for FVU 5.0
		System.out.println("the cinCheckStr is " + cinCheckStr);
		System.out.println("the checktoken no. is" + checkToken);
		System.out.println("the check token count token is " + checkToken.countTokens());
		// end for FVU 5.0
		//if(checkToken.countTokens()!=7) // changed count for FVU 5.0
		//Changes added for  6.7^2.163^2.1295 CSI File by kiran  value to be added as 13 instead of 11

		if(checkToken.countTokens()!=11)
		{
			iErrCode = 13; //Hashing fails for CIN
			System.out.println("checkToken.countTokens()!=3");
			return false;
		}
		
		
		String cinFilehashFromFile = "";
		
		

		try {
			while ((cinRecStr = cinbr.readLine()) != null)
			{
				if(cinRecStr.trim().equals(""))
				{
					iErrCode = 13; 
					System.out.println("cinRecStr.trim().equals");
					return false;
				}
				cinrecNo++;
				int k = cinRecStr.lastIndexOf("^");
				if (cinrecNo ==1)	
				{
					// added for FVU 5.0
					StringTokenizer strtoken = new StringTokenizer(cinRecStr,"^");
					if (strtoken.hasMoreElements()){
						challanCount = strtoken.nextToken();
						}
					System.out.println("the challan count is " + challanCount );
					// ended for FVU 5.0
					cinHashString = cinRecStr.substring(0,k);
					//challanCount = 	cinRecStr.substring(0,k);
					cinFilehashFromFile = cinRecStr.substring(k+1,cinRecStr.length());	
				}
				
				else
				cinHashString = cinRecStr.substring(0, cinRecStr.length());
		
				cinrlh = hashCode(cinHashString,false);
		
				cinFileLevelHC += (cinrecNo * cinrlh);
			}
			// testing for FVU 5.0
			// end for FVU 5.0
			if(!cinFilehashFromFile.equals(get20digitHashCode(cinFileLevelHC)))
			{
				
				iErrCode = 13;		
				return false;
			}
			else
			{
				try{
				
				if(Integer.parseInt(challanCount)!=(cinrecNo-1))
				{
					iErrCode = 16; //challan count doesnt match with cin file header
					
					return false;
				}
				else
				return true;
				}
				catch(NumberFormatException e)
				{
					e.printStackTrace();
					iErrCode = 16; //challan count doesnt match with cin file header
					System.out.println("NumberFormatException e");
					
				}
				
			}
			cinbr.close();
			cinCheckBr.close();
			
			
		} catch (IOException e1) {
			// TODO Auto-generated catch block
			
		}
		
			
		
		return true;
		
	}	
	private void tokenizeFileHeader() throws Exception
	{
		StringBuffer sb = null;
		try
		{
			NewStringTokenizer st = new NewStringTokenizer(recStr, "^");
			sb = new StringBuffer();
			String tokstr = st.nextToken();
			int tok = 0;
			int fhHCIndex = fhFieldCount + 1;
			int fvuVersionIndex = fhHCIndex + 1;
			int fvuFLHIndex = fvuVersionIndex + 1;
			int samVersionIndex = fvuFLHIndex + 1;
			int samFLHIndex = samVersionIndex + 1;
			int scmVersionIndex = samFLHIndex + 1;
			int scmFLHIndex = scmVersionIndex + 1;
			int consHashIndex = scmFLHIndex + 1;
			while (tokstr != null)
			{
				//		tokstr = tokstr.trim();
				tok++;
				if (tok < fhHCIndex)
				{
					sb.append(tokstr);
					if (tok != fhFieldCount)
						sb.append('^');
					if (tok == 2)
					{
						if (!tokstr.equals("FH"))
						{
							iErrCode = 2;
							//throw new Exception("Invalid File");
							break;
						}
					}
				}
				else if (tok == fhHCIndex)
				{
					try
					{
						fhHC = Long.parseLong(tokstr);
					}
					catch (NumberFormatException e)
					{
					}
				}
				else if (tok == fvuVersionIndex && tokstr.length() > 0)
				{
					fvuVersion = tokstr;
				}
				else if (tok == fvuFLHIndex)
				{
					try
					{
						fvuFLH = Long.parseLong(tokstr);
					}
					catch (NumberFormatException e)
					{
					}
				}
				else if (tok == samVersionIndex && tokstr.length() > 0)
				{
					samVersion = tokstr;
				}
				else if (tok == samFLHIndex)
				{
					try
					{
						samFLH = Long.parseLong(tokstr);
					}
					catch (NumberFormatException e)
					{
					}
				}
				else if (tok == scmVersionIndex && tokstr.length() > 0)
				{
					scmVersion = tokstr;
				}
				else if (tok == scmFLHIndex)
				{
					try
					{
						scmFLH = Long.parseLong(tokstr);
					}
					catch (NumberFormatException e)
					{
					}
				}
				else if(tok == consHashIndex)
				{
					consHash = tokstr;
				}
				tokstr = st.nextToken();
			}
		}
		catch (Exception e)
		{
			iErrCode = 2;
			//e.printStackTrace();
			//throw new Exception("Invalid File");
		}
		finally
		{
			if (sb.length() > 0)
			{
				fhString = sb.toString();
			}
		}
	}
	public int getRecordNumber()
	{
		return recNo;
	}
}
