package com.tin.tds;


/* 
 * FVU
 * ------------------------------------------------------------------------------------------------------------------------------------------

/* ------------------------------------------------------------------------------------------------------------------------------------------

 *  Modifications
 *  ------------- 
 *  M01      [M01_B  - Indicates beginning of the code change for M01  & M01_E - End of code change for M01]
 *  ----
 *  Description   : New value 80CCF is added in the list of allowable sections for form 24Q Q4  and section 16
 *  				If there, section should come in the order 80CCE,80CCF,OTHERS
 *  Modified By   : Dhanya P
 *  Modified Date : 09/12/2010
 *  
 *  ------------------------------------------------------------------------------------------------------------------------------------------
 *  
 *  M02     [M02_B  - Indicates beginning of the code change for M02  & M02_E - End of code change for M02] 
 *  ----
 *  Description    : Change in logic for validation in salary details for field Total Taxable Income with Surcharge and Education Cess
 *  				 The following new checks are added
 *  
 *  				 		File must be rejected if Surcharge on Total Income is greater than Total Taxable Income for electronic files.
 *							File must be rejected if Education Cess is greater than Total Taxable Income.
 *							File must be rejected if Surcharge on Total Income and Education Cess both are greater than Total Taxable Income.
 *							File must be rejected if (income tax on total income + surcharge + cess) > Total Taxable Income.
 *	
 *  Modified By    : Dhanya P
 *  Modififed Date : 14/12/2010
 *  
 *  ------------------------------------------------------------------------------------------------------------------------------------------
 *  
 *  ############################################################################################################
 *  Created on Oct 25, 2004
 *  Coding Complete till 28
    ############################################################################################################
 *  
 *  Note : Variables which are Name of Fields in the File format are starts with First Letter Capital
 *  Example : EmployeeName which is Name of Employe in the File Format.
 *  Local Variables starts with small letter.
 *  String Buffer are declared with Capital Letters. 
 *  
 *  
 *  
 */


//import java.awt.print.Paper;

import java.io.BufferedReader;
import java.math.BigDecimal;
import java.util.Arrays;
import java.util.Calendar;
import java.util.GregorianCalendar;
import java.util.HashSet;
import java.util.List;
import java.util.StringTokenizer;

import com.tin.tds.util.FileGenerator;

public class SalaryDetailValidation implements FileValidatorInterface
{
	FormValidator fvO = null;

	public SalaryDetailValidation(FormValidator validator)
	{
		fvO = validator;
	}

	//   processing the deductee till the count is less then the countofdeductee  
	Calendar cal = new GregorianCalendar();

	//   public StringBuffer obj_StringBufferSal = new StringBuffer(500);
	//  StringBuffer DD_obj_StringBuffer = new StringBuffer();
	//  StringBuffer SC_obj_StringBuffer = new StringBuffer();

	FieldValidation obj_FieldValidation = new FieldValidation();

	String tab = "^";
	String LineNo = null;
	String RecType = null;

	boolean deducteeLevelError;
	boolean section16LevelError;
	boolean section10LevelError;
	boolean sectionVIALevelError;
	boolean section8889LevelError;
	boolean salaryDetailAddMode = false;


	boolean validSecVIATotAmount = true;   //Added by Dhanya on 03/02/2011 as 4047 msg has to be displayed only if all the amount in 16A are valid.  


	int prevSalaryDeducteeRecCount = 0;
	double SummationGrossTotIncome = 0;

	double sumOfTotalIncomeTaxDeductedAtSource = 0;
	double sumSection16 = 0;
	double sumSection10 = 0;
	double sumSectionVIA = 0;
	double sumSection8889 = 0;
	double sumTotalTDS = 0;
	double sumSectionVIA80C_80CCC_80CCD_1=0;
	double aggrAmtOfDeductAdmiUndrSec80C_80CCC_80CCD_1=0;
	boolean errorFlagSDC6A=false;
	String ModeSD = null;

	private StringBuffer statisticFileSDRec = new StringBuffer();
	private String statPANRepDelemiter = "&";
	private String statFileDataSeperator = "^";
	//-----Added By Nahush
	public String CurrentDeducteeDetailRecNo = null ;
	public String CurrentlocalSDNumber = null;
	String lineNoOfSalaryDetailRec = "";
	/* To store Line Number of the Salary Detail Record whose Section Records we validate. 
	 * This line number is specified in Error File for the Errors occured in Control Total Fields of Section Record   
	 */

	// If the Value of all these count is Zero(0) then next Salary Detail Record is Read from the file if present.
	String countSec10 = null; // Getting the count of Section 10 after Salary Detail Validation 
	String countSec16 = null; // Getting the count of Section 16 after Salary Detail Validation
	String countSec6A = null; // Getting the count of Section 6A after Salary Detail Validation	
	String countSec88 = null; // Getting the count of Section 88 after Salary Detail Validation

	String[] sec16Array = new String[50]; // Array is used to store the Section 16 ID
	String[] sec10Array = new String[50]; // Array is used to store the Section 10 ID
	String[] secVIAArray = new String[50]; // Array is used to store the Section VI A ID
	String[] sec8889Array = new String[50]; // Array is used to store the Section 88 ID
	HashSet serialNoHS = new HashSet();
	
	//Added for FVU 7.1 for new column (to check in SD sub category)
	boolean wthrOptNewTaxRegimeIsY = false;


	//---- change in parameters done by Nahush 
	public void salaryDetailValidator(
			String record,
			String UploadType,
			int LineCount,
			String RecTypeFM,
			String BH_BatchNo,
			BufferedReader br,
			String TransactionType,
			int countOfBatch,
			String Qperiod,
			String FormNo, //CHANGE AMI
			String FinancialYr,
			String CountOfSalaryDetailRec,
			int i,
			String GrossTotalIncomeSD,
			Calendar RRRDatePresentDate,
			boolean paperReturnFile,
			String lineNoOfBatchRec,
			StringBuffer batchRecDataForPanStat,
			FileGenerator obj_FileGenerator,
			StringBufferTemp obj_StringBuffer,
			String fileNamePrintedinStatRep,
			String upload_Type,
			String PANForThisBatch,
			String BatchUpdationIndicator)
					throws Exception
	{
		System.out.println("Method Called");
		boolean NullField = false;
		boolean error = false;
		boolean error_flag = false;
		boolean Caret = true;
		boolean FieldFound = false;
		boolean duplicateFileHeader = false;
		LineNo = Integer.toString(LineCount);
		String CH_BatchNo = "";
		String DD_BatchNo = null;
		String DeducteeDetailRecNo = null;
		int countOfLocalSalaryDeductee = Integer.parseInt(CountOfSalaryDetailRec.trim());
		salaryDetailAddMode = false;
		prevSalaryDeducteeRecCount = 0;
		sumOfTotalIncomeTaxDeductedAtSource = 0;
		deducteeLevelError = true;
		int DeducteeCount = 0;
		serialNoHS.clear();
		SummationGrossTotIncome = 0;
		RecType = RecTypeFM;

		try
		{
			//added for fvu 4.5 by Shalin
			if(TransactionType.equals(FIELD_NULL) || TransactionType.equals(FIELD_SEPERATOR))
				TransactionType = UPLOADTYPE_REGULAR;
			
			aggrAmtOfDeductAdmiUndrSec80C_80CCC_80CCD_1=0;
			for (int localDeducteeCount = 1; localDeducteeCount <= countOfLocalSalaryDeductee; localDeducteeCount++)
			{
				String FormNumber = null;
				String EmployeeSerialNo = null;
				String EmployeePan = null;
				String EmployeePanRefNo = null;
				String SalaryAsPerProvisionSec17 = null;
				String NumberPerqRecords = null;
				String ValueOfPerq17 = null;
				String ProfitSalSec17 = null;
				String GrossSalary = null;
				String CountDeducteeSec10 = null;
				String GrossTotalDeducteeSec10 = null;
				String TotalSal906 = null;
				String CountDeducteeSec16 = null;
				String GrossTotalDeducteeSec16 = null;
				String IncomeChargeableUderTheHeadSalaries = null;
				String IncomeIncludingLossFrmHouseProUderAnyHeadOtherThanIncomeUderTheHeadSalOfferedForTds = null;
				String GrossTotIncome = null;
				String LastGrossTotIncome = null;
				String CountDeducteeChapVIDetails = null;
				String GrossTotDeducteeChapVIDetails = null;
				String TotTaxableIncome213217 = null;
				String IncomeTaxOnTotIncome = null;
				String CountDeducteeSec8889 = null;
				String GrossTotDeducteeSec8889 = null;
				String NetTaxPayable = null;
				String TotIncomeTaxDeductedAtSource226227 = null;
				String TaxPayRef = null;

				sumSection10 = 0; // Initialise Section 10 Amount to 0 (ZERO)		
				sumSection16 = 0; // Initialise Section 16 Amount to 0 (ZERO)
				sumSection8889 = 0; // Initialise Section 88 Amount to 0 (ZERO)
				sumSectionVIA = 0; // Initialise Section VI-A Amount to 0 (ZERO)

				sec16Array = new String[50]; // Initialise Section 16 Array
				sec10Array = new String[50]; // Initialise Section 10 Array
				sec8889Array = new String[50]; // Initialise Section 88 Array
				secVIAArray = new String[50]; // Initialise Section VI-A Array

				String localSalaryDetailNo = "";
				/*
				 * If Record Type is not Salary Detail(SD) then we read the next line form the file.
				 */
				if (!(RecType.equals(SALARY_STATEMENT_IDENTIFIER)))
				{
					record = br.readLine();
					LineCount++;
					int localCountField_DD = 1;
					int localCaretCount = 0;
					String localSDNumber = "-";

					if (record == null || record.length() == 0)
					{
						obj_StringBuffer.append(lineNoOfBatchRec + tab + upload_Type + tab + "NA" + tab + tab + tab + T_FV_2129_C + tab + T_FV_2129_M);
						fvO.returnRecordType = RecType;
						fvO.returnLineCount = LineCount;
						fvO.returnRecord = record;
						return;
					}
					if (record != null || record.length() > 0)
					{
						StringTokenizer st_DD = new StringTokenizer(record, "^", true);
						while (st_DD.hasMoreTokens())
						{
							String val = st_DD.nextToken();
							NullField = false;
							FieldFound = false;
							if ((val.equals(FIELD_SEPERATOR) && Caret) || val.length() == 0)
							{
								NullField = true;
								FieldFound = true;
							}
							if (val.equals(FIELD_SEPERATOR))
							{
								Caret = true;
								if (localCaretCount == 0 && localCountField_DD == 1)
								{
									//        localCountField_DD++;
									LineNo = "";
								}
								localCaretCount++;
							}
							else
							{
								Caret = false;
								FieldFound = true;
							}
							if (localCountField_DD > 4)
							{
								break;
							}
							if (FieldFound)
							{
								switch (localCountField_DD)
								{
								case 1 :
									LineNo = val;
									break;
								case 2 :
									RecType = val;
									break;
								case 4 :
									localSDNumber = val;
									localSalaryDetailNo = val;
									break;

								} //Closing switch
								localCountField_DD++;
							} //Closing if
						}
					}

					if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_BATCH) || TransactionType.equals(TRANSACTIONTYPE_CANCELLATION_BATCH))

						CurrentlocalSDNumber = "Null";

					else

						CurrentlocalSDNumber = localSDNumber;


					if (localCaretCount != 4)
					{
						obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary record Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_4064_C + tab + T_FV_4064_M);
						continue;
					}
					//			checking for non availablity of the Deductee
					if ((record == null || record.length() == 0) && localDeducteeCount <= countOfLocalSalaryDeductee)
					{
						obj_StringBuffer.append(lineNoOfBatchRec + tab + upload_Type + tab + "NA" + tab + tab + tab + T_FV_2129_C + tab + T_FV_2129_M);
						fvO.returnRecordType = RecType;
						fvO.returnLineCount = LineCount;
						fvO.returnRecord = record;
						return;
					}
					if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && !RecType.equals(SALARY_STATEMENT_IDENTIFIER))
					{
						obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary record Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_4124_C + tab + T_FV_4124_M);
						continue;
					}
					//to be added here
					
				} // if (!(RecType.equals(SALARY_STATEMENT_IDENTIFIER) ))

				if (RecType.equals(SALARY_STATEMENT_IDENTIFIER))
				{
					if (record == null || record.length() == 0)
					{
						if (!(localDeducteeCount <= countOfLocalSalaryDeductee))
						{
							obj_StringBuffer.append(lineNoOfBatchRec + tab + upload_Type + tab + "NA" + tab + tab + tab + T_FV_2129_C + tab + T_FV_2129_M);
						}
						fvO.returnRecordType = RecType;
						fvO.returnLineCount = LineCount;
						fvO.returnRecord = record;
						return;
					}

					DeducteeCount++;
					cal = new GregorianCalendar();

					if (localDeducteeCount == countOfLocalSalaryDeductee)
					{
						fvO.lastSalaryDeducteeError1 = obj_StringBuffer.errorBufferString.length();
					}

					long salDetailErrRecLengthBefore = obj_StringBuffer.errorBufferString.length();
					validateSalaryDeducteeDetails(
							record,
							LineCount,
							BH_BatchNo,
							DeducteeCount,
							countOfLocalSalaryDeductee,
							TransactionType,
							UploadType,
							Qperiod,
							FormNo, //CHANGE AMI
							FinancialYr,
							GrossTotalIncomeSD,
							RRRDatePresentDate,
							paperReturnFile,
							lineNoOfBatchRec,
							batchRecDataForPanStat,
							obj_FileGenerator,
							obj_StringBuffer,
							fileNamePrintedinStatRep,
							upload_Type,
							PANForThisBatch,
							BatchUpdationIndicator);

					cal = new GregorianCalendar();
					if (localDeducteeCount == countOfLocalSalaryDeductee)
					{

						fvO.lastSalaryDeducteeError2 = obj_StringBuffer.errorBufferString.length();

						if ((fvO.lastSalaryDeducteeError2 - fvO.lastSalaryDeducteeError1) == 0)
						{
							fvO.lastSalaryDeducteeFlag = true;
						}
						else
						{
							fvO.lastSalaryDeducteeFlag = false;
						}
					}

					long salDetailErrRecLengthAfter = obj_StringBuffer.errorBufferString.length();

					//boolean errorInSalaryDetailRec = false;
					if ((salDetailErrRecLengthAfter - salDetailErrRecLengthBefore) != 0)
					{
						fvO.errorInSalaryDetailRec = true;
					}
					else
					{
						fvO.errorInSalaryDetailRec = false;
					}
					/*
					 *  This validation checks if the count of all Sections for one Salary Detail Record  				
					 *  If count of any Section is not equal to 0, sectionCountError flag is set to false else true
					 */
					boolean sectionCountError = false;
					try
					{
						if (/*Integer.parseInt(countSec10.trim()) == 0
																																																																																																																																																																																																																																																																																																																																																																																					&&*/
								Integer.parseInt(countSec16.trim()) == 0 && Integer.parseInt(countSec6A.trim()) == 0 /*&& Integer.parseInt(countSec88.trim()) == 0*/
								)
						{
							sectionCountError = true;
						}
						else
							sectionCountError = false;
					}
					catch (Exception e)
					{
						sectionCountError = false;
					}
					// This validation checks if the count of all Sections for one Salary Detail Record 				  

					if (fvO.errorInSalaryDetailRec
							|| TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN)
							|| (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D"))
							|| (sectionCountError == true))
					{
						error = true;
						deducteeLevelError = false;

						if ((localDeducteeCount <= countOfLocalSalaryDeductee) || (i <= countOfBatch))
						{
							String LocalMode = null;
							do
							{
								record = br.readLine();
								LineCount++;
								if (record == null || record.length() == 0)
								{
									if ((localDeducteeCount != countOfLocalSalaryDeductee))
									{
										obj_StringBuffer.append(lineNoOfBatchRec + tab + upload_Type + tab + "NA" + tab + tab + tab + T_FV_2129_C + tab + T_FV_2129_M);
									}
									fvO.returnRecordType = RecType;
									fvO.returnLineCount = LineCount;
									fvO.returnRecord = record;
									return;
								}

								int localCaretCount = 0;
								int localCountField_DD = 1;
								String localSDNumber = "-";
								StringTokenizer st_DD = new StringTokenizer(record, "^", true);

								LineNo = null;
								RecType = null;

								while (st_DD.hasMoreTokens())
								{
									String val = st_DD.nextToken();
									NullField = false;
									FieldFound = false;
									if ((val.equals(FIELD_SEPERATOR) && Caret) || val.length() == 0)
									{
										NullField = true;
										FieldFound = true;
									}
									if (val.equals(FIELD_SEPERATOR))
									{
										Caret = true;
										if (localCaretCount == 0 && localCountField_DD == 1)
										{
											//          localCountField_DD++;
											LineNo = "";
										}
										localCaretCount++;
									}
									else
									{
										Caret = false;
										FieldFound = true;
									}

									if (localCountField_DD > 5)
									{
										break;
									}
									if (FieldFound)
									{
										switch (localCountField_DD)
										{
										case 1 :
											LineNo = val;
											break;
										case 2 :
											RecType = val;
											break;
										case 4 :
											localSDNumber = val;
											break;
										case 5 :
											LocalMode = val;

										} //Closing switch
										localCountField_DD++;
									} //Closing if
								}


								if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_BATCH) || TransactionType.equals(TRANSACTIONTYPE_CANCELLATION_BATCH))

									CurrentlocalSDNumber = "Null";

								else

									CurrentlocalSDNumber = localSDNumber;





								if (localCaretCount != 2 && ((LineNo == null || LineNo.length() == 0) || (RecType == null || RecType.length() == 0)))
								{
									if (LineNo == null || LineNo.length() == 0)
										obj_StringBuffer.append("-" + tab + upload_Type + tab + "Line No" + tab + tab + CurrentlocalSDNumber + tab + T_FV_4004_C + tab + T_FV_4004_M);
									else if ((RecType == null || RecType.length() == 0))
										obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Record Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_4124_C + tab + T_FV_4124_M);
									else
										obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "NA" + tab + tab + CurrentlocalSDNumber + tab + T_FV_4064_C + tab + T_FV_4064_M);
									continue;
								}
								if (localCaretCount < 5)
								{
									obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "NA" + tab + tab + CurrentlocalSDNumber + tab + T_FV_4064_C + tab + T_FV_4064_M);
									continue;
								}
								if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN) && !(RecType.equals(SALARY_STATEMENT_IDENTIFIER) || RecType.equals(SEC_194P_STATEMENT_IDENTIFIER))) //28 March 2022 added for 7.5_2.171_2.1303
								{
									if ((localDeducteeCount == countOfLocalSalaryDeductee) && RecType.equals(BATCH_HEADER_IDENTIFIER))
									{
										/*
										 *  In case of Multiple Batch Correction, after Validation of all the Salary Detail Record
										 *  if a Batch Record is fountd we donot log error. Else we log error 
										 */
										System.out.println("In C5 If");
									}
									else
									{

										System.out.println("In C5 Else");
										obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "NA" + tab + tab + CurrentlocalSDNumber + tab + T_FV_4106_C + tab + T_FV_4106_M);
										continue;
									}
								}

								if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D") && !RecType.equals(SALARY_STATEMENT_IDENTIFIER))
								{
									if ((localDeducteeCount == countOfLocalSalaryDeductee) && RecType.equals(BATCH_HEADER_IDENTIFIER))
									{
										/*
										 *  In case of Multiple Batch Correction, after Validation of all the Salary Detail Record
										 *  if a Batch Record is fountd we donot log error. Else we log error 
										 */
									}
									else
									{
										obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "NA" + tab + tab + CurrentlocalSDNumber + tab + T_FV_2139_C + tab + T_FV_2139_M);
										continue;
									}
								}
								else if ((localDeducteeCount == countOfLocalSalaryDeductee) && RecType.equals(SALARY_STATEMENT_IDENTIFIER))
								{
									obj_StringBuffer.append(lineNoOfBatchRec + tab + upload_Type + tab + "NA" + tab + tab + tab + T_FV_2129_C + tab + T_FV_2129_M);
								}
								else if (sectionCountError && !RecType.equals(SALARY_STATEMENT_IDENTIFIER) && !RecType.equals(BATCH_HEADER_IDENTIFIER) &&  !RecType.equals(SEC_194P_STATEMENT_IDENTIFIER)) //08 April 2022 added for 7.5_2.171_2.1303
								{
									obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Record Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_4124_C + tab + T_FV_4124_M);
								}
								else if ((localDeducteeCount != countOfLocalSalaryDeductee) && RecType.equals(BATCH_HEADER_IDENTIFIER))
								{
									obj_StringBuffer.append(lineNoOfBatchRec + tab + upload_Type + tab + "NA" + tab + tab + tab + T_FV_2129_C + tab + T_FV_2129_M);
								}

							}
							while (!(RecType.equals(BATCH_HEADER_IDENTIFIER) || RecType.equals(SALARY_STATEMENT_IDENTIFIER)  ||  RecType.equals(SEC_194P_STATEMENT_IDENTIFIER)));// Added on 30 Mar 2022 - VK

							if (RecType.equals(BATCH_HEADER_IDENTIFIER))
							{
								fvO.returnRecordType = RecType;
								fvO.returnLineCount = LineCount;
								fvO.returnRecord = record;
								return;
							}
							if (RecType.equals(SEC_194P_STATEMENT_IDENTIFIER))// Added on 30 Mar 2022 - VK
							{
								fvO.returnRecordType = RecType;
								fvO.returnLineCount = LineCount;
								fvO.returnRecord = record;
								return;
							}
							if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A") && !RecType.equals(SALARY_STATEMENT_IDENTIFIER))
							{
								fvO.returnRecordType = RecType;
								fvO.returnLineCount = LineCount;
								fvO.returnRecord = record;
								return;
							}
							else if (RecType.equals(SALARY_STATEMENT_IDENTIFIER))
							{
								continue;
							}
						}
						else
						{
							continue;
						}
					}
					else
					{
						error = false;
						deducteeLevelError = true;
						StringTokenizer st_DD = new StringTokenizer(record, "^", true);
						//String[] deducteeFields = new String[110];
						// Added by Priya for FVU 5.2
						String[] deducteeFields = new String[161];
						int localX = 0;
						int fieldCounter = 0;
						while (st_DD.hasMoreTokens())
						{
							fieldCounter++;
							//System.out.println("fieldCounter"+fieldCounter);
							String data = st_DD.nextToken();

							if (data.equals("^") && fieldCounter == 1)
							{
								fieldCounter++;
								deducteeFields[fieldCounter] = "";
							}
							else if (!data.equals("^") && fieldCounter == 1)
							{
								deducteeFields[fieldCounter] = data;
							}
							else if (data.equals("^") && (fieldCounter % 2) == 1)
							{
								fieldCounter++;
								deducteeFields[fieldCounter] = "";
							}
							else if (!data.equals("^") && (fieldCounter % 2) == 1)
							{
								deducteeFields[fieldCounter] = data;
							}
						}

						LineNo = deducteeFields[1];
						RecType = deducteeFields[3];
						DD_BatchNo = deducteeFields[5];
						DeducteeDetailRecNo = deducteeFields[7];
						ModeSD = deducteeFields[9];
						EmployeeSerialNo = deducteeFields[11];
						EmployeePan = deducteeFields[13];
						EmployeePanRefNo = deducteeFields[15];
						ProfitSalSec17 = deducteeFields[27];
						CountDeducteeSec16 = deducteeFields[29];
						GrossTotalDeducteeSec16 = deducteeFields[31];
						GrossTotIncome = deducteeFields[37];
						LastGrossTotIncome = deducteeFields[39];
						CountDeducteeChapVIDetails = deducteeFields[41];
						GrossTotDeducteeChapVIDetails = deducteeFields[43];
						IncomeTaxOnTotIncome = deducteeFields[47];
						NetTaxPayable = deducteeFields[55];


						if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_BATCH) || TransactionType.equals(TRANSACTIONTYPE_CANCELLATION_BATCH))
						{
							CurrentDeducteeDetailRecNo = "Null";
						}

						else
						{
							CurrentDeducteeDetailRecNo = DeducteeDetailRecNo;
						}



					}

				} // if((RecType.equals(QUATAR_DEDUCTEE_HEADER_IDENTIFIER)))
				else
				{
					deducteeLevelError = false;
					obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Detail Record Type" + tab + tab + localSalaryDetailNo + tab + T_FV_4124_C + tab + T_FV_4124_M);

					/*
					 * If Batch Record is identified We return to the FormValidator.java Class
					 */
					if (RecType.equals(BATCH_HEADER_IDENTIFIER))
					{
						fvO.returnRecordType = RecType;
						fvO.returnLineCount = LineCount;
						fvO.returnRecord = record;
						return;
					}
					else if (RecType.equals(SEC_194P_STATEMENT_IDENTIFIER)) // Added on 30 Mar 2022 - VK
					{
						fvO.returnRecordType = RecType;
						fvO.returnLineCount = LineCount;
						fvO.returnRecord = record;
						return;
					}

					do
					{

						record = br.readLine();
						LineCount++;
						if (record == null || record.length() == 0)
						{
							if (!(localDeducteeCount <= countOfLocalSalaryDeductee))
							{
								obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Detail Record Type" + tab + tab + localDeducteeCount + tab + T_FV_4124_C + tab + T_FV_4124_M);
							}
							fvO.returnRecordType = RecType;
							fvO.returnLineCount = LineCount;
							fvO.returnRecord = record;
							return;
						}

						int localCountField_DD = 1;
						int localCaretCount = 0;
						String localSDNumber = "-";
						LineNo = null;
						RecType = null;

						StringTokenizer st_DD = new StringTokenizer(record, "^", true);
						while (st_DD.hasMoreTokens())
						{
							String val = st_DD.nextToken();
							NullField = false;
							FieldFound = false;
							if ((val.equals(FIELD_SEPERATOR) && Caret) || val.length() == 0)
							{
								NullField = true;
								FieldFound = true;
							}
							if (val.equals(FIELD_SEPERATOR))
							{
								Caret = true;
								if (localCaretCount == 0 && localCountField_DD == 0)
								{
									localCountField_DD++;
									LineNo = "";
								}
								localCaretCount++;
							}
							else
							{
								Caret = false;
								FieldFound = true;
							}

							if (localCountField_DD > 4)
							{
								break;
							}
							if (FieldFound)
							{
								switch (localCountField_DD)
								{
								case 1 :
									LineNo = val;
									break;
								case 2 :
									RecType = val;
									break;
								case 4 :
									localSDNumber = val;
									break;
								} //Closing switch
								localCountField_DD++;
							} //Closing if
						}


						if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_BATCH) || TransactionType.equals(TRANSACTIONTYPE_CANCELLATION_BATCH))

							CurrentlocalSDNumber = "Null";

						else

							CurrentlocalSDNumber = localSDNumber;





						if (localCaretCount != 4 && ((LineNo == null || LineNo.length() == 0) || (RecType == null || RecType.length() == 0)))
						{
							obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "NA" + tab + tab + CurrentlocalSDNumber + tab + T_FV_4064_C + tab + T_FV_4064_M);
							continue;
						}

						if (localCaretCount < 4)
						{
							obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "NA" + tab + tab + CurrentlocalSDNumber + tab + T_FV_4064_C + tab + T_FV_4064_M);
							continue;
						}
					}
					while (!(RecType.equals(BATCH_HEADER_IDENTIFIER) || RecType.equals(SALARY_STATEMENT_IDENTIFIER)));

					if (RecType.equals(BATCH_HEADER_IDENTIFIER))
					{
						fvO.returnRecordType = RecType;
						fvO.returnLineCount = LineCount;
						fvO.returnRecord = record;
						return;
					}
					else if (RecType.equals(SALARY_STATEMENT_IDENTIFIER))
					{
						continue;
					}

				}

				//    Checking Section 16 records
				int section16ValidCount = 0;
				section16LevelError = true;

				int errorCountCode = obj_FieldValidation.checkNumeric(CountDeducteeSec16, 9);

				if (errorCountCode == 4)
				{
					if (deducteeLevelError && Integer.parseInt(CountDeducteeSec16.trim()) > 0)
					{
						for (int localCountSec16 = 0; localCountSec16 < Integer.parseInt(CountDeducteeSec16.trim()); localCountSec16++)
						{

							if (!(RecType.equals(SECTION16_HEADER_IDENTIFIER)))
							{
								record = br.readLine();
								LineCount++;

								if (record == null || record.length() == 0)
								{
									if (localCountSec16 < Integer.parseInt(CountDeducteeSec16.trim()))
									{
										obj_StringBuffer.append(lineNoOfSalaryDetailRec + tab + upload_Type + tab + "Count of ' Salary Details  - Section 16 Detail ' Records  associated with this Deductee" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6030_C + tab + T_FV_6030_M);
									}
									fvO.returnRecordType = RecType;
									fvO.returnLineCount = LineCount;
									fvO.returnRecord = record;
									break;
								}
								if (record != null || record.length() > 0)
								{
									int localCountField_DD = 1;
									int localCaretCount = 0;

									StringTokenizer st_DD = new StringTokenizer(record, "^", true);
									while (st_DD.hasMoreTokens())
									{
										String val = st_DD.nextToken();
										NullField = false;
										FieldFound = false;
										if ((val.equals(FIELD_SEPERATOR) && Caret) || val.length() == 0)
										{
											NullField = true;
											FieldFound = true;
										}
										if (val.equals(FIELD_SEPERATOR))
										{
											Caret = true;
											if (localCaretCount == 0 && localCountField_DD == 1)
											{
												//         localCountField_DD++;
												LineNo = "";
											}
											localCaretCount++;
										}
										else
										{
											Caret = false;
											FieldFound = true;
										}

										if (localCountField_DD > 3)
										{
											break;
										}

										if (FieldFound)
										{
											switch (localCountField_DD)
											{
											case 1 :
												LineNo = val;
												break;
											case 2 :
												RecType = val;
												break;
											} //Closing switch
											localCountField_DD++;
										} //Closing if
									} //Closing While	

									if (localCaretCount < 3)
									{
										obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "NA" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6001_C + tab + T_FV_6001_M);
										continue;
									}
								}
								//			checking for non availablity of the Deductee
								if ((record == null || record.length() == 0) && (localCountSec16 + 1) <= Integer.parseInt(CountDeducteeSec16.trim()))
								{
									obj_StringBuffer.append(lineNoOfSalaryDetailRec + tab + upload_Type + tab + "Count of ' Salary Details  - Section 16 Detail ' Records  associated with this Deductee " + tab + tab + CurrentlocalSDNumber + tab + T_FV_6030_C + tab + T_FV_6030_M);
									section16LevelError = false;
									fvO.returnRecordType = RecType;
									fvO.returnLineCount = LineCount;
									fvO.returnRecord = record;
									break;
									//	   return obj_StringBufferSal ;
								}
							}

							if (RecType.equals(SECTION16_HEADER_IDENTIFIER))
							{
								section16ValidCount++;
								cal = new GregorianCalendar();
								long sec16ErrRecLengthBefore = obj_StringBuffer.errorBufferString.length();


								validateSection16(
										record,
										LineCount,
										BH_BatchNo,
										DeducteeDetailRecNo,
										CountDeducteeSec16,
										GrossTotalDeducteeSec16,
										section16ValidCount,
										paperReturnFile,
										obj_StringBuffer,
										upload_Type,FinancialYr,Qperiod,TransactionType);

								cal = new GregorianCalendar();
								long sec16ErrRecLengthAfter = obj_StringBuffer.errorBufferString.length();

								boolean errorInSec16Record = false;
								if ((sec16ErrRecLengthAfter - sec16ErrRecLengthBefore) != 0)
								{
									errorInSec16Record = true;
								}
								else
								{
									errorInSec16Record = false;
								}
								if (!errorInSec16Record)
								{
									error = false;
									section16LevelError = true;

									if (section16ValidCount < Integer.parseInt(CountDeducteeSec16.trim()))
									{
										record = br.readLine();
										LineCount++;

										if (record == null || record.length() == 0)
										{
											obj_StringBuffer.append(lineNoOfSalaryDetailRec + tab + upload_Type + tab + "Count of ' Salary Details  - Section 16 Detail ' Records  associated with this Deductee " + tab + tab + CurrentlocalSDNumber + tab + T_FV_6030_C + tab + T_FV_6030_M);
											fvO.returnRecordType = RecType;
											fvO.returnLineCount = LineCount;
											fvO.returnRecord = record;
											break;
											//	 return obj_StringBufferSal;
										}

										int localCaretCount = 0;
										int localCountField_DD = 1;
										StringTokenizer st_DD = new StringTokenizer(record, "^", true);
										while (st_DD.hasMoreTokens())
										{
											String val = st_DD.nextToken();
											NullField = false;
											FieldFound = false;
											if ((val.equals(FIELD_SEPERATOR) && Caret) || val.length() == 0)
											{
												NullField = true;
												FieldFound = true;
											}
											if (val.equals(FIELD_SEPERATOR))
											{
												Caret = true;
												localCaretCount++;
											}
											else
											{
												Caret = false;
												FieldFound = true;
											}

											if (localCountField_DD > 2)
											{
												break;
											}
											if (FieldFound)
											{
												switch (localCountField_DD)
												{
												case 1 :
													LineNo = val;
													break;
												case 2 :
													RecType = val;
													break;

												} //Closing switch
												localCountField_DD++;
											} //Closing if
										} //Closing While	

										if (localCaretCount < 2)
										{
											obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "NA" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6001_C + tab + T_FV_6001_M);
											continue;
										}

										if (RecType.equals(SECTION16_HEADER_IDENTIFIER))
										{
											continue;
										}
										else if (RecType.equals(BATCH_HEADER_IDENTIFIER))
										{
											obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Detail record Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6006_C + tab + T_FV_6006_M);
											fvO.returnRecordType = RecType;
											fvO.returnLineCount = LineCount;
											fvO.returnRecord = record;
											return;
										}
										else
										{
											obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Detail record Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6006_C + tab + T_FV_6006_M);
											break;
										}
									}
								}
								else
								{
									error = true;
									section16LevelError = false;

									if (section16ValidCount < Integer.parseInt(CountDeducteeSec16.trim()))
									{
										record = br.readLine();
										LineCount++;

										if (record == null || record.length() == 0)
										{
											fvO.returnRecordType = RecType;
											fvO.returnLineCount = LineCount;
											fvO.returnRecord = record;
											break;

										}

										int localCaretCount = 0;
										int localCountField_DD = 1;
										StringTokenizer st_DD = new StringTokenizer(record, "^", true);
										while (st_DD.hasMoreTokens())
										{
											String val = st_DD.nextToken();
											NullField = false;
											FieldFound = false;
											if ((val.equals(FIELD_SEPERATOR) && Caret) || val.length() == 0)
											{
												NullField = true;
												FieldFound = true;
											}
											if (val.equals(FIELD_SEPERATOR))
											{
												Caret = true;
												localCaretCount++;
											}
											else
											{
												Caret = false;
												FieldFound = true;
											}

											if (localCountField_DD > 2)
											{
												break;
											}
											if (FieldFound)
											{
												switch (localCountField_DD)
												{
												case 1 :
													LineNo = val;
													break;
												case 2 :
													RecType = val;
													break;

												} //Closing switch
												localCountField_DD++;
											} //Closing if
										} //Closing While	

										if (localCaretCount < 2)
										{
											obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "NA" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6001_C + tab + T_FV_6001_M);
											continue;
										}
										if (RecType.equals(SECTION16_HEADER_IDENTIFIER))
										{
											continue;
										}
										else if (RecType.equals(BATCH_HEADER_IDENTIFIER))
										{
											obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Detail record Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6006_C + tab + T_FV_6006_M);
											fvO.returnRecordType = RecType;
											fvO.returnLineCount = LineCount;
											fvO.returnRecord = record;
											return;
										}
										else
										{
											obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Detail record Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6006_C + tab + T_FV_6006_M);
											break;
										}
									}
								}
							} // if((RecType.equals(QUATAR_DEDUCTEE_HEADER_IDENTIFIER)))
							else
							{
								obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Detail record Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6006_C + tab + T_FV_6006_M);
								section16LevelError = false;

								if (RecType.equals(BATCH_HEADER_IDENTIFIER))
								{
									fvO.returnRecordType = RecType;
									fvO.returnLineCount = LineCount;
									fvO.returnRecord = record;
									return;
								}

								if (section16ValidCount < Integer.parseInt(CountDeducteeSec16.trim()))
								{
									record = br.readLine();
									LineCount++;

									if (record == null || record.length() == 0)
									{
										fvO.returnRecordType = RecType;
										fvO.returnLineCount = LineCount;
										fvO.returnRecord = record;
										break;

									}

									int localCaretCount = 0;
									int localCountField_DD = 1;
									StringTokenizer st_DD = new StringTokenizer(record, "^", true);
									while (st_DD.hasMoreTokens())
									{
										String val = st_DD.nextToken();
										NullField = false;
										FieldFound = false;
										if ((val.equals(FIELD_SEPERATOR) && Caret) || val.length() == 0)
										{
											NullField = true;
											FieldFound = true;
										}
										if (val.equals(FIELD_SEPERATOR))
										{
											Caret = true;
											localCaretCount++;
										}
										else
										{
											Caret = false;
											FieldFound = true;
										}

										if (localCountField_DD > 2)
										{
											break;
										}
										if (FieldFound)
										{
											switch (localCountField_DD)
											{
											case 1 :
												LineNo = val;
												break;
											case 2 :
												RecType = val;
												break;

											} //Closing switch
											localCountField_DD++;
										} //Closing if
									} //Closing While	

									if (localCaretCount < 2)
									{
										obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Section 10" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6002_C + tab + T_FV_6002_M);
										continue;
									}
									if (RecType.equals(SECTION16_HEADER_IDENTIFIER))
									{
										continue;
									}
									else if (RecType.equals(BATCH_HEADER_IDENTIFIER))
									{
										obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Detail record Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6006_C + tab + T_FV_6006_M);
										fvO.returnRecordType = RecType;
										fvO.returnLineCount = LineCount;
										fvO.returnRecord = record;
										return;
									}
									else
									{
										obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Detail record Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6006_C + tab + T_FV_6006_M);
										break;
									}
								}
							}
						} // Closing for loop Section 16 record)
					} // Closing if(!deducteeLevelError && Integer.parseInt(CountDeducteeSec16)>0 && section16LevelError)
				}

				//	 Checking Section 10 records

				int Sec10ValidCount = 0;
				section10LevelError = true;

				errorCountCode = obj_FieldValidation.checkNumeric(CountDeducteeSec10, 9);

				if (errorCountCode == 4)
				{
					if (deducteeLevelError && Integer.parseInt(CountDeducteeSec10.trim()) > 0) //&& section16LevelError && section10LevelError)
					{
						for (int localCountSec10 = 0; localCountSec10 < Integer.parseInt(CountDeducteeSec10.trim()); localCountSec10++)
						{
							if (!(RecType.equals(SECTION10_HEADER_IDENTIFIER)))
							{
								record = br.readLine();
								LineCount++;

								if (record == null || record.length() == 0)
								{
									if (localCountSec10 < Integer.parseInt(CountDeducteeSec10.trim()))
									{
										obj_StringBuffer.append(lineNoOfSalaryDetailRec + tab + upload_Type + tab + "Section-10" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6031_C + tab + T_FV_6031_M);
									}
									fvO.returnRecordType = RecType;
									fvO.returnLineCount = LineCount;
									fvO.returnRecord = record;
									break;
								}

								if (record != null || record.length() > 0)
								{
									int localCaretCount = 0;
									int localCountField_DD = 1;
									StringTokenizer st_DD = new StringTokenizer(record, "^", true);
									while (st_DD.hasMoreTokens())
									{
										String val = st_DD.nextToken();
										NullField = false;
										FieldFound = false;
										if ((val.equals(FIELD_SEPERATOR) && Caret) || val.length() == 0)
										{
											NullField = true;
											FieldFound = true;
										}
										if (val.equals(FIELD_SEPERATOR))
										{
											Caret = true;
											localCaretCount++;
										}
										else
										{
											Caret = false;
											FieldFound = true;
										}

										if (localCountField_DD > 2)
										{
											break;
										}
										if (FieldFound)
										{
											switch (localCountField_DD)
											{
											case 1 :
												LineNo = val;
												break;
											case 2 :
												RecType = val;
												break;

											} //Closing switch
											localCountField_DD++;
										} //Closing if
									} //Closing While	
									if (localCaretCount < 2)
									{
										obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Section-10" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6002_C + tab + T_FV_6002_M);
										continue;
									}
								}

								if ((record == null || record.length() == 0) && (localCountSec10 + 1) <= Integer.parseInt(CountDeducteeSec10.trim()))
								{
									obj_StringBuffer.append(lineNoOfSalaryDetailRec + tab + upload_Type + tab + "Section-10" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6031_C + tab + T_FV_6031_M);
									section10LevelError = false;
									fvO.returnRecordType = RecType;
									fvO.returnLineCount = LineCount;
									fvO.returnRecord = record;
									break;
									//			  return obj_StringBufferSal ;
								}
							}

							if (RecType.equals(SECTION10_HEADER_IDENTIFIER))
							{
								Sec10ValidCount++;
								long sec10ErrRecLengthBefore = obj_StringBuffer.errorBufferString.length();
								cal = new GregorianCalendar();

								//								validateSection10(record, LineCount, BH_BatchNo, DeducteeDetailRecNo, CountDeducteeSec10, GrossTotalDeducteeSec10, Sec10ValidCount, paperReturnFile, obj_StringBuffer);

								cal = new GregorianCalendar();

								long sec10ErrRecLengthAfter = obj_StringBuffer.errorBufferString.length();

								boolean errorInSec10Record = false;
								if ((sec10ErrRecLengthBefore - sec10ErrRecLengthAfter) != 0)
								{
									errorInSec10Record = true;
								}
								else
								{
									errorInSec10Record = false;
								}

								if (!errorInSec10Record)
								{
									error = false;
									section10LevelError = true;

									if (Sec10ValidCount < Integer.parseInt(CountDeducteeSec10.trim()))
									{
										record = br.readLine();
										LineCount++;

										if (record == null || record.length() == 0)
										{
											obj_StringBuffer.append(lineNoOfSalaryDetailRec + tab + upload_Type + tab + "Section-10" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6031_C + tab + T_FV_6031_M);
											fvO.returnRecordType = RecType;
											fvO.returnLineCount = LineCount;
											fvO.returnRecord = record;
											break;

										}

										int localCountField_DD = 1;
										StringTokenizer st_DD = new StringTokenizer(record, "^", true);
										while (st_DD.hasMoreTokens())
										{
											String val = st_DD.nextToken();
											NullField = false;
											FieldFound = false;
											if ((val.equals(FIELD_SEPERATOR) && Caret) || val.length() == 0)
											{
												NullField = true;
												FieldFound = true;
											}
											if (val.equals(FIELD_SEPERATOR))
												Caret = true;
											else
											{
												Caret = false;
												FieldFound = true;
											}

											if (localCountField_DD > 2)
											{
												break;
											}
											if (FieldFound)
											{
												switch (localCountField_DD)
												{
												case 1 :
													LineNo = val;
													break;
												case 2 :
													RecType = val;
													break;

												} //Closing switch
												localCountField_DD++;
											} //Closing if
										} //Closing While	

										if (RecType.equals(SECTION10_HEADER_IDENTIFIER))
										{
											continue;
										}
										else if (RecType.equals(BATCH_HEADER_IDENTIFIER))
										{
											obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Recor Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6006_C + tab + T_FV_6006_M);
											fvO.returnRecordType = RecType;
											fvO.returnLineCount = LineCount;
											fvO.returnRecord = record;
											return;
										}
										else
										{
											obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Recor Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6006_C + tab + T_FV_6006_M);
											break;
										}
									}
								}
								else
								{
									error = true;
									section10LevelError = false;

									if (Sec10ValidCount < Integer.parseInt(CountDeducteeSec10.trim()))
									{
										record = br.readLine();
										LineCount++;

										if (record == null || record.length() == 0)
										{
											fvO.returnRecordType = RecType;
											fvO.returnLineCount = LineCount;
											fvO.returnRecord = record;
											break;

										}

										int localCountField_DD = 1;
										StringTokenizer st_DD = new StringTokenizer(record, "^", true);
										while (st_DD.hasMoreTokens())
										{
											String val = st_DD.nextToken();
											NullField = false;
											FieldFound = false;
											if ((val.equals(FIELD_SEPERATOR) && Caret) || val.length() == 0)
											{
												NullField = true;
												FieldFound = true;
											}
											if (val.equals(FIELD_SEPERATOR))
												Caret = true;
											else
											{
												Caret = false;
												FieldFound = true;
											}

											if (localCountField_DD > 2)
											{
												break;
											}
											if (FieldFound)
											{
												switch (localCountField_DD)
												{
												case 1 :
													LineNo = val;
													break;
												case 2 :
													RecType = val;
													break;

												} //Closing switch
												localCountField_DD++;
											} //Closing if
										} //Closing While	

										if (RecType.equals(SECTION10_HEADER_IDENTIFIER))
										{
											continue;
										}
										else if (RecType.equals(BATCH_HEADER_IDENTIFIER))
										{
											obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Recor Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6006_C + tab + T_FV_6006_M);
											fvO.returnRecordType = RecType;
											fvO.returnLineCount = LineCount;
											fvO.returnRecord = record;
											return;
										}
										else
										{
											obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Recor Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6006_C + tab + T_FV_6006_M);
											break;
										}
									}
								}
							} // if((RecType.equals(QUATAR_DEDUCTEE_HEADER_IDENTIFIER)))
							else if (RecType.equals(SECTION16_HEADER_IDENTIFIER))
							{
								obj_StringBuffer.append(lineNoOfSalaryDetailRec + tab + upload_Type + tab + "Count of ' Salary Details  - Section 16 Detail ' Records  associated with this Deductee " + tab + tab + CurrentlocalSDNumber + tab + T_FV_6030_C + tab + T_FV_6030_M);
								section10LevelError = false;
								localCountSec10 = localCountSec10 - 1;
							}
							else if (RecType.equals(BATCH_HEADER_IDENTIFIER))
							{
								obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Detail Record Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6006_C + tab + T_FV_6006_M);
								fvO.returnRecordType = RecType;
								fvO.returnLineCount = LineCount;
								fvO.returnRecord = record;
								return;
							}
							else
							{
								obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Detail Record Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6006_C + tab + T_FV_6006_M);
								section10LevelError = false;
								break;
							}
						} // Closing for loop Section 16 record)
					}
				}

				// Closing if(!deducteeLevelError && Integer.parseInt(CountDeducteeSec16)>0 && section16LevelError)	
				//		Checking Section Chapter VI-A records

				int SecVIAValidCount = 0;
				sectionVIALevelError = true;

				errorCountCode = obj_FieldValidation.checkNumeric(CountDeducteeChapVIDetails, 9);

				if (errorCountCode == 4)
				{
					if (deducteeLevelError && Integer.parseInt(CountDeducteeChapVIDetails.trim()) > 0) // && section16LevelError && section10LevelError)
					{
						sumSectionVIA80C_80CCC_80CCD_1 =0;
						errorFlagSDC6A=false;
						for (int localCountSecVIA = 0; localCountSecVIA < Integer.parseInt(CountDeducteeChapVIDetails.trim()); localCountSecVIA++)
						{
							if (!(RecType.equals(SECTIONVIA_HEADER_IDENTIFIER)))
							{
								record = br.readLine();
								LineCount++;

								if (record == null || record.length() == 0)
								{
									if (localCountSecVIA < Integer.parseInt(CountDeducteeChapVIDetails.trim()))
									{
										obj_StringBuffer.append(lineNoOfSalaryDetailRec + tab + upload_Type + tab + "Count of ' Salary Details  - Chapter VI-A Detail ' Records  associated with Deductee - Chapter VIA Detail " + tab + tab + CurrentlocalSDNumber + tab + T_FV_6033_C + tab + T_FV_6033_M);
									}
									fvO.returnRecordType = RecType;
									fvO.returnLineCount = LineCount;
									fvO.returnRecord = record;
									break;

								}

								if (record != null || record.length() > 0)
								{
									int localCountField_DD = 1;
									StringTokenizer st_DD = new StringTokenizer(record, "^", true);
									while (st_DD.hasMoreTokens())
									{
										String val = st_DD.nextToken();
										NullField = false;
										FieldFound = false;
										if ((val.equals(FIELD_SEPERATOR) && Caret) || val.length() == 0)
										{
											NullField = true;
											FieldFound = true;
										}
										if (val.equals(FIELD_SEPERATOR))
											Caret = true;
										else
										{
											Caret = false;
											FieldFound = true;
										}

										if (localCountField_DD > 2)
										{
											break;
										}
										if (FieldFound)
										{
											switch (localCountField_DD)
											{
											case 1 :
												LineNo = val;
												break;
											case 2 :
												RecType = val;
												break;

											} //Closing switch
											localCountField_DD++;
										} //Closing if
									} //Closing While	
								}

								if ((record == null || record.length() == 0) && (localCountSecVIA + 1) <= Integer.parseInt(CountDeducteeChapVIDetails.trim()))
								{
									obj_StringBuffer.append(lineNoOfSalaryDetailRec + tab + upload_Type + tab + "Count of ' Salary Details  - Chapter VI-A Detail ' Records  associated with Deductee - Chapter VIA Detail " + tab + tab + CurrentlocalSDNumber + tab + T_FV_6033_C + tab + T_FV_6033_M);
									section10LevelError = false;
									fvO.returnRecordType = RecType;
									fvO.returnLineCount = LineCount;
									fvO.returnRecord = record;
									break;

								}
							}

							if ((RecType.equals(SECTIONVIA_HEADER_IDENTIFIER) || RecType == null))
							{
								SecVIAValidCount++;
								long secVIErrRecLengthBefore = obj_StringBuffer.errorBufferString.length();
								cal = new GregorianCalendar();
								
								validateSectionVIA(
										record,
										LineCount,
										BH_BatchNo,
										DeducteeDetailRecNo,
										CountDeducteeChapVIDetails,
										GrossTotDeducteeChapVIDetails,
										SecVIAValidCount,
										paperReturnFile,
										obj_StringBuffer,
										upload_Type,
										FinancialYr,
										Qperiod,
										TransactionType);

								cal = new GregorianCalendar();

								long secVIErrRecLengthAfter = obj_StringBuffer.errorBufferString.length();
								boolean errorInSecVIRecord = false;
								if ((secVIErrRecLengthAfter - secVIErrRecLengthBefore) != 0)
								{
									errorInSecVIRecord = true;
								}
								else
								{
									errorInSecVIRecord = false;
								}

								if (!errorInSecVIRecord)
								{
									error = false;
									sectionVIALevelError = true;

									if (SecVIAValidCount < Integer.parseInt(CountDeducteeChapVIDetails.trim()))
									{

										record = br.readLine();
										LineCount++;

										if (record == null || record.length() == 0)
										{
											obj_StringBuffer.append(lineNoOfSalaryDetailRec + tab + upload_Type + tab + "Count of ' Salary Details  - Chapter VI-A Detail ' Records  associated with Deductee - Chapter VIA Detail " + tab + tab + CurrentlocalSDNumber + tab + T_FV_6033_C + tab + T_FV_6033_M);
											fvO.returnRecordType = RecType;
											fvO.returnLineCount = LineCount;
											fvO.returnRecord = record;
											break;

										}

										int localCountField_DD = 1;
										StringTokenizer st_DD = new StringTokenizer(record, "^", true);
										while (st_DD.hasMoreTokens())
										{
											String val = st_DD.nextToken();
											NullField = false;
											FieldFound = false;
											if ((val.equals(FIELD_SEPERATOR) && Caret) || val.length() == 0)
											{
												NullField = true;
												FieldFound = true;
											}
											if (val.equals(FIELD_SEPERATOR))
												Caret = true;
											else
											{
												Caret = false;
												FieldFound = true;
											}

											if (localCountField_DD > 2)
											{
												break;
											}
											if (FieldFound)
											{
												switch (localCountField_DD)
												{
												case 1 :
													LineNo = val;
													break;
												case 2 :
													RecType = val;
													break;

												} //Closing switch
												localCountField_DD++;
											} //Closing if
										} //Closing While	

										if (RecType.equals(SECTIONVIA_HEADER_IDENTIFIER))
										{
											continue;
										}
										else if (RecType.equals(BATCH_HEADER_IDENTIFIER))
										{
											obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Detail Record Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6006_C + tab + T_FV_6006_M);
											fvO.returnRecordType = RecType;
											fvO.returnLineCount = LineCount;
											fvO.returnRecord = record;
											return;
										}
										else
										{
											obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Detail Record Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6006_C + tab + T_FV_6006_M);
											break;
										}
									}
								}
								else
								{
									error = true;
									sectionVIALevelError = false;

									if (SecVIAValidCount < Integer.parseInt(CountDeducteeChapVIDetails.trim()))
									{
										record = br.readLine();
										LineCount++;

										if (record == null || record.length() == 0)
										{
											obj_StringBuffer.append(lineNoOfSalaryDetailRec + tab + upload_Type + tab + "Count of ' Salary Details  - Chapter VI-A Detail ' Records  associated with Deductee - Chapter VIA Detail " + tab + tab + CurrentlocalSDNumber + tab + T_FV_6033_C + tab + T_FV_6033_M);
											fvO.returnRecordType = RecType;
											fvO.returnLineCount = LineCount;
											fvO.returnRecord = record;
											break;

										}

										int localCountField_DD = 1;
										StringTokenizer st_DD = new StringTokenizer(record, "^", true);
										while (st_DD.hasMoreTokens())
										{
											String val = st_DD.nextToken();
											NullField = false;
											FieldFound = false;
											if ((val.equals(FIELD_SEPERATOR) && Caret) || val.length() == 0)
											{
												NullField = true;
												FieldFound = true;
											}
											if (val.equals(FIELD_SEPERATOR))
												Caret = true;
											else
											{
												Caret = false;
												FieldFound = true;
											}

											if (localCountField_DD > 2)
											{
												break;
											}
											if (FieldFound)
											{
												switch (localCountField_DD)
												{
												case 1 :
													LineNo = val;
													break;
												case 2 :
													RecType = val;
													break;

												} //Closing switch
												localCountField_DD++;
											} //Closing if
										} //Closing While	

										if (RecType.equals(SECTIONVIA_HEADER_IDENTIFIER))
										{
											continue;
										}
										else if (RecType.equals(BATCH_HEADER_IDENTIFIER))
										{
											obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Detail Record Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6006_C + tab + T_FV_6006_M);

											fvO.returnRecordType = RecType;
											fvO.returnLineCount = LineCount;
											fvO.returnRecord = record;
											return;
										}
										else
										{
											obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Detail Record Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6006_C + tab + T_FV_6006_M);
											break;
										}
									}
								}
							} //  if ((RecType.equals(SECTIONVIA_HEADER_IDENTIFIER) || RecType == null))
							else if (RecType.equals(SECTION10_HEADER_IDENTIFIER))
							{
								obj_StringBuffer.append(lineNoOfSalaryDetailRec + tab + upload_Type + tab + "Section Record" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6031_C + tab + T_FV_6031_M);
								sectionVIALevelError = false;
								localCountSecVIA = localCountSecVIA - 1;
							}
							else if (RecType.equals(BATCH_HEADER_IDENTIFIER))
							{
								obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Detail Record Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6006_C + tab + T_FV_6006_M);

								fvO.returnRecordType = RecType;
								fvO.returnLineCount = LineCount;
								fvO.returnRecord = record;
								return;
							}
							else
							{
								obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Detail Record Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6006_C + tab + T_FV_6006_M);
								sectionVIALevelError = false;
								break;
							}
						} // Closing for loop Section 16 record)
						
						//start: added for Remark1 of SD check after C6A validations for fvu 6.2 by Jacky
						if (aggrAmtOfDeductAdmiUndrSec80C_80CCC_80CCD_1 != 0 && sumSectionVIA80C_80CCC_80CCD_1!=0) {

							if (aggrAmtOfDeductAdmiUndrSec80C_80CCC_80CCD_1 != sumSectionVIA80C_80CCC_80CCD_1) {

								obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Aggregate amount of deductions admissible under section 80C, 80CCC and 80CCD(1)" + tab + "NA" + tab
										+ CurrentlocalSDNumber + tab + T_FV_6129_C + tab + T_FV_6129_M);

							}
						}
						//end: added for Remark1 of SD check after C6A validations for fvu 6.2 by Jacky
						
						if (sumSectionVIA80C_80CCC_80CCD_1 == 0 && aggrAmtOfDeductAdmiUndrSec80C_80CCC_80CCD_1 != 0) {
							obj_StringBuffer.append(lineNoOfSalaryDetailRec + tab + upload_Type + tab
									+ "Aggregate amount of deductions admissible under section 80C, 80CCC and 80CCD(1)"
									+ tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6129_C + tab + T_FV_6129_M);
						}
						
					
					}
				} // Closing if(deducteeLevelError && Integer.parseInt(CountDeducteeSec16)>0 && section16LevelError)

				//		Checking Section 8889 records

				int Sec8889ValidCount = 0;
				section8889LevelError = true;

				errorCountCode = obj_FieldValidation.checkNumeric(CountDeducteeSec8889, 9);

				if (errorCountCode == 4)
				{
					if (deducteeLevelError && Integer.parseInt(CountDeducteeSec8889.trim()) > 0) //&& section16LevelError && section10LevelError)
					{
						for (int localCountSec8889 = 0; localCountSec8889 < Integer.parseInt(CountDeducteeSec8889.trim()); localCountSec8889++)
						{
							if (!(RecType.equals(SECTION8889_HEADER_IDENTIFIER)))
							{
								record = br.readLine();
								LineCount++;

								if (record == null || record.length() == 0)
								{
									if (localCountSec8889 < Integer.parseInt(CountDeducteeSec8889.trim()))
									{
										obj_StringBuffer.append(lineNoOfSalaryDetailRec + tab + upload_Type + tab + "Section-88" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6032_C + tab + T_FV_6032_M);
									}
									fvO.returnRecordType = RecType;
									fvO.returnLineCount = LineCount;
									fvO.returnRecord = record;
									break;

								}

								if (record != null || record.length() > 0)
								{
									int localCaretCount89 = 0;
									int localCountField_DD = 1;
									StringTokenizer st_DD = new StringTokenizer(record, "^", true);
									while (st_DD.hasMoreTokens())
									{
										String val = st_DD.nextToken();
										NullField = false;
										FieldFound = false;
										if ((val.equals(FIELD_SEPERATOR) && Caret) || val.length() == 0)
										{
											NullField = true;
											FieldFound = true;
										}
										if (val.equals(FIELD_SEPERATOR))
										{
											Caret = true;
											localCaretCount89++;
										}
										else
										{
											Caret = false;
											FieldFound = true;
										}

										if (localCountField_DD > 2)
										{
											break;
										}
										if (FieldFound)
										{
											switch (localCountField_DD)
											{
											case 1 :
												LineNo = val;
												break;
											case 2 :
												RecType = val;
												break;

											} //Closing switch
											localCountField_DD++;
										} //Closing if
									} //Closing While	

									if (localCaretCount89 < 2)
									{
										obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "NA" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6004_C + tab + T_FV_6004_M);
										continue;
									}
								}

								if ((record == null || record.length() == 0) && (localCountSec8889 + 1) <= Integer.parseInt(CountDeducteeSec8889.trim()))
								{
									obj_StringBuffer.append(lineNoOfSalaryDetailRec + tab + upload_Type + tab + "NA" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6032_C + tab + T_FV_6032_M);
									section10LevelError = false;
									fvO.returnRecordType = RecType;
									fvO.returnLineCount = LineCount;
									fvO.returnRecord = record;
									break;

								}
							}

							if ((RecType.equals(SECTION8889_HEADER_IDENTIFIER) || RecType == null))
							{
								Sec8889ValidCount++;

								cal = new GregorianCalendar();
								long sec8889ErrRecLengthBefore = obj_StringBuffer.errorBufferString.length();

								/*								validateSection8889(
																	record,
																	LineCount,
																	BH_BatchNo,
																	DeducteeDetailRecNo,
																	CountDeducteeSec8889,
																	GrossTotDeducteeSec8889,
																	Sec8889ValidCount,
																	paperReturnFile,
																	obj_StringBuffer);
								 */
								cal = new GregorianCalendar();

								long sec8889ErrRecLengthAfter = obj_StringBuffer.errorBufferString.length();
								boolean errorInSec8889RecLength = false;

								if ((sec8889ErrRecLengthAfter - sec8889ErrRecLengthBefore) != 0)
								{
									errorInSec8889RecLength = true;
								}
								else
								{
									errorInSec8889RecLength = false;
								}

								if (!errorInSec8889RecLength)
								{
									error = false;
									section8889LevelError = true;

									if (Sec8889ValidCount < Integer.parseInt(CountDeducteeSec8889.trim()))
									{
										record = br.readLine();
										LineCount++;

										if (record == null || record.length() == 0)
										{
											obj_StringBuffer.append(lineNoOfSalaryDetailRec + tab + upload_Type + tab + "Section-88" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6032_C + tab + T_FV_6032_M);
											fvO.returnRecordType = RecType;
											fvO.returnLineCount = LineCount;
											fvO.returnRecord = record;
											break;

										}

										int localCountField_DD = 1;
										int localCaretCounter88 = 0;
										StringTokenizer st_DD = new StringTokenizer(record, "^", true);
										while (st_DD.hasMoreTokens())
										{
											String val = st_DD.nextToken();
											NullField = false;
											FieldFound = false;
											if ((val.equals(FIELD_SEPERATOR) && Caret) || val.length() == 0)
											{
												NullField = true;
												FieldFound = true;
											}
											if (val.equals(FIELD_SEPERATOR))
											{
												Caret = true;
												localCaretCounter88++;
											}
											else
											{
												Caret = false;
												FieldFound = true;
											}

											if (localCountField_DD > 2)
											{
												break;
											}
											if (FieldFound)
											{
												switch (localCountField_DD)
												{
												case 1 :
													LineNo = val;
													break;
												case 2 :
													RecType = val;
													break;

												} //Closing switch
												localCountField_DD++;
											} //Closing if
										} //Closing While

										if (localCaretCounter88 < 2)
										{
											obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "NA" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6004_C + tab + T_FV_6004_M);
											continue;
										}

										if (RecType.equals(SECTION8889_HEADER_IDENTIFIER))
										{
											continue;
										}
										else if (RecType.equals(BATCH_HEADER_IDENTIFIER))
										{
											obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Detail Record Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6006_C + tab + T_FV_6006_M);

											fvO.returnRecordType = RecType;
											fvO.returnLineCount = LineCount;
											fvO.returnRecord = record;
											return;
										}
										else
										{
											obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Detail Record Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6006_C + tab + T_FV_6006_M);
											break;
										}
									}
								}
								else
								{
									error = true;
									section8889LevelError = false;

									if (Sec8889ValidCount < Integer.parseInt(CountDeducteeSec8889.trim()))
									{
										record = br.readLine();
										LineCount++;

										if (record == null || record.length() == 0)
										{
											obj_StringBuffer.append(lineNoOfSalaryDetailRec + tab + upload_Type + tab + "NA" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6032_C + tab + T_FV_6032_M);
											fvO.returnRecordType = RecType;
											fvO.returnLineCount = LineCount;
											fvO.returnRecord = record;
											break;

										}

										int localCaretCounter88 = 0;
										int localCountField_DD = 1;
										StringTokenizer st_DD = new StringTokenizer(record, "^", true);
										while (st_DD.hasMoreTokens())
										{
											String val = st_DD.nextToken();
											NullField = false;
											FieldFound = false;
											if ((val.equals(FIELD_SEPERATOR) && Caret) || val.length() == 0)
											{
												NullField = true;
												FieldFound = true;
											}
											if (val.equals(FIELD_SEPERATOR))
											{
												Caret = true;
												localCaretCounter88++;
											}
											else
											{
												Caret = false;
												FieldFound = true;
											}

											if (localCountField_DD > 2)
											{
												break;
											}
											if (FieldFound)
											{
												switch (localCountField_DD)
												{
												case 1 :
													LineNo = val;
													break;
												case 2 :
													RecType = val;
													break;
												} //Closing switch
												localCountField_DD++;
											} //Closing if
										} //Closing While	
										if (localCaretCounter88 < 2)
										{
											obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "NA" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6004_C + tab + T_FV_6004_M);
											continue;
										}
										if (RecType.equals(SECTION8889_HEADER_IDENTIFIER))
										{
											continue;
										}
										else if (RecType.equals(BATCH_HEADER_IDENTIFIER))
										{
											obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Detail Record Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6006_C + tab + T_FV_6006_M);

											fvO.returnRecordType = RecType;
											fvO.returnLineCount = LineCount;
											fvO.returnRecord = record;
											return;
										}
										else
										{
											obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Detail Record Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6006_C + tab + T_FV_6006_M);
											break;
										}
									}
								}

							} // if((RecType.equals(QUATAR_DEDUCTEE_HEADER_IDENTIFIER)))
							else if (RecType.equals(SECTIONVIA_HEADER_IDENTIFIER))
							{
								obj_StringBuffer.append(lineNoOfSalaryDetailRec + tab + upload_Type + tab + "Count of ' Salary Details  - Chapter VI-A Detail ' Records  associated with Deductee - Chapter VIA Detail" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6033_C + tab + T_FV_6033_M);
								sectionVIALevelError = false;
								localCountSec8889 = localCountSec8889 - 1;
							}
							else if (RecType.equals(BATCH_HEADER_IDENTIFIER))
							{
								obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Detail Record Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6006_C + tab + T_FV_6006_M);

								fvO.returnRecordType = RecType;
								fvO.returnLineCount = LineCount;
								fvO.returnRecord = record;
								return;
							}
							else
							{
								obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Detail Record Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6006_C + tab + T_FV_6006_M);
								section8889LevelError = true;
								break;
							}
						} // Closing for loop Section 8889 record)
					}
				} // Closing if(!deducteeLevelError && Integer.parseInt(CountDeducteeSec16)>0 && section16LevelError)
			} //CLOSING FOR for (int k = 1; k <= countOfDeducteeSD; k++)
		}
		catch (Exception e1)
		{			
			throw e1;
		} //CLOSING CATCH	

		fvO.returnRecordType = RecType;
		fvO.returnLineCount = LineCount;
		fvO.returnRecord = record;
		return;
	}

	////////////    Validate Salary Statement Record START ////////////////
	private void validateSalaryDeducteeDetails(
			String deductee,
			int LineCount,
			String BH_BatchNo,
			int DeducteeCount,
			int localCountOfSD,
			String TransactionType,
			String UploadType,
			String Qperiod,
			String FormNo, //CHANGE AMI
			String FinancialYr,
			String GrossTotalIncomeSD,
			Calendar RRRDatePresentDate,
			boolean paperReturnFile,
			String lineNoOfBatchRec,
			StringBuffer batchRecDataForPanStat,
			FileGenerator obj_FileGenerator,
			StringBufferTemp obj_StringBuffer,
			String fileNamePrintedinStatRep,
			String v_upload_Type,
			String PANForThisBatch,
			String BatchUpdationIndicator)
					throws Exception
	{

		StringBufferTemp Str_Buffer;
		Str_Buffer = obj_StringBuffer;
		boolean NullField = false;
		boolean localErrorFlag = false;
		validSecVIATotAmount = true; // FVU 7.2 bug fix 24 Jun 2021

		//Added By AMI For FVU 3.0
		FormValidator formVal = new FormValidator();

		try
		{
			//added for fvu 4.5 by Shalin
			if(TransactionType.equals(FIELD_NULL) || TransactionType.equals(FIELD_SEPERATOR))
				TransactionType = UPLOADTYPE_REGULAR;
			String LineNo = null;
			String RecType = null;
			String DD_BatchNo = null;
			String DeducteeDetailRecNo = null;
			String EmployeeSerialNo = null;
			String EmployeePan = null;
			String EmployeePanRefNo = null;
			String EmployeeName = null;
			String EmployeeCategory = null;
			String PeriodEmploymentFrm = null;
			String PeriodEmploymentTo = null;
			String ProfitSalSec17 = null;
			String CountDeducteeSec16 = null;
			String GrossTotalDeducteeSec16 = null;
			String IncomeChargeableUderTheHeadSalaries = null;
			String IncomeLossFrmHouse = null;
			String GrossTotIncome = null;
			String LastGrossTotIncome = null;
			String CountDeducteeChapVIDetails = null;
			String GrossTotDeducteeChapVIDetails = null;
			String TotTaxableIncome355366 = null;
			String IncomeTaxOnTotIncome = null;
			String Surcharge = null;
			String Cess = null;
			String NetTaxPayable = null;
			String TotTDSWholeYear = null;
			String ShortfallExcessTaxDeduc = null;
			String Remark1 = null;
			String Remark2 = null;
			String Remark3 = null;
			String TotalSalaryExeclud338n339 = null;
			String IncomeTaxRelief = null;
			String SalaryDeducteeHash = null;


			//Added for FVU 3.8 by Shalin

			String TaxblAmtCurEmp = null;
			String TaxblAmtPreEmp = null;
			String TDSCurEmp = null;
			String TDSPreEmp = null;
			String WhethrTaxDedAtHighrRate = null;

			// Added by Priya for FVU5.2


			String  WhethrHouseRentClaimExced = null;
			String  CountOfPanLanloard =null;
			String LandlordPan1 = null;
			String LandlordName1 = null;
			String LandlordPan2 = null;
			String LandlordName2 = null;
			String LandlordPan3 = null;
			String LandlordName3 = null;
			String LandlordPan4 = null;
			String LandlordName4 = null;

			String WhethrInterestPaidLender= null;
			String  CountOfPanLender =null;
			String LenderPan1 = null;
			String LenderName1 = null;
			String LenderPan2 = null;
			String LenderName2 = null;
			String LenderPan3 = null;
			String LenderName3 = null;
			String LenderPan4 = null;
			String LenderName4 = null;

			String WhethrContribtnPaidByTrusty = null;
			String NameOfSuperannuationFund = null;
			String StartDate =null;
			String EndDate =null;
			String AvgRateOfdeductionOfTaxforLastThreeYears = null;
			String AmountOfRepaidOnAccountOfPrincipalAndInterest =null;
			String AmountOfTaxDeductedOnRepayment = null;
			String GrossTotalIncomeFromSuperannuationFund = null;
			//End :: Added by Priya for FVU5.2

			//start:added for FVU 6.2 by jacky
			String grossSalaryContainedInSec17_1=null;
			String valueOfPerquisitesSec17_2=null;
			String profitsInLieuOfSalarySec17_3=null;
			String travelConcessionOrAssistanceSec10_5=null;
			String deathCumRetirementGratuitySec10_10=null;
			String commutedValueOfPensionSec10_10A=null;
			String cashEquivalentOfLeaveSalEncashmentSec10_10AA=null;
			String houseRentAllowanceSec10_13A=null;
			String amountOfAnyOtherExemptionUnderSec10=null;
			String totAmtOfExempClaimedUnderSec10_340n341n342n343n344n346=null;
			String incomeUnderHeadOtherSourOfferForTDSSec192_2B=null;
			String rebateUnderSec87A=null;
			//end:added for FVU 6.2 by jacky
			String whthrOptTax115BAC = null; // Added for FVU 7.1 - Vinita

			int Count_DD_field = 1;
			FieldValidation obj_FieldValidation = new FieldValidation();

			StringTokenizer st_DD = new StringTokenizer(deductee, "^", true);

			boolean Caret = false;
			boolean FieldFound;

			int caretCounter = 0;
			
			Count_DD_field = 1;
			while (st_DD.hasMoreTokens())
			{
				String val = st_DD.nextToken();
				NullField = false;
				FieldFound = false;
				if ((val.equals(FIELD_SEPERATOR) && Caret) || val.trim().length() == 0)
				{
					NullField = true;
					FieldFound = true;
				}

				if (val.equals(FIELD_SEPERATOR))
				{
					Caret = true;
					if ((caretCounter == 0) && (Count_DD_field == 1))
					{
						Count_DD_field++;
						LineNo = "";
					}
					caretCounter++;
				}
				else
				{
					Caret = false;
					FieldFound = true;
				}


				if (Count_DD_field > 80) //added for FVU 6.2 by jacky //Obs 2 FVU 7.1
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "NA" + tab + tab + CurrentlocalSDNumber + tab + T_FV_4064_C + tab + T_FV_4064_M);
					fvO.returnRecordType = RecType;
					return;
				}





				/*	if (Count_DD_field > 67) commented for FVU 6.2
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "NA" + tab + tab + CurrentlocalSDNumber + tab + T_FV_4064_C + tab + T_FV_4064_M);
					fvO.returnRecordType = RecType;
					return;
				}

				 */

				/*	if (Count_DD_field > 59)
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "NA" + tab + tab + CurrentlocalSDNumber + tab + T_FV_4064_C + tab + T_FV_4064_M);
					fvO.returnRecordType = RecType;
					return;
				}*/

				/*if (Count_DD_field > 39)
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "NA" + tab + tab + CurrentlocalSDNumber + tab + T_FV_4064_C + tab + T_FV_4064_M);
					fvO.returnRecordType = RecType;
					return;
				}*/
				if (FieldFound)
				{
					switch (Count_DD_field)
					{
					case 1 :
						LineNo = val;
						break;
					case 2 :
						RecType = val;
						break;
					case 3 :
						DD_BatchNo = val;
						break;
					case 4 :
						DeducteeDetailRecNo = val;
						break;
					case 5 :
						ModeSD = val;
						break;
					case 6 :
						EmployeeSerialNo = val; // Filler-7 Field
						break;
					case 7 :
						EmployeePan = val;
						break;
					case 8 :
						EmployeePanRefNo = val;
						break;
					case 9 :
						EmployeeName = val;
						break;
					case 10 :
						EmployeeCategory = val;
						break;
					case 11 :
						PeriodEmploymentFrm = val;
						break;
					case 12 :
						PeriodEmploymentTo = val;
						break;
					case 13 :
						TotalSalaryExeclud338n339 = val;
						break;
					case 14 :
						ProfitSalSec17 = val;
						break;
					case 15 :
						CountDeducteeSec16 = val;
						countSec16 = val;
						break;
					case 16 :
						GrossTotalDeducteeSec16 = val;
						break;
					case 17 :
						IncomeChargeableUderTheHeadSalaries = val;
						break;
					case 18 :
						IncomeLossFrmHouse = val;
						break;
					case 19 :
						GrossTotIncome = val;
						break;
					case 20 :
						LastGrossTotIncome = val;
						break;
					case 21 :
						CountDeducteeChapVIDetails = val;
						countSec6A = val;
						break;
					case 22 :
						GrossTotDeducteeChapVIDetails = val;
						break;
					case 23 :
						TotTaxableIncome355366 = val;
						break;
					case 24 :
						IncomeTaxOnTotIncome = val;
						break;
					case 25 :
						Surcharge = val;
						break;
					case 26 :
						Cess = val;
						break;
					case 27 :
						IncomeTaxRelief = val;
						break;
					case 28 :
						NetTaxPayable = val;
						break;
					case 29 :
						TotTDSWholeYear = val;
						break;
					case 30 :
						ShortfallExcessTaxDeduc = val;
						break;
					case 31 :
						Remark1 = val;
						break;
					case 32 :
						Remark2 = val;
						break;
					case 33 :
						Remark3 = val;
						break;

						//Added for FVU 3.8 by Shalin
					case 34 :
						TaxblAmtCurEmp = val;
						break;
					case 35 :
						TaxblAmtPreEmp = val;
						break;
					case 36 :
						TDSCurEmp = val;
						break;
					case 37 :
						TDSPreEmp = val;
						break;
					case 38 :
						WhethrTaxDedAtHighrRate = val;
						break;

						/*case 39 :
							SalaryDeducteeHash = val;
							break;*/



						// Added  for FVU 5.2 by priya
					case 39:
						WhethrHouseRentClaimExced = val;
						break;

					case 40:

						CountOfPanLanloard = val;
						break;

					case 41:
						LandlordPan1 = val;
						break;

					case 42:
						LandlordName1 = val;
						break;

					case 43:
						LandlordPan2 = val;
						break;

					case 44:
						LandlordName2 = val;
						break;

					case 45:
						LandlordPan3 = val;
						break;

					case 46:
						LandlordName3 = val;
						break;

					case 47:
						LandlordPan4 = val;
						break;

					case 48:
						LandlordName4 = val;
						break;

					case 49:
						WhethrInterestPaidLender = val;
						break;

					case 50:
						CountOfPanLender = val;
						break;

					case 51:
						LenderPan1 = val;
						break;

					case 52:
						LenderName1 = val;
						break;

					case 53:
						LenderPan2 = val;
						break;

					case 54:
						LenderName2 = val;
						break;

					case 55:
						LenderPan3 = val;
						break;

					case 56:
						LenderName3 = val;
						break;

					case 57:
						LenderPan4 = val;
						break;

					case 58:
						LenderName4 = val;
						break;

					case 59:
						WhethrContribtnPaidByTrusty= val;
						break;

					case 60:
						NameOfSuperannuationFund = val;
						break;

					case 61 :
						StartDate = val;
						break;

					case 62 :
						EndDate = val;
						break;

					case 63 :
						AmountOfRepaidOnAccountOfPrincipalAndInterest = val;
						break;

					case 64 :
						AvgRateOfdeductionOfTaxforLastThreeYears = val;
						break;

					case 65 :
						AmountOfTaxDeductedOnRepayment = val;
						break;

					case 66 :
						GrossTotalIncomeFromSuperannuationFund =val;
						break;

					case 67 :
						grossSalaryContainedInSec17_1 =val;
						break;

					case 68 :
						valueOfPerquisitesSec17_2 =val;
						break;

					case 69 :
						profitsInLieuOfSalarySec17_3 =val;
						break;

					case 70 :
						travelConcessionOrAssistanceSec10_5 =val;
						break;	

					case 71 :
						deathCumRetirementGratuitySec10_10 =val;
						break;


					case 72 :
						commutedValueOfPensionSec10_10A =val;
						break;

					case 73 :
						cashEquivalentOfLeaveSalEncashmentSec10_10AA =val;
						break;	

					case 74 :
						houseRentAllowanceSec10_13A =val;
						break;	

					case 75 :
						amountOfAnyOtherExemptionUnderSec10 =val;
						break;

					case 76 :
						totAmtOfExempClaimedUnderSec10_340n341n342n343n344n346 =val;
						break;	

					case 77 :
						incomeUnderHeadOtherSourOfferForTDSSec192_2B =val;
						break;	

					case 78 :
						rebateUnderSec87A =val;
						break;	

					case 79: //Added for FVU 7.1 - Vinita
						whthrOptTax115BAC = val;
						break;
						
					case 80:	
						SalaryDeducteeHash = val;
						break;

					} //SWITCH
					Count_DD_field++;
				}
			} //WHILE


			if (caretCounter != 79)//added for fvu 6.2 by jacky  //Changed for FVU 7.1 - Vinita
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "NA" + tab + tab + CurrentlocalSDNumber + tab + T_FV_4064_C + tab + T_FV_4064_M);
				fvO.returnRecordType = RecType;
				return;
			}








			//check of deductee fields starts

			//	  check LineNo --1

			if (LineNo.equals(FIELD_NULL) || LineNo.equals(FIELD_SEPERATOR))
			{
				Str_Buffer.append("-" + tab + v_upload_Type + tab + "Line_Number" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4004_C + tab + T_FV_4004_M);
				LineNo = "-";
			}
			else if (LineNo.length() <= 9)
			{
				if (obj_FieldValidation.isInt(LineNo))
				{
					Str_Buffer.append("-" + tab + v_upload_Type + tab + "Line_Number" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4004_C + tab + T_FV_4004_M);
					LineNo = "-";
				}
				else if (Integer.parseInt(LineNo.trim()) != LineCount)
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Line_Number" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4003_C + tab + T_FV_4003_M);
				else
					lineNoOfSalaryDetailRec = LineNo;
			}
			else
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "NA" + tab + "Line_Number" + tab + CurrentlocalSDNumber + tab + T_FV_4004_C + tab + T_FV_4004_M);
			//	  check LineNo --1

			//	  check RecType --2
			if (RecType.equals(FIELD_NULL) || RecType.equals(FIELD_SEPERATOR))
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Salary Detail Record Type" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4124_C + tab + T_FV_4124_M);
			}
			else if (!(RecType.equals(SALARY_STATEMENT_IDENTIFIER)))
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Salary Detail Record Type" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4124_C + tab + T_FV_4124_M);
			}

			//		check RecType --2
			//	  check BatchNo --3
			if (DD_BatchNo.equals(FIELD_NULL) || DD_BatchNo.equals(FIELD_SEPERATOR))
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Batch Number" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4005_C + tab + T_FV_4005_M);
			}
			else if (DD_BatchNo.length() > 9)
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Batch Number" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4005_C + tab + T_FV_4005_M);
			}
			else if (obj_FieldValidation.isInt(DD_BatchNo))
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Batch Number" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4005_C + tab + T_FV_4005_M);
			}
			else if (Integer.parseInt(DD_BatchNo.trim()) != Integer.parseInt(BH_BatchNo.trim()))
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Batch Number" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4169_C + tab + T_FV_4169_M);
			}
			//				check BatchNo --3

			//		check DeducteeDetailRecNo --4
			boolean validDeducteeDetailRecNo = false;
			if (DeducteeDetailRecNo.equals(FIELD_NULL) || DeducteeDetailRecNo.equals(FIELD_SEPERATOR))
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Salary Details  Record No" + tab + "NA" + tab + "NULL" + tab + T_FV_4174_C + tab + T_FV_4174_M);


			}
			else
			{
				if (DeducteeDetailRecNo.length() <= 9)
				{
					if (obj_FieldValidation.isInt(DeducteeDetailRecNo))
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Salary Details  Record No" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4174_C + tab + T_FV_4174_M);
					}
					else if (UploadType.equals(UPLOADTYPE_REGULAR))
					{
						if (Integer.parseInt(DeducteeDetailRecNo.trim()) != DeducteeCount)
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Salary Details  Record No" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4174_C + tab + T_FV_4174_M);
						else
							validDeducteeDetailRecNo = true;
					}
					else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
					{
						if (prevSalaryDeducteeRecCount >= Integer.parseInt(DeducteeDetailRecNo.trim()))
						{
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Salary Details  Record No" + tab + "NA" + tab + T_FV_4168_C + tab + T_FV_4168_M);
						}
						validDeducteeDetailRecNo = true;
						prevSalaryDeducteeRecCount = Integer.parseInt(DeducteeDetailRecNo.trim());
					}
					else
					{
						if ((salaryDetailAddMode == true) && ((prevSalaryDeducteeRecCount + 1) != Integer.parseInt(DeducteeDetailRecNo.trim())))
						{
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Salary Details  Record No" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4174_C + tab + T_FV_4174_M);
						}
						else if ((salaryDetailAddMode == false) && (prevSalaryDeducteeRecCount >= Integer.parseInt(DeducteeDetailRecNo.trim())))
						{
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Salary Details  Record No" + tab + "NA" + tab + tab + T_FV_4168_C + tab + T_FV_4168_M);
						}
						prevSalaryDeducteeRecCount = Integer.parseInt(DeducteeDetailRecNo.trim());
						validDeducteeDetailRecNo = true;
					}
				}
				else
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Salary Details  Record No" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4174_C + tab + T_FV_4174_M);
				}
			}
			//	  check DeducteeDetailRecNo --4

			//			Check ModeSD  ----  5
			if (ModeSD.equals(FIELD_NULL) || ModeSD.equals(FIELD_SEPERATOR))
			{
				if (!TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Mode" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4120_C + tab + T_FV_4120_M);
				else
				{
					salaryDetailAddMode = true;
					prevSalaryDeducteeRecCount = Integer.parseInt(DeducteeDetailRecNo.trim());
				}
			}
			else
			{

				if(TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("F") && Qperiod.equals("Q4")){ //Added by shruti FVU 5.4

					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Mode" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4347_C + tab + T_FV_4347_M);
				}

				if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
				{
					if(ModeSD.equals("F") && Qperiod.equals("Q4")){ //Added if condition by shruti FVU 5.4
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Mode" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4346_C + tab + T_FV_4346_M);

					}
					else{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Mode" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4131_C + tab + T_FV_4131_M);
					}
				}
				else if (UploadType.equals(UPLOADTYPE_REGULAR))
				{
					if (!ModeSD.equals("A"))
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Mode" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4127_C + tab + T_FV_4127_M);
					else if (validDeducteeDetailRecNo)
						fvO.receiptLastSDNumber = Integer.toString(Integer.parseInt(DeducteeDetailRecNo.trim()));

				}
				else if (!ModeSD.equals("D") && !ModeSD.equals("A"))
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Mode" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4121_C + tab + T_FV_4121_M);
				}
				else if ((salaryDetailAddMode == true) && !ModeSD.equals("A"))
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Mode" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4173_C + tab + T_FV_4173_M);
				}
				else if (ModeSD.equals("A"))
				{
					salaryDetailAddMode = true;

					if (!DeducteeDetailRecNo.trim().equals("^"))
					{
						prevSalaryDeducteeRecCount = Integer.parseInt(DeducteeDetailRecNo.trim());  //to be changed for 7.0
					}
					fvO.receiptLastSDNumber = Integer.toString(prevSalaryDeducteeRecCount);
				}


			}
			//			Check ModeSD --5

			//		check EmployeeSerialNo  ----6 
			if (!EmployeeSerialNo.equals(FIELD_NULL) && !EmployeeSerialNo.equals(FIELD_SEPERATOR))
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Filler 7" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4008_C + tab + T_FV_4008_M);
			}

			//	  check EmployeeSerialNo ---6

			//	check EmployeePan   ----   7
			if (EmployeePan.equals(FIELD_NULL) || EmployeePan.equals(FIELD_SEPERATOR) || EmployeePan.trim().length() == 0)
			{
				if (paperReturnFile)
				{
					fvO.setPaperReturnRelax(true);
					//fvO.receiptPanInvaild++;
					fvO.receiptSalPanInvaild++;
					Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + CurrentlocalSDNumber + tab + T_FV_4009_C + tab + T_FV_4009_M);
					/*
					 * code added on 06-oct-2006 to make an entry of Null value of PAN
					 * in PAN stat buffer file.
					 */
					if (fvO.batchNumberOfRecord == 0)
					{
						fvO.batchNumberOfRecord = Integer.parseInt(BH_BatchNo.trim());
						Str_Buffer.appendPANStat(obj_FileGenerator.createPANStatFileHeader());
						Str_Buffer.appendPANStat(obj_FileGenerator.createPANStatTableStructureStart(batchRecDataForPanStat.toString()));
						batchRecDataForPanStat = new StringBuffer();
						Str_Buffer.appendPANStat("<TR>");
						Str_Buffer.appendPANStat("<TD  valign=top style='text-align:right' width=75> " + LineNo + "</TD>");
						Str_Buffer.appendPANStat("<TD  valign=top style='text-align:right' width=125>" + DeducteeDetailRecNo + "</TD>");
						Str_Buffer.appendPANStat("<TD  ALIGN=LEFT width=188> " + "" + "</TD>");
						Str_Buffer.appendPANStat("<TD  ALIGN=LEFT width=180>" + "PAN not Provided" + "</TD>");
						Str_Buffer.appendPANStat("</TR>");
					}
					else if (fvO.batchNumberOfRecord == Integer.parseInt(BH_BatchNo.trim()))
					{
						Str_Buffer.appendPANStat("<TR>");
						Str_Buffer.appendPANStat("<TD  valign=top style='text-align:right' width=75> " + LineNo + "</TD>");
						Str_Buffer.appendPANStat("<TD  valign=top style='text-align:right' width=125>" + DeducteeDetailRecNo + "</TD>");
						Str_Buffer.appendPANStat("<TD  ALIGN=LEFT width=188> " + "" + "</TD>");
						Str_Buffer.appendPANStat("<TD  ALIGN=LEFT width=180>" + "PAN not Provided" + "</TD>");
						Str_Buffer.appendPANStat("</TR>");
					}
				}
				else if (ModeSD.equals("A") || TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Employee PAN" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4009_C + tab + T_FV_4009_M);
				}
			}
			else
			{
				if (ModeSD.equals("D"))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Employee PAN" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4136_C + tab + T_FV_4136_M);
				else if (EmployeePan.length() > 10)
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Employee PAN" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4009_C + tab + T_FV_4009_M);
				else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN) && obj_FieldValidation.checkPan(EmployeePan))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Employee PAN" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4009_C + tab + T_FV_4009_M);
				else if (!EmployeePan.equals(PAN_NOT_AVAILABLE) && !EmployeePan.equals(PAN_APPLIED) && !EmployeePan.equals(PAN_INVALID))
				{
					if (EmployeePan.length() == 10 && EmployeePan.trim().length() == 10)
					{

						if (obj_FieldValidation.checkPan(EmployeePan))
						{
							if (paperReturnFile)
							{
								if (obj_FieldValidation.isAlphaNum(EmployeePan))
								{
									Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "NA" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4009_C + tab + T_FV_4009_M);
								}
								else
								{
									fvO.setPaperReturnRelax(true);
									Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "NA" + tab + DeducteeDetailRecNo + tab + T_FV_4009_C + tab + T_FV_4009_M);
									//fvO.receiptPanInvaild++;
									fvO.receiptSalPanInvaild++;
									/*
									 * code added on 06-oct-2006 to make an entry of Structurally invalid PAN
									 * in PAN stat buffer file.
									 */
									if (fvO.batchNumberOfRecord == 0)
									{
										fvO.batchNumberOfRecord = Integer.parseInt(BH_BatchNo.trim());
										Str_Buffer.appendPANStat(obj_FileGenerator.createPANStatFileHeader());
										Str_Buffer.appendPANStat(obj_FileGenerator.createPANStatTableStructureStart(batchRecDataForPanStat.toString()));
										batchRecDataForPanStat = new StringBuffer();
										Str_Buffer.appendPANStat("<TR>");
										Str_Buffer.appendPANStat("<TD  valign=top style='text-align:right' width=75> " + LineNo + "</TD>");
										Str_Buffer.appendPANStat("<TD  valign=top style='text-align:right' width=125>" + DeducteeDetailRecNo + "</TD>");
										Str_Buffer.appendPANStat("<TD  ALIGN=LEFT width=188> " + EmployeePan + "</TD>");
										Str_Buffer.appendPANStat("<TD  ALIGN=LEFT width=180>" + "Structurally Invalid Pan" + "</TD>");
										Str_Buffer.appendPANStat("</TR>");
									}
									else if (fvO.batchNumberOfRecord == Integer.parseInt(BH_BatchNo.trim()))
									{
										Str_Buffer.appendPANStat("<TR>");
										Str_Buffer.appendPANStat("<TD  valign=top style='text-align:right' width=75> " + LineNo + "</TD>");
										Str_Buffer.appendPANStat("<TD  valign=top style='text-align:right' width=125>" + DeducteeDetailRecNo + "</TD>");
										Str_Buffer.appendPANStat("<TD  ALIGN=LEFT width=188> " + EmployeePan + "</TD>");
										Str_Buffer.appendPANStat("<TD  ALIGN=LEFT width=180>" + "Structurally Invalid Pan" + "</TD>");
										Str_Buffer.appendPANStat("</TR>");
									}
								}
							}
							else
								Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Employee PAN" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4009_C + tab + T_FV_4009_M);
						}
						//CHANGE AMI
						else if(FormNo.equals(FORM_24Q) && !paperReturnFile && Qperiod.equals("Q4") && (ModeSD.equals("A") || UploadType.equals(UPLOADTYPE_REGULAR) || TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN)))
						{
							if(obj_FieldValidation.checkPanForthDigit24Q(EmployeePan))
								Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Employee PAN" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4264_C + tab + T_FV_4264_M);
							else
								fvO.receiptSalValidPAN++;
						}
						//END

						else
							//fvO.receiptValidPAN++;
							fvO.receiptSalValidPAN++;
					}
					else
					{
						if (paperReturnFile)
						{
							if (obj_FieldValidation.isAlphaNum(EmployeePan))
							{
								Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Employee PAN" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4009_C + tab + T_FV_4009_M);
							}
							else
							{
								fvO.setPaperReturnRelax(true);
								Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "NA" + tab + DeducteeDetailRecNo + tab + T_FV_4009_C + tab + T_FV_4009_M);
								//fvO.receiptPanInvaild++;
								fvO.receiptSalPanInvaild++;
								/*
								 * code added on 06-oct-2006 to make an entry of Structurally invalid PAN
								 * in PAN stat buffer file.
								 */
								if (fvO.batchNumberOfRecord == 0)
								{
									fvO.batchNumberOfRecord = Integer.parseInt(BH_BatchNo.trim());
									Str_Buffer.appendPANStat(obj_FileGenerator.createPANStatFileHeader());
									Str_Buffer.appendPANStat(obj_FileGenerator.createPANStatTableStructureStart(batchRecDataForPanStat.toString()));
									batchRecDataForPanStat = new StringBuffer();
									Str_Buffer.appendPANStat("<TR>");
									Str_Buffer.appendPANStat("<TD  valign=top style='text-align:right' width=75> " + LineNo + "</TD>");
									Str_Buffer.appendPANStat("<TD  valign=top style='text-align:right' width=125>" + DeducteeDetailRecNo + "</TD>");
									Str_Buffer.appendPANStat("<TD  ALIGN=LEFT width=188> " + EmployeePan + "</TD>");
									Str_Buffer.appendPANStat("<TD  ALIGN=LEFT width=180>" + "Structurally Invalid Pan" + "</TD>");
									Str_Buffer.appendPANStat("</TR>");
								}
								else if (fvO.batchNumberOfRecord == Integer.parseInt(BH_BatchNo.trim()))
								{
									Str_Buffer.appendPANStat("<TR>");
									Str_Buffer.appendPANStat("<TD  valign=top style='text-align:right' width=75> " + LineNo + "</TD>");
									Str_Buffer.appendPANStat("<TD  valign=top style='text-align:right' width=125>" + DeducteeDetailRecNo + "</TD>");
									Str_Buffer.appendPANStat("<TD  ALIGN=LEFT width=188> " + EmployeePan + "</TD>");
									Str_Buffer.appendPANStat("<TD  ALIGN=LEFT width=180>" + "Structurally Invalid Pan" + "</TD>");
									Str_Buffer.appendPANStat("</TR>");
								}
							}
						}
						else
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Employee PAN" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4009_C + tab + T_FV_4009_M);
					}
				}
				else
				{
					// used to generate provisional receipt
					// adding PANINVALID/PANAPPLIED/PANNOTAVL count to respective Vector for respective BATCH Record

					String tempPanSt = null;
					if (EmployeePan.equals(PAN_NOT_AVAILABLE))
					{
						//fvO.receiptPanNotAvbl++;
						fvO.receiptSalPanNotAvbl++; 
						tempPanSt = "PAN not available";
					}
					else if (EmployeePan.equals(PAN_APPLIED))
					{
						//fvO.receiptPanApplied++;
						fvO.receiptSalPanApplied++;
						tempPanSt = "PAN applied";
					}
					else if (EmployeePan.equals(PAN_INVALID))
					{
						//fvO.receiptPanInvaild++;
						fvO.receiptSalPanInvaild++;
						tempPanSt = "Invalid PAN";
					}

					// changed on 1 Sept 	
					//  statisticFileSDRec.append(LineNo + "$" + DeducteeDetailRecNo + "$" + panErrorDesc + "*");

					if (FormValidator.generateTdsPANStatBuffer && Str_Buffer.getErrorCount() == 0)
					{
						if (fvO.batchNumberOfRecord == 0)
						{
							fvO.batchNumberOfRecord = Integer.parseInt(BH_BatchNo.trim());
							Str_Buffer.appendPANStat(obj_FileGenerator.createPANStatFileHeader());
							Str_Buffer.appendPANStat(obj_FileGenerator.createPANStatTableStructureStart(batchRecDataForPanStat.toString()));
							batchRecDataForPanStat = new StringBuffer();
							Str_Buffer.appendPANStat("<TR>");
							Str_Buffer.appendPANStat("<TD  valign=top style='text-align:right' width=75> " + LineNo + "</TD>");
							Str_Buffer.appendPANStat("<TD  valign=top style='text-align:right' width=125>" + DeducteeDetailRecNo + "</TD>");
							Str_Buffer.appendPANStat("<TD  ALIGN=LEFT width=188> " + EmployeePan + "</TD>");
							Str_Buffer.appendPANStat("<TD  ALIGN=LEFT width=180>" + tempPanSt + "</TD>");
							Str_Buffer.appendPANStat("</TR>");
						}
						else if (fvO.batchNumberOfRecord == Integer.parseInt(BH_BatchNo.trim()))
						{
							Str_Buffer.appendPANStat("<TR>");
							Str_Buffer.appendPANStat("<TD  valign=top style='text-align:right' width=75> " + LineNo + "</TD>");
							Str_Buffer.appendPANStat("<TD  valign=top style='text-align:right' width=125>" + DeducteeDetailRecNo + "</TD>");
							Str_Buffer.appendPANStat("<TD  ALIGN=LEFT width=188> " + EmployeePan + "</TD>");
							Str_Buffer.appendPANStat("<TD  ALIGN=LEFT width=180>" + tempPanSt + "</TD>");
							Str_Buffer.appendPANStat("</TR>");
						}
						else
						{
							fvO.batchNumberOfRecord = Integer.parseInt(BH_BatchNo.trim());
							Str_Buffer.appendPANStat(obj_FileGenerator.createPANStatTableStructureEnd(fileNamePrintedinStatRep));
							Str_Buffer.appendPANStat(obj_FileGenerator.createPANStatTableStructureStart(batchRecDataForPanStat.toString()));
							batchRecDataForPanStat = new StringBuffer();
							Str_Buffer.appendPANStat("<TR>");
							Str_Buffer.appendPANStat("<TD  valign=top style='text-align:right' width=75> " + LineNo + "</TD>");
							Str_Buffer.appendPANStat("<TD  valign=top style='text-align:right' width=120>" + DeducteeDetailRecNo + "</TD>");
							Str_Buffer.appendPANStat("<TD  ALIGN=LEFT width=188> " + EmployeePan + "</TD>");
							Str_Buffer.appendPANStat("<TD  ALIGN=LEFT width=180>" + tempPanSt + "</TD>");
							Str_Buffer.appendPANStat("</TR>");
						}
					}
				}


				//				---------------Added by Nahush for validating Deductor PAN against PAN of deductee.

				if(!(EmployeePan.equals(PAN_NOT_AVAILABLE) || 
						EmployeePan.equals(PAN_APPLIED) || 
						EmployeePan.equals(PAN_INVALID)) && 
						PANForThisBatch.equals(EmployeePan) &&
						(UploadType.equals("R") || (UploadType.equals("C") && BatchUpdationIndicator.equals("1"))))
				{
					if (paperReturnFile)
					{
						Str_Buffer.appendPaperWarning(LineNo + tab + "Salary Detail" + tab + BH_BatchNo + tab + "NA" + tab + DeducteeDetailRecNo + tab + "NA" + tab + "NA" + tab + "NA" + tab + T_FV_4262_C + tab + T_FV_4262_M);
					}

					else
					{
						Str_Buffer.appendElectronicWarning(LineNo + tab + "Salary Detail" + tab + BH_BatchNo + tab + "NA" + tab + DeducteeDetailRecNo + tab + "NA" + tab + "NA" + tab + "NA" + tab + T_FV_4262_C + tab + T_FV_4262_M);
					}
				}




			}
			//	check EmployeePan --7

			//		check EmployeePanRefNo   ------ 8
			if (EmployeePanRefNo.equals(FIELD_NULL) || EmployeePanRefNo.equals(FIELD_SEPERATOR))
			{
			}
			// added by faizan for FVU 4.5
			else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
				if(!(EmployeePanRefNo.equals(FIELD_NULL) || EmployeePanRefNo.equals(FIELD_SEPERATOR))){
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "PAN Ref. No." + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_2227_C + tab + T_FV_2227_M);	
				}
			}
			//ended by faizan 
			/*
			 * Paper Return clause added on 06-oct-2006 as PAN Ref No. field is not present in Physical Form
			 */
			else if (ModeSD.equals("D") || TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN) || paperReturnFile)
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "PAN Ref. No." + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4126_C + tab + T_FV_4126_M);
			else if (EmployeePanRefNo.length() != 10 || EmployeePanRefNo.trim().length() != 10 || obj_FieldValidation.isAlphaNum(EmployeePanRefNo))
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "PAN Ref. No." + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4010_C + tab + T_FV_4010_M);
			}
			//		check EmployeePanRefNo --8

			//		check of EmployeeName   ----   9
			if (EmployeeName.equals(FIELD_NULL) || EmployeeName.equals(FIELD_SEPERATOR))
			{
				if (ModeSD.equals("A"))
				{
					/*
					 * Code modified on 06-oct-2006 for Paper Return Relaxation of Employee Name
					 */
					if (paperReturnFile)
					{
						fvO.setPaperReturnRelax(true);
						Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "NA" + tab + DeducteeDetailRecNo + tab + T_FV_4012_C + tab + T_FV_4012_M);
					}
					else
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Name of Employee" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4012_C + tab + T_FV_4012_M);
				}
			}
			// added by faizan for FVU 4.5
			else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
				if( ! ( EmployeeName.equals(FIELD_NULL) || EmployeeName.equals(FIELD_SEPERATOR)))
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Name of Employee" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_2227_C + tab + T_FV_2227_M);	
				}
			}
			//ended by faizan
			else
			{
				if (ModeSD.equals("D") || TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Name of Employee" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4137_C + tab + T_FV_4137_M);
				else if (EmployeeName.length() <= 75 || EmployeeName.trim().length() == 0)
				{
					if (obj_FieldValidation.isValidCharString(EmployeeName))
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Name of Employee" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4012_C + tab + T_FV_4012_M);
					}
				}
				else
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Name of Employee" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4012_C + tab + T_FV_4012_M);
				}
			}
			//				check EmployeeName 

			// check for Category ---- 10
			if (EmployeeCategory.equals(FIELD_NULL) || EmployeeCategory.equals(FIELD_SEPERATOR))
			{
				if (ModeSD.equals("A"))
				{
					/*
					 * Code modified on 06-oct-2006 for Paper Return Relaxation of Category
					 */
					if (paperReturnFile)
					{
						fvO.setPaperReturnRelax(true);
						Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "NA" + tab + DeducteeDetailRecNo + tab + T_FV_4217_C + tab + T_FV_4217_M);
					}
					else
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Category" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4217_C + tab + T_FV_4217_M);
				}
			}
			// added by faizan for FVU 4.5
			else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
				if(!(EmployeeCategory.equals(FIELD_NULL)||EmployeeCategory.equals(FIELD_SEPERATOR))){
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Category" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_2227_C + tab + T_FV_2227_M);	
				}
			}
			//ended by faizan
			else if (ModeSD.equals("D") || TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Category" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4218_C + tab + T_FV_4218_M);
			else if (EmployeeCategory.length() > 1 || EmployeeCategory.trim().length() == 0 || obj_FieldValidation.isValidCharString(EmployeeCategory))
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Category" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4217_C + tab + T_FV_4217_M);
			}
			else if (!EmployeeCategory.equals("W") && !EmployeeCategory.equals("S") && !EmployeeCategory.equals("G") && !(EmployeeCategory.equals("O")&& Integer.parseInt(FinancialYr)>=201112))
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Category" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4217_C + tab + T_FV_4217_M);
			}
			// check for Category

			//check for Period of Employment From - Date    -------  11
			boolean invalidEmpFrmDate = false;
			if (PeriodEmploymentFrm.equals(FIELD_NULL) || PeriodEmploymentFrm.equals(FIELD_SEPERATOR))
			{
				//Added By Priya for FVU 5.2 
				if( !(WhethrContribtnPaidByTrusty.equals("Y") && TaxblAmtCurEmp.equals("0.00")) )
				{
					if (ModeSD.equals("A"))
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Period of Employment From - Date" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4014_C + tab + T_FV_4014_M);
					invalidEmpFrmDate = true;
				}

			}
			// added by faizan for FVU 4.5
			else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
				if(!(PeriodEmploymentFrm.equals(FIELD_NULL)|| PeriodEmploymentFrm.equals(FIELD_SEPERATOR))){
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Period of Employment From - Date" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_2227_C + tab + T_FV_2227_M);	
				}
			}
			//ended by faizan
			else if (PeriodEmploymentFrm.length() == 8 && PeriodEmploymentFrm.trim().length() == 8)
			{
				if (ModeSD.equals("D") || TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Period of Employment From - Date" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4139_C + tab + T_FV_4139_M);
				else if (obj_FieldValidation.isInt(PeriodEmploymentFrm))
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Period of Employment From - Date" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4014_C + tab + T_FV_4014_M);
					invalidEmpFrmDate = true;
				}
				else if (obj_FieldValidation.isDate(PeriodEmploymentFrm))
				{
					/*
					 * Code modified on 06-oct-2006 for Paper Return Relaxation of from date
					 */
					if (paperReturnFile)
					{
						if (PeriodEmploymentFrm.equals(paperRetDateBankChalnDefValue))
						{
							fvO.setPaperReturnRelax(true);
							Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "NA" + tab + DeducteeDetailRecNo + tab + T_FV_4014_C + tab + T_FV_4014_M);
							invalidEmpFrmDate = true;
						}
						else
						{
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Period of Employment From - Date" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4014_C + tab + T_FV_4014_M);
							invalidEmpFrmDate = true;
						}
					}
					else
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Period of Employment From - Date" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4014_C + tab + T_FV_4014_M);
						invalidEmpFrmDate = true;
					}
				}
				else if (!paperReturnFile) // commented on 10-Oct-05 By Mayank Paper Return Changes
				{
					if (obj_FieldValidation.isDateGreaterThenRRRDatePresentDate(PeriodEmploymentFrm, RRRDatePresentDate))
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Period of Employment From - Date" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4014_C + tab + T_FV_4014_M);
						invalidEmpFrmDate = true;
					}
					else
					{
						Calendar today = Calendar.getInstance();
						Calendar cal =
								new GregorianCalendar(
										Integer.parseInt(PeriodEmploymentFrm.substring(4)),
										Integer.parseInt(PeriodEmploymentFrm.substring(2, 4)) - 1,
										Integer.parseInt(PeriodEmploymentFrm.substring(0, 2)));

						if (!(cal.before(today)))
						{
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Period of Employment From - Date" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4014_C + tab + T_FV_4014_M);
							invalidEmpFrmDate = true;
						}
						else if (obj_FieldValidation.employmentFromDateBeforeQuatEnd(PeriodEmploymentFrm, FinancialYr, Qperiod))
						{
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Period of Employment From - Date" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4014_C + tab + T_FV_4014_M);
						}
					}
				}
				else if (paperReturnFile) // commented on 10-Oct-05 By Mayank Paper Return Changes
				{
					if (obj_FieldValidation.isDateGreaterThenRRRDatePresentDate(PeriodEmploymentFrm, RRRDatePresentDate))
					{
						fvO.setPaperReturnRelax(true);
						Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "NA" + tab + DeducteeDetailRecNo + tab + T_FV_4014_C + tab + T_FV_4014_M);
						invalidEmpFrmDate = true;
					}
					else
					{
						Calendar today = Calendar.getInstance();
						Calendar cal =
								new GregorianCalendar(
										Integer.parseInt(PeriodEmploymentFrm.substring(4)),
										Integer.parseInt(PeriodEmploymentFrm.substring(2, 4)) - 1,
										Integer.parseInt(PeriodEmploymentFrm.substring(0, 2)));

						if (!(cal.before(today)))
						{
							fvO.setPaperReturnRelax(true);
							Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "NA" + tab + DeducteeDetailRecNo + tab + T_FV_4014_C + tab + T_FV_4014_M);
							invalidEmpFrmDate = true;
						}
						else if (obj_FieldValidation.employmentFromDateBeforeQuatEnd(PeriodEmploymentFrm, FinancialYr, Qperiod))
						{
							fvO.setPaperReturnRelax(true);
							Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "NA" + tab + DeducteeDetailRecNo + tab + T_FV_4014_C + tab + T_FV_4014_M);
							invalidEmpFrmDate = true;
						}
					}
				}
			}
			else
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Period of Employment From - Date" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4014_C + tab + T_FV_4014_M);
				invalidEmpFrmDate = true;
			}
			//	check for Period of Employment From - Date

			// 	check for Period of Employment To - Date   ----  12

			if (PeriodEmploymentTo.equals(FIELD_NULL) || PeriodEmploymentTo.equals(FIELD_SEPERATOR))
			{
				if( !(WhethrContribtnPaidByTrusty.equals("Y") && TaxblAmtCurEmp.equals("0.00")) )
				{
					if (ModeSD.equals("A"))
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Period of Employment To - Date" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4015_C + tab + T_FV_4015_M);
				}
			}

			// added by faizan for FVU 4.5
			else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
				if(!(PeriodEmploymentTo.equals(FIELD_NULL) || PeriodEmploymentTo.equals(FIELD_SEPERATOR))){
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab +  "Period of Employment To - Date" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_2227_C + tab + T_FV_2227_M);	
				}
			}
			//ended by faizan
			else if (PeriodEmploymentTo.length() == 8 && PeriodEmploymentTo.trim().length() == 8)
			{
				if (ModeSD.equals("D") || TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Period of Employment To - Date" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4140_C + tab + T_FV_4140_M);
				else if (obj_FieldValidation.isInt(PeriodEmploymentTo))
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Period of Employment To - Date" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4015_C + tab + T_FV_4015_M);
				}
				else if (obj_FieldValidation.isDate(PeriodEmploymentTo))
				{
					/*
					 * Code modified on 06-oct-2006 for Paper Return Relaxation of to date
					 */
					if (paperReturnFile)
					{
						if (PeriodEmploymentTo.equals(paperRetDateBankChalnDefValue))
						{
							fvO.setPaperReturnRelax(true);
							Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "NA" + tab + DeducteeDetailRecNo + tab + T_FV_4015_C + tab + T_FV_4015_M);
						}
						else
						{
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Period of Employment To - Date" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4015_C + tab + T_FV_4015_M);
						}
					}
					else
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Period of Employment To - Date" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4015_C + tab + T_FV_4015_M);
					}
				}
				else if (!paperReturnFile) // commented on 10-Oct-05 By Mayank Paper Return Changes
				{
					if (obj_FieldValidation.isDateGreaterThenRRRDatePresentDate(PeriodEmploymentTo, RRRDatePresentDate))
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Period of Employment To - Date" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4015_C + tab + T_FV_4015_M);
					}
					else if (invalidEmpFrmDate == false)
					{
						Calendar today = Calendar.getInstance();
						Calendar cal =
								new GregorianCalendar(
										Integer.parseInt(PeriodEmploymentTo.substring(4)),
										Integer.parseInt(PeriodEmploymentTo.substring(2, 4)) - 1,
										Integer.parseInt(PeriodEmploymentTo.substring(0, 2)));
						Calendar cal1 =
								new GregorianCalendar(
										Integer.parseInt(PeriodEmploymentFrm.substring(4)),
										Integer.parseInt(PeriodEmploymentFrm.substring(2, 4)) - 1,
										Integer.parseInt(PeriodEmploymentFrm.substring(0, 2)));
						if (!(cal.before(today)))
						{
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Period of Employment To - Date" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4015_C + tab + T_FV_4015_M);
						}
						else if (invalidEmpFrmDate == false && cal.before(cal1))
						{
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Period of Employment To - Date" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4015_C + tab + T_FV_4015_M);
						}
						/*
						 * code commented to allow To-date to have any value upto the financial
						 * year but should be greater than From date
						 */
						/*else if (obj_FieldValidation.employmentDateWithinFinQuat(PeriodEmploymentTo, FinancialYr, Qperiod))
						{
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "NA" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4015_C + tab + T_FV_4015_M);
						 }
						 */
						else if (!obj_FieldValidation.isDateBeforeFinYearEndDate(PeriodEmploymentTo, FinancialYr))
						{
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Period of Employment To - Date" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4015_C + tab + T_FV_4015_M);
						}

					}
				}
				else if (paperReturnFile) // commented on 10-Oct-05 By Mayank Paper Return Changes
				{
					if (obj_FieldValidation.isDateGreaterThenRRRDatePresentDate(PeriodEmploymentTo, RRRDatePresentDate))
					{
						fvO.setPaperReturnRelax(true);
						Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "NA" + tab + DeducteeDetailRecNo + tab + T_FV_4015_C + tab + T_FV_4015_M);
					}
					else if (invalidEmpFrmDate == false)
					{
						Calendar today = Calendar.getInstance();
						Calendar cal =
								new GregorianCalendar(
										Integer.parseInt(PeriodEmploymentTo.substring(4)),
										Integer.parseInt(PeriodEmploymentTo.substring(2, 4)) - 1,
										Integer.parseInt(PeriodEmploymentTo.substring(0, 2)));
						Calendar cal1 =
								new GregorianCalendar(
										Integer.parseInt(PeriodEmploymentFrm.substring(4)),
										Integer.parseInt(PeriodEmploymentFrm.substring(2, 4)) - 1,
										Integer.parseInt(PeriodEmploymentFrm.substring(0, 2)));
						if (!(cal.before(today)))
						{
							Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "NA" + tab + DeducteeDetailRecNo + tab + T_FV_4015_C + tab + T_FV_4015_M);
						}
						else if (invalidEmpFrmDate == false && cal.before(cal1))
						{
							fvO.setPaperReturnRelax(true);
							Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "NA" + tab + DeducteeDetailRecNo + tab + T_FV_4015_C + tab + T_FV_4015_M);
						}

						/*
						 * code commented to allow To-date to have any value upto the financial
						 * year but should be greater than From date
						 */

						/*else if (obj_FieldValidation.employmentDateWithinFinQuat(PeriodEmploymentTo, FinancialYr, Qperiod))
						{
							fvO.setPaperReturnRelax(true);
							Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4015_C + tab + T_FV_4015_M);
						}*/
						else if (!obj_FieldValidation.isDateBeforeFinYearEndDate(PeriodEmploymentTo, FinancialYr))
						{
							Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "NA" + tab + DeducteeDetailRecNo + tab + T_FV_4015_C + tab + T_FV_4015_M);
						}
					}
				}
			}
			else
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "NA" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4015_C + tab + T_FV_4015_M);
			}
			//			check for Period of Employment To - Date

			//     Validating TotalSalaryExeclud333n334   --- 13
			boolean validTotalSalaryExeclud338n339 = false;
			if (TotalSalaryExeclud338n339.equals(FIELD_NULL) || TotalSalaryExeclud338n339.equals(FIELD_SEPERATOR))
			{
				if (ModeSD.equals("A"))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Total amount of salary " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4011_C + tab + T_FV_4011_M);
			}
			// added by faizan for FVU 4.5
			else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
				if(!(TotalSalaryExeclud338n339.equals(FIELD_NULL) || TotalSalaryExeclud338n339.equals(FIELD_SEPERATOR))){
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab +  "Total amount of salary "  + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_2227_C + tab + T_FV_2227_M);	
				}
			}
			//ended by faizan
			else
			{
				if (ModeSD.equals("D") || TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Total amount of salary " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4016_C + tab + T_FV_4016_M);
				//Added By amit for 4.5
				else if(TotalSalaryExeclud338n339.length()!=TotalSalaryExeclud338n339.trim().length())
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Total amount of salary " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4011_C + tab + T_FV_4011_M);			
				}
				//Amit end for Fvu 4.5 
				else if (TotalSalaryExeclud338n339.length() <= 15)
				{
					if (obj_FieldValidation.isDecimalNumber(TotalSalaryExeclud338n339))
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Total amount of salary " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4011_C + tab + T_FV_4011_M);
					//Added by faizan for fvu 4.5
					else if(!(Double.parseDouble(TotalSalaryExeclud338n339)>=0))
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Total amount of salary " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4011_C + tab + T_FV_4011_M);
					}
					else
						validTotalSalaryExeclud338n339 = true;
				}
				else
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Total amount of salary " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4011_C + tab + T_FV_4011_M);
			}
			//	   Validating TotalSalaryExeclud333n334

			//		Validate Profit lieu of salary under sec 17(3) ----  14  Filler field,  Filler-8
			if (!ProfitSalSec17.equals(FIELD_NULL) && !ProfitSalSec17.equals(FIELD_SEPERATOR))
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Filler 8" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4019_C + tab + T_FV_4019_M);
			}
			// added by faizan for FVU 4.5
			else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
				if(!(ProfitSalSec17.equals(FIELD_NULL) || ProfitSalSec17.equals(FIELD_SEPERATOR))){
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab +  "Filler 8"   + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_2227_C + tab + T_FV_2227_M);	
				}
			}
			//ended by faizan
			//		Validate Profit lieu of salary under sec 17(3)

			//Validate Count of Deductee Section 16   -----  15
			boolean validCountDeducteeSec16 = false;
			if (CountDeducteeSec16.equals(FIELD_NULL) || CountDeducteeSec16.equals(FIELD_SEPERATOR))
			{
				if (ModeSD.equals("A"))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Count of ' Salary Details  - Section 16 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4024_C + tab + T_FV_4024_M);
			}
			// added by faizan for FVU 4.5
			else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
				if(! (CountDeducteeSec16.equals(FIELD_NULL)|| CountDeducteeSec16.equals(FIELD_SEPERATOR))){
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab +  "Count of ' Salary Details  - Section 16 "   + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_2227_C + tab + T_FV_2227_M);	
				}
			}
			//ended by faizan
			else if (CountDeducteeSec16.length() <= 15)
			{
				if (ModeSD.equals("D") || TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Count of ' Salary Details  - Section 16 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4149_C + tab + T_FV_4149_M);
				else if (obj_FieldValidation.isInt(CountDeducteeSec16))
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Count of ' Salary Details  - Section 16 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4024_C + tab + T_FV_4024_M);
				}
				else if (Integer.parseInt(CountDeducteeSec16.trim()) > sec16Identification.length)
				{
					/*
					 * code modified to allow one more row in sec 16 
					 * for paper return with default section Id
					 */
					if (paperReturnFile)
					{
						if (Integer.parseInt(CountDeducteeSec16.trim()) > (sec16Identification.length + 1))
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Count of ' Salary Details  - Section 16 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4024_C + tab + T_FV_4024_M);
						else
						{
							fvO.setPaperReturnRelax(true);
							Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "NA" + tab + DeducteeDetailRecNo + tab + T_FV_4024_C + tab + T_FV_4024_M);
						}
					}
					else
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Count of ' Salary Details  - Section 16 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4024_C + tab + T_FV_4024_M);
				}
				else
					validCountDeducteeSec16 = true;
			}
			else
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Count of ' Salary Details  - Section 16 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4024_C + tab + T_FV_4024_M);
			}
			//Validate Count of Deductee Section 16 	

			//Validate Gross Total of deduction under section 16   --------- 16
			boolean validGrossTotalDeducteeSec16 = false;
			if (GrossTotalDeducteeSec16.equals(FIELD_NULL) || GrossTotalDeducteeSec16.equals(FIELD_SEPERATOR))
			{
				if (ModeSD.equals("A"))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Gross Total of 'Total Deduction under section 16' under  associated ' Salary Details  - Section 16 Detail ' " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4025_C + tab + T_FV_4025_M);
			}
			// added by faizan for FVU 4.5
			else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
				if(!(GrossTotalDeducteeSec16.equals(FIELD_NULL) || GrossTotalDeducteeSec16.equals(FIELD_SEPERATOR))){
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab +  "Gross Total of 'Total Deduction under section 16' under  associated ' Salary Details  - Section 16 Detail ' "  + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_2227_C + tab + T_FV_2227_M);	
				}
			}
			//ended by faizan
			//Added By amit for 4.5

			else if(GrossTotalDeducteeSec16.length()!=GrossTotalDeducteeSec16.trim().length())
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Gross Total of 'Total Deduction under section 16' under  associated ' Salary Details  - Section 16 Detail ' " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4025_C + tab + T_FV_4025_M);	
			}

			//Amit end for Fvu 4.5 
			else if (GrossTotalDeducteeSec16.length() <= 15)
			{
				if (ModeSD.equals("D") || TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Gross Total of 'Total Deduction under section 16' under  associated ' Salary Details  - Section 16 Detail ' " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4150_C + tab + T_FV_4150_M);
				else if (obj_FieldValidation.isDecimalNumber(GrossTotalDeducteeSec16))
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Gross Total of 'Total Deduction under section 16' under  associated ' Salary Details  - Section 16 Detail ' " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4025_C + tab + T_FV_4025_M);
				}
				else // if (!paperReturnFile)  commented on 10-Oct-05 By Mayank Paper Return Changes
				{
					if (validCountDeducteeSec16)
					{
						if ((Long.parseLong(CountDeducteeSec16.trim()) == 0) && (Double.parseDouble(GrossTotalDeducteeSec16.trim()) != 0))
						{
							if (paperReturnFile)
							{
								fvO.setPaperReturnRelax(true);
								Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "NA" + tab + DeducteeDetailRecNo + tab + T_FV_4025_C + tab + T_FV_4025_M);
								validGrossTotalDeducteeSec16 = true;
							}
							else
								Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Gross Total of 'Total Deduction under section 16' under  associated ' Salary Details  - Section 16 Detail ' " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4025_C + tab + T_FV_4025_M);
						}
						else if ((Long.parseLong(CountDeducteeSec16.trim()) > 0) && (Double.parseDouble(GrossTotalDeducteeSec16.trim()) == 0))
						{
							if (paperReturnFile)
							{
								fvO.setPaperReturnRelax(true);
								Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "NA" + tab + DeducteeDetailRecNo + tab + T_FV_4025_C + tab + T_FV_4025_M);
								validGrossTotalDeducteeSec16 = true;
							}
							else
								Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Gross Total of 'Total Deduction under section 16' under  associated ' Salary Details  - Section 16 Detail ' " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4025_C + tab + T_FV_4025_M);
						}
						else
							validGrossTotalDeducteeSec16 = true;
					}
					else
						validGrossTotalDeducteeSec16 = true;
				}
			}
			else
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Gross Total of 'Total Deduction under section 16' under  associated ' Salary Details  - Section 16 Detail ' " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4025_C + tab + T_FV_4025_M);
			}
			//Validate Gross Total of deduction under section 16

			// start:validate Total amount of exemption claimed under section 10
			// (340+341+342+343+345+346) for fvu 6.2 by jacky

			boolean validTravelConcessionOrAssistanceSec10_5 = false;
			boolean validDeathCumRetirementGratuitySec10_10 = false;
			boolean validCommutedValueOfPensionSec10_10A = false;
			boolean validCashEquivalentOfLeaveSalEncashmentSec10_10AA = false;
			boolean validHouseRentAllowanceSec10_13A = false;
			boolean validAmountOfAnyOtherExemptionUnderSec10 = false;

			// start: added for fvu 6.2 by jacky

			if ((Integer.parseInt(FinancialYr) >= 201819) && (TransactionType.equals(UPLOADTYPE_REGULAR)
					|| (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A")))) {

				validTravelConcessionOrAssistanceSec10_5 = validateField6_2Onwards(FinancialYr,Qperiod,v_upload_Type, Str_Buffer, LineNo,
						DeducteeDetailRecNo, travelConcessionOrAssistanceSec10_5, obj_FieldValidation,
						"Travel concession or assistance [section 10(5)]", T_FV_6116_C, T_FV_6104_C, T_FV_6116_M,
						T_FV_6104_M,whthrOptTax115BAC,"");

				validDeathCumRetirementGratuitySec10_10 = validateField6_2Onwards(FinancialYr,Qperiod,v_upload_Type, Str_Buffer, LineNo,
						DeducteeDetailRecNo, deathCumRetirementGratuitySec10_10, obj_FieldValidation,
						"Death-cum-retirement gratuity [section 10(10)]", T_FV_6117_C, T_FV_6105_C, T_FV_6117_M,
						T_FV_6105_M,whthrOptTax115BAC,"");

				validCommutedValueOfPensionSec10_10A = validateField6_2Onwards(FinancialYr,Qperiod,v_upload_Type, Str_Buffer, LineNo,
						DeducteeDetailRecNo, commutedValueOfPensionSec10_10A, obj_FieldValidation,
						"Commuted value of pension [section 10(10A)]", T_FV_6118_C, T_FV_6106_C, T_FV_6118_M,
						T_FV_6106_M,whthrOptTax115BAC,"");

				validCashEquivalentOfLeaveSalEncashmentSec10_10AA = validateField6_2Onwards(FinancialYr,Qperiod,v_upload_Type, Str_Buffer,
						LineNo, DeducteeDetailRecNo, cashEquivalentOfLeaveSalEncashmentSec10_10AA, obj_FieldValidation,
						"Cash equivalent of leave salary encashment[section 10(10AA)]", T_FV_6119_C, T_FV_6107_C,
						T_FV_6119_M, T_FV_6107_M,whthrOptTax115BAC,"");

				validHouseRentAllowanceSec10_13A = validateField6_2Onwards(FinancialYr,Qperiod,v_upload_Type,Str_Buffer, LineNo,
						DeducteeDetailRecNo, houseRentAllowanceSec10_13A, obj_FieldValidation,
						"House rent allowance [section 10(13A)]", T_FV_6120_C, T_FV_6108_C, T_FV_6120_M, T_FV_6108_M,whthrOptTax115BAC,"");

				validAmountOfAnyOtherExemptionUnderSec10 = validateField6_2Onwards(FinancialYr,Qperiod,v_upload_Type, Str_Buffer, LineNo,
						DeducteeDetailRecNo, amountOfAnyOtherExemptionUnderSec10, obj_FieldValidation,
						"Amount of any other exemption under section 10", T_FV_6121_C, T_FV_6109_C, T_FV_6121_M,
						T_FV_6109_M,whthrOptTax115BAC,"");

			}

			else {

				validateFieldFinYrUpto201819(v_upload_Type, Str_Buffer, LineNo, DeducteeDetailRecNo,
						travelConcessionOrAssistanceSec10_5, "Travel concession or assistance [section 10(5)]");

				validateFieldFinYrUpto201819(v_upload_Type, Str_Buffer, LineNo, DeducteeDetailRecNo,
						deathCumRetirementGratuitySec10_10, "Death-cum-retirement gratuity [section 10(10)]");

				validateFieldFinYrUpto201819(v_upload_Type, Str_Buffer, LineNo, DeducteeDetailRecNo,
						commutedValueOfPensionSec10_10A, "Commuted value of pension [section 10(10A)]");

				validateFieldFinYrUpto201819(v_upload_Type, Str_Buffer, LineNo, DeducteeDetailRecNo,
						cashEquivalentOfLeaveSalEncashmentSec10_10AA,
						"Cash equivalent of leave salary encashment[section 10(10AA)]");

				validateFieldFinYrUpto201819(v_upload_Type, Str_Buffer, LineNo, DeducteeDetailRecNo,
						houseRentAllowanceSec10_13A, "House rent allowance [section 10(13A)]");

				validateFieldFinYrUpto201819(v_upload_Type, Str_Buffer, LineNo, DeducteeDetailRecNo,
						amountOfAnyOtherExemptionUnderSec10, "Amount of any other exemption under section 10");

			}

			// end : added for fvu 6.2 by jacky

			// end:validate Total amount of exemption claimed under section 10
			// (340+341+342+343+345+346) for fvu 6.2 by jacky

			// start:Validate Total amount of exemption claimed under section 10
			// (340+341+342+343+345+346) newly added for fvu 6.2 by jacky

			boolean validTotAmtOfExempClaimedUnderSec10_340n341n342n343n344n346 = false;
			if ((Integer.parseInt(FinancialYr) >= 201819) && (TransactionType.equals(UPLOADTYPE_REGULAR)
					|| (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A")))) {

				validTotAmtOfExempClaimedUnderSec10_340n341n342n343n344n346 = validateField6_2Onwards(FinancialYr,Qperiod,v_upload_Type,
						Str_Buffer, LineNo, DeducteeDetailRecNo,
						totAmtOfExempClaimedUnderSec10_340n341n342n343n344n346, obj_FieldValidation,
						"Total amount of exemption claimed under section 10 (340+341+342+343+345+346)", T_FV_6122_C,
						T_FV_6110_C, T_FV_6122_M, T_FV_6110_M,whthrOptTax115BAC,"");

				if (validTravelConcessionOrAssistanceSec10_5 && validDeathCumRetirementGratuitySec10_10
						&& validCommutedValueOfPensionSec10_10A && validCashEquivalentOfLeaveSalEncashmentSec10_10AA
						&& validHouseRentAllowanceSec10_13A && validAmountOfAnyOtherExemptionUnderSec10
						&& validTotAmtOfExempClaimedUnderSec10_340n341n342n343n344n346) {
					
					// Condition changed ternary operator added for FVU 7.1 Obs no 24 26 Mar 2021 - Vinita
					if ((Double.parseDouble(totAmtOfExempClaimedUnderSec10_340n341n342n343n344n346.trim())
							* 100.0) < (-1000.0
									+ ((travelConcessionOrAssistanceSec10_5.equals(FIELD_NULL) || travelConcessionOrAssistanceSec10_5.equals(FIELD_SEPERATOR)) ? 0.0d : (Double.parseDouble(travelConcessionOrAssistanceSec10_5.trim()) * 100.0) )
									+ (Double.parseDouble(deathCumRetirementGratuitySec10_10.trim()) * 100.0)
									+ (Double.parseDouble(commutedValueOfPensionSec10_10A.trim()) * 100.0)
									+ (Double.parseDouble(cashEquivalentOfLeaveSalEncashmentSec10_10AA.trim()) * 100.0)
									+ ((houseRentAllowanceSec10_13A.equals(FIELD_NULL) || houseRentAllowanceSec10_13A.equals(FIELD_SEPERATOR)) ? 0.0d : (Double.parseDouble(houseRentAllowanceSec10_13A.trim()) * 100.0) )
									+ (Double.parseDouble(amountOfAnyOtherExemptionUnderSec10.trim()) * 100.0))
							|| (Double.parseDouble(totAmtOfExempClaimedUnderSec10_340n341n342n343n344n346.trim())
									* 100.0) > (1000.0
											+ ((travelConcessionOrAssistanceSec10_5.equals(FIELD_NULL) || travelConcessionOrAssistanceSec10_5.equals(FIELD_SEPERATOR)) ? 0.0d : (Double.parseDouble(travelConcessionOrAssistanceSec10_5.trim()) * 100.0) )
											+ (Double.parseDouble(deathCumRetirementGratuitySec10_10.trim()) * 100.0)
											+ (Double.parseDouble(commutedValueOfPensionSec10_10A.trim()) * 100.0)
											+ (Double.parseDouble(cashEquivalentOfLeaveSalEncashmentSec10_10AA.trim())
													* 100.0)
											+ ((houseRentAllowanceSec10_13A.equals(FIELD_NULL) || houseRentAllowanceSec10_13A.equals(FIELD_SEPERATOR)) ? 0.0d : (Double.parseDouble(houseRentAllowanceSec10_13A.trim()) * 100.0) )
											+ (Double.parseDouble(amountOfAnyOtherExemptionUnderSec10.trim())
													* 100.0))) {

						Str_Buffer.append(LineNo + tab + v_upload_Type + tab
								+ "Total amount of exemption claimed under section 10 (340+341+342+343+344+346)" + tab
								+ "NA" + tab + DeducteeDetailRecNo + tab + T_FV_6130_C + tab + T_FV_6130_M);

					}

				}
			}else {

				validateFieldFinYrUpto201819(v_upload_Type, Str_Buffer, LineNo, DeducteeDetailRecNo,
						totAmtOfExempClaimedUnderSec10_340n341n342n343n344n346,
						"Total amount of exemption claimed under section 10 (340+341+342+343+345+346)");
			}

			// end: Validate Total amount of exemption claimed under section 10
			// (340+341+342+343+345+346) newly added for fvu 6.2 by jacky
	
			//modified by jacky for FVU 6.2
			//Validate Income Chargeable under the Head Salaries. -------- 17
			boolean validIncomeChargeableUderTheHeadSalaries = false;
			if (IncomeChargeableUderTheHeadSalaries.equals(FIELD_NULL) || IncomeChargeableUderTheHeadSalaries.equals(FIELD_SEPERATOR))
			{
				if (ModeSD.equals("A"))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Income chargeable under the head Salaries (334-338)" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4026_C + tab + T_FV_4026_M);
			}
			// added by faizan for FVU 4.5
			else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
				if(! (IncomeChargeableUderTheHeadSalaries.equals(FIELD_NULL) || IncomeChargeableUderTheHeadSalaries.equals(FIELD_SEPERATOR))){
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab +  "Income chargeable under the head Salaries (334-338)"  + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_2227_C + tab + T_FV_2227_M);	
				}
			}
			else
			{
				if (ModeSD.equals("D") || TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Income chargeable under the head Salaries (334-338)" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4151_C + tab + T_FV_4151_M);
				//Added By amit for 4.5		
				else if(IncomeChargeableUderTheHeadSalaries.length()!=IncomeChargeableUderTheHeadSalaries.trim().length())
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Income chargeable under the head Salaries (334-338)" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4026_C + tab + T_FV_4026_M);	
				}
				//Amit end for Fvu 4.5 
				else if (IncomeChargeableUderTheHeadSalaries.length() <= 15)
				{
					if (obj_FieldValidation.isDecimalNumber(IncomeChargeableUderTheHeadSalaries))
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Income chargeable under the head Salaries (334-338)" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4026_C + tab + T_FV_4026_M);
					}
					else // if (!paperReturnFile)  commented on 10-Oct-05 By Mayank Paper Return Changes 
					{ //modified for fvu 6.2 by jacky
						if (Integer.parseInt(FinancialYr) < 201819) {
							if (validTotalSalaryExeclud338n339 && validGrossTotalDeducteeSec16) {
								if ((Double.parseDouble(IncomeChargeableUderTheHeadSalaries.trim()) * 100.0) < (-1000.0
										+ (Double.parseDouble(TotalSalaryExeclud338n339.trim()) * 100.0)
										- (Double.parseDouble(GrossTotalDeducteeSec16.trim()) * 100.0))
										|| (Double.parseDouble(IncomeChargeableUderTheHeadSalaries.trim())
												* 100.0) > (1000.0
														+ (Double.parseDouble(TotalSalaryExeclud338n339.trim()) * 100.0)
														- (Double.parseDouble(GrossTotalDeducteeSec16.trim())
																* 100.0))) {
									if (paperReturnFile) // &&
															// (Double.parseDouble(IncomeChargeableUderTheHeadSalaries.trim())
															// == 0))
									{
										fvO.setPaperReturnRelax(true);
										Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "NA" + tab
												+ DeducteeDetailRecNo + tab + T_FV_4023_C + tab + T_FV_4023_M);
										validIncomeChargeableUderTheHeadSalaries = true;
									} else
										Str_Buffer.append(LineNo + tab + v_upload_Type + tab
												+ "Income chargeable under the head Salaries (334-338)" + tab + "NA"
												+ tab + CurrentlocalSDNumber + tab + T_FV_4023_C + tab + T_FV_4023_M);
								} else
									validIncomeChargeableUderTheHeadSalaries = true;
							}
						} else {

							if (validTotalSalaryExeclud338n339 && validGrossTotalDeducteeSec16
									&& validTotAmtOfExempClaimedUnderSec10_340n341n342n343n344n346) {
								if ((Double.parseDouble(IncomeChargeableUderTheHeadSalaries.trim()) * 100.0) < (-1000.0
										+ (Double.parseDouble(TotalSalaryExeclud338n339.trim()) * 100.0)
										- (Double.parseDouble(GrossTotalDeducteeSec16.trim()) * 100.0)
										- (Double.parseDouble(
												totAmtOfExempClaimedUnderSec10_340n341n342n343n344n346.trim()) * 100.0))
										|| (Double.parseDouble(IncomeChargeableUderTheHeadSalaries.trim())
												* 100.0) > (1000.0
														+ (Double.parseDouble(TotalSalaryExeclud338n339.trim()) * 100.0)
														- (Double.parseDouble(GrossTotalDeducteeSec16.trim()) * 100.0)
														- (Double.parseDouble(
																totAmtOfExempClaimedUnderSec10_340n341n342n343n344n346
																		.trim())
																* 100.0))) {
									if (paperReturnFile) // &&
															// (Double.parseDouble(IncomeChargeableUderTheHeadSalaries.trim())
															// == 0))
									{
										fvO.setPaperReturnRelax(true);
										Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "NA" + tab
												+ DeducteeDetailRecNo + tab + T_FV_4023_C + tab + T_FV_4023_M);
										validIncomeChargeableUderTheHeadSalaries = true;
									} else
										Str_Buffer.append(LineNo + tab + v_upload_Type + tab
												+ "Income chargeable under the head Salaries (334-338)" + tab + "NA"
												+ tab + CurrentlocalSDNumber + tab + T_FV_4023_C + tab + T_FV_4023_M);
								} else
									validIncomeChargeableUderTheHeadSalaries = true;
							}

						}

					}
				}
				else
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Income chargeable under the head Salaries (334-338)" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4026_C + tab + T_FV_4026_M);
				}
			}
			//Income chargeable under the head Salaries 

			//Income ( including loss from house property) under any head other than  income under the head "salaries" offered for TDS  --- 18
			boolean validIncomeLossFrmHouse = false;
			if (IncomeLossFrmHouse.equals(FIELD_NULL) || IncomeLossFrmHouse.equals(FIELD_SEPERATOR))
			{
				if (ModeSD.equals("A"))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Income ( including loss from house property) under any head other than income under the head 'salaries' offered for TDS [section 192(2B)]" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4027_C + tab + T_FV_4027_M);
			}
			// added by faizan for FVU 4.5
			else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
				if(! (IncomeLossFrmHouse.equals(FIELD_NULL) || IncomeLossFrmHouse.equals(FIELD_SEPERATOR))){
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab +  "Income ( including loss from house property) under any head other than income under the head 'salaries' offered for TDS [section 192(2B)]"  + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_2227_C + tab + T_FV_2227_M);	
				}
			}
			//ended by faizan
			else if (ModeSD.equals("D") || TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Income ( including loss from house property) under any head other than income under the head 'salaries' offered for TDS [section 192(2B)]" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4152_C + tab + T_FV_4152_M);
			//Added By amit for 4.5
			else if(IncomeLossFrmHouse.length()!=IncomeLossFrmHouse.trim().length())
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Income ( including loss from house property) under any head other than income under the head 'salaries' offered for TDS [section 192(2B)]" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4027_C + tab + T_FV_4027_M);	
			}
			//Amit end for Fvu 4.5 
			else if (IncomeLossFrmHouse.length() <= 15)
			{
				if (obj_FieldValidation.isPositiveNegativeDecimalNumber(IncomeLossFrmHouse))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Income ( including loss from house property) under any head other than income under the head 'salaries' offered for TDS [section 192(2B)]" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4027_C + tab + T_FV_4027_M);
				else
					validIncomeLossFrmHouse = true;
			}
			else
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Income ( including loss from house property) under any head other than income under the head 'salaries' offered for TDS [section 192(2B)]" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4027_C + tab + T_FV_4027_M);
			//Income ( including loss from house property) under any head other than	

			// start: validation Income under the head other sources offered for
			// TDS [section 192 (2B)] for fvu 6.2 by jacky

			boolean validIncomeUnderHeadOtherSourOfferForTDSSec192_2B = false;
			if ((Integer.parseInt(FinancialYr) >= 201819) && (TransactionType.equals(UPLOADTYPE_REGULAR)
					|| (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A")))) {
				validIncomeUnderHeadOtherSourOfferForTDSSec192_2B = validateField6_2Onwards(FinancialYr,Qperiod,v_upload_Type, Str_Buffer,
						LineNo, DeducteeDetailRecNo, incomeUnderHeadOtherSourOfferForTDSSec192_2B, obj_FieldValidation,
						"Income under the head other sources offered for TDS [section 192 (2B)]", T_FV_6123_C,
						T_FV_6111_C, T_FV_6123_M, T_FV_6111_M,whthrOptTax115BAC,"");
			} else {
				validateFieldFinYrUpto201819(v_upload_Type, Str_Buffer, LineNo, DeducteeDetailRecNo,
						incomeUnderHeadOtherSourOfferForTDSSec192_2B,
						"Income under the head other sources offered for TDS [section 192 (2B)]");
			}

			// end: validation Income under the head other sources offered for
			// TDS [section 192 (2B)] for fvu 6.2 by jacky

			//Gross Total Income (211 + 212)  ----- 19
			boolean validGrossTotIncome = false;
			boolean validGrossTotIncome2 = false;
			if (GrossTotIncome.equals(FIELD_NULL) || GrossTotIncome.equals(FIELD_SEPERATOR))
			{
				if (!TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Gross Total Income" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4028_C + tab + T_FV_4028_M);
			}
			else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Gross Total Income" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4210_C + tab + T_FV_4210_M);
			}
			//Added By amit for 4.5
			else if(GrossTotIncome.length()!=GrossTotIncome.trim().length())
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Gross Total Income" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4028_C + tab + T_FV_4028_M);	
			}
			//Amit end for Fvu 4.5 
			else if (GrossTotIncome.length() <= 15)
			{
				if (obj_FieldValidation.isDecimalNumber(GrossTotIncome))
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Gross Total Income" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4028_C + tab + T_FV_4028_M);
				}
				else // if (!paperReturnFile) commented on 10-Oct-05 By Mayank Paper Return Changes
				{
					validGrossTotIncome2 = true;
					SummationGrossTotIncome = SummationGrossTotIncome + Double.parseDouble(GrossTotIncome.trim());

					if (ModeSD.equals("A")) {
						// modified for fvu 6.2 by jacky
						if (Integer.parseInt(FinancialYr) < 201819) {
							if (validIncomeChargeableUderTheHeadSalaries && validIncomeLossFrmHouse) {
								if ((Double.parseDouble(GrossTotIncome.trim()) * 100.0) < (-1000.0
										+ (Double.parseDouble(IncomeChargeableUderTheHeadSalaries.trim()) * 100.0)
										+ (Double.parseDouble(IncomeLossFrmHouse.trim()) * 100.0))
										|| (Double.parseDouble(GrossTotIncome.trim()) * 100.0) > (1000.0
												+ (Double.parseDouble(IncomeChargeableUderTheHeadSalaries.trim())
														* 100.0)
												+ (Double.parseDouble(IncomeLossFrmHouse.trim()) * 100.0))) {
									if (paperReturnFile) // &&
															// (Double.parseDouble(GrossTotIncome.trim())
															// == 0))
									{
										fvO.setPaperReturnRelax(true);
										Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "NA" + tab
												+ DeducteeDetailRecNo + tab + T_FV_4020_C + tab + T_FV_4020_M);
										validGrossTotIncome = true;
									} else
										Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Gross Total Income"
												+ tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4020_C + tab
												+ T_FV_4020_M);
								} else
									validGrossTotIncome = true;
							}

						} else {

							if (validIncomeChargeableUderTheHeadSalaries && validIncomeLossFrmHouse
									&& validIncomeUnderHeadOtherSourOfferForTDSSec192_2B) {
								if ((Double.parseDouble(GrossTotIncome.trim()) * 100.0) < (-1000.0
										+ (Double.parseDouble(IncomeChargeableUderTheHeadSalaries.trim()) * 100.0)
										+ (Double.parseDouble(IncomeLossFrmHouse.trim()) * 100.0)
										+ (Double.parseDouble(incomeUnderHeadOtherSourOfferForTDSSec192_2B.trim())
												* 100.0))
										|| (Double.parseDouble(GrossTotIncome.trim()) * 100.0) > (1000.0
												+ (Double.parseDouble(IncomeChargeableUderTheHeadSalaries.trim())
														* 100.0)
												+ (Double.parseDouble(IncomeLossFrmHouse.trim()) * 100.0)
												+ (Double.parseDouble(
														incomeUnderHeadOtherSourOfferForTDSSec192_2B.trim())
														* 100.0))) {
									if (paperReturnFile) // &&
															// (Double.parseDouble(GrossTotIncome.trim())
															// == 0))
									{
										fvO.setPaperReturnRelax(true);
										Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "NA" + tab
												+ DeducteeDetailRecNo + tab + T_FV_4020_C + tab + T_FV_4020_M);
										validGrossTotIncome = true;
									} else
										Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Gross Total Income"
												+ tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4020_C + tab
												+ T_FV_4020_M);
								} else
									validGrossTotIncome = true;
							}

						}
					}
				}
				//  commented on 10-Oct-05 By Mayank Paper Return Changes
				//            else
				//            {
				//               validGrossTotIncome2 = true;
				//               SummationGrossTotIncome = SummationGrossTotIncome + Double.parseDouble(GrossTotIncome.trim());
				//            }
			}
			else
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Gross Total Income" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4028_C + tab + T_FV_4028_M);
			}
			//Gross Total Income (211 + 212)

			// Last Gross Total Income  ----- 20
			if (LastGrossTotIncome.equals(FIELD_NULL) || LastGrossTotIncome.equals(FIELD_SEPERATOR))
			{
				if (ModeSD.equals("D") || TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Last Gross Total Income " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4170_C + tab + T_FV_4170_M);
			}
			else if (ModeSD.equals("A"))
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Last Gross Total Income " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4171_C + tab + T_FV_4171_M);
			//Added By amit for 4.5
			else if(LastGrossTotIncome.length()!=LastGrossTotIncome.trim().length())
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Last Gross Total Income "  + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4170_C + tab + T_FV_4170_M);	
			}			
			//Amit end for Fvu 4.5 
			else if (LastGrossTotIncome.length() <= 15)
			{
				if (obj_FieldValidation.isDecimalNumber(LastGrossTotIncome))
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Last Gross Total Income " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4170_C + tab + T_FV_4170_M);
				}
				else if (validGrossTotIncome2)
				{
					if (Double.parseDouble(GrossTotIncome.trim()) != Double.parseDouble(LastGrossTotIncome.trim()))
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Last Gross Total Income " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4164_C + tab + T_FV_4164_M);
				}
			}
			else
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Last Gross Total Income " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4170_C + tab + T_FV_4170_M);
			//Last Gross Total Income		

			//			Validate Count of deductee - Chapter VI Details -----  21
			boolean validCountDeducteeChapVIDetails = false;
			if (CountDeducteeChapVIDetails.equals(FIELD_NULL) || CountDeducteeChapVIDetails.equals(FIELD_SEPERATOR))
			{
				if (ModeSD.equals("A"))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Count of ' Salary Details  - Chapter VI-A Detail ' Records  associated with Deductee - Chapter VIA Detail  " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4029_C + tab + T_FV_4029_M);
			}
			// added by faizan for FVU 4.5
			else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
				if(! (CountDeducteeChapVIDetails.equals(FIELD_NULL) || CountDeducteeChapVIDetails.equals(FIELD_SEPERATOR))){
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab +  "Count of ' Salary Details  - Chapter VI-A Detail ' Records  associated with Deductee - Chapter VIA Detail  "  + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_2227_C + tab + T_FV_2227_M);	
				}
			}
			//ended by faizan
			else if (ModeSD.equals("D") || TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Count of ' Salary Details  - Chapter VI-A Detail ' Records  associated with Deductee - Chapter VIA Detail " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4153_C + tab + T_FV_4153_M);
			else if (CountDeducteeChapVIDetails.length() <= 9)
			{
				if(fvO.isFinYrGrtr)
				{
					if (obj_FieldValidation.isInt(CountDeducteeChapVIDetails)) {
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab
								+ "Count of ' Salary Details  - Chapter VI-A Detail ' Records  associated with Deductee - Chapter VIA Detail "
								+ tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4029_C + tab + T_FV_4029_M);
					} else if (Integer.parseInt(FinancialYr) < 201819
							&& (Long.parseLong(CountDeducteeChapVIDetails.trim()) > secVIAIdentification.length))
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab
								+ "Count of ' Salary Details  - Chapter VI-A Detail ' Records  associated with Deductee - Chapter VIA Detail "
								+ tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4029_C + tab + T_FV_4029_M);
					else if (Integer.parseInt(FinancialYr) >= 201819 && (Long
							.parseLong(CountDeducteeChapVIDetails.trim()) > secVIAIdentification201819Onwards.length)) {

						Str_Buffer.append(LineNo + tab + v_upload_Type + tab
								+ "Count of ' Salary Details  - Chapter VI-A Detail ' Records  associated with Deductee - Chapter VIA Detail "
								+ tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4029_C + tab + T_FV_4029_M);

					} else
						validCountDeducteeChapVIDetails = true;
				}
				else
				{
					if (obj_FieldValidation.isInt(CountDeducteeChapVIDetails))
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Count of ' Salary Details  - Chapter VI-A Detail ' Records  associated with Deductee - Chapter VIA Detail " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4029_C + tab + T_FV_4029_M);
					}
					else if (Long.parseLong(CountDeducteeChapVIDetails.trim()) > (secVIAIdentification.length-1))
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Count of ' Salary Details  - Chapter VI-A Detail ' Records  associated with Deductee - Chapter VIA Detail " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4029_C + tab + T_FV_4029_M);
					else
						validCountDeducteeChapVIDetails = true;
				}
			}
			else
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Count of ' Salary Details  - Chapter VI-A Detail ' Records  associated with Deductee - Chapter VIA Detail " + tab + "NA" + tab + DeducteeDetailRecNo + T_FV_4029_C + tab + T_FV_4029_M);
			//	Validate Count of deductee - Chapter VI Details

			// Validate Gross Total of Deductee - Chapter VI details   ------- 22
			boolean validGrossTotDeducteeChapVIDetails = false;
			if (GrossTotDeducteeChapVIDetails.equals(FIELD_NULL) || GrossTotDeducteeChapVIDetails.equals(FIELD_SEPERATOR))
			{
				if (ModeSD.equals("A"))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Gross Total of 'Amount deductible under provisions of chapter VI-A' under  associated ' Salary Details  - Chapter VIA Detail" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4030_C + tab + T_FV_4030_M);
			}
			// added by faizan for FVU 4.5
			else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
				if(! (GrossTotDeducteeChapVIDetails.equals(FIELD_NULL) || GrossTotDeducteeChapVIDetails.equals(FIELD_SEPERATOR))){
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab +  "Gross Total of 'Amount deductible under provisions of chapter VI-A' under  associated ' Salary Details  - Chapter VIA Detail"  + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_2227_C + tab + T_FV_2227_M);	
				}
			}
			//ended by faizan
			else if (ModeSD.equals("D") || TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Gross Total of 'Amount deductible under provisions of chapter VI-A' under  associated ' Salary Details  - Chapter VIA Detail" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4154_C + tab + T_FV_4154_M);
			//Added By amit for 4.5
			else if(GrossTotDeducteeChapVIDetails.length()!=GrossTotDeducteeChapVIDetails.trim().length())
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Gross Total of 'Amount deductible under provisions of chapter VI-A' under  associated ' Salary Details  - Chapter VIA Detail" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4030_C + tab + T_FV_4030_M);	
			}			
			//Amit end for Fvu 4.5 
			else if (GrossTotDeducteeChapVIDetails.length() <= 15)
			{
				if (obj_FieldValidation.isDecimalNumber(GrossTotDeducteeChapVIDetails))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Gross Total of 'Amount deductible under provisions of chapter VI-A' under  associated ' Salary Details  - Chapter VIA Detail" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4030_C + tab + T_FV_4030_M);
				else // if (!paperReturnFile) commented on 10-Oct-05 By Mayank Paper Return Changes
				{
					if (validCountDeducteeChapVIDetails)
					{
						if ((Long.parseLong(CountDeducteeChapVIDetails.trim()) == 0) && (Double.parseDouble(GrossTotDeducteeChapVIDetails.trim()) != 0))
						{
							if (paperReturnFile)
							{
								fvO.setPaperReturnRelax(true);
								Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4030_C + tab + T_FV_4030_M);
								validGrossTotDeducteeChapVIDetails = true;
							}
							else
								Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Gross Total of 'Amount deductible under provisions of chapter VI-A' under  associated ' Salary Details  - Chapter VIA Detail " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4030_C + tab + T_FV_4030_M);
						}
						else
							validGrossTotDeducteeChapVIDetails = true;
					}
					else
						validGrossTotDeducteeChapVIDetails = true;
				}
			}
			else
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Gross Total of 'Amount deductible under provisions of chapter VI-A' under  associated ' Salary Details  - Chapter VIA Detail" + tab + "NA" + tab + CurrentlocalSDNumber + tab + tab + T_FV_4030_C + tab + T_FV_4030_M);
			//	Validate Gross Total of Deductee - Chapter VI details

			//	Total Taxable Income ( 213 - 217)    ---- 23
			boolean validTotTaxableIncome = false;
			if (TotTaxableIncome355366.equals(FIELD_NULL) || TotTaxableIncome355366.equals(FIELD_SEPERATOR))
			{
				if (ModeSD.equals("A"))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Total Taxable Income " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4031_C + tab + T_FV_4031_M);
			}
			// added by faizan for FVU 4.5
			else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
				if(! (TotTaxableIncome355366.equals(FIELD_NULL) || TotTaxableIncome355366.equals(FIELD_SEPERATOR))){
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab +  "Total Taxable Income " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_2227_C + tab + T_FV_2227_M);	
				}
			}
			//ended by faizan
			else if (ModeSD.equals("D") || TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Total Taxable Income " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4155_C + tab + T_FV_4155_M);
			//Added By amit for 4.5
			else if(TotTaxableIncome355366.length()!=TotTaxableIncome355366.trim().length())
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Total Taxable Income " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4031_C + tab + T_FV_4031_M);	
			}			
			//Amit end for Fvu 4.5 
			else if (TotTaxableIncome355366.length() <= 15)
			{
				if (obj_FieldValidation.isDecimalNumber(TotTaxableIncome355366))
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Total Taxable Income" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4031_C + tab + T_FV_4031_M);
				}
				else // if (!paperReturnFile) commented on 10-Oct-05 By Mayank Paper Return Changes
				{
					//Amit added here for FVU 4.4
					// added for FVU 4.8
					//if(FormNo.equals(FORM_24Q) && Double.parseDouble(TotTaxableIncome340344.trim())>999999999.00 && (UploadType.equals(UPLOADTYPE_REGULAR) || (UploadType.equals(UPLOADTYPE_CORRECTION) && (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_DEDUCTEE) || (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A"))))))
					if(FormNo.equals(FORM_24Q) && Double.parseDouble(TotTaxableIncome355366.trim())>9999999999.00 && (UploadType.equals(UPLOADTYPE_REGULAR) || (UploadType.equals(UPLOADTYPE_CORRECTION) && (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_DEDUCTEE) || (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A"))))))
					{ 
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Total Taxable Income" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4031_C + tab + T_FV_4031_M);
					}
					else if(TotTaxableIncome355366.trim().length() != TotTaxableIncome355366.length())
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Total Taxable Income" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4031_C + tab + T_FV_4031_M);
					}
					//amit end
					if (validGrossTotIncome && validGrossTotDeducteeChapVIDetails)
					{
						if ((Double.parseDouble(TotTaxableIncome355366.trim()) * 100.0)
								< (-1000.0 + (Double.parseDouble(GrossTotIncome.trim()) * 100.0) - (Double.parseDouble(GrossTotDeducteeChapVIDetails.trim()) * 100.0))
								|| (Double.parseDouble(TotTaxableIncome355366.trim()) * 100.0)
								> (1000.0 + (Double.parseDouble(GrossTotIncome.trim()) * 100.0) - (Double.parseDouble(GrossTotDeducteeChapVIDetails.trim()) * 100.0)))
						{
							if (paperReturnFile) // && (Double.parseDouble(TotTaxableIncome340344.trim()) == 0))
							{
								fvO.setPaperReturnRelax(true);
								Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "NA" + tab + DeducteeDetailRecNo + tab + T_FV_4040_C + tab + T_FV_4040_M);
								validTotTaxableIncome = true;
							}
							else
								Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Total Taxable Income" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4040_C + tab + T_FV_4040_M);
						}
						else
							validTotTaxableIncome = true;
					}
					//Added By AMI For FVU 3.0

					//Commented by Dhanya on 29/04/2011 as the data type of 'sumOfSalDelTotTaxableIncome' is changed to BigDecimal from 'double'.
					//formVal.sumOfSalDelTotTaxableIncome = formVal.sumOfSalDelTotTaxableIncome + Double.parseDouble(TotTaxableIncome340344);
					formVal.sumOfSalDelTotTaxableIncome = formVal.sumOfSalDelTotTaxableIncome.add(new BigDecimal(TotTaxableIncome355366.trim()));
					//Ends addition by Dhanya on 29/04/2011 for the data type change
				}
			}
			else
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Total Taxable Income " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4031_C + tab + T_FV_4031_M);
			//		Total Taxable Income ( 213 - 217)


			//		Income Tax on Total Income  --------   24
			boolean validIncomeTaxOnTotIncome = false;
			if (IncomeTaxOnTotIncome.equals(FIELD_NULL) || IncomeTaxOnTotIncome.equals(FIELD_SEPERATOR))
			{
				if (ModeSD.equals("A"))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Income Tax on Total Income" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4032_C + tab + T_FV_4032_M);
			}
			// added by faizan for FVU 4.5
			else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
				if(!(IncomeTaxOnTotIncome.equals(FIELD_NULL) || IncomeTaxOnTotIncome.equals(FIELD_SEPERATOR))){
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Income Tax on Total Income" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_2227_C + tab + T_FV_2227_M);	
				}
			}
			//ended by faizan
			else if (ModeSD.equals("D") || TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Income Tax on Total Income" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4156_C + tab + T_FV_4156_M);
			//Added By amit for 4.5			
			else if(IncomeTaxOnTotIncome.length()!=IncomeTaxOnTotIncome.trim().length())
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Income Tax on Total Income" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4032_C + tab + T_FV_4032_M);	
			}			
			//Amit end for Fvu 4.5 
			else if (IncomeTaxOnTotIncome.length() <= 15)
			{
				if (obj_FieldValidation.isDecimalNumber(IncomeTaxOnTotIncome))
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Income Tax on Total Income" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4032_C + tab + T_FV_4032_M);
				}
				else // if (!paperReturnFile) commented on 10-Oct-05 By Mayank Paper Return Changes
				{
					if (validTotTaxableIncome)
					{
						if (Double.parseDouble(IncomeTaxOnTotIncome.trim()) > Double.parseDouble(TotTaxableIncome355366.trim()))
						{

							if (paperReturnFile) // && (Double.parseDouble(IncomeTaxOnTotIncome.trim()) == 0))
							{
								fvO.setPaperReturnRelax(true);
								Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "NA" + tab + DeducteeDetailRecNo + tab + T_FV_4214_C + tab + T_FV_4214_M);
								validIncomeTaxOnTotIncome = true;
							}
							else
								Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Income Tax on Total Income" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4214_C + tab + T_FV_4214_M);
						}

						else
							validIncomeTaxOnTotIncome = true;
					}
					else
						validIncomeTaxOnTotIncome = true;
				}
				// commented on 10-Oct-05 By Mayank Paper Return Changes
				//            else
				//               validIncomeTaxOnTotIncome = true;
			}
			else
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Income Tax on Total Income" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4032_C + tab + T_FV_4032_M);
			//Income Tax on Total Income

			// Validate Surcharge ---- 25
			boolean validSurcharge = false;
			if (Surcharge.equals(FIELD_NULL) || Surcharge.equals(FIELD_SEPERATOR))
			{
				if (ModeSD.equals("A"))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Surcharge" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4219_C + tab + T_FV_4219_M);
			}
			// added by faizan for FVU 4.5
			else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
				if(! (Surcharge.equals(FIELD_NULL) || Surcharge.equals(FIELD_SEPERATOR))){
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Surcharge" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_2227_C + tab + T_FV_2227_M);	
				}
			}
			//ended by faizan
			else if (ModeSD.equals("D") || TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Surcharge" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4220_C + tab + T_FV_4220_M);
			//Added By amit for 4.5			
			else if(Surcharge.length()!=Surcharge.trim().length())
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Surcharge" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4219_C + tab + T_FV_4219_M);	
			}			
			//Amit end for Fvu 4.5 
			else if (Surcharge.length() <= 15)
			{

				if (obj_FieldValidation.isDecimalNumber(Surcharge))
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Surcharge" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4219_C + tab + T_FV_4219_M);
				}


				/*
				 * code added on 18oct 2006 to generate warning file in 
				 * case value of surcharge is greater then total taxable income for paperReturnFile
				 */

				else if (validTotTaxableIncome && paperReturnFile)
				{

					if (Double.parseDouble(Surcharge.trim()) > Double.parseDouble(TotTaxableIncome355366.trim()))
					{
						fvO.setPaperReturnRelax(true);
						Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "NA" + tab + DeducteeDetailRecNo + tab + T_FV_4215_C + tab + T_FV_4215_M);
						validSurcharge = true;
					}

					else
						validSurcharge = true;
				}
				else
					validSurcharge = true;


				//M02_B
				//Check for surcharge > totaltaxableincome for electronic files
				if(validTotTaxableIncome && !paperReturnFile)
				{
					if (Double.parseDouble(Surcharge.trim()) > Double.parseDouble(TotTaxableIncome355366.trim()))
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Surcharge" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4215_C + tab + T_FV_4215_M);
					}
				}
				//M02_E


			}
			else
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Surcharge" + tab + "NA" + tab + DeducteeDetailRecNo + tab + T_FV_4219_C + tab + T_FV_4219_M);

			// Validate Surcharge

			//          Validate Cess ---- 26
			boolean validCess = false;
			if (Cess.equals(FIELD_NULL) || Cess.equals(FIELD_SEPERATOR))
			{
				if (ModeSD.equals("A"))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Education Cess" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4223_C + tab + T_FV_4223_M);
			}
			// added by faizan for FVU 4.5
			else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
				if(! (Cess.equals(FIELD_NULL) || Cess.equals(FIELD_SEPERATOR))){
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Education Cess" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_2227_C + tab + T_FV_2227_M);	
				}
			}
			//ended by faizan
			else if (ModeSD.equals("D") || TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Education Cess" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4224_C + tab + T_FV_4224_M);

			//Added By amit for 4.5			
			else if(Cess.length()!=Cess.trim().length())
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Education Cess" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4223_C + tab + T_FV_4223_M);	
			}			
			//Amit end for Fvu 4.5 
			else if (Cess.length() <= 15)
			{
				if (obj_FieldValidation.isDecimalNumber(Cess))
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Education Cess" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4223_C + tab + T_FV_4223_M);
				}

				else if (validTotTaxableIncome && paperReturnFile)
				{

					if (Double.parseDouble(Cess.trim()) > Double.parseDouble(TotTaxableIncome355366.trim()))
					{
						fvO.setPaperReturnRelax(true);
						Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "Education Cess" + tab + DeducteeDetailRecNo + tab + T_FV_4206_C + tab + T_FV_4206_M);
						validCess = true;
					}

					else
						validCess = true;
				}
				else
					validCess = true;


				//M02_B
				//Check for Cess > totaltaxableincome for electronic files
				if (validTotTaxableIncome && !paperReturnFile)
				{
					if (Double.parseDouble(Cess.trim()) > Double.parseDouble(TotTaxableIncome355366.trim()))
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Education Cess" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4206_C + tab + T_FV_4206_M);
					}
				}
				//check for  income tax on total income + surcharge + cess > Total taxable income
				if(validTotTaxableIncome && validSurcharge && validCess && validIncomeTaxOnTotIncome){

				if(Double.parseDouble(IncomeTaxOnTotIncome.trim()) + Double.parseDouble(Cess.trim()) + Double.parseDouble(Surcharge.trim()) > Double.parseDouble(TotTaxableIncome355366.trim()))
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Income Tax on Total Income" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4279_C + tab + T_FV_4279_M);

				}
				
				}


				//M02_E

			}
			else
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Education Cess" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4223_C + tab + T_FV_4223_M);
			// Validate Cess

			//    Validating IncomeTaxRelief ----------  27
			boolean validIncomeTaxRelief = false;
			if (IncomeTaxRelief.equals(FIELD_NULL) || IncomeTaxRelief.equals(FIELD_SEPERATOR))
			{
				if (ModeSD.equals("A"))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Income Tax Relief u/s 89 when salary etc is paid in arrear or advance" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4073_C + tab + T_FV_4073_M);
			}
			// added by faizan for FVU 4.5
			else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
				if(! (IncomeTaxRelief.equals(FIELD_NULL) || IncomeTaxRelief.equals(FIELD_SEPERATOR))){
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Income Tax Relief u/s 89 when salary etc is paid in arrear or advance" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_2227_C + tab + T_FV_2227_M);	
				}
			}
			//ended by faizan
			else if (ModeSD.equals("D") || TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Income Tax Relief u/s 89 when salary etc is paid in arrear or advance" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4074_C + tab + T_FV_4074_M);
			//Added By amit for 4.5			
			else if(IncomeTaxRelief.length()!=IncomeTaxRelief.trim().length())
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Income Tax Relief u/s 89 when salary etc is paid in arrear or advance"  + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4073_C + tab + T_FV_4073_M);	
			}			
			//Amit end for Fvu 4.5 
			else if (IncomeTaxRelief.length() <= 15)
			{
				if (obj_FieldValidation.isDecimalNumber(IncomeTaxRelief))
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Income Tax Relief u/s 89 when salary etc is paid in arrear or advance" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4073_C + tab + T_FV_4073_M);
				}
				else
					validIncomeTaxRelief = true;
			}
			else
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Income Tax Relief u/s 89 when salary etc is paid in arrear or advance" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4073_C + tab + T_FV_4073_M);
			//		Validating IncomeTaxRelief				

			// start: validation for Rebate under section 87A for fvu 6.2 by
			// jacky

			boolean validRebateUnderSec87A = false;
			if ((Integer.parseInt(FinancialYr) >= 201819) && (TransactionType.equals(UPLOADTYPE_REGULAR)
					|| (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A")))) {

				validRebateUnderSec87A = validateField6_2Onwards(FinancialYr,Qperiod,v_upload_Type, Str_Buffer, LineNo,
						DeducteeDetailRecNo, rebateUnderSec87A, obj_FieldValidation, "Rebate under section 87A",
						T_FV_6124_C, T_FV_6112_C, T_FV_6124_M, T_FV_6112_M,whthrOptTax115BAC,"");

			} else {

				validateFieldFinYrUpto201819(v_upload_Type, Str_Buffer, LineNo, DeducteeDetailRecNo, rebateUnderSec87A,
						"Rebate under section 87A");

			}

			// end: validation for Rebate under section 87A for fvu 6.2 by jacky
			//modified by jacky for FVU 6.2
			
			// Validating field whthrOptTax115BAC Added for FVU 7.1 - Vinita
			validateSDfield79(UploadType,TransactionType,FinancialYr, Str_Buffer, Qperiod, v_upload_Type, whthrOptTax115BAC, IncomeLossFrmHouse, travelConcessionOrAssistanceSec10_5, deathCumRetirementGratuitySec10_10, houseRentAllowanceSec10_13A);
			
			//Net Income Tax payable (341+342+343-344)  ------ 28
			boolean validNetTaxPayable = false;
			if (NetTaxPayable.equals(FIELD_NULL) || NetTaxPayable.equals(FIELD_SEPERATOR))
			{
				if (ModeSD.equals("A"))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Net Income Tax payable (368+370+371-(369+372))" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4035_C + tab + T_FV_4035_M);
			}
			// added by faizan for FVU 4.5
			else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
				if(! (NetTaxPayable.equals(FIELD_NULL) || NetTaxPayable.equals(FIELD_SEPERATOR))){
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Net Income Tax payable (368+370+371-(369+372))" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_2227_C + tab + T_FV_2227_M);	
				}
			}
			//ended by faizan
			else if (ModeSD.equals("D") || TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Net Income Tax payable (368+370+371-(369+372))" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4159_C + tab + T_FV_4159_M);
			//Added By amit for 4.5			
			else if(NetTaxPayable.length()!=NetTaxPayable.trim().length())
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Net Income Tax payable (368+370+371-(369+372))" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4035_C + tab + T_FV_4035_M);	
			}			
			//Amit end for Fvu 4.5 
			else if (NetTaxPayable.length() <= 15)
			{
				if (obj_FieldValidation.isDecimalNumber(NetTaxPayable))
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Net Income Tax payable (368+370+371-(369+372))" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4035_C + tab + T_FV_4035_M);
				}
				else //if (!paperReturnFile) commented on 10-Oct-05 By Mayank Paper Return Changes
				{
					//modified for fvu 6.2 by jacky
					
					if(Integer.parseInt(FinancialYr)<201819){
					if (validIncomeTaxOnTotIncome && validSurcharge && validCess && validIncomeTaxRelief)
					{
						if ((Double.parseDouble(NetTaxPayable.trim()) * 100.0)
								< (
										- 1000.0
										+ (Double.parseDouble(IncomeTaxOnTotIncome.trim()) * 100.0)
										+ (Double.parseDouble(Surcharge.trim()) * 100.0)
										+ (Double.parseDouble(Cess.trim()) * 100.0)
										- (Double.parseDouble(IncomeTaxRelief.trim()) * 100.0))
								|| (Double.parseDouble(NetTaxPayable.trim()) * 100.0)
								> (1000.0
										+ (Double.parseDouble(IncomeTaxOnTotIncome.trim()) * 100.0)
										+ (Double.parseDouble(Surcharge.trim()) * 100.0)
										+ (Double.parseDouble(Cess.trim()) * 100.0)
										- (Double.parseDouble(IncomeTaxRelief.trim()) * 100.0)))
						{
							if (paperReturnFile) // && (Double.parseDouble(NetTaxPayable.trim()) == 0))
							{
								fvO.setPaperReturnRelax(true);
								Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "NA" + tab + DeducteeDetailRecNo + tab + T_FV_4202_C + tab + T_FV_4202_M);
							}
							else
								Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Net Income Tax payable (368+370+371-(369+372))" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4202_C + tab + T_FV_4202_M);
						}
						else
							validNetTaxPayable = true;
					}
				}
					else {//modified for fvu 6.2 by jacky

						if (validIncomeTaxOnTotIncome && validSurcharge && validCess && validIncomeTaxRelief
								&& validRebateUnderSec87A) {
							if ((Double.parseDouble(NetTaxPayable.trim()) * 100.0) < (-1000.0
									+ (Double.parseDouble(IncomeTaxOnTotIncome.trim()) * 100.0)
									+ (Double.parseDouble(Surcharge.trim()) * 100.0)
									+ (Double.parseDouble(Cess.trim()) * 100.0)
									- (Double.parseDouble(IncomeTaxRelief.trim()) * 100.0)
									- (Double.parseDouble(rebateUnderSec87A.trim()) * 100.0))
									|| (Double.parseDouble(NetTaxPayable.trim()) * 100.0) > (1000.0
											+ (Double.parseDouble(IncomeTaxOnTotIncome.trim()) * 100.0)
											+ (Double.parseDouble(Surcharge.trim()) * 100.0)
											+ (Double.parseDouble(Cess.trim()) * 100.0)
											- (Double.parseDouble(IncomeTaxRelief.trim()) * 100.0)
											- (Double.parseDouble(rebateUnderSec87A.trim()) * 100.0))) {
								if (paperReturnFile) // &&
														// (Double.parseDouble(NetTaxPayable.trim())
														// == 0))
								{
									fvO.setPaperReturnRelax(true);
									Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "NA" + tab
											+ DeducteeDetailRecNo + tab + T_FV_4202_C + tab + T_FV_4202_M);
								} else
									Str_Buffer.append(LineNo + tab + v_upload_Type + tab
											+ "Net Income Tax payable (368+370+371-(369+372))" + tab + "NA" + tab
											+ CurrentlocalSDNumber + tab + T_FV_4202_C + tab + T_FV_4202_M);
							} else
								validNetTaxPayable = true;
						}

					}
				}
			}
			else
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Net Income Tax payable (368+370+371-(369+372))" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4035_C + tab + T_FV_4035_M);

			//Net Income Tax payable (341+342+343-344) 			  		

			//validate TotTDSWholeYear ----  29
			boolean validTotTDSWholeYear = false;
			if (TotTDSWholeYear.equals(FIELD_NULL) || TotTDSWholeYear.equals(FIELD_SEPERATOR))
			{
				if (ModeSD.equals("A"))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Total Amount of Tax Deducted at source for the whole year" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4225_C + tab + T_FV_4225_M);
			}
			// added by faizan for FVU 4.5
			else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
				if(! (TotTDSWholeYear.equals(FIELD_NULL) || TotTDSWholeYear.equals(FIELD_SEPERATOR))){
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab +"Total Amount of Tax Deducted at source for the whole year" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_2227_C + tab + T_FV_2227_M);	
				}
			}
			//ended by faizan
			else if (ModeSD.equals("D") || TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Total Amount of Tax Deducted at source for the whole year" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4226_C + tab + T_FV_4226_M);
			else if (TotTDSWholeYear.length() <= 15)
			{
				if (obj_FieldValidation.isDecimalNumber(TotTDSWholeYear))
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Total Amount of Tax Deducted at source for the whole year" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4225_C + tab + T_FV_4225_M);
				}
				//Added By amit for 4.5				
				else if(TotTDSWholeYear.length()!=TotTDSWholeYear.trim().length())
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Total Amount of Tax Deducted at source for the whole year" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4225_C + tab + T_FV_4225_M);	
				}
				//Added by faizan for fvu 4.5
				else if(!(Double.parseDouble(TotTDSWholeYear)>=0))
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Total Amount of Tax Deducted at source for the whole year " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4225_C + tab + T_FV_4225_M);
				}
				//Amit end for Fvu 4.5 
				else
					validTotTDSWholeYear = true;
			}
			else
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Total Amount of Tax Deducted at source for the whole year" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4225_C + tab + T_FV_4225_M);

			//validate TotTDSWholeYear
			//modified by jacky  FVU 6.2
			//Validate ShortfallExcessTaxDeduc ---- 30
			boolean validShortfallExcessTaxDeduc = false;
			if (ShortfallExcessTaxDeduc.equals(FIELD_NULL) || ShortfallExcessTaxDeduc.equals(FIELD_SEPERATOR))
			{
				if (ModeSD.equals("A"))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Shortfall in tax deduction(+)/Excess tax deduction(-) [373 - 376]" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4227_C + tab + T_FV_4227_M);
			}
			// added by faizan for FVU 4.5
			else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
				if(! (ShortfallExcessTaxDeduc.equals(FIELD_NULL) || ShortfallExcessTaxDeduc.equals(FIELD_SEPERATOR))){
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab +"Shortfall in tax deduction(+)/Excess tax deduction(-) [373 - 376]" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_2227_C + tab + T_FV_2227_M);	
				}
			}
			//ended by faizan
			else if (ModeSD.equals("D") || TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Shortfall in tax deduction(+)/Excess tax deduction(-) [373 - 376]" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4228_C + tab + T_FV_4228_M);
			//Added By amit for 4.5			
			else if(ShortfallExcessTaxDeduc.length()!=ShortfallExcessTaxDeduc.trim().length())
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Shortfall in tax deduction(+)/Excess tax deduction(-) [373 - 376]" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4227_C + tab + T_FV_4227_M);	
			}			
			//Amit end for Fvu 4.5 
			else if (ShortfallExcessTaxDeduc.length() <= 15)
			{
				if (obj_FieldValidation.isPositiveNegativeDecimalNumber(ShortfallExcessTaxDeduc))
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Shortfall in tax deduction(+)/Excess tax deduction(-) [373 - 376]" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4227_C + tab + T_FV_4227_M);
				}
				else
				{
					if (validNetTaxPayable && validTotTDSWholeYear)
					{
						if ((Double.parseDouble(ShortfallExcessTaxDeduc.trim()) * 100.0)
								< (-1000.0 + (Double.parseDouble(NetTaxPayable.trim()) * 100.0) - (Double.parseDouble(TotTDSWholeYear.trim()) * 100.0))
								|| (Double.parseDouble(ShortfallExcessTaxDeduc.trim()) * 100.0)
								> (1000.0 + (Double.parseDouble(NetTaxPayable.trim()) * 100.0) - (Double.parseDouble(TotTDSWholeYear.trim()) * 100.0)))
						{
							/*
							 * Code modified on 09-oct-2006 for Paper Return Relaxation of Shortfall/excess
							 * tax deduction
							 */

							if (paperReturnFile)
							{
								fvO.setPaperReturnRelax(true);
								Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + DeducteeDetailRecNo + tab + T_FV_4242_C + tab + T_FV_4242_M);
							}
							else
								Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Shortfall in tax deduction(+)/Excess tax deduction(-) [373 - 376]" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4242_C + tab + T_FV_4242_M);
						}
						else
							validShortfallExcessTaxDeduc = true;
					}
				}
			}
			else
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Shortfall in tax deduction(+)/Excess tax deduction(-) [373 - 376]" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4227_C + tab + T_FV_4227_M);

			//Validate ShortfallExcessTaxDeduc

			//		check of Remark1   ----- 31
			//modified: start for fvu 6.2 by Jacky
			
			if (Integer.parseInt(FinancialYr) < 201819) {
				if (Remark1.trim().equals(FIELD_NULL) || Remark1.trim().equals(FIELD_SEPERATOR)) {
				}
				// added by faizan for FVU 4.5
				else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")) {
					if (!(Remark1.trim().equals(FIELD_NULL) || Remark1.trim().equals(FIELD_SEPERATOR))) {
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Aggregate amount of deductions admissible under section 80C, 80CCC and 80CCD(1)" + tab + "NA" + tab
								+ CurrentlocalSDNumber + tab + T_FV_2227_C + tab + T_FV_2227_M);
					}
				}
				// ended by faizan
				else
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Aggregate amount of deductions admissible under section 80C, 80CCC and 80CCD(1)" + tab + "NA" + tab
							+ CurrentlocalSDNumber + tab + T_FV_6139_C + tab + T_FV_6139_M);

			}
			else {

				validateRemark1(TransactionType, v_upload_Type, Str_Buffer, LineNo, Remark1, obj_FieldValidation);

			}
			
			//modified: end for fvu 6.2 by Jacky
			
			//		check of Remark1

			//		check of Remark2  ---------   32
			if (Remark2.equals(FIELD_NULL) || Remark2.equals(FIELD_SEPERATOR))
			{
			}
			// added by faizan for FVU 4.5
			else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
				if(! (Remark2.equals(FIELD_NULL)||Remark2.equals(FIELD_SEPERATOR))){
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab +"Remarks2" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_2227_C + tab + T_FV_2227_M);	
				}
			}
			//ended by faizan
			else
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Remarks2" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4042_C + tab + T_FV_4042_M);
			
			//		check of Remark2

			//		check of Remark3   ------   33
			if (Remark3.equals(FIELD_NULL) || Remark3.equals(FIELD_SEPERATOR))
			{
			}
			// added by faizan for FVU 4.5
			else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
				if(! (Remark3.equals(FIELD_NULL) || Remark3.equals(FIELD_SEPERATOR))){
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab +"Remarks3" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_2227_C + tab + T_FV_2227_M);	
				}
			}
			//ended by faizan
			else
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Remarks3" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4043_C + tab + T_FV_4043_M);
	
			//		check of Remark3

			// start:added for column 67,68,69 for fvu 6.2 by jacky
			boolean validGrossSalaryContainedInSec17_1 = false;
			boolean validValueOfPerquisitesSec17_2 = false;
			boolean validProfitsInLieuOfSalarySec17_3 = false;

			if ((Integer.parseInt(FinancialYr) >= 201819) && (TransactionType.equals(UPLOADTYPE_REGULAR)
					|| (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A")))) {

				validGrossSalaryContainedInSec17_1 = validateField6_2Onwards(FinancialYr,Qperiod,v_upload_Type, Str_Buffer, LineNo,
						DeducteeDetailRecNo, grossSalaryContainedInSec17_1, obj_FieldValidation,
						"Gross Salary as per provisions contained in sec.17(1)", T_FV_6113_C, T_FV_6101_C, T_FV_6113_M,
						T_FV_6101_M,whthrOptTax115BAC,"");
				validValueOfPerquisitesSec17_2 = validateField6_2Onwards(FinancialYr,Qperiod,v_upload_Type, Str_Buffer, LineNo,
						DeducteeDetailRecNo, valueOfPerquisitesSec17_2, obj_FieldValidation,
						"Value of perquisites [section 17(2)]", T_FV_6114_C, T_FV_6102_C, T_FV_6114_M, T_FV_6102_M,whthrOptTax115BAC,"");

				validProfitsInLieuOfSalarySec17_3 = validateField6_2Onwards(FinancialYr,Qperiod,v_upload_Type, Str_Buffer, LineNo,
						DeducteeDetailRecNo, profitsInLieuOfSalarySec17_3, obj_FieldValidation,
						"Profits in lieu of salary [section 17(3)]", T_FV_6115_C, T_FV_6103_C, T_FV_6115_M,
						T_FV_6103_M,whthrOptTax115BAC,"");

			} else {
				validateFieldFinYrUpto201819(v_upload_Type, Str_Buffer, LineNo, DeducteeDetailRecNo,
						grossSalaryContainedInSec17_1, "Gross Salary as per provisions contained in sec.17(1)");
				validateFieldFinYrUpto201819(v_upload_Type, Str_Buffer, LineNo, DeducteeDetailRecNo,
						valueOfPerquisitesSec17_2, "Value of perquisites [section 17(2)]");
				validateFieldFinYrUpto201819(v_upload_Type, Str_Buffer, LineNo, DeducteeDetailRecNo,
						profitsInLieuOfSalarySec17_3, "Profits in lieu of salary [section 17(3)]");

			}

			// end:added for column 67,68,69 for fvu 6.2 by jacky

			//Added for FVU 3.8 by Shalin --- START


			if(fvO.isFinYrGrtrthn) //Changed for fvu 3.9
			{

				//				Validating TaxblAmtCurEmp
				if (TaxblAmtCurEmp.equals(FIELD_NULL) || TaxblAmtCurEmp.equals(FIELD_SEPERATOR))
				{
					if (TransactionType.equals(UPLOADTYPE_REGULAR) || (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A")))
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Taxable Amount of current employer" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4306_C + tab + T_FV_4306_M);

				}
				// added by faizan for FVU 4.5
				else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
					if(! (TaxblAmtCurEmp.equals(FIELD_NULL) || TaxblAmtCurEmp.equals(FIELD_SEPERATOR))){
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab +"Taxable Amount of current employer" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_2227_C + tab + T_FV_2227_M);	
					}
				}
				//ended by faizan
				else
				{
					if(TaxblAmtCurEmp.trim().length()<=15)
					{
						//added by faizan for FVU 4.5
						if (!(TaxblAmtCurEmp.trim().length()==TaxblAmtCurEmp.length()))
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Taxable Amount of current employer" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4306_C + tab + T_FV_4306_M);
						//ended by faizan
						else if (obj_FieldValidation.isDecimalNumber(TaxblAmtCurEmp))
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Taxable Amount of current employer" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4306_C + tab + T_FV_4306_M);
						else if (!TaxblAmtCurEmp.trim().endsWith(".00"))
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Taxable Amount of current employer" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4306_C + tab + T_FV_4306_M);
						else if(!(Double.parseDouble(TaxblAmtCurEmp)>=0))
						{
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Taxable Amount of current employer" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4306_C + tab + T_FV_4306_M);
						}
						else if (Integer.parseInt(FinancialYr) >= 201819) {//added for fvu 6.2 by jacky
							
							
							if(validGrossSalaryContainedInSec17_1 && validValueOfPerquisitesSec17_2 && validProfitsInLieuOfSalarySec17_3){

							if ((Double.parseDouble(TaxblAmtCurEmp.trim())
									* 100.0) != ((Double.parseDouble(grossSalaryContainedInSec17_1.trim()) * 100.0)
											+ (Double.parseDouble(valueOfPerquisitesSec17_2.trim()) * 100.0)
											+ (Double.parseDouble(profitsInLieuOfSalarySec17_3.trim()) * 100.0))) {

								Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Taxable Amount of current employer" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6128_C + tab + T_FV_6128_M);
								
								
							}
							}
						}
					}
					else
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Taxable Amount of current employer" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4306_C + tab + T_FV_4306_M);

				}
				//				Validating TaxblAmtCurEmp

				//				Validating TaxblAmtPreEmp
				if (TaxblAmtPreEmp.equals(FIELD_NULL) || TaxblAmtPreEmp.equals(FIELD_SEPERATOR))
				{
					if (TransactionType.equals(UPLOADTYPE_REGULAR) || (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A")))
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Reported Taxable Amount of previous employer" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4307_C + tab + T_FV_4307_M);

				}
				// added by faizan for FVU 4.5
				else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
					if(! (TaxblAmtPreEmp.equals(FIELD_NULL)||TaxblAmtPreEmp.equals(FIELD_SEPERATOR))){
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab +"Reported Taxable Amount of previous employer" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_2227_C + tab + T_FV_2227_M);	
					}
				}
				//ended by faizan
				else
				{
					if(TaxblAmtPreEmp.trim().length()<=15)
					{
						if (obj_FieldValidation.isDecimalNumber(TaxblAmtPreEmp))
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Reported Taxable Amount of previous employer" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4307_C + tab + T_FV_4307_M);
						// added by faizan for FVU 4.5
						else if (!(TaxblAmtPreEmp.trim().length()==TaxblAmtPreEmp.length()))
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Reported Taxable Amount of previous employer" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4307_C + tab + T_FV_4307_M);
						//ended by Faizan

						else if (!TaxblAmtPreEmp.trim().endsWith(".00"))
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Reported Taxable Amount of previous employer" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4307_C + tab + T_FV_4307_M);
						else if(!(Double.parseDouble(TaxblAmtPreEmp)>=0))
						{
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Reported Taxable Amount of previous employer" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4307_C + tab + T_FV_4307_M);
						}

					}
					else
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Reported Taxable Amount of previous employer" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4307_C + tab + T_FV_4307_M);

				}
				//				Validating TaxblAmtPreEmp
				// added by faizan for FVU 4.5
				if(!(TotalSalaryExeclud338n339.equals(FIELD_NULL) || TotalSalaryExeclud338n339.equals(FIELD_SEPERATOR)) && !(TaxblAmtCurEmp.equals(FIELD_NULL) || TaxblAmtCurEmp.equals(FIELD_SEPERATOR)) && !(TaxblAmtPreEmp.equals(FIELD_NULL) || TaxblAmtPreEmp.equals(FIELD_SEPERATOR)))
				{
					if(!obj_FieldValidation.isDecimalNumber(TotalSalaryExeclud338n339) && !obj_FieldValidation.isDecimalNumber(TaxblAmtCurEmp) && !obj_FieldValidation.isDecimalNumber(TaxblAmtPreEmp))
						if (!((Double.parseDouble(TotalSalaryExeclud338n339.trim()))==(Double.parseDouble(TaxblAmtCurEmp.trim()) + Double.parseDouble(TaxblAmtPreEmp.trim()))))
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Total amount of salary " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4328_C + tab + T_FV_4328_M);
				}

				// ended by Faizan

				//				Validating TDSCurEmp
				if (TDSCurEmp.equals(FIELD_NULL) || TDSCurEmp.equals(FIELD_SEPERATOR))
				{
					if (TransactionType.equals(UPLOADTYPE_REGULAR) || (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A")))
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Total TDS of current employer" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4308_C + tab + T_FV_4308_M);

				}
				// added by faizan for FVU 4.5
				else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
					if(!(TDSCurEmp.equals(FIELD_NULL)||TDSCurEmp.equals(FIELD_SEPERATOR))){
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab +"Total TDS of current employer" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_2227_C + tab + T_FV_2227_M);	
					}
				}
				//ended by faizan
				else
				{
					if(TDSCurEmp.trim().length()<=15)
					{
						if (obj_FieldValidation.isDecimalNumber(TDSCurEmp))
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Total TDS of current employer " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4308_C + tab + T_FV_4308_M);
						// added by faizan for FVU 4.5
						else if (!(TDSCurEmp.trim().length()==TDSCurEmp.length()))
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Total TDS of current employer " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4308_C + tab + T_FV_4308_M);
						// ended by Faizan

						else if (!TDSCurEmp.trim().endsWith(".00"))
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Total TDS of current employer " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4308_C + tab + T_FV_4308_M);
						else if(!(Double.parseDouble(TDSCurEmp)>=0))
						{
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Total TDS of current employer " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4308_C + tab + T_FV_4308_M);
						}
					}

					else
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Total TDS of current employer " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4308_C + tab + T_FV_4308_M);

				}
				//				Validating TDSCurEmp

				//				Validating TDSPreEmp
				if (TDSPreEmp.equals(FIELD_NULL) || TDSPreEmp.equals(FIELD_SEPERATOR))
				{
					if (TransactionType.equals(UPLOADTYPE_REGULAR) || (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A")))
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Reported TDS of previous employer" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4309_C + tab + T_FV_4309_M);

				}
				// added by faizan for FVU 4.5
				else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
					if(! (TDSPreEmp.equals(FIELD_NULL) || TDSPreEmp.equals(FIELD_SEPERATOR))){
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab +"Reported TDS of previous employer" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_2227_C + tab + T_FV_2227_M);	
					}
				}
				//ended by faizan
				else
				{
					if(TDSPreEmp.trim().length()<=15)
					{
						// added by Faizan For fvu 4.5
						if (!(TDSPreEmp.trim().length()==TDSPreEmp.length()))
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Reported TDS of previous employer" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4309_C + tab + T_FV_4309_M);
						else if (obj_FieldValidation.isDecimalNumber(TDSPreEmp))
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Reported TDS of previous employer" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4309_C + tab + T_FV_4309_M);
						else if (!TDSPreEmp.trim().endsWith(".00"))
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Reported TDS of previous employer" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4309_C + tab + T_FV_4309_M);
						else if(!(Double.parseDouble(TDSPreEmp)>=0))
						{
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Reported TDS of previous employer" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4309_C + tab + T_FV_4309_M);
						}
					}

					else
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Reported TDS of previous employer" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4309_C + tab + T_FV_4309_M);

				}

				//				Validating TDSPreEmp
				System.out.println("TotTDSWholeYear- "+TotTDSWholeYear+"TDSCurEmp- "+TDSCurEmp+"TDSPreEmp- "+TDSPreEmp);
				// For FVU 5.2 for 29th field
	
				//				Validating WhethrTaxDedAtHighrRate
				if (WhethrTaxDedAtHighrRate.equals(FIELD_NULL) || WhethrTaxDedAtHighrRate.equals(FIELD_SEPERATOR))
				{

					if (UploadType.equals(UPLOADTYPE_REGULAR) || (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A")))
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Whether tax deducted at Higher rate due to non furnishing of PAN by deductee" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4310_C + tab + T_FV_4310_M);

				}
				// added by faizan for FVU 4.5
				else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
					if(! (WhethrTaxDedAtHighrRate.equals(FIELD_NULL)||WhethrTaxDedAtHighrRate.equals(FIELD_SEPERATOR))){
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Whether tax deducted at Higher rate due to non furnishing of PAN by deductee" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_2227_C + tab + T_FV_2227_M);	
					}
				}
				else
				{

					if(!(WhethrTaxDedAtHighrRate.equals("Y") || WhethrTaxDedAtHighrRate.equals("N")))
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Whether tax deducted at Higher rate due to non furnishing of PAN by deductee" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4310_C + tab + T_FV_4310_M);

					//Added for FVU 3.9
					if((UploadType.equals(UPLOADTYPE_REGULAR) || (UploadType.equals(UPLOADTYPE_CORRECTION) && TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A"))) && FormNo.equals(FORM_24Q) && Qperiod.equals("Q4") && !WhethrTaxDedAtHighrRate.equals("Y") )
					{

						if(EmployeePan.equals(PAN_NOT_AVAILABLE) || EmployeePan.equals(PAN_APPLIED) || EmployeePan.equals(PAN_INVALID))
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Whether tax deducted at Higher rate due to non furnishing of PAN by deductee" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4319_C + tab + T_FV_4319_M);

					}
				}
				//				Validating WhethrTaxDedAtHighrRate

				// added  for FVU 5.2				
				// Validating WhethrHouseRentClaimExced ::  for FVU5.2 :: field no 39

				if (WhethrHouseRentClaimExced.equals(FIELD_NULL) || WhethrHouseRentClaimExced.equals(FIELD_SEPERATOR) || WhethrHouseRentClaimExced.trim().length() == 0)
				{	
					if(Integer.parseInt(FinancialYr) >=201617 && ((TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A") ) || UploadType.equals(UPLOADTYPE_REGULAR)))
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Whether house rent allowance claim exceeds rupees one lakh " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6070_C + tab + T_FV_6070_M);
					}
				}
				else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
					if(!(WhethrHouseRentClaimExced.equals(FIELD_NULL)||WhethrHouseRentClaimExced.equals(FIELD_SEPERATOR))){
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Whether house rent allowance claim exceeds rupees one lakh" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6070_C + tab + T_FV_6070_M);
					}
				}
				else
				{

					if(Integer.parseInt(FinancialYr) < 201617)
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Whether house rent allowance claim exceeds rupees one lakh" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6070_C + tab + T_FV_6070_M);
					} 
					else if (Integer.parseInt(FinancialYr) >= 201617 && ((TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A") ) || UploadType.equals(UPLOADTYPE_REGULAR)))
					{
						if (!(WhethrHouseRentClaimExced.equals("Y") || WhethrHouseRentClaimExced.equals("N")) )
						{
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Whether house rent allowance claim exceeds rupees one lakh" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6070_C + tab + T_FV_6070_M);
						}
					}
					else
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Whether house rent allowance claim exceeds rupees one lakh" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6070_C + tab + T_FV_6070_M);

				}	
				// End :: Validating WhethrTaxDedAtHighrRate :: for FVU5.2 

				//Validating for CountOfPanLanloard
				if(CountOfPanLanloard.equals(FIELD_NULL) || CountOfPanLanloard.equals(FIELD_SEPERATOR) || CountOfPanLanloard.trim().length() == 0 || Integer.parseInt(CountOfPanLanloard)==0 )
				{

					if(("N".equals(WhethrHouseRentClaimExced)) &&  Integer.parseInt(FinancialYr) >= 201617 && ((TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A") ) || UploadType.equals(UPLOADTYPE_REGULAR)) )
					{
						if((CountOfPanLanloard.equals(FIELD_NULL) || CountOfPanLanloard.equals(FIELD_SEPERATOR) || CountOfPanLanloard.trim().length() == 0))
						{
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Count of PAN of the Landloard" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6071_C + tab + T_FV_6071_M);
						}
						else if (Integer.parseInt(CountOfPanLanloard)!= 0)
						{
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Count of PAN of the Landloard" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6071_C + tab + T_FV_6071_M);
						}

					}
					else if((WhethrHouseRentClaimExced.equals(FIELD_NULL)|| WhethrHouseRentClaimExced.equals(FIELD_SEPERATOR)))
					{
						if( !(CountOfPanLanloard.equals(FIELD_NULL) || CountOfPanLanloard.equals(FIELD_SEPERATOR) || CountOfPanLanloard.trim().length()==0) )
						{
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Count of PAN of the Landloard" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6071_C + tab + T_FV_6071_M);

						}

					}
					else
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Count of PAN of the Landloard" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6071_C + tab + T_FV_6071_M);


				}
				else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
					if(!(CountOfPanLanloard.equals(FIELD_NULL)||CountOfPanLanloard.equals(FIELD_SEPERATOR))){
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Count of PAN of the Landloard" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6071_C + tab + T_FV_6071_M);
					}
				}
				else
				{
					if( !("Y".equals(WhethrHouseRentClaimExced)) )
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Count of PAN of the Landloard" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6071_C + tab + T_FV_6071_M);
					}
					else if(("Y".equals(WhethrHouseRentClaimExced)) &&  Integer.parseInt(FinancialYr) >= 201617 && ((TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A") ) || UploadType.equals(UPLOADTYPE_REGULAR)))
					{
						int landloardPanCount=0;
						if( !(LandlordPan1.equals(FIELD_NULL) || LandlordPan1.equals(FIELD_SEPERATOR) || LandlordPan1.trim().length() == 0))
						{
							landloardPanCount++;
						}
						if( !(LandlordPan2.equals(FIELD_NULL) || LandlordPan2.equals(FIELD_SEPERATOR) || LandlordPan2.trim().length() == 0))
						{
							landloardPanCount++;
						}
						if( !(LandlordPan3.equals(FIELD_NULL) || LandlordPan3.equals(FIELD_SEPERATOR) || LandlordPan3.trim().length() == 0))
						{
							landloardPanCount++;
						}
						if( !(LandlordPan4.equals(FIELD_NULL) || LandlordPan4.equals(FIELD_SEPERATOR) || LandlordPan4.trim().length() == 0))
						{
							landloardPanCount++;
						}


						if(Integer.parseInt(CountOfPanLanloard)!= landloardPanCount)
						{
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Count of PAN of the Landloard" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6071_C + tab + T_FV_6071_M);
						}
					}
					else
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Count of PAN of the Landloard" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6071_C + tab + T_FV_6071_M);

				}


				// End :: Validating CountOfPanLanloard



				// Validating LandlordPan1 ::  for FVU5.2 

				if ( !(LandlordPan1.equals(FIELD_NULL) || LandlordPan1.equals(FIELD_SEPERATOR) || LandlordPan1.trim().length() == 0))
				{
					if( !"Y".equals(WhethrHouseRentClaimExced) || Integer.parseInt(FinancialYr) < 201617 || !((TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A") ) || UploadType.equals(UPLOADTYPE_REGULAR)) )
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "PAN of landlord 1" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6072_C + tab + T_FV_6072_M);
					}
					else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
						if(!(LandlordPan1.equals(FIELD_NULL)||LandlordPan1.equals(FIELD_SEPERATOR))){
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "PAN of landlord 1" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6072_C + tab + T_FV_6072_M);
						}
					}
					else if(WhethrHouseRentClaimExced.equals("Y") && Integer.parseInt(FinancialYr) >=201617 && ((TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A") ) || UploadType.equals(UPLOADTYPE_REGULAR)) )
					{
						if (!LandlordPan1.equals(PAN_NOT_AVAILABLE) && !LandlordPan1.equals(PAN_APPLIED) && !LandlordPan1.equals(PAN_INVALID))
						{
							if (LandlordPan1.length() == 10 && LandlordPan1.trim().length() == 10)
							{
								if (!LandlordPan1.equals(GOVERNMENT) && !LandlordPan1.equals(NON_RESDENT) && !LandlordPan1.equals(OTHER_VALUE) ) // IF condition Added by shruti FVU 5.4
								{
									if (obj_FieldValidation.checkPan(LandlordPan1))
									{ 
										Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "PAN of landlord 1" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6072_C + tab + T_FV_6072_M);
									}
								}
							}
							else
								Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "PAN of landlord 1" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6072_C + tab + T_FV_6072_M);

						}
						else
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "PAN of landlord 1" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6072_C + tab + T_FV_6072_M);


					}
					else
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "PAN of landlord 1" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6072_C + tab + T_FV_6072_M);

				}
				// End :: Validating LandlordPan1 ::  for FVU5.2	
				// Validating LandlordName1 ::  for FVU5.2 
				if (LandlordName1.equals(FIELD_NULL) || LandlordName1.equals(FIELD_SEPERATOR) || LandlordName1.trim().length() == 0)
				{
					if(! (LandlordPan1.equals(FIELD_NULL) || LandlordPan1.equals(FIELD_SEPERATOR))  )
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Name of landlord 1 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6073_C + tab + T_FV_6073_M);
					}		
				}	
				else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
					if(!(LandlordName1.equals(FIELD_NULL)||LandlordName1.equals(FIELD_SEPERATOR))){
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Name of landlord 1" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6073_C + tab + T_FV_6073_M);
					}
				}
				else
				{
					if(  LandlordPan1.equals(FIELD_NULL) || LandlordPan1.equals(FIELD_SEPERATOR)  )
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Name of landlord 1 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6073_C + tab + T_FV_6073_M);
					}
					else if (LandlordName1.length() <= 75  )
					{
						if(!obj_FieldValidation.checkNonSpecialCharacter(LandlordName1) || obj_FieldValidation.isNumber(LandlordName1) || obj_FieldValidation.isNumeric(LandlordName1)){

							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Name of landlord 1 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6073_C + tab + T_FV_6073_M);
						}

						if (obj_FieldValidation.isValidCharString(LandlordName1))
						{
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Name of landlord 1 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6073_C + tab + T_FV_6073_M);
						}

					}
					else
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Name of landlord 1 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6073_C + tab + T_FV_6073_M);

				} 	

				// End :: Validating LandlordName1 ::  for FVU5.2

				// Validating LandlordPan2 ::  for FVU5.2 


				if ( !(LandlordPan2.equals(FIELD_NULL) || LandlordPan2.equals(FIELD_SEPERATOR) || LandlordPan2.trim().length() == 0))
				{
					if( !"Y".equals(WhethrHouseRentClaimExced) || Integer.parseInt(FinancialYr) < 201617 || !((TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A") ) || UploadType.equals(UPLOADTYPE_REGULAR)) )
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "PAN of landlord 2" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6074_C + tab + T_FV_6074_M);
					}
					else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
						if(!(LandlordPan2.equals(FIELD_NULL)||LandlordPan2.equals(FIELD_SEPERATOR))){
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "PAN of landlord 2" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6074_C + tab + T_FV_6074_M);
						}
					}
					else if(WhethrHouseRentClaimExced.equals("Y") && Integer.parseInt(FinancialYr) >=201617 && ((TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A") ) || UploadType.equals(UPLOADTYPE_REGULAR)) )
					{
						if (!LandlordPan2.equals(PAN_NOT_AVAILABLE) && !LandlordPan2.equals(PAN_APPLIED) && !LandlordPan2.equals(PAN_INVALID))
						{
							if (LandlordPan2.length() == 10 && LandlordPan2.trim().length() == 10)
							{
								if (!LandlordPan2.equals(GOVERNMENT) && !LandlordPan2.equals(NON_RESDENT) && !LandlordPan2.equals(OTHER_VALUE) ) // IF condition Added by shruti FVU 5.4
								{
									if (obj_FieldValidation.checkPan(LandlordPan2))
									{ 
										Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "PAN of landlord 2" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6074_C + tab + T_FV_6074_M);
									}
								}
							}
							else
								Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "PAN of landlord 2" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6074_C + tab + T_FV_6074_M);

						}
						else
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "PAN of landlord 2" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6074_C + tab + T_FV_6074_M);

					}
					else
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "PAN of landlord 2" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6074_C + tab + T_FV_6074_M);

				}
				// End :: Validating LandlordPan2 ::  for FVU5.2	

				// Validating LandlordName2 ::  for FVU5.2 

				if (LandlordName2.equals(FIELD_NULL) || LandlordName2.equals(FIELD_SEPERATOR) || LandlordName2.trim().length() == 0)
				{
					if( !(LandlordPan2.equals(FIELD_NULL) || LandlordPan2.equals(FIELD_SEPERATOR)) )
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Name of landlord 2 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6075_C + tab + T_FV_6075_M);
					}		
				}	

				else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
					if(!(LandlordName2.equals(FIELD_NULL)||LandlordName2.equals(FIELD_SEPERATOR))){
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Name of landlord 2 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6074_C + tab + T_FV_6074_M);
					}
				}

				else
				{

					if( LandlordPan2.equals(FIELD_NULL)  || LandlordPan2.equals(FIELD_SEPERATOR) )
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Name of landlord 2 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6075_C + tab + T_FV_6075_M);
					}
					else if (LandlordName2.length() <= 75 )
					{
						if(!obj_FieldValidation.checkNonSpecialCharacter(LandlordName2) || obj_FieldValidation.isNumber(LandlordName2)|| obj_FieldValidation.isNumeric(LandlordName2)){

							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Name of landlord 2 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6075_C + tab + T_FV_6075_M);

						}
						if (obj_FieldValidation.isValidCharString(LandlordName2))
						{
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Name of landlord 2 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6075_C + tab + T_FV_6075_M);
						}



					}
					else
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Name of landlord 2 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6075_C + tab + T_FV_6075_M);

				} 	

				// End :: Validating LandlordName2 ::  for FVU5.2

				// Validating LandlordPan3 ::  for FVU5.2 :: field no 40

				if(!(LandlordPan3.equals(FIELD_NULL) || LandlordPan3.equals(FIELD_SEPERATOR) || LandlordPan3.trim().length() == 0))
				{
					if( !"Y".equals(WhethrHouseRentClaimExced) || Integer.parseInt(FinancialYr) < 201617 || !((TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A") ) || UploadType.equals(UPLOADTYPE_REGULAR)) )
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "PAN of landlord 3 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6076_C + tab + T_FV_6076_M);
					}

					else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
						if(!(LandlordPan2.equals(FIELD_NULL)||LandlordPan2.equals(FIELD_SEPERATOR))){
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "PAN of landlord 3 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6074_C + tab + T_FV_6074_M);
						}
					}
					else if(WhethrHouseRentClaimExced.equals("Y") && Integer.parseInt(FinancialYr) >=201617 && ((TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A") ) || UploadType.equals(UPLOADTYPE_REGULAR)))
					{
						if (!LandlordPan3.equals(PAN_NOT_AVAILABLE) && !LandlordPan3.equals(PAN_APPLIED) && !LandlordPan3.equals(PAN_INVALID))
						{
							if (LandlordPan3.length() == 10 && LandlordPan3.trim().length() == 10)
							{
								if (!LandlordPan3.equals(GOVERNMENT) && !LandlordPan3.equals(NON_RESDENT) && !LandlordPan3.equals(OTHER_VALUE) ) // IF condition Added by shruti FVU 5.4
								{
									if (obj_FieldValidation.checkPan(LandlordPan3))
									{ 
										Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "PAN of landlord 3" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6076_C + tab + T_FV_6076_M);
									}
								}
							}
							else
								Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "PAN of landlord 3 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6076_C + tab + T_FV_6076_M);

						}
						else
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "PAN of landlord 3" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6076_C + tab + T_FV_6076_M);

					}
					else
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "PAN of landlord 3 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6076_C + tab + T_FV_6076_M);

				}
				// End :: Validating LandlordPan3 ::  for FVU5.2	

				// Validating LandlordName3 ::  for FVU5.2 
				if (LandlordName3.equals(FIELD_NULL) || LandlordName3.equals(FIELD_SEPERATOR) || LandlordName3.trim().length() == 0)
				{
					if( !(LandlordPan3.equals(FIELD_NULL) || LandlordPan3.equals(FIELD_SEPERATOR)) )
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Name of landlord 3" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6077_C + tab + T_FV_6077_M);
					}		
				}	
				else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
					if(!(LandlordName3.equals(FIELD_NULL)||LandlordName3.equals(FIELD_SEPERATOR))){
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Name of landlord 3" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6077_C + tab + T_FV_6077_M);
					}
				}
				else
				{
					if(LandlordPan3.equals(FIELD_NULL) || LandlordPan3.equals(FIELD_SEPERATOR) )
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Name of landlord 3 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6077_C + tab + T_FV_6077_M);
					}
					else if (LandlordName3.length() <= 75 )
					{
						if(!obj_FieldValidation.checkNonSpecialCharacter(LandlordName3) || obj_FieldValidation.isNumber(LandlordName3) || obj_FieldValidation.isNumeric(LandlordName3)){
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Name of landlord 3 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6077_C + tab + T_FV_6077_M);
						}
						if (obj_FieldValidation.isValidCharString(LandlordName3))
						{
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Name of landlord 3 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6077_C + tab + T_FV_6077_M);
						}


					}
					else
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Name of landlord 3 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6077_C + tab + T_FV_6077_M);

				} 	

				// End :: Validating LandlordName3 :: for FVU5.2

				// Validating LandlordPan4 ::  for FVU5.2 


				if(!(LandlordPan4.equals(FIELD_NULL) || LandlordPan4.equals(FIELD_SEPERATOR) || LandlordPan4.trim().length() == 0))
				{
					if( !"Y".equals(WhethrHouseRentClaimExced) || Integer.parseInt(FinancialYr) < 201617 || !((TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A") ) || UploadType.equals(UPLOADTYPE_REGULAR))  )
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "PAN of landlord 4 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6078_C + tab + T_FV_6078_M);
					}
					else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
						if(!(LandlordPan4.equals(FIELD_NULL)||LandlordPan4.equals(FIELD_SEPERATOR))){
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "PAN of landlord 4 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6078_C + tab + T_FV_6078_M);
						}
					}
					else if(WhethrHouseRentClaimExced.equals("Y") && Integer.parseInt(FinancialYr) >=201617 && ((TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A") ) || UploadType.equals(UPLOADTYPE_REGULAR)))
					{
						if (!LandlordPan4.equals(PAN_NOT_AVAILABLE) && !LandlordPan4.equals(PAN_APPLIED) && !LandlordPan4.equals(PAN_INVALID))
						{
							if (LandlordPan4.length() == 10 && LandlordPan4.trim().length() == 10)
							{
								if (!LandlordPan4.equals(GOVERNMENT) && !LandlordPan4.equals(NON_RESDENT) && !LandlordPan4.equals(OTHER_VALUE) ) // IF condition Added by shruti FVU 5.4
								{
									if (obj_FieldValidation.checkPan(LandlordPan4))
									{ 
										Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "PAN of landlord 4  " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6078_C + tab + T_FV_6078_M);
									}
								}
							}
							else
								Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "PAN of landlord 4  " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6078_C + tab + T_FV_6078_M);

						}
						else
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "PAN of landlord 4 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6078_C + tab + T_FV_6078_M);

					}
					else
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "PAN of landlord 4 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6078_C + tab + T_FV_6078_M);

				}
				// End :: Validating LandlordPan4 ::  for FVU5.2	

				// Validating LandlordName4 ::  for FVU5.2 :: field no 41
				if (LandlordName4.equals(FIELD_NULL) || LandlordName4.equals(FIELD_SEPERATOR) || LandlordName4.trim().length() == 0)
				{
					if(!(LandlordPan4.equals(FIELD_NULL) || LandlordPan4.equals(FIELD_SEPERATOR)))
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Name of landlord 4" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6079_C + tab + T_FV_6079_M);
					}		
				}
				else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
					if(!(LandlordName4.equals(FIELD_NULL)||LandlordName4.equals(FIELD_SEPERATOR))){
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Name of landlord 4" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6079_C + tab + T_FV_6079_M);
					}
				}
				else
				{
					if( (LandlordPan4.equals(FIELD_NULL) || LandlordPan4.equals(FIELD_SEPERATOR))  )
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Name of landlord 4 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6079_C + tab + T_FV_6079_M);
					}
					else if (LandlordName4.length() <= 75 )
					{
						if(!obj_FieldValidation.checkNonSpecialCharacter(LandlordName4) || obj_FieldValidation.isNumber(LandlordName4)|| obj_FieldValidation.isNumeric(LandlordName4)){
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Name of landlord 4 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6079_C + tab + T_FV_6079_M);
						}
						if (obj_FieldValidation.isValidCharString(LandlordName4))
						{
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Name of landlord 4 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6079_C + tab + T_FV_6079_M);
						}


					}
					else
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Name of landlord 4 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6079_C + tab + T_FV_6079_M);

				} 	

				// End :: Validating LandlordName4 ::  for FVU5.2	

				// Validating WhethrInterestPaidLender ::  for FVU5.2 

				if (WhethrInterestPaidLender.equals(FIELD_NULL) || WhethrInterestPaidLender.equals(FIELD_SEPERATOR) || WhethrInterestPaidLender.trim().length() == 0)
				{

					if(Integer.parseInt(FinancialYr) >=201617 && ((TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A") ) || UploadType.equals(UPLOADTYPE_REGULAR)))
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Whether Interest paid  to the lender under the head 'Income from house property'" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6080_C + tab + T_FV_6080_M);
					}
				}
				else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
					if(!(WhethrInterestPaidLender.equals(FIELD_NULL)||WhethrInterestPaidLender.equals(FIELD_SEPERATOR))){
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Whether Interest paid  to the lender under the head 'Income from house property' " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6080_C + tab + T_FV_6080_M);
					}
				}
				else
				{
					if(Integer.parseInt(FinancialYr) < 201617)
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Whether Interest paid  to the lender under the head 'Income from house property' " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6080_C + tab + T_FV_6080_M);
					} 
					else if ( Integer.parseInt(FinancialYr) >=201617 && ((TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A") ) || UploadType.equals(UPLOADTYPE_REGULAR)))
					{
						if (!(WhethrInterestPaidLender.equals("Y") || WhethrInterestPaidLender.equals("N")) )
						{
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Whether Interest paid  to the lender under the head 'Income from house property' " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6080_C + tab + T_FV_6080_M);
						}
					}
					else
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Whether Interest paid  to the lender under the head 'Income from house property' " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6080_C + tab + T_FV_6080_M);

				}	
				// End :: Validating WhethrInterestPaidLender ::  for FVU5.2 


				//Added for CountOfPanLender

				if(CountOfPanLender.equals(FIELD_NULL) || CountOfPanLender.equals(FIELD_SEPERATOR) || CountOfPanLender.trim().length() == 0 ||  Integer.parseInt(CountOfPanLender)== 0   )
				{
					if(("N".equals(WhethrInterestPaidLender)) &&  Integer.parseInt(FinancialYr) >= 201617 && ((TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A") ) || UploadType.equals(UPLOADTYPE_REGULAR)) )
					{
						if((CountOfPanLender.equals(FIELD_NULL) || CountOfPanLender.equals(FIELD_SEPERATOR) || CountOfPanLender.trim().length() == 0))
						{
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Count of PAN of the Lender " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6081_C + tab + T_FV_6081_M);
						}
						else if (Integer.parseInt(CountOfPanLender)!= 0)
						{
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Count of PAN of the Lender " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6081_C + tab + T_FV_6081_M);

						}


					}
					else if((WhethrInterestPaidLender.equals(FIELD_NULL) || WhethrInterestPaidLender.equals(FIELD_SEPERATOR))  )
					{
						if( !(CountOfPanLender.equals(FIELD_NULL) || CountOfPanLender.equals(FIELD_SEPERATOR) || CountOfPanLender.trim().length() == 0) )
						{
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Count of PAN of the Lender " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6081_C + tab + T_FV_6081_M);

						}

					}
					else
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Count of PAN of the Lender " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6081_C + tab + T_FV_6081_M);
				}

				else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
					if(!(CountOfPanLender.equals(FIELD_NULL)||CountOfPanLender.equals(FIELD_SEPERATOR))){
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Count of PAN of the Lender " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6081_C + tab + T_FV_6081_M);
					}
				}
				else
				{
					if( !("Y".equals(WhethrInterestPaidLender)) )
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Count of PAN of the Lender " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6081_C + tab + T_FV_6081_M);
					}
					else if("Y".equals(WhethrInterestPaidLender) && Integer.parseInt(FinancialYr) >=201617 && ((TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A") ) || UploadType.equals(UPLOADTYPE_REGULAR)))
					{
						int lenderPanCount=0;
						if( !(LenderPan1.equals(FIELD_NULL) || LenderPan1.equals(FIELD_SEPERATOR) || LenderPan1.trim().length() == 0))
						{
							lenderPanCount++;
						}
						if( !(LenderPan2.equals(FIELD_NULL) || LenderPan2.equals(FIELD_SEPERATOR) || LenderPan2.trim().length() == 0))
						{
							lenderPanCount++;
						}
						if( !(LenderPan3.equals(FIELD_NULL) || LenderPan3.equals(FIELD_SEPERATOR) || LenderPan3.trim().length() == 0))
						{
							lenderPanCount++;
						}
						if( !(LenderPan4.equals(FIELD_NULL) || LenderPan4.equals(FIELD_SEPERATOR) || LenderPan4.trim().length() == 0))
						{
							lenderPanCount++;
						}
						if(Integer.parseInt(CountOfPanLender)!= lenderPanCount)
						{
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Count of PAN of the Lender " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6081_C + tab + T_FV_6081_M);
						}
					}
					else
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Count of PAN of the Lender " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6081_C + tab + T_FV_6081_M);

				}


				// End :: Added for CountOfPanLender



				// Validating LenderPan1 :: priya for FVU5.2 :: field no 42

				if(!(LenderPan1.equals(FIELD_NULL) || LenderPan1.equals(FIELD_SEPERATOR) || LenderPan1.trim().length() == 0))
				{
					if( !"Y".equals(WhethrInterestPaidLender) || Integer.parseInt(FinancialYr) < 201617 || !((TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A") ) || UploadType.equals(UPLOADTYPE_REGULAR)) )	
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "PAN of lender 1 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6082_C + tab + T_FV_6082_M);
					}

					else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
						if(!(LenderPan1.equals(FIELD_NULL)||LenderPan1.equals(FIELD_SEPERATOR))){
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + " PAN of lender 1 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6082_C + tab + T_FV_6082_M);
						}
					}

					else if(WhethrInterestPaidLender.equals("Y") && Integer.parseInt(FinancialYr) >=201617 && ((TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A") ) || UploadType.equals(UPLOADTYPE_REGULAR)) )
					{
						if (!LenderPan1.equals(PAN_NOT_AVAILABLE) && !LenderPan1.equals(PAN_APPLIED) && !LenderPan1.equals(PAN_INVALID))
						{
							if (LenderPan1.length() == 10 && LenderPan1.trim().length() == 10)
							{
								if (!LenderPan1.equals(GOVERNMENT) && !LenderPan1.equals(NON_RESDENT) && !LenderPan1.equals(OTHER_VALUE) ) // IF condition Added by shruti FVU 5.5
								{
									if (obj_FieldValidation.checkPan(LenderPan1))
									{ 
										Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "PAN of lender 1 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6082_C + tab + T_FV_6082_M);
									}
								}
							}
							else
								Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "PAN of lender 1 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6082_C + tab + T_FV_6082_M);

						}
						else
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "PAN of lender 1 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6082_C + tab + T_FV_6082_M);

					}
					else
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "PAN of lender 1 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6082_C + tab + T_FV_6082_M);

				}

				// End :: Validating LenderPan1 ::  for FVU5.2


				// Validating LenderName1 ::  for FVU5.2 

				if (LenderName1.equals(FIELD_NULL) || LenderName1.equals(FIELD_SEPERATOR) || LenderName1.trim().length() == 0)
				{
					if( !(LenderPan1.equals(FIELD_NULL) || LenderPan1.equals(FIELD_SEPERATOR)) )
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Name of lender 1 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6083_C + tab + T_FV_6083_M);
					}		
				}	
				else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
					if(!(LenderName1.equals(FIELD_NULL)||LenderName1.equals(FIELD_SEPERATOR))){
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + " Name of lender 1 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6083_C + tab + T_FV_6083_M);
					}
				}
				else
				{
					if( LenderPan1.equals(FIELD_NULL) || LenderPan1.equals(FIELD_SEPERATOR) )
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + " Name of lender 1 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6083_C + tab + T_FV_6083_M);
					}	

					else if (LenderName1.length() <= 75 )
					{

						if(!obj_FieldValidation.checkNonSpecialCharacter(LenderName1) || obj_FieldValidation.isNumber(LenderName1)|| obj_FieldValidation.isNumeric(LenderName1)){
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + " Name of lender 1 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6083_C + tab + T_FV_6083_M);
						}
						if (obj_FieldValidation.isValidCharString(LenderName1))
						{
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + " Name of lender 1 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6083_C + tab + T_FV_6083_M);
						}

					}
					else
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + " Name of lender 1 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6083_C + tab + T_FV_6083_M);

				} 
				// End :: Validating LenderName1 ::  for FVU5.2

				// Validating LenderPan2 ::  for FVU5.2 



				if(!(LenderPan2.equals(FIELD_NULL) || LenderPan2.equals(FIELD_SEPERATOR) || LenderPan2.trim().length() == 0))
				{
					if( !"Y".equals(WhethrInterestPaidLender) || Integer.parseInt(FinancialYr) < 201617 || !((TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A") ) || UploadType.equals(UPLOADTYPE_REGULAR)) )	
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "PAN of lender 2 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6084_C + tab + T_FV_6084_M);
					}

					else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
						if(!(LenderPan2.equals(FIELD_NULL)||LenderPan2.equals(FIELD_SEPERATOR))){
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + " PAN of lender 2 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6084_C + tab + T_FV_6084_M);
						}
					}

					else if(WhethrInterestPaidLender.equals("Y") && Integer.parseInt(FinancialYr) >=201617 && ((TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A") ) || UploadType.equals(UPLOADTYPE_REGULAR)) )
					{
						if (!LenderPan2.equals(PAN_NOT_AVAILABLE) && !LenderPan2.equals(PAN_APPLIED) && !LenderPan2.equals(PAN_INVALID))
						{
							if (LenderPan2.length() == 10 && LenderPan2.trim().length() == 10)
							{
								if (!LenderPan2.equals(GOVERNMENT) && !LenderPan2.equals(NON_RESDENT) && !LenderPan2.equals(OTHER_VALUE) ) // IF condition Added by shruti FVU 5.5
								{
									if (obj_FieldValidation.checkPan(LenderPan2))
									{ 
										Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "PAN of lender 2 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6084_C + tab + T_FV_6084_M);
									}
								}
							}
							else
								Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "PAN of lender 2 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6084_C + tab + T_FV_6084_M);

						}
						else
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "PAN of lender 2 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6084_C + tab + T_FV_6084_M);

					}
					else
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "PAN of lender 2 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6084_C + tab + T_FV_6084_M);

				}

				// End :: Validating LenderPan2 ::  for FVU5.2


				// Validating LenderName2 ::  for FVU5.2

				if (LenderName2.equals(FIELD_NULL) || LenderName2.equals(FIELD_SEPERATOR) || LenderName2.trim().length() == 0)
				{
					if( !(LenderPan2.equals(FIELD_NULL) || LenderPan2.equals(FIELD_SEPERATOR)) )
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Name of lender 2 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6085_C + tab + T_FV_6085_M);
					}		
				}

				else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
					if(!(LenderName2.equals(FIELD_NULL)||LenderName2.equals(FIELD_SEPERATOR))){
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Name of lender 2 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6085_C + tab + T_FV_6085_M);
					}
				}
				else
				{
					if( (LenderPan2.equals(FIELD_NULL) || LenderPan2.equals(FIELD_SEPERATOR))  )
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + " Name of lender 2 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6085_C + tab + T_FV_6085_M);
					}	

					else if (LenderName2.length() <= 75 )
					{

						if(!obj_FieldValidation.checkNonSpecialCharacter(LenderName2) || obj_FieldValidation.isNumber(LenderName2)|| obj_FieldValidation.isNumeric(LenderName2)){
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + " Name of lender 2 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6085_C + tab + T_FV_6085_M);	
						}
						if (obj_FieldValidation.isValidCharString(LenderName2))
						{
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + " Name of lender 2 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6085_C + tab + T_FV_6085_M);
						}


					}
					else
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + " Name of lender 2 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6085_C + tab + T_FV_6085_M);


				} 
				// End :: Validating LenderName2 ::  for FVU5.2

				// Validating LenderPan3 ::  for FVU5.2 



				if(!(LenderPan3.equals(FIELD_NULL) || LenderPan3.equals(FIELD_SEPERATOR) || LenderPan3.trim().length() == 0))
				{
					if( !"Y".equals(WhethrInterestPaidLender) || Integer.parseInt(FinancialYr) < 201617 || !((TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A") ) || UploadType.equals(UPLOADTYPE_REGULAR))  )
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "PAN of lender 3 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6086_C + tab + T_FV_6086_M);
					}

					else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
						if(!(LenderPan3.equals(FIELD_NULL)||LenderPan3.equals(FIELD_SEPERATOR))){
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "PAN of lender 3 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6086_C + tab + T_FV_6086_M);
						}
					}
					else if(WhethrInterestPaidLender.equals("Y") && Integer.parseInt(FinancialYr) >=201617 && ((TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A") ) || UploadType.equals(UPLOADTYPE_REGULAR)) )
					{
						if (!LenderPan3.equals(PAN_NOT_AVAILABLE) && !LenderPan3.equals(PAN_APPLIED) && !LenderPan3.equals(PAN_INVALID))
						{
							if (LenderPan3.length() == 10 && LenderPan3.trim().length() == 10)
							{
								if (!LenderPan3.equals(GOVERNMENT) && !LenderPan3.equals(NON_RESDENT) && !LenderPan3.equals(OTHER_VALUE) ) // IF condition Added by shruti FVU 5.5
								{
									if (obj_FieldValidation.checkPan(LenderPan3))
									{ 
										Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "PAN of lender 3" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6086_C + tab + T_FV_6086_M);
									}
								}
							}
							else
								Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "PAN of lender 3" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6086_C + tab + T_FV_6086_M);

						}
						else
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "PAN of lender 3" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6086_C + tab + T_FV_6086_M);

					}
					else
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "PAN of lender 3" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6086_C + tab + T_FV_6086_M);

				}

				// End :: Validating LenderPan3 ::  for FVU5.2


				// Validating LenderName3 ::  for FVU5.2 

				if (LenderName3.equals(FIELD_NULL) || LenderName3.equals(FIELD_SEPERATOR) || LenderName3.trim().length() == 0)
				{
					if( !(LenderPan3.equals(FIELD_NULL) || LenderPan3.equals(FIELD_SEPERATOR)) )
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Name of lender 3 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6087_C + tab + T_FV_6087_M);
					}		
				}	
				else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
					if(!(LenderName3.equals(FIELD_NULL)||LenderName3.equals(FIELD_SEPERATOR))){
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + " Name of lender 3 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6087_C + tab + T_FV_6087_M);
					}
				}
				else
				{
					if( LenderPan3.equals(FIELD_NULL) || LenderPan3.equals(FIELD_NULL)  )
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Name of lender 3 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6087_C + tab + T_FV_6087_M);
					}	

					else if (LenderName3.length() <= 75 )
					{

						if(!obj_FieldValidation.checkNonSpecialCharacter(LenderName3) || obj_FieldValidation.isNumber(LenderName3) || obj_FieldValidation.isNumeric(LenderName3)){
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + " Name of lender 3 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6087_C + tab + T_FV_6087_M);
						}
						if (obj_FieldValidation.isValidCharString(LenderName3))
						{
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + " Name of lender 3 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6087_C + tab + T_FV_6087_M);
						}


					}
					else
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + " Name of lender 3 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6087_C + tab + T_FV_6087_M);


				} 
				// End :: Validating LenderName3 ::  for FVU5.2


				// Validating LenderPan4 ::  for FVU5.2 


				if(! (LenderPan4.equals(FIELD_NULL) || LenderPan4.equals(FIELD_SEPERATOR) || LenderPan4.trim().length() == 0))
				{
					if( !"Y".equals(WhethrInterestPaidLender) || Integer.parseInt(FinancialYr) < 201617 || !((TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A") ) || UploadType.equals(UPLOADTYPE_REGULAR))  )
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "PAN of lender 4 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6088_C + tab + T_FV_6088_M);
					}

					else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
						if(!(LenderPan4.equals(FIELD_NULL)||LenderPan4.equals(FIELD_SEPERATOR))){
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "PAN of lender 4 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6088_C + tab + T_FV_6088_M);
						}
					}

					else if(WhethrInterestPaidLender.equals("Y") && Integer.parseInt(FinancialYr) >=201617 && ((TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A") ) || UploadType.equals(UPLOADTYPE_REGULAR)) )
					{
						if (!LenderPan4.equals(PAN_NOT_AVAILABLE) && !LenderPan4.equals(PAN_APPLIED) && !LenderPan4.equals(PAN_INVALID))
						{
							if (LenderPan4.length() == 10 && LenderPan4.trim().length() == 10)
							{
								if (!LenderPan4.equals(GOVERNMENT) && !LenderPan4.equals(NON_RESDENT) && !LenderPan4.equals(OTHER_VALUE) ) // IF condition Added by shruti FVU 5.5
								{
									if (obj_FieldValidation.checkPan(LenderPan4))
									{ 
										Str_Buffer.append(LineNo + tab + v_upload_Type + tab + " PAN of lender 4 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6088_C + tab + T_FV_6088_M);
									}
								}
							}
							else
								Str_Buffer.append(LineNo + tab + v_upload_Type + tab + " PAN of lender 4 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6088_C + tab + T_FV_6088_M);
						}
						else
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + " PAN of lender 4 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6088_C + tab + T_FV_6088_M);

					}
					else
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + " PAN of lender 4 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6088_C + tab + T_FV_6088_M);

				}

				// End :: Validating LenderPan4 ::  for FVU5.2


				// Validating LenderName4 ::  for FVU5.2 

				if (LenderName4.equals(FIELD_NULL) || LenderName4.equals(FIELD_SEPERATOR) || LenderName4.trim().length() == 0)
				{
					if( !(LenderPan4.equals(FIELD_NULL) || LenderPan4.equals(FIELD_SEPERATOR)) )
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + " Name of lender 4 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6089_C + tab + T_FV_6089_M);
					}		
				}	
				else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
					if(!(LenderName4.equals(FIELD_NULL)||LenderName4.equals(FIELD_SEPERATOR))){
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + " Name of lender 4" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6089_C + tab + T_FV_6089_M);
					}
				}
				else
				{
					if( LenderPan4.equals(FIELD_NULL) || LenderPan4.equals(FIELD_SEPERATOR) )
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + " Name of lender 4 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6089_C + tab + T_FV_6089_M);
					}	

					else if (LenderName4.length() <= 75 )
					{
						if(!obj_FieldValidation.checkNonSpecialCharacter(LenderName4) || obj_FieldValidation.isNumber(LenderName4) || obj_FieldValidation.isNumeric(LenderName4)){
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + " Name of lender 4 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6089_C + tab + T_FV_6089_M);
						}
						if (obj_FieldValidation.isValidCharString(LenderName4))
						{
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + " Name of lender 4 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6089_C + tab + T_FV_6089_M);
						}


					}
					else
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + " Name of lender 4 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6089_C + tab + T_FV_6089_M);


				} 
				// End :: Validating LenderName4 ::  for FVU5.2

				//Validating WhethrContribtnPaidByTrusty
				// Whether contributions paid by the trustees of an approved superannuation fund


				if (WhethrContribtnPaidByTrusty.equals(FIELD_NULL) || WhethrContribtnPaidByTrusty.equals(FIELD_SEPERATOR) || WhethrContribtnPaidByTrusty.trim().length() == 0)
				{
					if(Integer.parseInt(FinancialYr) >=201314 && ((TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A") ) || UploadType.equals(UPLOADTYPE_REGULAR)))
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Whether contributions paid by the trustees of an approved superannuation fund " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6090_C + tab + T_FV_6090_M);
					}
				}
				else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
					if(!(WhethrContribtnPaidByTrusty.equals(FIELD_NULL)||WhethrContribtnPaidByTrusty.equals(FIELD_SEPERATOR))){
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Whether contributions paid by the trustees of an approved superannuation fund " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6090_C + tab + T_FV_6090_M);
					}
				}
				else
				{
					if (Integer.parseInt(FinancialYr) >= 201314 && ((TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A") ) || UploadType.equals(UPLOADTYPE_REGULAR)) )
					{
						if (!(WhethrContribtnPaidByTrusty.equals("Y") || WhethrContribtnPaidByTrusty.equals("N")) )
						{
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Whether contributions paid by the trustees of an approved superannuation fund " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6090_C + tab + T_FV_6090_M);
						}
					}
					else
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Whether contributions paid by the trustees of an approved superannuation fund " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6090_C + tab + T_FV_6090_M);

				}	


				// End :: Validating WhethrContribtnPaidByTrusty

				//Validating NameOfSuperannuationFund

				if (NameOfSuperannuationFund.equals(FIELD_NULL) || NameOfSuperannuationFund.equals(FIELD_SEPERATOR) || NameOfSuperannuationFund.trim().length() == 0)
				{
					if( (!"N".equals(WhethrContribtnPaidByTrusty) && !(WhethrContribtnPaidByTrusty.equals(FIELD_NULL) || WhethrContribtnPaidByTrusty.equals(FIELD_SEPERATOR))) && (Integer.parseInt(FinancialYr) >= 201314 && ((TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A") ) || UploadType.equals(UPLOADTYPE_REGULAR))))
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Name of the superannuation fund " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6091_C + tab + T_FV_6091_M);

					}

				}
				else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
					if(!(NameOfSuperannuationFund.equals(FIELD_NULL)||NameOfSuperannuationFund.equals(FIELD_SEPERATOR))){
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Name of the superannuation fund" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6091_C + tab + T_FV_6091_M);
					}
				}

				else
				{
					if(!("Y".equals(WhethrContribtnPaidByTrusty)))
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Name of the superannuation fund" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6091_C + tab + T_FV_6091_M);
					} 
					else if ( "Y".equals(WhethrContribtnPaidByTrusty) && (Integer.parseInt(FinancialYr) >= 201314 &&( ( TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A") ) || UploadType.equals(UPLOADTYPE_REGULAR))))
					{
						if (NameOfSuperannuationFund.length() > 75)
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Name of the superannuation fund" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6091_C + tab + T_FV_6091_M);

						else if (obj_FieldValidation.isValidCharString(NameOfSuperannuationFund))
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Name of the superannuation fund" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6091_C + tab + T_FV_6091_M);

					}
					else
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Name of the superannuation fund" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6091_C + tab + T_FV_6091_M);


				}


				//End : Validating NameOfSuperannuationFund




				// Validating StartDate

				if (StartDate.equals(FIELD_NULL) || StartDate.equals(FIELD_SEPERATOR) || StartDate.trim().length() == 0)
				{
					if( (!"N".equals(WhethrContribtnPaidByTrusty) && !(WhethrContribtnPaidByTrusty.equals(FIELD_NULL) || WhethrContribtnPaidByTrusty.equals(FIELD_SEPERATOR)) ) && (Integer.parseInt(FinancialYr) >= 201314 && ( (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A") )  || UploadType.equals(UPLOADTYPE_REGULAR))))
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Date from which the employee has contributed to the superannuation fund" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6092_C + tab + T_FV_6092_M);
					}
				}
				else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
					if(!(StartDate.equals(FIELD_NULL)||StartDate.equals(FIELD_SEPERATOR))){
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Date from which the employee has contributed to the superannuation fund" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6092_C + tab + T_FV_6092_M);
					}
				}
				else
				{
					if(!("Y".equals(WhethrContribtnPaidByTrusty)))
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Date from which the employee has contributed to the superannuation fund" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6092_C + tab + T_FV_6092_M);
					} 
					else if ( "Y".equals(WhethrContribtnPaidByTrusty) && (Integer.parseInt(FinancialYr) >= 201314 &&  ((TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A"))  || UploadType.equals(UPLOADTYPE_REGULAR))))
					{
						if ((obj_FieldValidation.isDate(StartDate)) )
						{
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Date from which the employee has contributed to the superannuation fund " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6092_C + tab + T_FV_6092_M);
						}
					}
					else
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Date from which the employee has contributed to the superannuation fund " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6092_C + tab + T_FV_6092_M);

				}	

				// end :: Validating StartDate


				// Validating EndDate

				if (EndDate.equals(FIELD_NULL) || EndDate.equals(FIELD_SEPERATOR) || EndDate.trim().length() == 0)
				{

					if( (!"N".equals(WhethrContribtnPaidByTrusty) && !(WhethrContribtnPaidByTrusty.equals(FIELD_NULL) || WhethrContribtnPaidByTrusty.equals(FIELD_SEPERATOR)) ) && (Integer.parseInt(FinancialYr) >= 201314 && (( TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A") ) || UploadType.equals(UPLOADTYPE_REGULAR)) ))
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Date to which the employee has contributed to the superannuation fund" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6093_C + tab + T_FV_6093_M);
					}
				}
				else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
					if(!(EndDate.equals(FIELD_NULL)||EndDate.equals(FIELD_SEPERATOR))){
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Date to which the employee has contributed to the superannuation fund" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6093_C + tab + T_FV_6093_M);
					}
				}
				else
				{

					if(!("Y".equals(WhethrContribtnPaidByTrusty)))
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Date to which the employee has contributed to the superannuation fund" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6093_C + tab + T_FV_6093_M);
					} 
					else if ("Y".equals(WhethrContribtnPaidByTrusty) && Integer.parseInt(FinancialYr) >= 201314 && ((TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A") ) || UploadType.equals(UPLOADTYPE_REGULAR)))
					{
						if ((obj_FieldValidation.isDate(EndDate)) )
						{
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Date to which the employee has contributed to the superannuation fund" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6093_C + tab + T_FV_6093_M);
						}
					}
					else
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Date to which the employee has contributed to the superannuation fund" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6093_C + tab + T_FV_6093_M);

				}	

				// end :: Validating EndDate

				// Validation for From date and To Date 

				if(!(StartDate.equals(FIELD_NULL) || StartDate.equals(FIELD_SEPERATOR)) && !(EndDate.equals(FIELD_NULL) || EndDate.equals(FIELD_SEPERATOR)) )
				{
					if (!(obj_FieldValidation.isDate(StartDate)) && !(obj_FieldValidation.isDate(EndDate))  )
					{
						Calendar today = Calendar.getInstance();
						Calendar cal_StartDate =
								new GregorianCalendar(
										Integer.parseInt(StartDate.substring(4)),
										Integer.parseInt(StartDate.substring(2, 4)) - 1,
										Integer.parseInt(StartDate.substring(0, 2)));


						Calendar cal_EndDate =
								new GregorianCalendar(
										Integer.parseInt(EndDate.substring(4)),
										Integer.parseInt(EndDate.substring(2, 4)) - 1,
										Integer.parseInt(EndDate.substring(0, 2)));

						int datecompare =cal_StartDate.compareTo(cal_EndDate);

						if ( (cal_StartDate.before(today) && cal_EndDate.before(today)) )
						{
							System.out.println("datecompare "+datecompare);
							if(datecompare == 0 ||  datecompare == 1)
							{
								Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Date from which the employee has contributed to the superannuation fund " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6092_C + tab + T_FV_6092_M);

							}
						}
					}
					else
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Date to which the employee has contributed to the superannuation fund" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6093_C + tab + T_FV_6093_M);

				}
				// Validating AmountOfRepaidOnAccountOfPrincipalAndInterest

				if (AmountOfRepaidOnAccountOfPrincipalAndInterest.equals(FIELD_NULL) || AmountOfRepaidOnAccountOfPrincipalAndInterest.equals(FIELD_SEPERATOR) || AmountOfRepaidOnAccountOfPrincipalAndInterest.trim().length() == 0)
				{
					if((!"N".equals(WhethrContribtnPaidByTrusty) && !( WhethrContribtnPaidByTrusty.equals(FIELD_NULL) || WhethrContribtnPaidByTrusty.equals(FIELD_SEPERATOR)) ) && (Integer.parseInt(FinancialYr) >= 201314 && (( TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A") ) || UploadType.equals(UPLOADTYPE_REGULAR))))
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "The amount of contribution repaid on account of principal and interest from superannuation fund" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6094_C + tab + T_FV_6094_M);
					}
				}
				else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
					if(!(AmountOfRepaidOnAccountOfPrincipalAndInterest.equals(FIELD_NULL)||AmountOfRepaidOnAccountOfPrincipalAndInterest.equals(FIELD_SEPERATOR))){
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "The amount of contribution repaid on account of principal and interest from superannuation fund" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6094_C + tab + T_FV_6094_M);
					}
				}
				else
				{
					if(!("Y".equals(WhethrContribtnPaidByTrusty)))
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "The amount of contribution repaid on account of principal and interest from superannuation fund" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6094_C + tab + T_FV_6094_M);
					} 
					else if ("Y".equals(WhethrContribtnPaidByTrusty) &&  (Integer.parseInt(FinancialYr) >= 201314 && (( TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A")) || UploadType.equals(UPLOADTYPE_REGULAR) )) )
					{
						if(obj_FieldValidation.isNumeric(AmountOfRepaidOnAccountOfPrincipalAndInterest))
						{
							if( AmountOfRepaidOnAccountOfPrincipalAndInterest.length()>15 || !( Double.parseDouble(AmountOfRepaidOnAccountOfPrincipalAndInterest) > 0) )
							{
								Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "The amount of contribution repaid on account of principal and interest from superannuation fund" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6094_C + tab + T_FV_6094_M);
							}
						}
						else
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "The amount of contribution repaid on account of principal and interest from superannuation fund" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6094_C + tab + T_FV_6094_M);

					}
					else
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "The amount of contribution repaid on account of principal and interest from superannuation fund" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6094_C + tab + T_FV_6094_M);

				}	
				//End : Validating AmountOfRepaidOnAccountOfPrincipalAndInterest



				// Validating AvgRateOfdeductionOfTaxforLastThreeYears
				if (AvgRateOfdeductionOfTaxforLastThreeYears.equals(FIELD_NULL) || AvgRateOfdeductionOfTaxforLastThreeYears.equals(FIELD_SEPERATOR) || AvgRateOfdeductionOfTaxforLastThreeYears.trim().length() == 0)
				{
					if((!"N".equals(WhethrContribtnPaidByTrusty) && !( WhethrContribtnPaidByTrusty.equals(FIELD_NULL) || WhethrContribtnPaidByTrusty.equals(FIELD_SEPERATOR))) && (Integer.parseInt(FinancialYr) >= 201314 && (( TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A") ) || UploadType.equals(UPLOADTYPE_REGULAR))))
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "The average rate of deduction of tax during the preceding three years" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6095_C + tab + T_FV_6095_M);
					}
				}
				else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
					if(!(AvgRateOfdeductionOfTaxforLastThreeYears.equals(FIELD_NULL)||AvgRateOfdeductionOfTaxforLastThreeYears.equals(FIELD_SEPERATOR))){
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "The average rate of deduction of tax during the preceding three years" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6095_C + tab + T_FV_6095_M);
					}
				}

				else
				{
					//System.out.println("WhethrContribtnPaidByTrusty  :"+WhethrContribtnPaidByTrusty);
					if(!("Y".equals(WhethrContribtnPaidByTrusty)))
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "The average rate of deduction of tax during the preceding three years" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6095_C + tab + T_FV_6095_M);
					} 
					else if ( "Y".equals(WhethrContribtnPaidByTrusty) && Integer.parseInt(FinancialYr) >= 201314 && ((TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A") ) || UploadType.equals(UPLOADTYPE_REGULAR)))
					{
						if(obj_FieldValidation.isNumeric(AvgRateOfdeductionOfTaxforLastThreeYears))
						{
							if(AvgRateOfdeductionOfTaxforLastThreeYears.length() <=7 && obj_FieldValidation.isInt(AvgRateOfdeductionOfTaxforLastThreeYears))
							{

								String[] mySplit = AvgRateOfdeductionOfTaxforLastThreeYears.split("\\.");

								BigDecimal decimal = new BigDecimal(mySplit[0]);
								BigDecimal real = new BigDecimal(AvgRateOfdeductionOfTaxforLastThreeYears);
								BigDecimal fraction = real.subtract(decimal);

								String[] splitter = fraction.toString().split("\\.");
								if (splitter[1].toString().length() != 4  )
								{
									Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "The average rate of deduction of tax during the preceding three years" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6095_C + tab + T_FV_6095_M);
								}
							}
							else
								Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "The average rate of deduction of tax during the preceding three years" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6095_C + tab + T_FV_6095_M);
						}
						else
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "The average rate of deduction of tax during the preceding three years" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6095_C + tab + T_FV_6095_M);

					}
					else
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "The average rate of deduction of tax during the preceding three years" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6095_C + tab + T_FV_6095_M);

				}	

				// End :: Validating AvgRateOfdeductionOfTaxforLastThreeYears


				// Validating AmountOfTaxDeductedOnRepayment



				double value = 0;
				if(obj_FieldValidation.isNumeric(AmountOfRepaidOnAccountOfPrincipalAndInterest) && obj_FieldValidation.isNumeric(AvgRateOfdeductionOfTaxforLastThreeYears) )
				{
					if(!(AvgRateOfdeductionOfTaxforLastThreeYears.equals(FIELD_NULL) || AvgRateOfdeductionOfTaxforLastThreeYears.equals(FIELD_SEPERATOR)) && !(AmountOfRepaidOnAccountOfPrincipalAndInterest.equals(FIELD_NULL) || AmountOfRepaidOnAccountOfPrincipalAndInterest.equals(FIELD_SEPERATOR)))
						value = (Double.parseDouble(AvgRateOfdeductionOfTaxforLastThreeYears) * Double.parseDouble(AmountOfRepaidOnAccountOfPrincipalAndInterest)/100);
				}

				if (AmountOfTaxDeductedOnRepayment.equals(FIELD_NULL) || AmountOfTaxDeductedOnRepayment.equals(FIELD_SEPERATOR) || AmountOfTaxDeductedOnRepayment.trim().length() == 0)
				{
					if((!"N".equals(WhethrContribtnPaidByTrusty) && !( WhethrContribtnPaidByTrusty.equals(FIELD_NULL) || WhethrContribtnPaidByTrusty.equals(FIELD_SEPERATOR))) &&(Integer.parseInt(FinancialYr) >= 201314 && ((TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A") ) || UploadType.equals(UPLOADTYPE_REGULAR))))
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "The amount of tax deducted on repayment of superannuation fund" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6096_C + tab + T_FV_6096_M);
					}
				}
				else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
					if(!(AmountOfTaxDeductedOnRepayment.equals(FIELD_NULL)||AmountOfTaxDeductedOnRepayment.equals(FIELD_SEPERATOR))){
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "The amount of tax deducted on repayment of superannuation fund" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6096_C + tab + T_FV_6096_M);
					}
				}
				else
				{
					if(!("Y".equals(WhethrContribtnPaidByTrusty)))
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "The amount of tax deducted on repayment of superannuation fund" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6096_C + tab + T_FV_6096_M);
					} 
					// added for FVU 5.5
					else  if (Double.parseDouble(AvgRateOfdeductionOfTaxforLastThreeYears) == 0) {

						if ( Double.parseDouble(AmountOfTaxDeductedOnRepayment) > 0){

							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "The amount of tax deducted on repayment of superannuation fund" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6096_C + tab + T_FV_6096_M);

						}
					}
					// ended for FVU 5.5	
					else if ( Integer.parseInt(FinancialYr) >= 201314 && ((TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A") ) || UploadType.equals(UPLOADTYPE_REGULAR)))
					{
						if(obj_FieldValidation.isNumeric(AmountOfTaxDeductedOnRepayment))
						{
							if(AmountOfTaxDeductedOnRepayment.length() <=15)
							{
								if (!( Double.parseDouble(AmountOfTaxDeductedOnRepayment) >= 0) ) // added >= for FVU 5.5
								{
									Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "The amount of tax deducted on repayment of superannuation fund" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6096_C + tab + T_FV_6096_M);
								}

								else if (!(value == Double.parseDouble(AmountOfTaxDeductedOnRepayment) ||( ( Double.parseDouble(AmountOfTaxDeductedOnRepayment) >= (value-10)) && (Double.parseDouble(AmountOfTaxDeductedOnRepayment) <= (value+10))) ) )
								{
									Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "The amount of tax deducted on repayment of superannuation fund" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6096_C + tab + T_FV_6096_M);
								}
							}
							else
								Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "The amount of tax deducted on repayment of superannuation fund" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6096_C + tab + T_FV_6096_M);
						}
						else
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "The amount of tax deducted on repayment of superannuation fund" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6096_C + tab + T_FV_6096_M);


					}

					else
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "The amount of tax deducted on repayment of superannuation fund" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6096_C + tab + T_FV_6096_M);

				}	

				// End ::  Validating AmountOfTaxDeductedOnRepayment

				//added  for FVU 5.2 For 29th Field 
						if("Y".equals(WhethrContribtnPaidByTrusty) && Integer.parseInt(FinancialYr) >= 201314 && ((TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A") ) || UploadType.equals(UPLOADTYPE_REGULAR)))
				{
					if(!(TotTDSWholeYear.equals(FIELD_NULL) || TotTDSWholeYear.equals(FIELD_SEPERATOR)) && !(TDSCurEmp.equals(FIELD_NULL) || TDSCurEmp.equals(FIELD_SEPERATOR)) && !(TDSPreEmp.equals(FIELD_NULL) || TDSPreEmp.equals(FIELD_SEPERATOR)) && !(AmountOfTaxDeductedOnRepayment.equals(FIELD_NULL) || AmountOfTaxDeductedOnRepayment.equals(FIELD_SEPERATOR)))
					{
						if(!obj_FieldValidation.isDecimalNumber(TotTDSWholeYear) && !obj_FieldValidation.isDecimalNumber(TDSCurEmp) && !obj_FieldValidation.isDecimalNumber(TDSPreEmp) &&  !obj_FieldValidation.isDecimalNumber(AmountOfTaxDeductedOnRepayment) )
							if(!((Double.parseDouble(TotTDSWholeYear.trim()))==(Double.parseDouble(TDSCurEmp.trim()) + Double.parseDouble(TDSPreEmp.trim()) + Double.parseDouble(AmountOfTaxDeductedOnRepayment) )) && Integer.parseInt(FinancialYr)>=201314)
								Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Total Amount of Tax Deducted at source for the whole year" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4327_C + tab + T_FV_4327_M);
					}
				}
				else
				{
					if(!(TotTDSWholeYear.equals(FIELD_NULL) || TotTDSWholeYear.equals(FIELD_SEPERATOR)) && !(TDSCurEmp.equals(FIELD_NULL) || TDSCurEmp.equals(FIELD_SEPERATOR)) && !(TDSPreEmp.equals(FIELD_NULL) || TDSPreEmp.equals(FIELD_SEPERATOR)))
					{
						if(!obj_FieldValidation.isDecimalNumber(TotTDSWholeYear) && !obj_FieldValidation.isDecimalNumber(TDSCurEmp) && !obj_FieldValidation.isDecimalNumber(TDSPreEmp) )
							if(!((Double.parseDouble(TotTDSWholeYear.trim()))==(Double.parseDouble(TDSCurEmp.trim()) + Double.parseDouble(TDSPreEmp.trim()))) && Integer.parseInt(FinancialYr)>=201314)
								Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Total Amount of Tax Deducted at source for the whole year" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4327_C + tab + T_FV_4327_M);
					}

				}
				// End :: added  for FVU 5.2 For 29th Field  


				//Validating GrossTotalIncomeFromSuperannuationFund

				if (GrossTotalIncomeFromSuperannuationFund.equals(FIELD_NULL) || GrossTotalIncomeFromSuperannuationFund.equals(FIELD_SEPERATOR) || GrossTotalIncomeFromSuperannuationFund.trim().length() == 0)
				{
					if( (!"N".equals(WhethrContribtnPaidByTrusty)  && !( WhethrContribtnPaidByTrusty.equals(FIELD_NULL) || WhethrContribtnPaidByTrusty.equals(FIELD_SEPERATOR)) ) && ( Integer.parseInt(FinancialYr) >= 201314 &&  ((TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A") ) || UploadType.equals(UPLOADTYPE_REGULAR))) )
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Gross total income including contribution repaid on account of principal and interest from superannuation fund" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6097_C + tab + T_FV_6097_M);
					}
				}

				else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D")){
					if(!(GrossTotalIncomeFromSuperannuationFund.equals(FIELD_NULL)||GrossTotalIncomeFromSuperannuationFund.equals(FIELD_SEPERATOR))){
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Gross total income including contribution repaid on account of principal and interest from superannuation fund" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6097_C + tab + T_FV_6097_M);
					}
				}

				else
				{
					if( !("Y".equals(WhethrContribtnPaidByTrusty)) )
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Gross total income including contribution repaid on account of principal and interest from superannuation fund" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6097_C + tab + T_FV_6097_M);
					}
					else if("Y".equals(WhethrContribtnPaidByTrusty) && Integer.parseInt(FinancialYr) >= 201314 && (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A") ) || UploadType.equals(UPLOADTYPE_REGULAR))
					{
						if(obj_FieldValidation.isNumeric(AmountOfRepaidOnAccountOfPrincipalAndInterest) && obj_FieldValidation.isNumeric(GrossTotalIncomeFromSuperannuationFund) && obj_FieldValidation.isNumeric(GrossTotIncome) )
						{
							if(GrossTotalIncomeFromSuperannuationFund.length()<=15)
							{
								if(!( Double.parseDouble(GrossTotalIncomeFromSuperannuationFund) >0 ))
								{
									Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Gross total income including contribution repaid on account of principal and interest from superannuation fund" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6097_C + tab + T_FV_6097_M);
								}
								else if( !(AmountOfRepaidOnAccountOfPrincipalAndInterest.equals(FIELD_NULL) || AmountOfRepaidOnAccountOfPrincipalAndInterest.equals(FIELD_SEPERATOR) ) && !(GrossTotIncome.equals(FIELD_NULL) || GrossTotIncome.equals(FIELD_SEPERATOR) ))
								{
									if( ! (Double.parseDouble(GrossTotalIncomeFromSuperannuationFund) == Double.parseDouble(AmountOfRepaidOnAccountOfPrincipalAndInterest)+ Double.parseDouble(GrossTotIncome))  )
									{
										Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Gross total income including contribution repaid on account of principal and interest from superannuation fund" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6097_C + tab + T_FV_6097_M); 
									}
								}
							}
							else
								Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Gross total income including contribution repaid on account of principal and interest from superannuation fund" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6097_C + tab + T_FV_6097_M); 

						}
						else
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Gross total income including contribution repaid on account of principal and interest from superannuation fund" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6097_C + tab + T_FV_6097_M); 

					}
					else
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Gross total income including contribution repaid on account of principal and interest from superannuation fund" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6097_C + tab + T_FV_6097_M); 



				}

				// End :: GrossTotalIncomeFromSuperannuationFund



			}
			else
			{
				if (!TaxblAmtCurEmp.equals(FIELD_NULL) && !TaxblAmtCurEmp.equals(FIELD_SEPERATOR))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Taxable Amount of current employer" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4317_C + tab + T_FV_4317_M);
				if (!TaxblAmtPreEmp.equals(FIELD_NULL) && !TaxblAmtPreEmp.equals(FIELD_SEPERATOR))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Reported Taxable Amount of previous employer" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4317_C + tab + T_FV_4317_M);
				if (!TDSCurEmp.equals(FIELD_NULL) && !TDSCurEmp.equals(FIELD_SEPERATOR))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Total TDS of current employer" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4317_C + tab + T_FV_4317_M);
				if (!TDSPreEmp.equals(FIELD_NULL) && !TDSPreEmp.equals(FIELD_SEPERATOR))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Reported TDS of previous employer" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4317_C + tab + T_FV_4317_M);
				if (!WhethrTaxDedAtHighrRate.equals(FIELD_NULL) && !WhethrTaxDedAtHighrRate.equals(FIELD_SEPERATOR))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Whether tax deducted at Higher rate due to non furnishing of PAN by deductee" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4317_C + tab + T_FV_4317_M);

				//added For FVU 5.2

				if(!(WhethrContribtnPaidByTrusty.equals(FIELD_NULL) || WhethrContribtnPaidByTrusty.equals(FIELD_SEPERATOR)))
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Whether contributions paid by the trustees of an approved superannuation fund 1" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6090_C + tab + T_FV_6090_M);

				}

				if(!(NameOfSuperannuationFund.equals(FIELD_NULL) || NameOfSuperannuationFund.equals(FIELD_SEPERATOR)))
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Name of the superannuation fund " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6091_C + tab + T_FV_6091_M);
				}

				if(!(StartDate.equals(FIELD_NULL) || StartDate.equals(FIELD_SEPERATOR)))
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Date from which the employee has contributed to the superannuation fund" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6092_C + tab + T_FV_6092_M);
				}

				if(!(EndDate.equals(FIELD_NULL) || EndDate.equals(FIELD_SEPERATOR)))
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Date to which the employee has contributed to the superannuation fund" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6093_C + tab + T_FV_6093_M);
				}

				if(!(AmountOfRepaidOnAccountOfPrincipalAndInterest.equals(FIELD_NULL) || AmountOfRepaidOnAccountOfPrincipalAndInterest.equals(FIELD_SEPERATOR)))
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "The amount of contribution repaid on account of principal and interest from superannuation fund" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6094_C + tab + T_FV_6094_M);
				}

				if(!(AvgRateOfdeductionOfTaxforLastThreeYears.equals(FIELD_NULL) || AvgRateOfdeductionOfTaxforLastThreeYears.equals(FIELD_SEPERATOR)))
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "The average rate of deduction of tax during the preceding three years" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6095_C + tab + T_FV_6095_M);
				}

				if(!(AmountOfTaxDeductedOnRepayment.equals(FIELD_NULL) || AmountOfTaxDeductedOnRepayment.equals(FIELD_SEPERATOR)))
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "The amount of tax deducted on repayment of superannuation fund" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6096_C + tab + T_FV_6096_M);
				}

				if(!(GrossTotalIncomeFromSuperannuationFund.equals(FIELD_NULL) || GrossTotalIncomeFromSuperannuationFund.equals(FIELD_SEPERATOR)))
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Gross total income including contribution repaid on account of principal and interest from superannuation fund" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6097_C + tab + T_FV_6097_M); 
				}
				//end :: Added By FVU 5.2

			}

			//			Validating SectionCode




			// 		Checking if Summation of Gross Total Income specified at Batch Record equal to sum of Gross Total Income specified at deductee record
			if ((localCountOfSD == DeducteeCount) && !TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
			{
			
				double doubValSummationGrossTotIncome = Math.round((double) (SummationGrossTotIncome * 100)) / 100.0;
				if (doubValSummationGrossTotIncome != Double.parseDouble(GrossTotalIncomeSD.trim()))
				{
					Str_Buffer.append(lineNoOfBatchRec + tab + v_upload_Type + tab + "Batch Total of - Gross Total Income as per Salary Detail" + tab + tab + tab + T_FV_2092_C + tab + T_FV_2092_M);
				}
			}
			// 		Checking if Summation of Gross Total Income specified at Batch Record equal to sum of Gross Total Income specified at deductee record

		} //try
		catch (Exception e)
		{			
			throw e;
		}
		fvO.returnRecordType = RecType;
		return;
	} //method Validate deductee details for annual file format.

	private void validateRemark1(String TransactionType, String v_upload_Type, StringBufferTemp Str_Buffer,
			String LineNo, String Remark1, FieldValidation obj_FieldValidation) {
		if ((Remark1 == null || Remark1.trim().equals(FIELD_NULL) || Remark1.trim().equals(FIELD_SEPERATOR))
				&& ModeSD.equals("A")) {
			Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Aggregate amount of deductions admissible under section 80C, 80CCC and 80CCD(1)" + tab + "NA" + tab + CurrentlocalSDNumber
					+ tab + T_FV_6127_C + tab + T_FV_6127_M);
		} else if ((TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D"))
				|| TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN)) {
			if (!(Remark1.equals(FIELD_NULL) || Remark1.equals(FIELD_SEPERATOR))) {
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Aggregate amount of deductions admissible under section 80C, 80CCC and 80CCD(1)" + tab + "NA" + tab
						+ CurrentlocalSDNumber + tab + T_FV_2227_C + tab + T_FV_2227_M);
			}
		} else if (Remark1.trim().length() < 75) {

			if (obj_FieldValidation.isDecimalNumber(Remark1)) {

				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Aggregate amount of deductions admissible under section 80C, 80CCC and 80CCD(1)" + tab + "NA" + tab
						+ CurrentlocalSDNumber + tab + T_FV_6139_C + tab + T_FV_6139_M);

			} else if (Double.parseDouble(Remark1.trim()) > 150000) {
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Aggregate amount of deductions admissible under section 80C, 80CCC and 80CCD(1)" + tab + "NA" + tab
						+ CurrentlocalSDNumber + tab + T_FV_6129_C + tab + T_FV_6129_M);
			} else {
				aggrAmtOfDeductAdmiUndrSec80C_80CCC_80CCD_1 = Double.parseDouble(Remark1.trim());
			}
		} else
			Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Aggregate amount of deductions admissible under section 80C, 80CCC and 80CCD(1)" + tab + "NA" + tab + CurrentlocalSDNumber
					+ tab + T_FV_6139_C + tab + T_FV_6139_M);
	}


	//start:added for fvu 6.2 by jacky
	/**
	 * This method is used to validate fields for fin yr greater than 201819
	 * added for FVU 6.2
	 * @param v_upload_Type
	 * @param Str_Buffer
	 * @param LineNo
	 * @param currentlocalSDNumber
	 * @param fieldValue
	 * @param obj_FieldValidation
	 * @param addErrMsg
	 * @param errCode1
	 * @param errCode2
	 * @param errMsg1
	 * @param errMsg2
	 */ // Parameters added for FVU 7.1 - Vinita
	private boolean validateField6_2Onwards(String FinancialYr,String Qperiod,String v_upload_Type, StringBufferTemp Str_Buffer, String LineNo,String currentlocalSDNumber,
			String fieldValue, FieldValidation obj_FieldValidation, String addErrMsg, String errCode1, String errCode2,
			String errMsg1, String errMsg2,String whthrOptTax115BAC,String SecVIA_ID) {
		if (fieldValue.length() <= 15) {

			if (fieldValue.trim().equals(FIELD_NULL) || fieldValue.trim().equals(FIELD_SEPERATOR)
					|| fieldValue.trim().length() == 0) {
				
				// Added if condition for FVU 7.1 - Vinita --- Obs no 1 // Req updated 7.1 'Death cum Requirement' removed 10 Mar 2021 - Vinita
				if((addErrMsg.equalsIgnoreCase("Travel concession or assistance [section 10(5)]") ||
				   addErrMsg.equalsIgnoreCase("House rent allowance [section 10(13A)]") ||
				   (addErrMsg.equalsIgnoreCase("Total Gross amount under Chapter VI-A") ||  addErrMsg.equalsIgnoreCase("Total Qualifying amount under Chapter VI-A") && !SecVIA_ID.equalsIgnoreCase("80CCD(2)"))) &&
				   (Integer.parseInt(FinancialYr) == 202021 && (Qperiod.equals("Q4"))) || (Integer.parseInt(FinancialYr) > 202021 && (Qperiod.equals("Q1") || Qperiod.equals("Q2") || Qperiod.equals("Q3") || Qperiod.equals("Q4"))) &&
				   (whthrOptTax115BAC != null && whthrOptTax115BAC.equals("Y"))){
					return true; // changed  for FVU 7.1 Obs no 24 26 Mar 2021 - Vinita
				}
				else{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + addErrMsg + tab + "NA" + tab
						+ currentlocalSDNumber + tab + errCode1 + tab + errMsg1);
				return false;
				}
			} else if (obj_FieldValidation.isDecimalNumber(fieldValue) || (Double.parseDouble(fieldValue) < 0)) {

				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + addErrMsg + tab + "NA" + tab
						+ currentlocalSDNumber + tab + errCode2 + tab + errMsg2);
				return false;
			}

		}

		else {
			Str_Buffer.append(LineNo + tab + v_upload_Type + tab + addErrMsg + tab + "NA" + tab + currentlocalSDNumber
					+ tab + errCode2 + tab + errMsg2);
			return false;

		}
		return true;
	}

	/**
	 * This method is used to validate fields for fin yr upto 201819
	 * added for FVU 6.2
	 * @param v_upload_Type
	 * @param Str_Buffer
	 * @param LineNo
	 * @param currentlocalSDNumber
	 * @param fieldValue
	 * @param addErrMsg
	 */
	private void validateFieldFinYrUpto201819(String v_upload_Type,
			StringBufferTemp Str_Buffer, String LineNo,
			String currentlocalSDNumber, String fieldValue, String addErrMsg) {

		if (!(fieldValue == null || fieldValue.trim().equals(FIELD_NULL) || fieldValue.trim().equals(FIELD_SEPERATOR))) {

			Str_Buffer.append(LineNo + tab + v_upload_Type + tab + addErrMsg + tab + "NA" + tab + currentlocalSDNumber
					+ tab + T_FV_6100_C + tab + T_FV_6100_M);

			
		}
		
	}

	//end:added for fvu 6.2 by jacky


	//		//////////    Validate Salary Statement Record END ////////////////

	// Validate Annual Section 16 whthrOptTax115BAC //Parameter added for FVU 7.1
	private void validateSection16(
			String Section16,
			int LineCount,
			String BH_BatchNo,
			String DeducteeDetailRecNo,
			String Sec16Count,
			String Sec16TotalAmount,
			int section16ValidCount,
			boolean paperReturnFile,
			StringBufferTemp obj_StringBuffer,
			String v_upload_Type,String FinancialYr,String Qperiod,String TransactionType)
					throws Exception
	{
		StringBufferTemp Str_Buffer;
		Str_Buffer = obj_StringBuffer;

		boolean NullField = false;
		int Count_Section16_fields = 1;
		boolean FieldFound;
		boolean Caret = false;
		boolean localErrorFlag = false;

		try
		{
			String Sec16_LineNo = null;
			String Sec16_RecType = null;
			String Sec16_BatchNo = null;
			String Sec16_DeducteeDetailRecNo = null;
			String Sec16_RecordNo = null;
			String Sec16_ID = null;
			String Sec16_DeductionAmount = null;
			String Sec16_Hash = null;
			int Sec16_ia_DeductionAmount=40000;
			int Sec16_ia_DeductionAmount_201819_onwards =50000;

			FieldValidation obj_FieldValidation = new FieldValidation();

			StringTokenizer st_DD_Sec16 = new StringTokenizer(Section16, FIELD_SEPERATOR, true);
			
			//Added for FVU 7.1
			String whthrOptTax115BAC = "";
			
			if(wthrOptNewTaxRegimeIsY)
				whthrOptTax115BAC = "Y";
			else
				whthrOptTax115BAC = "";

			int caretCounter = 0;
			while (st_DD_Sec16.hasMoreTokens())
			{
				String val = st_DD_Sec16.nextToken();
				NullField = false;
				FieldFound = false;
				if ((val.equals(FIELD_SEPERATOR) && Caret) || val.trim().length() == 0)
				{
					NullField = true;
					FieldFound = true;
				}
				if (val.equals(FIELD_SEPERATOR))
				{
					Caret = true;
					if (caretCounter == 0 && Count_Section16_fields == 1)
					{
						Count_Section16_fields++;
						Sec16_LineNo = "";
					}
					caretCounter++;
				}
				else
				{
					Caret = false;
					FieldFound = true;
				}

				if (Count_Section16_fields > 8)
				{
					Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab + "Line_Number" + tab + tab + tab + T_FV_6001_C + tab + T_FV_6001_M);
					fvO.returnRecordType = RecType;
					return;
				}

				if (FieldFound)
				{
					switch (Count_Section16_fields)
					{
					case 1 :
						Sec16_LineNo = val;
						break;
					case 2 :
						Sec16_RecType = val;
						break;
					case 3 :
						Sec16_BatchNo = val;
						break;
					case 4 :
						Sec16_DeducteeDetailRecNo = val;
						break;
					case 5 :
						Sec16_RecordNo = val;
						break;
					case 6 :
						Sec16_ID = val;
						break;
					case 7 :
						Sec16_DeductionAmount = val;
						break;
					case 8 :
						Sec16_Hash = val;
						break;
					}
					Count_Section16_fields++;
				}
			}
			if (Sec16_DeductionAmount == null)
				Sec16_DeductionAmount = "";

			if (caretCounter != 7)
			{
				Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab + "Line_Number" + tab + tab + tab + T_FV_6001_C + tab + T_FV_6001_M);
				fvO.returnRecordType = RecType;
				return;
			}

			//validation starts 

			if (Sec16_LineNo.equals(FIELD_NULL) || Sec16_LineNo.equals(FIELD_SEPERATOR))
			{
				Str_Buffer.append("-" + tab + v_upload_Type + tab + "Line_Number" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6005_C + tab + T_FV_6005_M);
				Sec16_LineNo = "-";
			}
			else if (Sec16_LineNo.length() <= 9)
			{
				if (obj_FieldValidation.isInt(Sec16_LineNo))
				{
					Str_Buffer.append("-" + tab + v_upload_Type + tab + "Line_Number" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6005_C + tab + T_FV_6005_M);
					Sec16_LineNo = "-";
				}
				else if (Integer.parseInt(Sec16_LineNo.trim()) != LineCount)
				{
					Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab + "Line_Number" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6005_C + tab + T_FV_6005_M);
				}
			}
			else
			{
				Str_Buffer.append("-" + tab + v_upload_Type + tab + "Line_Number" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6005_C + tab + T_FV_6005_M);
				Sec16_LineNo = "-";
			}

			//	  check Sec16_LineNo
			//	  check RecType
			if (Sec16_RecType.equals(FIELD_NULL) || Sec16_RecType.equals(FIELD_SEPERATOR))
			{
				Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab + "Section 16 Detail Record Type" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6023_C + tab + T_FV_6023_M);
			}
			else if (!(Sec16_RecType.equals(SECTION16_HEADER_IDENTIFIER)))
			{
				Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab + "Section 16 Detail Record Type" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6023_C + tab + T_FV_6023_M);
			}
			//		check RecType

			//	  check BatchNo
			if (Sec16_BatchNo.equals(FIELD_NULL) || Sec16_BatchNo.equals(FIELD_SEPERATOR))
			{
				Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab + "Batch Number" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6007_C + tab + T_FV_6007_M);
			}
			else if (Sec16_BatchNo.length() <= 9)
			{
				if (obj_FieldValidation.isInt(Sec16_BatchNo))
				{
					Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab + "Batch Number" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6007_C + tab + T_FV_6007_M);
				}
				else if (Integer.parseInt(Sec16_BatchNo.trim()) != Integer.parseInt(BH_BatchNo.trim()))
				{
					Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab + "Batch Number" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6029_C + tab + T_FV_6029_M);
				}
			}
			else
			{
				Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab + "Batch Number" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6007_C + tab + T_FV_6007_M);
			}

			//				check BatchNo
			//		check Sec16_DeducteeDetailRecNo
			if (Sec16_DeducteeDetailRecNo.equals(FIELD_NULL) || Sec16_DeducteeDetailRecNo.equals(FIELD_SEPERATOR))
			{
				Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab + "Salary Detail Record No" + tab + "NA" + tab + "NULL" + tab + T_FV_6008_C + tab + T_FV_6008_M);

			}
			else if (Sec16_DeducteeDetailRecNo.length() <= 9)
			{
				if (obj_FieldValidation.isInt(Sec16_DeducteeDetailRecNo))
				{
					Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab + "Salary Detail Record No" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6008_C + tab + T_FV_6008_M);

				}
				else if (Integer.parseInt(Sec16_DeducteeDetailRecNo.trim()) != Integer.parseInt(DeducteeDetailRecNo.trim()))
				{
					Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab + "Salary Detail Record No" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6008_C + tab + T_FV_6008_M);

				}
			}
			else
			{
				Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab + "Salary Detail Record No" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6008_C + tab + T_FV_6008_M);
			}

			//	  check Sec16_DeducteeDetailRecNo

			//	check DeducteeDetailRecNo
			if (Sec16_RecordNo.equals(FIELD_NULL) || Sec16_RecordNo.equals(FIELD_SEPERATOR))
			{
				Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab + "Salary Detail  - Section 16 Details Record No" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6010_C + tab + T_FV_6010_M);
			}
			else if (Sec16_RecordNo.length() <= 9)
			{
				if (obj_FieldValidation.isInt(Sec16_RecordNo))
				{
					Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab + "Salary Detail  - Section 16 Details Record No" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6010_C + tab + T_FV_6010_M);
				}
				else if (section16ValidCount != Integer.parseInt(Sec16_RecordNo.trim()))
				{
					Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab + "Salary Detail  - Section 16 Details Record No" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6010_C + tab + T_FV_6010_M);
				}
			}
			else
			{
				Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab + "Salary Detail  - Section 16 Details Record No" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6010_C + tab + T_FV_6010_M);
			}

			//	  check DeducteeDetailRecNo

			//	check Section 16 I.D.
			boolean errUnique = false;
			boolean validSec16 = false;
			if (Sec16_ID.equals(FIELD_NULL) || Sec16_ID.equals(FIELD_SEPERATOR))
			{
				Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab + "section 16 section ID" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6013_C + tab + T_FV_6013_M);
			}
			else if (Sec16_ID.length() <= 15)
			{
				for (int localX = 0; localX < sec16Identification.length; localX++)
				{
					if (Sec16_ID.equals(sec16Identification[localX]))
					{
						validSec16 = true;
						break;
					}
				}
				/* 
				 * Code modified to allow default value 999 in sec ID for Paper Return , SD
				 */
				if (paperReturnFile)
				{
					if (Sec16_ID.equals(paperRetSecIDDefValue))
					{
						fvO.setPaperReturnRelax(true);
						Str_Buffer.appendPaperWarning(Sec16_LineNo + tab + BH_BatchNo + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6013_C + tab + T_FV_6013_M);
						validSec16 = true;
					}
				}
				if (validSec16 == false)
				{
					Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab + "section 16 section ID" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6013_C + tab + T_FV_6013_M);
				}

				if (validSec16)
				{
					for (int localI = 0; localI < section16ValidCount; localI++)
					{
						if (sec16Array[localI] != null && sec16Array[localI].equals(Sec16_ID))
						{
							errUnique = true;
							Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab + "section 16 section ID" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6025_C + tab + T_FV_6025_M);
							break;
						}
					}

					if (errUnique == false)
					{
						sec16Array[section16ValidCount - 1] = Sec16_ID;
					}
				}
				if (validSec16) // Added for FVU 5.8
				{
					if(Sec16_ID.equals("16(ia)") && Integer.parseInt(FinancialYr) < 201819 ){	

						Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab + "section 16 section ID" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6098_C + tab + T_FV_6098_M);

					}
				}
			}
			else
			{
				Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab + "section 16 section ID" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6013_C + tab + T_FV_6013_M);
			}

			//END	  check Section 16 I.D.

			// Check Total deduction Under sectionSection 16
			if (Sec16_DeductionAmount.equals(FIELD_NULL) || Sec16_DeductionAmount.equals(FIELD_SEPERATOR))
			{
				// Added if condition for FVU 7.1 - Obs no 11,12,13 - Vinita
				
				// FVU 7.1 Obs no 18 24 Mar 2021 - Vinita
				if( (TransactionType.equals(UPLOADTYPE_REGULAR) || (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A"))) 
						&& ((Integer.parseInt(FinancialYr) == 202021 && (Qperiod.equals("Q4"))) || (Integer.parseInt(FinancialYr) > 202021 && (Qperiod.equals("Q1") || Qperiod.equals("Q2") || Qperiod.equals("Q3") || Qperiod.equals("Q4")))) &&
				   (whthrOptTax115BAC.equals("Y"))){
					// no error to be thron if 'Y' is present in whthrOptTax115BAC
					localErrorFlag = true;
				}
				else{
					Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab + "Total Deduction under section 16" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6018_C + tab + T_FV_6018_M);
					localErrorFlag = true;
				}
			}
			//Added By amit for 4.5
			else if(Sec16_DeductionAmount.length()!=Sec16_DeductionAmount.trim().length())
			{
				Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab + "Total Deduction under section 16" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6018_C + tab + T_FV_6018_M);
				localErrorFlag = true;			
			}
			//Amit end for Fvu 4.5
			else if (Sec16_DeductionAmount.length() <= 15)
			{
				if (obj_FieldValidation.isDecimalNumber(Sec16_DeductionAmount))
				{
					Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab + "Total Deduction under section 16" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6018_C + tab + T_FV_6018_M);
					localErrorFlag = true;
				}
				//added for 6.1 by Jacky
				//Added by Puja for FVU 6.4:START
				else if(Sec16_ID.equals("16(ia)"))
				{
					if (Integer.parseInt(FinancialYr) <= 201819) {
						if ((Double.parseDouble(Sec16_DeductionAmount) > Sec16_ia_DeductionAmount)) {
							Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab
									+ "Total Deduction under section 16" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo
									+ tab + T_FV_6099_C + tab + T_FV_6099_M);
							localErrorFlag = true;
						}
					} else {
						if ((Double.parseDouble(Sec16_DeductionAmount) > Sec16_ia_DeductionAmount_201819_onwards)) {
							Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab
									+ "Total Deduction under section 16" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo
									+ tab + T_FV_6138_C + tab + T_FV_6138_M);
							localErrorFlag = true;
						}

					}

				}//Added by Puja for FVU 6.4:END
			}


			else
			{
				Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab + "Total Deduction under section 16" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6018_C + tab + T_FV_6018_M);
				localErrorFlag = true;
			}
			
			
			//FVU 7.1 - Vinita
			//if 79 field of SD record will be Y, no value to be mentioned under Total Deduction for 2020-21 and Quarter 4 onwards
			if(wthrOptNewTaxRegimeIsY){
				// FVU 7.1 Obs no 18 24 Mar 2021 - Vinita
				if((TransactionType.equals(UPLOADTYPE_REGULAR) || (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A"))) &&
						((Integer.parseInt(FinancialYr) == 202021 && (Qperiod.equals("Q4"))) || (Integer.parseInt(FinancialYr) > 202021 && (Qperiod.equals("Q1") || Qperiod.equals("Q2") || Qperiod.equals("Q3") || Qperiod.equals("Q4"))))){
					if(!(Sec16_DeductionAmount.equals(FIELD_NULL) || Sec16_DeductionAmount.equals(FIELD_SEPERATOR))){
					Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab + "Total Deduction under section 16" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6199_C + tab + T_FV_6199_M);
					}
					}
			}
					

			////validation ends
			//         if (!localErrorFlag && !paperReturnFile)

			if (!localErrorFlag)
			{
				sumSection16 = sumSection16 + Double.parseDouble(Sec16_DeductionAmount);
				/*
				 *  d4 = Math.round((double)(d4 * 100)) /100.0;	
				 *   16 July Code Changed 
				 */
				sumSection16 = Math.round((double) (sumSection16 * 100)) / 100.0;
				if (section16ValidCount == Integer.parseInt(Sec16Count.trim()) && (sumSection16 != Double.parseDouble(Sec16TotalAmount.trim())))
				{
					//  Log.tds_log.info("sumSection16 : " + sumSection16 + "\t\t Sec16TotalAmount : " + Sec16TotalAmount);
					if (paperReturnFile) // && (Double.parseDouble(Sec16TotalAmount.trim()) == 0))
					{
						fvO.setPaperReturnRelax(true);
						Str_Buffer.appendPaperWarning(lineNoOfSalaryDetailRec + tab + BH_BatchNo + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_4045_C + tab + T_FV_4045_M);
					}
					else
						Str_Buffer.append(lineNoOfSalaryDetailRec + tab + v_upload_Type + tab + "Total Deduction under section 16" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_4045_C + tab + T_FV_4045_M);
				}
			}	
		} //try
		catch (Exception e)
		{
			throw e;
		}
		fvO.returnRecordType = RecType;
		return;
	} // method ValidateAnnualSection16

	//	Validate Annual Section Chapter VI-A// Parameters added for FVU 7.1 - Vinita
	private void validateSectionVIA(
			String SectionVIA,
			int lineCount,
			String BH_BatchNo,
			String DeducteeDetailRecNo,
			String SecVIACount,
			String SecVIATotalAmount,
			int SecVIAValidCount,
			boolean paperReturnFile,
			StringBufferTemp obj_StringBuffer,
			String v_upload_Type,
			String FinancialYear,String Qperiod,String TransactionType)
					throws Exception
	{
		StringBufferTemp Str_Buffer;
		Str_Buffer = obj_StringBuffer;

		int Count_SectionVIA_fields = 1;
		boolean NullField = false;
		boolean FieldFound;
		boolean Caret = false;
		boolean chkFor80CCG = true;

		//			boolean localErrorFlag = false;
		try
		{
			String SecVIA_LineNo = null;
			String SecVIA_RecType = null;
			String SecVIA_BatchNo = null;
			String SecVIA_DeducteeDetailRecNo = null;
			String SecVIA_RecordNo = null;
			String SecVIA_ID = null;
			String totalDeductibleAmountSecVIA = null;//Modified by puja for FVU 6.4
			//Added by puja for FVU 6.4
			String totalGrossAmountSecVIA = null;
			String totalQualifyingAmountSecVIA = null;
			String SecVIA_Hash = null;

			FieldValidation obj_FieldValidation = new FieldValidation();

			StringTokenizer st_DD_SecVIA = new StringTokenizer(SectionVIA, FIELD_SEPERATOR, true);
			
			
			//Added for FVU 7.1
			String whthrOptTax115BAC = "";
			
			if(wthrOptNewTaxRegimeIsY)
				whthrOptTax115BAC = "Y";
			else
				whthrOptTax115BAC = "";

			int caretCounter = 0;
			while (st_DD_SecVIA.hasMoreTokens())
			{
				String val = st_DD_SecVIA.nextToken();
				NullField = false;
				FieldFound = false;
				if ((val.equals(FIELD_SEPERATOR) && Caret) || val.trim().length() == 0)
				{
					NullField = true;
					FieldFound = true;
				}
				if (val.equals(FIELD_SEPERATOR))
				{
					Caret = true;
					if (caretCounter == 0 && Count_SectionVIA_fields == 1)
					{
						Count_SectionVIA_fields++;
						SecVIA_LineNo = "";
					}
					caretCounter++;
				}
				else
				{
					Caret = false;
					FieldFound = true;
				}

				if (Count_SectionVIA_fields > 10)//Modified by puja for FVU 6.4
				{
					Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Line_Number" + tab + tab + tab + T_FV_6003_C + tab + T_FV_6003_M);
					fvO.returnRecordType = RecType;
					return;
				}
				if (FieldFound)
				{
					switch (Count_SectionVIA_fields)
					{
					case 1 :
						SecVIA_LineNo = val;
						break;
					case 2 :
						SecVIA_RecType = val;
						break;
					case 3 :
						SecVIA_BatchNo = val;
						break;
					case 4 :
						SecVIA_DeducteeDetailRecNo = val;
						break;
					case 5 :
						SecVIA_RecordNo = val;
						break;
					case 6 :
						SecVIA_ID = val;
						break;
					case 7 :
						totalDeductibleAmountSecVIA = val;
						break;
					case 8 :
						totalGrossAmountSecVIA = val;
						break;	
					case 9 :
						totalQualifyingAmountSecVIA = val;
						break;	
					case 10 :
						SecVIA_Hash = val;
						break;
					}
					Count_SectionVIA_fields++;
				}
			} //while 

			if (totalDeductibleAmountSecVIA == null)
				totalDeductibleAmountSecVIA = "";
			

			if (caretCounter != 9) //Modified by puja for FVU 6.4
			{
				Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "NA" + tab + tab + tab + T_FV_6003_C + tab
						+ T_FV_6003_M);
				fvO.returnRecordType = RecType;
				return;
			}

			//validation starts 
			if (SecVIA_LineNo.equals(FIELD_NULL) || SecVIA_LineNo.equals(FIELD_SEPERATOR))
			{
				Str_Buffer.append("-" + tab + v_upload_Type + tab + "Line_Number" + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6005_C + tab + T_FV_6005_M);
				SecVIA_LineNo = "-";
			}
			else if (SecVIA_LineNo.length() <= 9)
			{
				if (obj_FieldValidation.isInt(SecVIA_LineNo))
				{
					Str_Buffer.append("-" + tab + v_upload_Type + tab + "Line_Number" + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6005_C + tab + T_FV_6005_M);
					SecVIA_LineNo = "-";
				}
				else if (Integer.parseInt(SecVIA_LineNo.trim()) != lineCount)
				{
					Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Line_Number" + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6005_C + tab + T_FV_6005_M);
				}
			}
			else
			{
				Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Line_Number" + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6005_C + tab + T_FV_6005_M);
				SecVIA_LineNo = "-";
			}
			//	  check Section Chapter VIA LineNo
			//	  check RecType
			if (SecVIA_RecType.equals(FIELD_NULL) || SecVIA_RecType.equals(FIELD_SEPERATOR))
			{
				Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Section -Chapter VIA record Type" + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6022_C + tab + T_FV_6022_M);
			}
			else if (!(SecVIA_RecType.equals(SECTIONVIA_HEADER_IDENTIFIER)))
			{
				Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Section -Chapter VIA record Type" + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6022_C + tab + T_FV_6022_M);
			}
			//		check SecVIA_SecVIA_RecType

			//	  check BatchNo
			if (SecVIA_BatchNo.equals(FIELD_NULL) || SecVIA_BatchNo.equals(FIELD_SEPERATOR))
			{
				Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Batch Number" + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6007_C + tab + T_FV_6007_M);
			}
			else if (SecVIA_BatchNo.length() <= 9)
			{
				if (obj_FieldValidation.isInt(SecVIA_BatchNo))
				{
					Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Batch Number" + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6007_C + tab + T_FV_6007_M);
				}
				else if (Integer.parseInt(BH_BatchNo.trim()) != Integer.parseInt(SecVIA_BatchNo.trim()))
				{
					Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Batch Number" + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6029_C + tab + T_FV_6029_M);
				}
			}
			else
			{
				Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Batch Number" + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6007_C + tab + T_FV_6007_M);
			}
			//				check BatchNo
			//		check SecVIA_DeducteeDetailRecNo
			if (SecVIA_DeducteeDetailRecNo.equals(FIELD_NULL) || SecVIA_DeducteeDetailRecNo.equals(FIELD_SEPERATOR))
			{
				Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Salary Detail Record No" + tab + "NA" + tab + "Null" + tab + T_FV_6008_C + tab + T_FV_6008_M);

			}
			else if (SecVIA_DeducteeDetailRecNo.length() <= 9)
			{
				if (obj_FieldValidation.isInt(SecVIA_DeducteeDetailRecNo))
				{
					Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Salary Detail Record No" + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6008_C + tab + T_FV_6008_M);

				}
				else if (Integer.parseInt(SecVIA_DeducteeDetailRecNo.trim()) != Integer.parseInt(DeducteeDetailRecNo.trim()))
				{
					Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Salary Detail Record No" + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6008_C + tab + T_FV_6008_M);

				}
			}
			else
			{
				Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Salary Detail Record No" + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6008_C + tab + T_FV_6008_M);
			}
			//	  check SecVIA_DeducteeDetailRecNo

			//	check SECTION 10 DETAIL RECORD
			if (SecVIA_RecordNo.equals(FIELD_NULL) || SecVIA_RecordNo.equals(FIELD_SEPERATOR))
			{
				Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Salary Detail - Chapter VI -A Details Record No" + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6012_C + tab + T_FV_6012_M);
			}
			else if (SecVIA_RecordNo.length() <= 9)
			{
				if (obj_FieldValidation.isInt(SecVIA_RecordNo))
				{
					Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Salary Detail - Chapter VI -A Details Record No" + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6012_C + tab + T_FV_6012_M);
				}
				else if (Integer.parseInt(SecVIA_RecordNo.trim()) != SecVIAValidCount)
				{
					Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Salary Detail - Chapter VI -A Details Record No" + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6012_C + tab + T_FV_6012_M);
				}
			}
			else
			{
				Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Salary Detail - Chapter VI -A Details Record No" + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6012_C + tab + T_FV_6012_M);
			}
			//	  check DeducteeDetailRecNo



			if(Integer.parseInt(FinancialYear) < 201819)		//bifurcated after fvu 6.2 by jacky	
			{
				// check Section Chapter VI-A I.D.
				boolean errUnique = false;
				boolean validSecVIA = false;
				if (fvO.isFinYrGrtr) {
					if (SecVIA_ID.equals(FIELD_NULL) || SecVIA_ID.equals(FIELD_SEPERATOR)) {
						Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Chapter VI-A Section ID" + tab
								+ "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6046_C + tab + T_FV_6046_M);
					} else {
						if (SecVIA_ID.length() <= 15) {
							for (int localX = 0; localX < secVIAIdentification.length; localX++) {
								if (SecVIA_ID.equals(secVIAIdentification[localX])) {
									validSecVIA = true;
									break;
								}
							}
							if (validSecVIA == false) {
								Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Chapter VI-A Section ID"
										+ tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6046_C + tab
										+ T_FV_6046_M);
							}

							if (validSecVIA) {
								for (int localI = 0; localI < SecVIAValidCount; localI++) {
									if (secVIAArray[localI] != null && secVIAArray[localI].equals(SecVIA_ID)) {
										errUnique = true;
										Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab
												+ "Chapter VI-A Section ID" + tab + "NA" + tab
												+ SecVIA_DeducteeDetailRecNo + tab + T_FV_6027_C + tab + T_FV_6027_M);
										break;
									}
								}

								if (errUnique == false) {
									secVIAArray[SecVIAValidCount - 1] = SecVIA_ID;
								}
							}
						} else {
							Str_Buffer.append(
									SecVIA_LineNo + tab + v_upload_Type + tab + "Chapter VI-A Section ID" + tab + "NA"
											+ tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6046_C + tab + T_FV_6046_M);
						}
					}
				} else {
					if (SecVIA_ID.equals(FIELD_NULL) || SecVIA_ID.equals(FIELD_SEPERATOR)) {
						Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Chapter VI-A Section ID" + tab
								+ "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6015_C + tab + T_FV_6015_M);
					} else {
						if (SecVIA_ID.length() <= 15) {
							for (int localX = 0; localX < secVIAIdentification.length; localX++) {
								if (SecVIA_ID.equals(secVIAIdentification[localX])) {
									validSecVIA = true;
									break;
								}
							}
							if (validSecVIA == false) {
								Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Chapter VI-A Section ID"
										+ tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6015_C + tab
										+ T_FV_6015_M);
							}

							if (validSecVIA) {
								for (int localI = 0; localI < SecVIAValidCount; localI++) {
									if (secVIAArray[localI] != null && secVIAArray[localI].equals(SecVIA_ID)) {
										errUnique = true;
										Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab
												+ "Chapter VI-A Section ID" + tab + "NA" + tab
												+ SecVIA_DeducteeDetailRecNo + tab + T_FV_6027_C + tab + T_FV_6027_M);
										break;
									}
								}

								if (errUnique == false) {
									secVIAArray[SecVIAValidCount - 1] = SecVIA_ID;
								}
							}
						} else {
							Str_Buffer.append(
									SecVIA_LineNo + tab + v_upload_Type + tab + "Chapter VI-A Section ID" + tab + "NA"
											+ tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6015_C + tab + T_FV_6015_M);
						}
					}
				}
				// END check Section Chapter VI-A I.D.

				// M01_B
				// Checking the order of Section. It should be of the order
				// 80CCE,80CCF,OTHERS.
				if (!errUnique) // check for the sequence only if the sections
				// are unique and valid.
				{
					if (fvO.isFinYrGrtr) {
						if (SecVIAValidCount == 4) {

							if (secVIAArray[1] != null && secVIAArray[1].equals("OTHERS")) // As
								// for
								// (SecVIAValidCount==3),
								// the
								// conditions
								// specified
								// in
								// (SecVIAValidCount==2)
								// are
								// checked,
								// these
								// are
								// not
								// checked
								// explicitly
								// here
								// .

								if (secVIAArray[1].equals("OTHERS")) // As for
								// (SecVIAValidCount==3),
								// the
								// conditions
								// specified
								// in
								// (SecVIAValidCount==2)
								// are
								// checked,
								// these
								// are
								// not
								// checked
								// explicitly
								// here
								// .

								{

									Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab
											+ "Chapter VI-A Section ID" + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo
											+ tab + T_FV_6043_C + tab + T_FV_6043_M);
								}
						} else if (SecVIAValidCount == 3) {
							if ((secVIAArray[0] != null && secVIAArray[0].equals("80CCF"))
									&& ((secVIAArray[1] != null && secVIAArray[1].equals("80CCE"))
											|| (secVIAArray[2] != null && secVIAArray[2].equals("80CCE")))) {

								Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Chapter VI-A Section ID"
										+ tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6043_C + tab
										+ T_FV_6043_M);
							} else if (secVIAArray[0] != null
									&& (secVIAArray[0].equals("OTHERS") || secVIAArray[0].equals("80CCG"))) {

								Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Chapter VI-A Section ID"
										+ tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6043_C + tab
										+ T_FV_6043_M);
							} else if (secVIAArray[1] != null && secVIAArray[1].equals("OTHERS")) {

								Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Chapter VI-A Section ID"
										+ tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6043_C + tab
										+ T_FV_6043_M);
							}
						} else if (SecVIAValidCount == 2) {

							if ((secVIAArray[0] != null && secVIAArray[0].equals("80CCF"))
									&& (secVIAArray[1] != null && secVIAArray[1].equals("80CCE"))) {

								Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Chapter VI-A Section ID"
										+ tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6043_C + tab
										+ T_FV_6043_M);
							} else if ((secVIAArray[0] != null && secVIAArray[0].equals("80CCG"))
									&& (secVIAArray[1] != null && !secVIAArray[1].equals("OTHERS"))) {
								Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Chapter VI-A Section ID"
										+ tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6043_C + tab
										+ T_FV_6043_M);
							} else if (secVIAArray[0] != null && secVIAArray[0].equals("OTHERS")) {

								Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Chapter VI-A Section ID"
										+ tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6043_C + tab
										+ T_FV_6043_M);
							}
						}
					} else {
						System.out.println("inside else");
						for (int localI = 0; localI < SecVIAValidCount; localI++) {
							if (secVIAArray[localI] != null && secVIAArray[localI].equals("80CCG")) {
								System.out.println("inside for");
								chkFor80CCG = false;
								Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Chapter VI-A Section ID"
										+ tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6047_C + tab
										+ T_FV_6047_M);
								break;
							}
						}
						if (chkFor80CCG) {
							if (SecVIAValidCount == 3) {

								if (secVIAArray[1] != null && secVIAArray[1].equals("OTHERS")) // As
									// for
									// (SecVIAValidCount==3),
									// the
									// conditions
									// specified
									// in
									// (SecVIAValidCount==2)
									// are
									// checked,
									// these
									// are
									// not
									// checked
									// explicitly
									// here
									// .

									if (secVIAArray[1].equals("OTHERS")) // As
									// for
									// (SecVIAValidCount==3),
									// the
									// conditions
									// specified
									// in
									// (SecVIAValidCount==2)
									// are
									// checked,
									// these
									// are
									// not
									// checked
									// explicitly
									// here
									// .

									{

										Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab
												+ "Chapter VI-A Section ID" + tab + "NA" + tab
												+ SecVIA_DeducteeDetailRecNo + tab + T_FV_6043_C + tab + T_FV_6043_M);
									}
							} else if (SecVIAValidCount == 2) {
								if ((secVIAArray[0] != null && secVIAArray[0].equals("80CCF"))
										&& (secVIAArray[1] != null && secVIAArray[1].equals("80CCE"))) {

									Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab
											+ "Chapter VI-A Section ID" + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo
											+ tab + T_FV_6043_C + tab + T_FV_6043_M);
								} else if (secVIAArray[0] != null && secVIAArray[0].equals("OTHERS")) {

									Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab
											+ "Chapter VI-A Section ID" + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo
											+ tab + T_FV_6043_C + tab + T_FV_6043_M);
								}
							}
						}
					}

				}
				// Ends Checking the order of Section. It should be of the order
				// 80CCE,80CCF,OTHERS.
				// M01_E

				// boolean validSecVIATotAmount = false; //Commented by Dhanya
				// as the variable is declared as a class variable; since it has
				// to be initialized only once for a file. on 03/02/2011 as 4047
				// msg has to be displayed only if all the amount in 16A are
				// valid.

				if (totalDeductibleAmountSecVIA.equals(FIELD_NULL) || totalDeductibleAmountSecVIA.equals(FIELD_SEPERATOR)) {
					validSecVIATotAmount = false; // Added by Dhanya on
					// 03/02/2011 as 4047 msg
					// has to be displayed only
					// if all the amount in 16A
					// are valid.
					// M01_B
					if (SecVIA_ID.equals("80CCF")) // if invalid incase of
					// 80CCE, show msg specific
					// to 80CCF
					{

						Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Total Deductible amount under Chapter VI-A" + tab + "NA" + tab
								+ SecVIA_DeducteeDetailRecNo + tab + T_FV_6042_C + tab + T_FV_6042_M);
					}
					// M01_E
					else // for all other cases
						Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Total Deductible amount under Chapter VI-A" + tab + "NA" + tab
								+ SecVIA_DeducteeDetailRecNo + tab + T_FV_6021_C + tab + T_FV_6021_M);
				}
				// Added By amit for 4.5
				else if (totalDeductibleAmountSecVIA.length() != totalDeductibleAmountSecVIA.trim().length()) {
					validSecVIATotAmount = false;
					Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Total Deductible amount under Chapter VI-A" + tab + "NA" + tab
							+ SecVIA_DeducteeDetailRecNo + tab + T_FV_6021_C + tab + T_FV_6021_M);
				}
				// Amit end for Fvu 4.5
				else if (totalDeductibleAmountSecVIA.length() <= 15) {
					// Added for FVU 3.7 by Shalin

					if (SecVIA_ID.equals("80CCF") && !(fvO.financialYearOfFirstBatch.equals("201011")
							|| fvO.financialYearOfFirstBatch.equals("201112"))) {

						Str_Buffer.append(
								SecVIA_LineNo + tab + v_upload_Type + tab + "Chapter VI-A  Section 80CCF" + tab + "NA"
										+ tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6048_C + tab + T_FV_6048_M);
					}

					else {
						if (obj_FieldValidation.isDecimalNumber(totalDeductibleAmountSecVIA)) {
							validSecVIATotAmount = false; // Added by Dhanya on
							// 03/02/2011 as
							// 4047 msg has to
							// be displayed only
							// if all the amount
							// in 16A are valid.
							// M01_B
							if (SecVIA_ID.equals("80CCF")) // if invalid incase
							// of 80CCE, show
							// msg specific to
							// 80CCF
							{

								Str_Buffer.append(
										SecVIA_LineNo + tab + v_upload_Type + tab + "Total Deductible amount under Chapter VI-A" + tab + "NA" + tab
												+ SecVIA_DeducteeDetailRecNo + tab + T_FV_6044_C + tab + T_FV_6044_M);
							}
							// M01_E
							else // for all other sections
							{
								Str_Buffer.append(
										SecVIA_LineNo + tab + v_upload_Type + tab + "Total Deductible amount under Chapter VI-A" + tab + "NA" + tab
												+ SecVIA_DeducteeDetailRecNo + tab + T_FV_6021_C + tab + T_FV_6021_M);
							}
						}
						// Added for FVU 4.6
						else if (Integer.parseInt(FinancialYear) >= 201415 && SecVIA_ID.equals("80CCE")
								&& Double.parseDouble(totalDeductibleAmountSecVIA.trim()) > 150000) {
							validSecVIATotAmount = false; // Added by Dhanya on
							// 03/02/2011 as
							// 4047 msg has to
							// be displayed only
							// if all the amount
							// in 16A are valid.
							/*
							 * Code modified to allow paper ret in which 80CCE
							 * amount is greater than 1lakh warning file will be
							 * generated
							 */
							if (paperReturnFile) {
								fvO.setPaperReturnRelax(true);
								Str_Buffer.appendPaperWarning(SecVIA_LineNo + tab + BH_BatchNo + tab + "NA" + tab
										+ SecVIA_DeducteeDetailRecNo + tab + T_FV_6050_C + tab + T_FV_6050_M);
							} else {
								Str_Buffer.append(
										SecVIA_LineNo + tab + v_upload_Type + tab + "Total Deductible amount under Chapter VI-A" + tab + "NA" + tab
												+ SecVIA_DeducteeDetailRecNo + tab + T_FV_6050_C + tab + T_FV_6050_M);
							}
						} else if (Integer.parseInt(FinancialYear) < 201415 && SecVIA_ID.equals("80CCE")
								&& Double.parseDouble(totalDeductibleAmountSecVIA.trim()) > 100000) {
							validSecVIATotAmount = false; // Added by Dhanya on
							// 03/02/2011 as
							// 4047 msg has to
							// be displayed only
							// if all the amount
							// in 16A are valid.
							/*
							 * Code modified to allow paper ret in which 80CCE
							 * amount is greater than 1lakh warning file will be
							 * generated
							 */
							if (paperReturnFile) {
								fvO.setPaperReturnRelax(true);
								Str_Buffer.appendPaperWarning(SecVIA_LineNo + tab + BH_BatchNo + tab + "NA" + tab
										+ SecVIA_DeducteeDetailRecNo + tab + T_FV_6039_C + tab + T_FV_6039_M);
							} else {
								Str_Buffer.append(
										SecVIA_LineNo + tab + v_upload_Type + tab + "Total Deductible amount under Chapter VI-A" + tab + "NA" + tab
												+ SecVIA_DeducteeDetailRecNo + tab + T_FV_6039_C + tab + T_FV_6039_M);
							}
						}
						// M01_B
						else if (SecVIA_ID.equals("80CCF") && Double.parseDouble(totalDeductibleAmountSecVIA.trim()) > 20000) {
							validSecVIATotAmount = false; // Added by Dhanya on
							// 03/02/2011 as
							// 4047 msg has to
							// be displayed only
							// if all the amount
							// in 16A are valid.
							Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab
									+ "Chapter VI-A  Section 80CCF " + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo
									+ tab + T_FV_6040_C + tab + T_FV_6040_M);
						}

						else if (fvO.isFinYrGrtr && SecVIA_ID.equals("80CCG")
								&& Double.parseDouble(totalDeductibleAmountSecVIA.trim()) > 25000) {
							validSecVIATotAmount = false;
							Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab
									+ "Chapter VI-A  Section 80CCG " + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo
									+ tab + T_FV_6045_C + tab + T_FV_6045_M);
						}
						// M01_E
						/*
						 * else commented by Dhanya on 03/02/2011 as 4047 msg
						 * has to be displayed only if all the amount in 16A are
						 * valid. { validSecVIATotAmount = true; }
						 */
					}
				} else {
					validSecVIATotAmount = false; // Added by Dhanya on
					// 03/02/2011 as 4047 msg
					// has to be displayed only
					// if all the amount in 16A
					// are valid.
					//// M01_B
					if (SecVIA_ID.equals("80CCF")) // if invalid incase of
					// 80CCE, show msg specific
					// to 80CCF
					{

						Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Total Deductible amount under Chapter VI-A " + tab + "NA" + tab
								+ SecVIA_DeducteeDetailRecNo + tab + T_FV_6042_C + tab + T_FV_6042_M);
					}
					// M01_E
					else {

						Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Total Deductible amount under Chapter VI-A" + tab + "NA" + tab
								+ SecVIA_DeducteeDetailRecNo + tab + T_FV_6021_C + tab + T_FV_6021_M);
					}
				}
				// if (validSecVIADeductionAmount && !paperReturnFile)
				if (validSecVIATotAmount) {

					sumSectionVIA = sumSectionVIA + Double.parseDouble(totalDeductibleAmountSecVIA.trim());

					/*
					 * Code Changed 16 July 05 d4 = Math.round((double)(d4 *
					 * 100)) /100.0;
					 */
					sumSectionVIA = Math.round((double) (sumSectionVIA * 100)) / 100.0;

					if (SecVIAValidCount == Integer.parseInt(SecVIACount.trim()) && (sumSectionVIA
							* 100 < (-1000.0 + (Double.parseDouble(SecVIATotalAmount.trim()) * 100))
							|| sumSectionVIA * 100 > (1000.0 + (Double.parseDouble(SecVIATotalAmount.trim()) * 100)))) {

						if (paperReturnFile) // &&
						// (Double.parseDouble(SecVIATotalAmount.trim())
						// == 0))
						{
							fvO.setPaperReturnRelax(true);
							Str_Buffer.appendPaperWarning(lineNoOfSalaryDetailRec + tab + BH_BatchNo + tab
									+ "Gross Total of 'Amount deductible under provisions of chapter VI-A' under  associated ' Salary Details  - Chapter VIA Detail "
									+ tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_4047_C + tab + T_FV_4047_M);
						} else
							Str_Buffer.append(lineNoOfSalaryDetailRec + tab + v_upload_Type + tab
									+ "Gross Total of 'Amount deductible under provisions of chapter VI-A' under  associated ' Salary Details  - Chapter VIA Detail "
									+ tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_4047_C + tab
									+ T_FV_4047_M);
					}
				}
				
				//Bug fix CR 82938 A3
				if(!validSecVIATotAmount && FIELD_SEPERATOR.equals(totalDeductibleAmountSecVIA)){
					if(SecVIATotalAmount != null && !"".equals(SecVIATotalAmount) && !FIELD_SEPERATOR.equals(SecVIATotalAmount)){
						if (paperReturnFile) // &&
							// (Double.parseDouble(SecVIATotalAmount.trim())
							// == 0))
							{
								fvO.setPaperReturnRelax(true);
								Str_Buffer.appendPaperWarning(lineNoOfSalaryDetailRec + tab + BH_BatchNo + tab
										+ "Gross Total of 'Amount deductible under provisions of chapter VI-A' under  associated ' Salary Details  - Chapter VIA Detail "
										+ tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_4047_C + tab + T_FV_4047_M);
							} else
								Str_Buffer.append(lineNoOfSalaryDetailRec + tab + v_upload_Type + tab
										+ "Gross Total of 'Amount deductible under provisions of chapter VI-A' under  associated ' Salary Details  - Chapter VIA Detail "
										+ tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_4047_C + tab
										+ T_FV_4047_M);
					}
				}

			}
			else //added for change in secion VIA validation after fvu 6.2 by jacky
			{
				// check Section Chapter VI-A I.D.
				boolean errUnique = false;
				boolean validSecVIA = false;
				if (fvO.isFinYrGrtr) {
					if (SecVIA_ID.equals(FIELD_NULL) || SecVIA_ID.equals(FIELD_SEPERATOR)) {
						Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Chapter VI-A Section ID" + tab
								+ "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6046_C + tab + T_FV_6046_M);
					} else {
						if (SecVIA_ID.length() <= 15) {
							for (int localX = 0; localX < secVIAIdentification201819Onwards.length; localX++) {
								if (SecVIA_ID.equals(secVIAIdentification201819Onwards[localX])) {
									validSecVIA = true;
									break;
								}
							}
							if (validSecVIA == false) {
								Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Chapter VI-A Section ID"
										+ tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6046_C + tab
										+ T_FV_6046_M);
							}

							if (validSecVIA) {
								for (int localI = 0; localI < SecVIAValidCount; localI++) {
									if (secVIAArray[localI] != null && secVIAArray[localI].equals(SecVIA_ID)) {
										errUnique = true;
										Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab
												+ "Chapter VI-A Section ID" + tab + "NA" + tab
												+ SecVIA_DeducteeDetailRecNo + tab + T_FV_6027_C + tab + T_FV_6027_M);
										break;
									}
								}

								if (errUnique == false) {
									secVIAArray[SecVIAValidCount - 1] = SecVIA_ID;
								}
							}
						} else {
							Str_Buffer.append(
									SecVIA_LineNo + tab + v_upload_Type + tab + "Chapter VI-A Section ID" + tab + "NA"
											+ tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6046_C + tab + T_FV_6046_M);
						}
					}
				}
				// END check Section Chapter VI-A I.D.

				if (!errUnique) // check for the sequence only if the sections
				// are unique and valid.
				{
					if (fvO.isFinYrGrtr) {

						if (SecVIAValidCount > 1) {
							
							if(!errorFlagSDC6A){
							List<String> secVIAIdentification201819OnwardsList = Arrays
									.asList(secVIAIdentification201819Onwards);
							int baseIndex = secVIAIdentification201819OnwardsList.indexOf(secVIAArray[0]);

							for (int i = 0; i < SecVIAValidCount; i++) {

								if (secVIAIdentification201819OnwardsList.indexOf(secVIAArray[i]) < baseIndex) {

									Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab
											+ "Chapter VI-A Section ID" + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo
											+ tab + T_FV_6043_C + tab + T_FV_6043_M);
									errorFlagSDC6A=true;
									
									break;
								} else {

									baseIndex = secVIAIdentification201819OnwardsList.indexOf(secVIAArray[i]);
								}

							}
						}}

					}

				}

				if (totalDeductibleAmountSecVIA.equals(FIELD_NULL) || totalDeductibleAmountSecVIA.equals(FIELD_SEPERATOR)) {
					
					// Added if condition for FVU 7.1 - Obs no 14 - Vinita
					// FVU 7.1 Obs no 18 24 Mar 2021 - Vinita
					if( (TransactionType.equals(UPLOADTYPE_REGULAR) || (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A"))) &&
							((Integer.parseInt(FinancialYear) == 202021 && (Qperiod.equals("Q4"))) || (Integer.parseInt(FinancialYear) > 202021 && (Qperiod.equals("Q1") || Qperiod.equals("Q2") || Qperiod.equals("Q3") || Qperiod.equals("Q4")))) &&
					   (whthrOptTax115BAC.equals("Y")) && !SecVIA_ID.equals("80CCD(2)")){
						validSecVIATotAmount = false;
						// no error to be thrown if 'Y' is present in whthrOptTax115BAC
					}
					else{
						
						validSecVIATotAmount = false;
						Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Total Deductible amount under Chapter VI-A" + tab + "NA" + tab
							+ SecVIA_DeducteeDetailRecNo + tab + T_FV_6021_C + tab + T_FV_6021_M);
					}
					}

				else if (totalDeductibleAmountSecVIA.length() != totalDeductibleAmountSecVIA.trim().length()) {
					validSecVIATotAmount = false;
					Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Total Deductible amount under Chapter VI-A" + tab + "NA" + tab
							+ SecVIA_DeducteeDetailRecNo + tab + T_FV_6021_C + tab + T_FV_6021_M);
				}

				else if (totalDeductibleAmountSecVIA.length() <= 15) {

					if (obj_FieldValidation.isDecimalNumber(totalDeductibleAmountSecVIA)) {
						validSecVIATotAmount = false;

						Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Total Deductible amount under Chapter VI-A" + tab + "NA" + tab
								+ SecVIA_DeducteeDetailRecNo + tab + T_FV_6021_C + tab + T_FV_6021_M);

					}

					else if (fvO.isFinYrGrtr && SecVIA_ID.equals("80CCG")
							&& Double.parseDouble(totalDeductibleAmountSecVIA.trim()) > 25000) {
						validSecVIATotAmount = false;
						Str_Buffer.append(
								SecVIA_LineNo + tab + v_upload_Type + tab + "Chapter VI-A  Section 80CCG " + tab + "NA"
										+ tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6045_C + tab + T_FV_6045_M);
					}

				} else {
					validSecVIATotAmount = false;

					Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Total Deductible amount under Chapter VI-A" + tab + "NA" + tab
							+ SecVIA_DeducteeDetailRecNo + tab + T_FV_6021_C + tab + T_FV_6021_M);

				}

				if (validSecVIATotAmount) {
					
				if (SecVIA_ID.equals("80C") || SecVIA_ID.equals("80CCC") || SecVIA_ID.equals("80CCD(1)")) {
					
					sumSectionVIA80C_80CCC_80CCD_1 = sumSectionVIA80C_80CCC_80CCD_1
							+ Double.parseDouble(totalDeductibleAmountSecVIA.trim());

					if (sumSectionVIA80C_80CCC_80CCD_1 > 150000) {
						validSecVIATotAmount = false;
						if (paperReturnFile) {
							fvO.setPaperReturnRelax(true);
							Str_Buffer.appendPaperWarning(SecVIA_LineNo + tab + BH_BatchNo + tab + "NA" + tab
									+ SecVIA_DeducteeDetailRecNo + tab + T_FV_6126_C + tab + T_FV_6126_M);

						} else {
							Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Total Deductible amount under Chapter VI-A " + tab + "NA"
									+ tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6126_C + tab + T_FV_6126_M);

						}

					}
				}
				}
				
				if (validSecVIATotAmount) {

					sumSectionVIA = sumSectionVIA + Double.parseDouble(totalDeductibleAmountSecVIA.trim());

					/*
					 * Code Changed 16 July 05 d4 = Math.round((double)(d4 *
					 * 100)) /100.0;
					 */
					sumSectionVIA = Math.round((double) (sumSectionVIA * 100)) / 100.0;

					if (SecVIAValidCount == Integer.parseInt(SecVIACount.trim()) && (sumSectionVIA
							* 100 < (-1000.0 + (Double.parseDouble(SecVIATotalAmount.trim()) * 100))
							|| sumSectionVIA * 100 > (1000.0 + (Double.parseDouble(SecVIATotalAmount.trim()) * 100)))) {

						if (paperReturnFile) // &&

						{
							fvO.setPaperReturnRelax(true);
							Str_Buffer.appendPaperWarning(lineNoOfSalaryDetailRec + tab + BH_BatchNo + tab
									+ "Gross Total of 'Amount deductible under provisions of chapter VI-A' under  associated ' Salary Details  - Chapter VIA Detail "
									+ tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_4047_C + tab + T_FV_4047_M);
						} else
							Str_Buffer.append(lineNoOfSalaryDetailRec + tab + v_upload_Type + tab
									+ "Gross Total of 'Amount deductible under provisions of chapter VI-A' under  associated ' Salary Details  - Chapter VIA Detail "
									+ tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_4047_C + tab
									+ T_FV_4047_M);
					}
				}
				
				//Bug fix CR 82938 A3
				if(!validSecVIATotAmount && FIELD_SEPERATOR.equals(totalDeductibleAmountSecVIA)){
					if(SecVIATotalAmount != null && !"".equals(SecVIATotalAmount) && !FIELD_SEPERATOR.equals(SecVIATotalAmount)){
						if (paperReturnFile) // &&
							// (Double.parseDouble(SecVIATotalAmount.trim())
							// == 0))
							{
								fvO.setPaperReturnRelax(true);
								Str_Buffer.appendPaperWarning(lineNoOfSalaryDetailRec + tab + BH_BatchNo + tab
										+ "Gross Total of 'Amount deductible under provisions of chapter VI-A' under  associated ' Salary Details  - Chapter VIA Detail "
										+ tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_4047_C + tab + T_FV_4047_M);
							} else
								Str_Buffer.append(lineNoOfSalaryDetailRec + tab + v_upload_Type + tab
										+ "Gross Total of 'Amount deductible under provisions of chapter VI-A' under  associated ' Salary Details  - Chapter VIA Detail "
										+ tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_4047_C + tab
										+ T_FV_4047_M);
					}
				}

			}
			
			
			//Added by Puja for FVU 6.4:START
			if (Integer.parseInt(FinancialYear) < 201819) {

				validateFieldFinYrUpto201819(v_upload_Type, Str_Buffer, LineNo, DeducteeDetailRecNo,
						totalGrossAmountSecVIA, "Total Gross amount under Chapter VI-A");

				validateFieldFinYrUpto201819(v_upload_Type, Str_Buffer, LineNo, DeducteeDetailRecNo,
						totalQualifyingAmountSecVIA, "Total Qualifying amount under Chapter VI-A");

			} else {

				if (SecVIA_ID.equals("80CCG")) {
					validateFieldFinYrUpto201819(v_upload_Type, Str_Buffer, LineNo, DeducteeDetailRecNo,
							totalGrossAmountSecVIA, "Total Gross amount under Chapter VI-A");

					validateFieldFinYrUpto201819(v_upload_Type, Str_Buffer, LineNo, DeducteeDetailRecNo,
							totalQualifyingAmountSecVIA, "Total Qualifying amount under Chapter VI-A");

				} else {

					if (totalDeductibleAmountSecVIA != null && !totalDeductibleAmountSecVIA.equals(FIELD_SEPERATOR)
							&& totalGrossAmountSecVIA != null && !totalGrossAmountSecVIA.equals(FIELD_SEPERATOR)) {
						if (Double.parseDouble(totalDeductibleAmountSecVIA) > Double
								.parseDouble(totalGrossAmountSecVIA)) {
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab
									+ "Total Deductible amount under Chapter VI-A" + tab + "NA" + tab
									+ SecVIA_DeducteeDetailRecNo + tab + T_FV_6135_C + tab + T_FV_6135_M);
						}
					}

					validateField6_2Onwards(FinancialYear,Qperiod,v_upload_Type, Str_Buffer, LineNo, DeducteeDetailRecNo,
							totalGrossAmountSecVIA, obj_FieldValidation, "Total Gross amount under Chapter VI-A",
							T_FV_6131_C, T_FV_6133_C, T_FV_6131_M, T_FV_6133_M,whthrOptTax115BAC,SecVIA_ID);

					if (SecVIA_ID.equals("OTHERS") || SecVIA_ID.equals("80G") || SecVIA_ID.equals("80TTA")) {
						if (totalDeductibleAmountSecVIA != null && !totalDeductibleAmountSecVIA.equals(FIELD_SEPERATOR)
								&& totalGrossAmountSecVIA != null && !totalGrossAmountSecVIA.equals(FIELD_SEPERATOR)
								&& totalQualifyingAmountSecVIA != null
								&& !totalQualifyingAmountSecVIA.equals(FIELD_SEPERATOR)) {

							if (Double.parseDouble(totalDeductibleAmountSecVIA) > Double
									.parseDouble(totalQualifyingAmountSecVIA)) {

								Str_Buffer.append(LineNo + tab + v_upload_Type + tab
										+ "Total Deductible amount under Chapter VI-A" + tab + "NA" + tab
										+ SecVIA_DeducteeDetailRecNo + tab + T_FV_6136_C + tab + T_FV_6136_M);

							}
							if (Double.parseDouble(totalQualifyingAmountSecVIA) > Double
									.parseDouble(totalGrossAmountSecVIA)) {

								Str_Buffer.append(LineNo + tab + v_upload_Type + tab
										+ "Total Qualifying amount under Chapter VI-A" + tab + "NA" + tab
										+ SecVIA_DeducteeDetailRecNo + tab + T_FV_6137_C + tab + T_FV_6137_M);

							}
						}
						validateField6_2Onwards(FinancialYear,Qperiod,v_upload_Type, Str_Buffer, LineNo, DeducteeDetailRecNo,
								totalQualifyingAmountSecVIA, obj_FieldValidation,
								"Total Qualifying amount under Chapter VI-A", T_FV_6132_C, T_FV_6134_C, T_FV_6132_M,
								T_FV_6134_M,whthrOptTax115BAC,SecVIA_ID);
					} else {

						validateFieldFinYrUpto201819(v_upload_Type, Str_Buffer, LineNo, DeducteeDetailRecNo,
								totalQualifyingAmountSecVIA, "Total Qualifying amount under Chapter VI-A");

					}
				}
			}//Added by Puja for FVU 6.4:END
			
			//FVU 7.1 - Vinita
			//if 79 field of SD record will be Y, no value to be mentioned under Total Deduction for 2020-21 and Quarter 4 onwards
			if(wthrOptNewTaxRegimeIsY){
				// FVU 7.1 Obs no 18 24 Mar 2021 - Vinita
				if((TransactionType.equals(UPLOADTYPE_REGULAR) || (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A"))) &&
						((Integer.parseInt(FinancialYear) == 202021 && (Qperiod.equals("Q4"))) || (Integer.parseInt(FinancialYear) > 202021 && (Qperiod.equals("Q1") || Qperiod.equals("Q2") || Qperiod.equals("Q3") || Qperiod.equals("Q4"))))){
					if(!SecVIA_ID.equals("80CCD(2)")){	
					  if(!(totalDeductibleAmountSecVIA.equals(FIELD_NULL) || totalDeductibleAmountSecVIA.equals(FIELD_SEPERATOR))){
						  Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Total Deductible amount under Chapter VI-A" + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6199_C + tab + T_FV_6199_M);
					  }
					  if( !(totalGrossAmountSecVIA.equals(FIELD_NULL) || totalGrossAmountSecVIA.equals(FIELD_SEPERATOR))){
						  Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Total Gross amount under Chapter VI-A" + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6199_C + tab + T_FV_6199_M);
					  }
					   if(!(totalQualifyingAmountSecVIA.equals(FIELD_NULL) || totalQualifyingAmountSecVIA.equals(FIELD_SEPERATOR))){
						   Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Total Qualifying amount under Chapter VI-A" + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6199_C + tab + T_FV_6199_M);
					   }
					
					}
					}
			}

		}
		catch (Exception e)
		{

			throw e;
		}
		fvO.returnRecordType = RecType;
		return;
	}
	
	//Added for FVU 7.1 - Vinita
	public void validateSDfield79(String UploadType,String TransactionType, String FinancialYr,StringBufferTemp Str_Buffer,String Qperiod,String v_upload_Type, String whthrOptTax115BAC,String IncomeLossFrmHouse,String travelConcessionOrAssistanceSec10_5,String deathCumRetirementGratuitySec10_10,String houseRentAllowanceSec10_13A){
		
		if(whthrOptTax115BAC != null && !(whthrOptTax115BAC.equals(FIELD_NULL) || whthrOptTax115BAC.equals(FIELD_SEPERATOR))){
			if((TransactionType.equals(UPLOADTYPE_REGULAR) || (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A"))) &&		// FVU 7.1 Obs no 18 24 Mar 2021 - Vinita
				((Integer.parseInt(FinancialYr) == 202021 && (Qperiod.equals("Q4"))) || (Integer.parseInt(FinancialYr) > 202021 && (Qperiod.equals("Q1") || Qperiod.equals("Q2") || Qperiod.equals("Q3") || Qperiod.equals("Q4"))))){
				if(whthrOptTax115BAC.equals("Y") || whthrOptTax115BAC.equals("N")){
					if(whthrOptTax115BAC.equals("Y")){
						wthrOptNewTaxRegimeIsY = true;
						//No value should be specified for fields 18,70,71,74,deduction under sec 16 and all VI-A ded except 80CCD(2)
						// Negative value not allowed for IncomeLossFrmHouse
						if( !(IncomeLossFrmHouse.equals(FIELD_NULL) || IncomeLossFrmHouse.equals(FIELD_SEPERATOR)) && obj_FieldValidation.isDecimalNumber(IncomeLossFrmHouse)){
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Income (or admissible loss) from house property reported by employee offered for TDS [section 192 (2B)]" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6200_C + tab + T_FV_6200_M);
						}
						
						if(!(travelConcessionOrAssistanceSec10_5.equals(FIELD_NULL) || travelConcessionOrAssistanceSec10_5.equals(FIELD_SEPERATOR))){
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Travel Concession  or assistance [section 10(5)] " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6199_C + tab + T_FV_6199_M);
						}
						
						// Req updated 7.1 'Death cum Requirement' removed 10 Mar 2021 - Vinita
						/*if(!(deathCumRetirementGratuitySec10_10.equals(FIELD_NULL) || deathCumRetirementGratuitySec10_10.equals(FIELD_SEPERATOR))){
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Death cum Retirement Gratuity" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6199_C + tab + T_FV_6199_M);
						}*/
						
						if(!(houseRentAllowanceSec10_13A.equals(FIELD_NULL) || houseRentAllowanceSec10_13A.equals(FIELD_SEPERATOR))){
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "House Rent Allowance [Section 10(13A)]" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6199_C + tab + T_FV_6199_M);
						}
						
						
					}
					else{
						wthrOptNewTaxRegimeIsY = false;	// Added for FVU 7.1 - Obs no 2 - Vinita
					}
				}
				else{
					// Allowed values are Y or N
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Whether opting for taxation u/s 115BAC?" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6198_C + tab + T_FV_6198_M);
				}
			}
			else{
				// not Valid before FY 202021 Q4
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Whether opting for taxation u/s 115BAC?" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6196_C + tab + T_FV_6196_M);
			}
		}
		else{
			if( (TransactionType.equals(UPLOADTYPE_REGULAR) || (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A"))) &&
					((Integer.parseInt(FinancialYr) == 202021 && (Qperiod.equals("Q4"))) || (Integer.parseInt(FinancialYr) > 202021 && (Qperiod.equals("Q1") || Qperiod.equals("Q2") || Qperiod.equals("Q3") || Qperiod.equals("Q4"))))){  // FVU 7.1 Obs no 18 24 Mar 2021 - Vinita
				// Value must be provided for FY greater than 202021
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Whether opting for taxation u/s 115BAC?" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_6197_C + tab + T_FV_6197_M);
			}
			
		}
	}

	public StringBuffer getStatisticFileSDRec()
	{
		return statisticFileSDRec;
	}

}
